(* ::Package:: *)

(******************************************************************)
(*******Copyright Christoph Zimmer/Yale University**********)
(******************************************************************)


(* ::Subsection:: *)
(*All*)


(* ::Subsubsection:: *)
(*Initial*)


SetDirectory[ directory= "/home/cz/christoph-zimmer/Projects/filter-degeneracy_GFT-data/GFT_ili-add-on2/" ];


Get["MSS-realdata_14_nosigmauc.m"]


HumidCoeff={{0.005064799074082142`,117.76775606105384`,0.006876605592222039`},{0.0052567354341802675`,117.06399724658701`,0.0071022858562195005`},{0.005561638160663945`,113.84531867451282`,0.00800635363380129`},{0.0053359922944603965`,113.7537197409348`,0.010728017713734963`},{0.005489190101365939`,112.23568744021291`,0.007101359567932681`},{0.005104460324727496`,109.33215623975521`,0.009815677519985676`},{0.005758116252996642`,109.07887062168814`,0.007498017811133906`},{0.0025129907334943305`,109.93523331810319`,0.004883550566247092`},{0.0017990336116624774`,125.81516424751459`,0.006957445470895531`},{0.002378335185423547`,111.54982545404084`,0.006424873908707997`},{0.004387320463901742`,113.75546834897102`,0.008221735952830362`}};
regions={"National", "Region 1", "Region 2", "Region 3", "Region 4", "Region 5", "Region 6", "Region 7", "Region 8", "Region 9", "Region 10"};


(* ::Subsubsection::Closed:: *)
(*Load DATA*)


loadILI[name2_,name_]:={
zw1=Import[name];
zw2=zw1[[3;;-1,{3,4,5}]];
zw3 = Select[ zw2,#[[1]]>2002&][[40;;-1]];
zw4=Table[  
     Join[
      {{k,0,0,0}},
      Select[ zw3, k==#[[1]]\[And] 40<= #[[2]]&],
      Select[ zw3, k+1==#[[1]]\[And]  #[[2]]<= 39&]
      ],
    {k,2003,2016}
];
Table[
     {
        {name2,"  ",zw4[[i,1,1]]},
        {null},
        Table[
          {zw4[[i,j,2]],j*7-7,  1000 * zw4[[i,j,3]]},
        {j,1,Length[zw4[[i]]] } 
        ]
      },
  {i,1,Length[zw4]}
]
}[[1]]


SCAN = Flatten[
Join[
  {  loadILI["National","ILINet-national.csv"] },
  Table[
   loadILI[ StringJoin[{"Region ",ToString[reg]}], StringJoin[{"ILINet-reg",ToString[reg],".csv"}]],
   {reg,1,10}]
   ],1
   ];


peakcrit=Position[
Table[
Boole[
10<= peak[   SCAN[[kk,3,All,2;;3]]  ][[1]]<= 36-8
],
{kk,1,Length[SCAN]   }],
1
][[All,1]];


(* ::Subsubsection:: *)
(*Calc*)


(*  at -f ./run.sh 3:33 jan 17  *)


TOTALPOP=100000;
NUMBERGRIDPOINTS=1000;
NUMBERPOSTSAMPLES=100;
MAXKERNELS=15;
FOLDER="mss-04/";
RESAMPLINGQ="TRUE";
RESAMPCRIT = "Neff";   (* choice: IMIS, Neff,  else *)
RESAMPSTATE="NO";
imisBB=Max[ 50, NUMBERGRIDPOINTS/10];
imisJJ= NUMBERGRIDPOINTS;
imisFAC=2./4;
CUT=1000;
lnaupdate="FALSE";
oufc[];


CloseKernels[];LaunchKernels[MAXKERNELS];


SeedRandom[1];
RANGE= {{10,500},{1.5,7},{1.3,4},{0.8,1.2},{70000,97000},{500,2000},{1,2},{1,2},{1,2},{1,2}};
grid=RandomReal[UniformDistribution[RANGE],10000];
grid[[All,7;;8]]=grid[[All,5;;6]];
grid[[All,-1]]= Table[ 1,{i,1,Length[grid]}];


(*Table[
If[ 
Divisible[ seas,25], 
CloseKernels[];LaunchKernels[MAXKERNELS];
ParallelTable[     Off[Inverse::luc],    {k,1,MAXKERNELS}];
];
Print["********"," Seas =  ",seas, "    : ", q[t]];
If[ SCAN[[seas,1,3]]!= 2009,
SetUpRegHumid[ Position[ regions, SCAN[[seas,1,1]] ][[1,1]]  ];
loop[ (*peak[ SCAN[[seas ,3,All,2;;3]]]  [[1]]+8*)36 (*imax*) ,seas (*season*),10  ] 
],
{seas,1 , Length[SCAN],1}
]

 *)


(* ::Subsubsection:: *)
(*Compose pandemics*)


pandemic0=Select[ SCAN,#[[1,3]]==2008\[Or] #[[1,3]]==2009&];
cities=pandemic0[[1;;-1;;2,1,1]];


SCAN=pandemics=Flatten[
Table[
zw1=Select[ pandemic0, #[[1,1]]==cities[[i]] &];
zw10=zw1;
zw10[[2,3,All,2]]= zw10[[2,3,All,2]]+364+7;

{
{{ cities[[i]],"  ","firstwave"},{null}, zw1[[1,3,29-1;;-1]]  },
{{ cities[[i]],"  ","secondwave"},{null}, Join[  zw1[[1,3,46-1;;-1]], zw10[[2,3,2;;-19]]  ]  },
{{ cities[[i]],"  ","fullpandemic"},{null}, Join[  zw1[[1,3,29-1;;-1]], zw10[[2,3,2;;-19]]  ]  }
},
{i,1,Length[cities]}
],
1];


firstwave=Position[ SCAN[[All,1,3]],"firstwave"][[All,1]];
secondwave=Position[ SCAN[[All,1,3]],"secondwave"][[All,1]];
fullpandemic=Position[ SCAN[[All,1,3]],"fullpandemic"][[All,1]];


(* ::Subsubsection:: *)
(*Calc*)


TOTALPOP=100000;
NUMBERGRIDPOINTS=1000;
NUMBERPOSTSAMPLES=100;
MAXKERNELS=15;
FOLDER="mss-04_pandemic/";
RESAMPLINGQ="TRUE";
RESAMPCRIT = "Neff";   (* choice: IMIS, Neff,  else *)
RESAMPSTATE="NO";
imisBB=Max[ 50, NUMBERGRIDPOINTS/10];
imisJJ= NUMBERGRIDPOINTS;
imisFAC=2./4;
CUT=1000;
lnaupdate="FALSE";
oufc[];


CloseKernels[];LaunchKernels[MAXKERNELS];


SeedRandom[1];
RANGE = {{10,500},{1.5,7},{1.3,4},{0.8,1.2},{70000,97000},{500,2000},{1,2},{1,2},{1,2},{1,2}};
grid=RandomReal[UniformDistribution[RANGE],10000];
grid[[All,7;;8]]=grid[[All,5;;6]];
grid[[All,-1]]= Table[ 1,{i,1,Length[grid]}];


ParallelTable[     Off[Inverse::luc],    {k,1,MAXKERNELS}];
Table[
   SetUpRegHumid[ Position[ regions, SCAN[[seas,1,1]] ][[1,1]]  ];
   Print["********"," Seas =  ",seas, "    : ", q[t]];
   loop[ Length[SCAN[[seas,3]]]-3 (*imax*) ,seas (*season*),10  ] ,
{seas,fullpandemic }
]
 


ParallelTable[     Off[Inverse::luc],    {k,1,MAXKERNELS}];
Table[
   SetUpRegHumid[ Position[ regions, SCAN[[seas,1,1]] ][[1,1]]  ];
   Print["********"," Seas =  ",seas, "    : ", q[t]];
   loop[ Length[SCAN[[seas,3]]]-3 (*imax*) ,seas (*season*),10  ] ,
{seas,firstwave }
]


ParallelTable[     Off[Inverse::luc],    {k,1,MAXKERNELS}];
Table[
   SetUpRegHumid[ Position[ regions, SCAN[[seas,1,1]] ][[1,1]]  ];
   Print["********"," Seas =  ",seas, "    : ", q[t]];
   loop[ Length[SCAN[[seas,3]]]-3 (*imax*) ,seas (*season*),10  ] ,
{seas,secondwave }
]
 



