(* ::Package:: *)

(******************************************************************)
(*******Copyright Christoph Zimmer/Yale University**********)
(******************************************************************)


(* ::Subsection:: *)
(*All*)


(* ::Subsubsection:: *)
(*Initial*)


SetDirectory[ directory= "/home/cz/christoph-zimmer/Projects/filter-degeneracy_GFT-data/GFT-10/" ];


Get["MSS-realdata_14.m"]


(* ::Subsubsection::Closed:: *)
(*Load DATA*)


Alldata=Import["ILI+data_final.xlsx"][[1]];


pos=Position[
 Round[ Alldata[[4;;-1,2]],10000]/10000  ,
40
][[All,1]];


DATA0=Flatten[
Table[
zw1=Alldata[[ All,{2,loc}]];
zw2=zw1[[4;;-1]];
aba=Table[
{
{ zw1[[3,2]],"   ", Mod[ zw2[[1+52*(year-1) ,1]],10000]},
{null},
Table[  
{  zw2[[k,1]],7(k-pos[[year]]),zw2[[k,2]]},
{k,pos[[ year]],pos[[year+1]]-1  }
]
},
{year,1,11}
],
{loc,3,123}
],
1];


availa=Position[
Table[
zz1=Boole[
Table[
NumberQ[   DATA0[[kk,3,jj,3]]  ],
{jj,1,Length[  DATA0[[kk,3]]  ]}
]
];
zz2=Product[ zz1[[k]],{k,1,Length[zz1]}],
{kk,1,Length[DATA0]   }],
1][[All,1]];


AnchorageHonolulu=Join[  Position[ DATA0, "Honolulu, HI "] ,   Position[ DATA0, "Anchorage, AK "]   ][[All,1]];


rest=Intersection[
Complement[
 Table[i,{i,1,Length[DATA0]}],
 AnchorageHonolulu
],
availa
];
SCAN=DATA0[[rest]];


peakcrit=Position[
Table[
Boole[
10<= peak[   SCAN[[kk,3,All,2;;3]]  ][[1]]<= 36-8
],
{kk,1,Length[SCAN]   }],
1
][[All,1]];


(* ::Subsubsection:: *)
(*Calc*)


(*  at -f ./run.sh 3:33 jan 17  *)


TOTALPOP=100000;
NUMBERGRIDPOINTS=1000;
NUMBERPOSTSAMPLES=100;
MAXKERNELS=15;
FOLDER="mss-02_standard/";
RESAMPLINGQ="TRUE";
RESAMPCRIT = "Neff";   (* choice: IMIS, Neff,  else *)
RESAMPSTATE="NO";
imisBB=Max[ 50, NUMBERGRIDPOINTS/10];
imisJJ= NUMBERGRIDPOINTS;
imisFAC=2./4;
CUT=1000;
lnaupdate="FALSE";
oufc[];


SeedRandom[1];
RANGE = {{365,3650},{1.5,7},{1.3,4},{0.8,1.2},{50000,70000},{1,100},{1,2},{1,2},{1,2},{1,2}};
grid=RandomReal[UniformDistribution[RANGE],10000];
grid[[All,7;;8]]=grid[[All,5;;6]];
grid[[All,-1]]= Table[ 1,{i,1,Length[grid]}];
(**)


CloseKernels[];LaunchKernels[MAXKERNELS];







bigcities= Flatten[   Table[  Position [ SCAN[[All,1,1]],city  ][[All,1]],{city,{ "Chicago, IL ","New York, NY ","Miami, FL ","Los Angeles, CA ","San Francisco, CA ","New Orleans, LA ","Houston, TX ","Washington, DC ILI+","Kansas City, MO ","Seattle, WA "}}],1];
year2013 = Position[ SCAN[[All,1,3]],2013.][[All,1]];
big2013=Intersection[ year2013,bigcities];







(*Table[
If[ 
Divisible[ seas,25], 
CloseKernels[];LaunchKernels[MAXKERNELS];
ParallelTable[     Off[Inverse::luc],    {k,1,MAXKERNELS}];
];
Print["********"," Seas =  ",seas, "    : ", q[t]];
If[  SCAN[[seas,1,3]]!= 2009,
Quiet[   SetUpHumidFunc[    SeasonToCity[ seas]   ], Syntax::com  ];
loop[ (*peak[ SCAN[[seas ,3,All,2;;3]]]  [[1]]+8*)36 (*imax*) ,seas (*season*),10  ] 
],
{seas,big2013}
]*)


(*Table[
If[ 
Divisible[ seas,25], 
CloseKernels[];LaunchKernels[MAXKERNELS];
ParallelTable[     Off[Inverse::luc],    {k,1,MAXKERNELS}];
];
Print["********"," Seas =  ",seas, "    : ", q[t]];
If[  SCAN[[seas,1,3]]!= 2009,
Quiet[   SetUpHumidFunc[    SeasonToCity[ seas]   ], Syntax::com  ];
loop[ (*peak[ SCAN[[seas ,3,All,2;;3]]]  [[1]]+8*)36 (*imax*) ,seas (*season*),10  ] 
],
{seas,1 , Length[SCAN],1}
]*)

 



Table[
If[ 
Divisible[ seas,25], 
CloseKernels[];LaunchKernels[MAXKERNELS];
ParallelTable[     Off[Inverse::luc],    {k,1,MAXKERNELS}];
];
Print["********"," Seas =  ",seas, "    : ", q[t]];
If[  SCAN[[seas,1,3]]!= 2009,
Quiet[   SetUpHumidFunc[    SeasonToCity[ seas]   ], Syntax::com  ];
loop[ (*peak[ SCAN[[seas ,3,All,2;;3]]]  [[1]]+8*)36 (*imax*) ,seas (*season*),10  ] 
],
{seas,237 , Length[SCAN],1}
]
