(* ::Package:: *)

(******************************************************************)
(*******Copyright Christoph Zimmer/Yale University**********)
(******************************************************************)


Directory[]


(* ::Subsection:: *)
(*All*)


(* ::Subsubsection::Closed:: *)
(*Peak*)


peak[da_]:={
po=Position[da[[All,2]],Max[da[[1;;-10,2]]]];
{po[[1,1]],po[[1,1]]-4,po[[1,1]]-8,po[[1,1]]-12}
}[[1]]


(* ::Subsubsection::Closed:: *)
(*Gillespie Simulation Copasi*)


modify[x0_,p_, set_, seed_,pfad_, starttime_]:= {
ab=Import["sirs-rain0.cps","Text"];
ab2=StringReplace[ ab, {
(* params*)
"IDENTIFY_L"-> ToString[  AccountingForm [  p[[1]]    ]],
"IDENTIFY_D"-> ToString[  AccountingForm [  p[[2]]    ]],
"IDENTIFY_R0max"->ToString[  AccountingForm [  p[[3]]    ]],
"IDENTIFY_R0min"->ToString[  AccountingForm [  p[[4]]    ]],
(* sim settings:  duration, stepsize , intervalls *)
"IDENTIFY_duration"->ToString[ set[[1]]  ],
"IDENTIFY_stepsize"-> ToString[   set[[2]]  ],
"IDENTIFY_steps"-> ToString[   set[[1]]/set[[2]] 1.   ],
(* rs seed *)
"IDENTIFY_seed"->ToString[  AccountingForm [  seed]],
(* ivs *)
"IDENTIFY_s0"->ToString[  AccountingForm [  x0[[1]]   ]],
"IDENTIFY_i0"->ToString[  AccountingForm [  x0[[2]]   ]],
(* starttime *)
"IDENTIFY_starttime"->ToString[  AccountingForm [  starttime   ]],
(* qt Rain function Variables *)
"qtVARa"->ToString[AccountingForm[ qtVAR[[1]]  ]],
"qtVARc"->ToString[AccountingForm[qtVAR[[2]]  ]],
"qtVARd"->ToString[AccountingForm[  qtVAR[[3]]]]
}];
Export[ StringJoin[{pfad,"/1rs.cps"}]  ,ab2,"Text"];
}[[1]]


simgill[x00_,p_,starttime_,set_,seed_]:={
(*  set= (duration, stepsize )  *)
time1=AbsoluteTiming[
x0=Round[x00];
pfad1=StringJoin[{"Copasi",ToString[$KernelID],"temp-",FOLDER}];
SetDirectory[StringJoin[{directory,"/Copasi-Code"}]  ];
If[ DirectoryQ[pfad1], DeleteDirectory[pfad1,DeleteContents->True]  ];
CreateDirectory[pfad1];
];
(*ReadList[StringJoin[ {"!mkdir ",pfad1}],String];*)
time2=AbsoluteTiming[
modify[ x0, p,set,seed,pfad1,starttime];
];
time3=AbsoluteTiming[
CopyFile["rssimul.py", StringJoin[{pfad1,"/rssimul.py"}]];
(*ReadList[ StringJoin[ {   "!cp rssimul.py ", pfad1,"/"}],String];*)
SetDirectory[ StringJoin[{Directory[],"/",pfad1} ]   ];
(*ReadList[ StringJoin[ {   "!chmod 700 ", "1rs.cps"}],String];*)
];
time4=AbsoluteTiming[
ReadList["!./rssimul.py",String];
];
time5=AbsoluteTiming[
zr0= Drop[Import["asdf1.txt","Table"],1];
SetDirectory[StringJoin[{directory,"/Copasi-Code"}]];
DeleteDirectory[pfad1,DeleteContents->True];
(*ReadList[StringJoin[{"!rm -r ",pfad1}],String];*)
SetDirectory[directory];
];
zr0 
}[[1]]


(*simgill[ {60000,100},{1000,3,3,1},273,{50,7},1]*)


(* ::Subsubsection::Closed:: *)
(*LNA*)


sirs2lna[x0_,p_,T_,N_]:=
{
{L,DD,Rmax,Rmin}=p;
t1=-T[[1]];
s1=NDSolve[ 
{
Sus'[t]==(N-Inf[t]-Sus[t])/L-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] Sus[t])/(DD N),
Inf'[t]==-(Inf[t]/DD)+((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] Sus[t])/(DD N),
Rec1'[t]== Inf[t]/DD,

sigma1'[t]==2 (-(1/L)-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t])/(DD N)) sigma1[t]+(N-Inf[t]-Sus[t])/L+((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] Sus[t])/(DD N)+2 sigma12[t] (-(1/L)-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Sus[t])/(DD N)),
sigma12'[t]==((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] sigma1[t])/(DD N)+(-(1/L)-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t])/(DD N)) sigma12[t]-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] Sus[t])/(DD N)+sigma2[t] (-(1/L)-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Sus[t])/(DD N))+sigma12[t] (-(1/DD)+((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Sus[t])/(DD N)),
sigma13'[t]== sigma12[t]/DD+(-(1/L)-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t])/(DD N)) sigma13[t]+sigma23[t] (-(1/L)-((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Sus[t])/(DD N)),
sigma2'[t]==Inf[t]/DD+(2 (E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] sigma12[t])/(DD N)+((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] Sus[t])/(DD N)+2 sigma2[t] (-(1/DD)+((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Sus[t])/(DD N)),
sigma23'[t]== -(Inf[t]/DD)+((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Inf[t] sigma13[t])/(DD N)+sigma2[t]/DD+sigma23[t] (-(1/DD)+((E^(-180 q[t-t1]) (Rmax-Rmin)+Rmin) Sus[t])/(DD N)),
sigma3'[t]== Inf[t]/DD+(2 sigma23[t])/DD,
(* *)
Sus[0]==x0[[1]],
Inf[0]==x0[[2]],
Rec1[0]== 0,
sigma1[0]==x0[[5]],
sigma12[0]==x0[[8]],
sigma13[0]==x0[[9]],
sigma2[0]==x0[[6]],
sigma23[0]==x0[[10]],
sigma3[0]==x0[[7]]
},
{Sus,Inf,Rec1,sigma1,sigma12,sigma13,sigma2,sigma23,sigma3},
{t,0,T[[2]]-T[[1]]},
"Method"->{"EquationSimplification"->{Automatic,"TimeConstraint"->100}}
];
zw2=Evaluate[
{
Sus[t]/.s1,
Inf[t]/.s1,
Rec1[t]/.s1,
sigma1[t]/.s1,
sigma2[t]/.s1,
sigma3[t]/.s1,
sigma12[t]/.s1,
sigma13[t]/.s1,
sigma23[t]/.s1
}
]/.{t->T[[2]]-T[[1]]}
}[[1,All,1]]


(* ::Subsubsection::Closed:: *)
(*Prepare integration*)


SeedRandom[1];
Rset0=RandomReal[ MultinormalDistribution[ {0,0,0},DiagonalMatrix[{1,1,1}]],10000];


intfun[  mean_,cov_, bounds_,newly_,NN_,old_,absnoise_]:= { 
SeedRandom[1];
(*rset=RandomReal[  MultinormalDistribution[ mean[[1;;3]],cov],10000];*)
rset=Transpose[Transpose[ Rset0.MatrixPower[cov,.5]   ]+ mean[[1;;3]]   ];
newlyset= rset[[All,2]] - old[[2]] + rset[[All,3]];
(*newlyset=Table[ rset[[i,2]]-old[[2]]+ rset[[i,3]] ,{i,1,Length[rset]}];*)
me=Mean[newlyset];
stde=StandardDeviation[newlyset];
If[ absnoise>0,
dist=NormalDistribution[ me,stde + absnoise   ];,
dist=NormalDistribution[ me,stde];
];
If[Quantile[ dist,.01]>0,
PDF[dist,newly],
If[  Quantile[ dist,1-10^-6.]<0,
10.^-100,
PDF[TruncatedDistribution[{-10^-10.,NN}, dist],newly]
]
]
}[[1]]


(* ::Subsubsection::Closed:: *)
(*MSS*)


objSIRS[dat0weeks_,p1L_?NumberQ,p2D_?NumberQ,p3R0max_?NumberQ,p4R0min_?NumberQ,absnoise00_,x0_,var0_,NN_]:={
dat=dat0weeks;
For[
{it=1,y=zw1=xi0=Join[x0,{0},{NN-Total[x0]} ,var0 ],dt=dat[[2,1]]-dat[[1,1]],likelitab={1},newly=0,tabbnu={{}}  ,me2=1,flag=0,me=0},
it<Length[dat],
{ 
tabbnu=Join[tabbnu,{  Join[{dat[[it-1,1]]},y  ,{bounds} ,{newly},{me} ] }];
old=y;
(*If[ old[[2]]<0,y=zw1[[1;;3]];flag=1,flag=0  ];*)
(**)
If[  lnaupdate=="FALSE",y[[5;;-1]]=Table[0,{kk,1,6}]];
y[[{7,9,10}]]=0;
zw1=sirs2lna[ y      ,{p1L,p2D,p3R0max,p4R0min},{dat[[it-1,1]],dat[[it,1]]}+39*7,NN];
zw1[[4;;6]]={Max[10.^-6,zw1[[4]]],Max[10.^-6,zw1[[5]]], Max[10^-6,zw1[[6]]]  };
newly=dat[[it,2]];
If[newly<10,absnoise=100,  absnoise=absnoise00 ];
(* calculate estimate of state *)
cov={zw1[[{4,7,8}]],zw1[[{7,5,9}]],zw1[[{8,9,6}]] };
invcov=Inverse[cov];
If[ absnoise>0,
func= Simplify[({ sus1,inf1,rec01 } - zw1[[1;;3]] ).invcov.({ sus1,inf1,rec01 } - zw1[[1;;3]] ) + (inf1-old[[2]]+rec01-newly)^2/(  absnoise)^2];
ab2=Solve[ { D[func,sus1]==0,D[func,inf1]==0,D[func,rec01]==0},{sus1,inf1,rec01}][[1,All,2]];,
func= Simplify[({ sus1,inf1,newly-inf1+old[[2]] } - zw1[[1;;3]] ).invcov.({ sus1,inf1,newly-inf1+old[[2]] } - zw1[[1;;3]] )];
ab2=Solve[ { D[func,sus1]==0,D[func,inf1]==0},{sus1,inf1}][[1,All,2]];
];
RR={0,1,1}.cov.{0,1,1}+absnoise^2;
KK= cov.{0,1,1}  RR^-1;
varpost=cov- Table[  KK[[ii]]KK[[j]] RR,{ii,1,3},{j,1,3}];
(*Print[varpost-cov];*)
var00={ varpost[[1,1]],varpost[[2,2]],varpost[[3,3]],varpost[[1,2]],varpost[[1,3]],varpost[[2,3]]};
(* correct if necessary *)
bounds= { 
{  10^-6.,   NN-1.   },{ 10^-6.,NN(*Min[ newly+ old[[2]],NN ]*) (*x0[[2]]+Sum[dat[[ll,2]],{ll,1,it}]*)}
};
sus = Min[   Max[10^-5.,ab2[[1]]    ], bounds[[1,2]]     ];
inf = Min[   Max[10^-5.,ab2[[2]]    ], bounds[[2,2]]     ];
If[ absnoise>0,
rec= Min[  Max[10^-5. ,ab2[[3]]   ], TOTALPOP-1   ];,
rec= Max[0,newly-inf+ old[[2]]   ];
];
(* calculate probability *)
If[lnaupdate=="FALSE",
fwert=intfun[   zw1[[1;;3]],  cov ,  bounds,newly,NN , y,absnoise],
fwert= PDF[NormalDistribution[  zw1[[2]] + zw1[[3]] - old[[2]] , Sqrt[ RR]  ], newly]
];
(*Print[   ( (zw1[[2]] + zw1[[3]] - old[[2]])-newly)/Sqrt[RR]];*)
(**)
ab3={ sus,inf, rec };
(**)
likelitab= Join[ likelitab,{fwert}];
y= Join[ {sus,inf,rec,NN-sus-inf-rec} , If[ lnaupdate=="FALSE",zw1[[4;;-1]](*var00*),var00]     ];
},
it++];
tabbnu=Join[tabbnu,{  Join[{dat[[it,1]]},y  ,{bounds} ,{newly}  ,{me}] }];
tabbnu=Drop[tabbnu,1];
Product[ likelitab[[i]] ,{i,2,Length[likelitab]}]
}[[1]];


(* ::Subsubsection::Closed:: *)
(*Forward step *)


forwardstep[data_,i_,list1_,seas_,absnoise_]:={
Print[ i,"  ",DateString[] ];
time1=AbsoluteTiming[
tab1= ParallelTable[
(*Print["i",i,"   k",k];*)
If[ i>2,
{pa1,pa2,pa3,pa4,sus0,inf0,sust,inft,vart}=list1[[k,1;;-3]],
{pa1,pa2,pa3,pa4,sus0,inf0,sust,inft}=list1[[k,1;;-3]];
vart=Table[0,{l,1,6}] 
 ];
incre=objSIRS[ data[[i-1;;i ]] ,pa1 ,pa2,pa3,pa4,absnoise,{sust,inft},vart, TOTALPOP];
Join[  {pa1,pa2,pa3,pa4,sus0,inf0,tabbnu[[-1,2]],tabbnu[[-1,3]],tabbnu[[-1,6;;11]],(* variance I *)null},{list1[[k,-1]]*incre},{tabbnu } ],
{k,1,Length[list1]  }];
output00=Table[  Join[ tab1[[j,1;;-3]], {tab1[[j,11]]}   ],{j,1,Length[tab1]}];
];(*Print[time1];*)
(**)
time2=AbsoluteTiming[
If[ RESAMPLINGQ=="TRUE", 
If[  RESAMPCRIT =="IMIS",
output=IMIS[output00 , imisBB, absnoise,i];,
If[ RESAMPSTATE=="STATE",
output=resamplingSTATE[output00,i,NUMBERGRIDPOINTS,absnoise];,
output=resampling[output00,i,NUMBERGRIDPOINTS,absnoise];
]
],
output=output00;
];
];(*Print[time2];*)
(*Print[ Length[ Union[ output[[All,1]]]]];*)
(* output degeneracy measure *)
time3=AbsoluteTiming[
degenmeas[output,seas,i];
];(*Print[time3];Abort[];*)
(*   prediction  *)
(*If[forwardIT\[Equal]17,Abort[]];*)
time4=AbsoluteTiming[
evaluation[output,i,seas,absnoise];
];
(**)
timetable=Join[timetable,{{time1,time2,time3,time4}}];
output
}[[1]]


(* ::Subsubsection:: *)
(*resampling *)


resampling[tab1_,i_,nsamples_,absnoise_]:={
(* Normalize *)
tab2=tab1;tab2[[All,-1]]=tab2[[All,-1]]/Total[tab1[[All,-1]]];
If[ RESAMPCRIT== "LRq",
(* Calculate LR quantile *)
ab=Exp[  Log[ Max[ tab2[[All,-1]]  ]  ] - Quantile[  ChiSquareDistribution[6],.95]  ];
(* Select points within quantile *)
tab3=Select[  tab2, #[[-1]]>ab &];
crit=( Length[tab3] < NUMBERGRIDPOINTS/4);,
Neff= Total[ tab2[[All,-1]]^2]^-1;
crit= ( Neff<= NUMBERGRIDPOINTS/2)
];
(* IF too many points outside, enter re sampling procedure *)
If[ 
crit,
{
Print["      Resampling "]  ;
(* Re sample from current distribution    *)
SeedRandom[  i];
rr=RandomChoice[ tab1[[All,-1]]-> tab1[[All,1;;6]]   ,NUMBERGRIDPOINTS  ];
If[ 
Length[Union[rr]]==1,
Print["warning: still degenerated"]; 
rr= rr+ RandomReal[NormalDistribution[0,.001],{Length[rr],6}]
];
(*skd=KernelMixtureDistribution[rr,{100,.1,.1,.025,1000, 10.  },MaxMixtureKernels->5];*)
skd=KernelMixtureDistribution[rr,{100,.5,.5,.025,1000, Median[ rr[[All,-1]]]  },MaxMixtureKernels->5];
(*skd=KernelMixtureDistribution[rr,{100,.1,.1,.025,1000, Median[ rr[[All,-1]]]  },MaxMixtureKernels->5];*)
(*  Suggest new points according to this distribution *)
SeedRandom[  i];
rrnew=  RandomReal[TruncatedDistribution[ RANGE[[1;;6]] ,skd],nsamples]  ;
(* Let's see how good these suggestions actually are *)
tab1fd=ParallelTable[  
(*Print[k];*)
{pa1,pa2,pa3,pa4,sus0,inf0}=rrnew[[k]];
zy1=objSIRS[ data[[1;;i ]] ,pa1 ,pa2,pa3,pa4,absnoise,{sus0,inf0},{0,0,0,0,0,0}, TOTALPOP];
 {pa1,pa2,pa3,pa4,sus0,inf0,tabbnu[[-1,2]],tabbnu[[-1,3]],tabbnu[[-1,6;;11]],null,NUMBERGRIDPOINTS^-1  },
{k,1, Length[rrnew]}];
(*  *)
tab1fd
}[[1]],
(* else do nothing *)
zx1=Table[  Join[ tab1[[j,1;;-2]], {tab1[[j,11]]}   ],{j,1,Length[tab1]}];
zx1[[1;;nsamples]]
]
}[[1]]


resamplingSTATE[tab1_,i_,nsamples_,absnoise_]:={
(* Normalize *)
tab2=tab1;tab2[[All,-1]]=tab2[[All,-1]]/Total[tab1[[All,-1]]];
If[ RESAMPCRIT== "LRq",
(* Calculate LR quantile *)
ab=Exp[  Log[ Max[ tab2[[All,-1]]  ]  ] - Quantile[  ChiSquareDistribution[6],.95]  ];
(* Select points within quantile *)
tab3=Select[  tab2, #[[-1]]>ab &];
crit=( Length[tab3] < NUMBERGRIDPOINTS/4);,
Neff= Total[ tab2[[All,-1]]^2]^-1;
crit= ( Neff<= NUMBERGRIDPOINTS/2)
];
(* IF too many points outside, enter re sampling procedure *)
If[ 
crit,
{
Print["      Resampling "]  ;
(* Re sample from current distribution    *)
SeedRandom[  i];
rr=RandomChoice[ tab1[[All,-1]]-> tab1[[All,{1,2,3,4,7,8}]]   ,NUMBERGRIDPOINTS  ];
skd=KernelMixtureDistribution[rr,{100,.1,.1,.025,1000, 10.  },MaxMixtureKernels->5];
(*  Suggest new points according to this distribution *)
SeedRandom[  i];
rrnew=  RandomReal[TruncatedDistribution[ {{365,3650},{1.5,7},{1.3,4},{0.8,1.2},{50000,70000},{10,100}},skd],nsamples]  ;
(* Let's see how good these suggestions actually are *)
tab1fd=Table[  
(*Print[k];*)
{pa1,pa2,pa3,pa4,St,It}=rrnew[[k]];
zx=Covariance[rr];
zy={ zx[[5,5]],zx[[6,6]],0,zx[[5,6]],0,0};
 {pa1,pa2,pa3,pa4,null,null,St,It,zy,null,NUMBERGRIDPOINTS^-1  },
{k,1, Length[rrnew]}];
(*  *)
tab1fd
}[[1]],
(* else do nothing *)
zx1=Table[  Join[ tab1[[j,1;;-2]], {tab1[[j,11]]}   ],{j,1,Length[tab1]}];
zx1[[1;;nsamples]]
]
}[[1]]


(* ::Subsubsection::Closed:: *)
(*imis resampling*)


(*covcheck[matr_]:={
If[
Min[Eigenvalues[matr]]\[LessEqual] 0 \[Or] PositiveDefiniteMatrixQ[ matr]\[Equal]False,
{
covjter=0; matr1=matr;
While[ 
 If[
Total[ Abs[ Im[ Eigenvalues[ matr1 ]  ]    ]]>0,
True,
If[ Min[Eigenvalues[matr1]]\[LessEqual] 0\[Or] Total[Eigenvalues[matr1]]<10^-6.\[Or]PositiveDefiniteMatrixQ[matr1]\[Equal]False,
True,
False
]],
{
SeedRandom[covjter];
bb=RandomReal[ NormalDistribution[1,.0001],{6,6}];
matr1=bb Transpose[bb]  matr1;
};
covjter++
];
Print[ DateString[], "      Cov adjust active   ", covjter];
matr1
}[[1]],
matr
]
}[[1]]*)


(*covbuild[ co_,tc_, NNkk_]:={
matr1=co;covjter=0;
While[
PositiveDefiniteMatrixQ[matr1]\[Equal]False ,
{
SeedRandom[covjter];
matr1=Covariance[ RandomChoice[  WeightedData[  tc4[[All,1;;6]],1/2( tc4[[All,-2]]+1/NNkk) ],100000   ]  ];
If[ 1<covjter<11,Print[ Total[ matr1] ]   ];
};
covjter++
];
If[covjter\[GreaterEqual] 1, Print[ "Use of sampling for weighted cov  ",covjter] ];
matr1
}[[1]]*)


imischeck[inpu_, newsamples_]:= {
weights=Union[ inpu][[All,-1]];
abc=weights;
abc=abc/Total[ abc];
Total[  1-Table[  1- abc[[k]],{k,1,Length[abc]}]^newsamples  ]/newsamples
}[[1]]


priov=Diagonal[  Covariance[  UniformDistribution[{{365,3650},{1.5,7},{1.3,4},{0.8,1.2},{50000,70000},{10,100}}]  ]   ];


mahad[ x_,y_]:= Sum[ (x[[k]]-y[[k]])^2/priov[[k]],{k,1,Length[x]}]


samplesuggestion[ inpu_, BB_ , NNkk_]:={
po=Position[  inpu, Max[inpu[[All,-1]]]  ][[1,1]];
(* calculate mahabo distance *)
tc1=Table[ Join[ inpu[[k]],{mahad[  inpu[[po , 1;;6]] , inpu[[k,1;;6]]   ]}  ],{k,1,Length[inpu]}];
(* and sort *)
tc2=Sort[tc1,#1[[-1]]<#2[[-1]]&];
(* and take the BB closest and normalize weights *)
tc3=tc2;
tc3[[All,-2]]=tc3[[All,-2]]/Total[ tc3[[All,-2]]];
tc4=tc3[[1;;Min[ BB, Length[tc3]]   ]];
(* calculate weighted covariance of the BB closest *) 
co=Covariance[  WeightedData[  tc4[[All,1;;6]],1/2( tc4[[All,-2]]+1/NNkk) ]  ];
(*co= covbuild[ co, tc4, NNkk];*)
(* sample from that *)
hk=TruncatedDistribution[
{{365,3650},{1.5,7},{1.3,4},{0.8,1.2},{50000,70000},{10,100}},
 MultinormalDistribution[  inpu[[po,1;;6]],(*covcheck[ *)    Table[ co[[i,j]],{i,1,6},{j,1,6}]     (*]*)   ]
];
RandomReal[  hk   ,BB ]
}[[1]]


Qk[x_,BB_, NNkk_,hk_]:={
w1=Length[output00]/ (NNkk)   ;pd1=PDF[  UniformDistribution[ {{365,3650},{1.5`,7},{1.3`,4},{0.8`,1.2`},{50000,70000},{10,100}}],x];
pd2=BB/NNkk Sum[PDF[MultinormalDistribution[hktab[[k,2,1]],(*covcheck[*)  hktab[[k,2,2]]]   (*]*),x]  ,{k,2,Length[hktab]}];
w1 pd1+ pd2
}[[1]]


evalsuggestion[sugg_ ,BB_,NNkk_,hk_,absnoise_,i_]:={
(* how good are the suggestions *)
tab1fd= ParallelTable[  
(*Print[k];*)
{pa1,pa2,pa3,pa4,sus0,inf0}=sugg[[k]];
zy1=objSIRS[ data[[1;;i ]] ,pa1 ,pa2,pa3,pa4,absnoise,{sus0,inf0},{0,0,0,0,0,0}, TOTALPOP];
 {pa1,pa2,pa3,pa4,sus0,inf0,tabbnu[[-1,2]],tabbnu[[-1,3]],tabbnu[[-1,6;;11]],null,zy1  },
{k,1, Length[sugg]}];
(* join with previous *)
te1star=td1=Join[  te1star, tab1fd];
(* do some weighting *)
td2=td1;
tddiv=Table[Qk[td2[[k,1;;6]],BB,NNkk,hktab],{k,1,Length[td2]}];
(*Print[hktab[[-1,2]]];*)
td2[[All,-1]]=td2[[All,-1]]/tddiv;
td2[[All,-1]]=td2[[All,-1]]/Total[td2[[All,-1]]];
td2
}[[1]]


 


nextitnewsamp[ sugg_]:={
(* select the new sample *)
td3= RandomChoice[  sugg[[All,-1]]-> sugg , NUMBERGRIDPOINTS ];
(* equal weights *)
td4=Tally[td3];
td4[[All,1,-1]]=1.td4[[All,-1]]/ NUMBERGRIDPOINTS;
td4[[All,1]]
}[[1]]


IMIS[ inpu_,BB_,absnoise_,i_]:={
SeedRandom[i];
te1=inpu;
iter=0;
NNkk=Length[inpu](*NUMBERGRIDPOINTS*)+BB;
(*hkold={null,{Table[0,{kk,1,6}],Table[0,{kk,1,6},{ll,1,6}]}};*)
hktab={null};
(**)
If[
ichec=imischeck[  te1 , imisJJ  ];
ichec<imisFAC( 1.-1/Exp[1]),
te1star=te0star=ParallelTable[  
(*Print[k];*)
{pa1,pa2,pa3,pa4,sus0,inf0}=te1[[k,1;;6]];
zy1=objSIRS[ data[[1;;i ]] ,pa1 ,pa2,pa3,pa4,absnoise,{sus0,inf0},{0,0,0,0,0,0}, TOTALPOP];
 {pa1,pa2,pa3,pa4,sus0,inf0,tabbnu[[-1,2]],tabbnu[[-1,3]],tabbnu[[-1,6;;11]],null,zy1  },
{k,1, Length[te1]}];
];
(**)
While[
ichec=imischeck[  te1 , imisJJ  ];
ichec<imisFAC( 1.-1/Exp[1]),
{
Print[iter,"  ",ichec,"  ", NNkk];
(*If[iter\[Equal]1,Abort[]];*)
cde=samplesuggestion[ te1 , BB,NNkk];
hktab=Join[hktab,{hk}];
(*Print[c];If[iter\[Equal]1,Abort[]];*)
te1=evalsuggestion[  cde, BB,NNkk,hk ,absnoise,i];
NNkk= NNkk+ BB;
hkold=hk;
};
iter++
];
nextitnewsamp[ te1]
}[[1]]


(* ::Subsubsection:: *)
(*Evaluation and Prediction*)


leadweek[set_,cut_]:={
ta1=Table[ set[[i;;i+2]],{i,1,Length[set]-2}];
ta2=Select[ ta1, #[[1,2]]>cut\[And]#[[2,2]]>cut\[And]#[[3,2]]>cut&];
If[  Length[ta2]>0, ta2[[1,1,1]], set[[-1,1]]   ]
}[[1]]


IRE[ true_,ests_]:=100 Mean[ Abs[       Table[ ests[[l]]- true,{l,1,Length[ests]}]     ] ]/ true


RE[ true_,ests_]:=100 Abs[       Mean[ ests]- true ]   / true


AE[true_,ests_]:= Abs[ Mean[ests]-true]


metrics[ name_, true_, ests1_]:={ 
SeedRandom[forwardIT];
If[ 
Length[  Union[   ests1   ]   ] ==1,
ests= ests1 + RandomReal[ NormalDistribution[0,0.01],Length[ests1] ],
ests=ests1     
];
(*skd=TruncatedDistribution[ Select[  namerange, #[[1]]\[Equal]name&][[1,2]], SmoothKernelDistribution[ ests] ];*)
skd=  SmoothKernelDistribution[ ests] ;
{name,"true",true,"post-mean",Mean[skd],"confid",Quantile[ skd,{.05,.95}],
"abs err",AE[true,ests],"rel err", RE[true,ests],"integrated RE",IRE[true,ests],
"prob mass 10%",NIntegrate[ PDF[skd,x],{x,.9true,1.1true},AccuracyGoal->8], "prob mass 1%", NIntegrate[ PDF[skd,x],{x,.99true,1.01true},AccuracyGoal->8],
"50%confid", Quantile[skd,{.25,.75}]  }
}[[1]]


metricsESTS[ name_,  ests1_]:={ 
SeedRandom[forwardIT];
If[ 
Length[  Union[   ests1   ]   ] ==1,
ests= ests1 + RandomReal[ NormalDistribution[0,0.01],Length[ests1] ],
ests=ests1     
];
(*skd=TruncatedDistribution[ Select[  namerange, #[[1]]\[Equal]name&][[1,2]], SmoothKernelDistribution[ ests] ];*)
skd=  SmoothKernelDistribution[ ests] ;
{name,"true","nA","post-mean",Mean[skd],"confid",Quantile[ skd,{.05,.95}],
"abs err","nA","rel err", "nA","integrated RE","nA",
"prob mass 10%","nA", "prob mass 1%", "nA",
"50%confid", Quantile[skd,{.25,.75}]  }
}[[1]]


rrgen[x_,absnoise_]:= Max[ 0.1, RandomReal[NormalDistribution[ x,absnoise] ]  ]


CalculateMetrics[tabforecast_,ta7_,data_,i_]:={
timeD=AbsoluteTiming[
{LLmetric, DDmetric, R0maxmetric, R0minmetric,Infmetric,leadweekmetric,peaktimemetric,peakintensmetric, newlymetric, newly3specmetric,  newly3cummetric, ARmetrics,Sus0metric,Inf0metric,Susmetric,R0metric,Reffmetric}=Parallelize[{
(**)
tabLL = ta4[[All,1]];
LLmetric= metricsESTS[ "LL", tabLL],
(**)
tabDD = ta4[[All,2]];
DDmetric= metricsESTS[ "DD", tabDD],
(**)
tabR0max = ta4[[All,3]];
R0maxmetric= metricsESTS[ "R0max", tabR0max],
(**)
tabR0min = ta4[[All,4]];
R0minmetric= metricsESTS[ "R0min", tabR0min],
(**)
tabinf = ta4[[All,6]];
Infmetric= metricsESTS[ "Inf", tabinf],
(**)
tableadweek=Table[       leadweek[ tabforecast[[l]] ,CUT   ] ,     {l,1,Length[tabforecast]}     ];
leadweektrue= Max[ 0.1, leadweek[data , CUT] ];
leadweekmetric=metrics[ "leadweek", leadweektrue, tableadweek ],
(**)
tabpeaktime=Table[       peak[ tabforecast[[l]]   ][[1]],     {l,1,Length[tabforecast]}     ];
peaktimetrue= peak[data ][[1]];
peaktimemetric=metrics[ "peaktime", peaktimetrue, tabpeaktime ],
(**)
peaktimetrue= peak[data ][[1]];
tabpeakintens=Table[    po=peak[ tabforecast[[l]]   ][[1]];      tabforecast[[l,po,2]],       {l,1,Length[tabforecast]}   ];
peakintenstrue= data[[ peaktimetrue, 2]];
peakintensmetric= metrics["peakintens",peakintenstrue,tabpeakintens],
(**)
newlytrue=Max[0.1, data[[i+1,2]] ];
newlymetric= metrics[ "newly", newlytrue , ta7[[All,1]]   ],
(**)
newly3spectrue=Max[0.1, data[[i+3,2]]  ];
newly3specmetric=metrics[  "newly3spec", newly3spectrue , ta7[[All,3]]    ],
(**)
newly3cumtrue= Max[0.1,Total[  data[[i+1;;i+3,2]]  ]];
newly3cummetric=metrics[ "newly3cum",  newly3cumtrue , ta7[[All,1]]+ ta7[[All,2]]+ ta7[[All,3]]    ],
(**)
artrue=Total[ data[[All,2]] ];
ARmetrics=metrics[  "AR",artrue,Total[  data[[1;;i,2]] ]+ Sum[ ta7[[All,j]],{j,1,Length[ta7[[1]] ]  } ]    ],
(**)
tabSus0 = ta4[[All,7]];
Sus0metric= metricsESTS[ "Sus0", tabSus0],
(**)
tabInf0 = ta4[[All,8]];
Inf0metric= metricsESTS[ "Inf0", tabInf0],
(**)
tabsus = ta4[[All,5]];
Susmetric= metricsESTS[ "Sus", tabsus],
(**)
tabR0 = (E^(-180 q[ data[[i,1]] + 39*7 ]) (ta4[[All,3]]-ta4[[All,4]])+ta4[[All,4]] );
R0metric = metricsESTS[ "R0", tabR0 ],
(**)
tabR0 = (E^(-180 q[ data[[i,1]] + 39*7 ]) (ta4[[All,3]]-ta4[[All,4]])+ta4[[All,4]] );
tabsus = ta4[[All,5]];
tabReff = tabR0 * tabsus / 100000;
Reffmetric = metricsESTS[ "Reff",tabReff]
}
];
(**)
out=N[{ LLmetric, DDmetric, R0maxmetric, R0minmetric,Infmetric,leadweekmetric,peaktimemetric,peakintensmetric, newlymetric, newly3specmetric,  newly3cummetric, ARmetrics,Sus0metric,Inf0metric,Susmetric,R0metric,Reffmetric} ];
];
(*timeE=AbsoluteTiming[
Export[ StringJoin[{FOLDER,ToString[seas],"-",ToString[i] ,"_UncCoeff-",ToString[MODELuncertCOEFF],".txt"}],  out ];
]*)
}[[1]]


evaluation[input_,i_,seas_,absnoise_]:={
Print["        evaluation  ",DateString[]];
(* Resample if this has not just happend *)
timeA=AbsoluteTiming[
ta4=RandomChoice[ input[[All,-1]]->  input  ,NUMBERPOSTSAMPLES ][[All,{1,2,3,4,7,8,5,6,9}]];
];(*Print[timeA];*)
(**)
timeB=AbsoluteTiming[
ta7= ParallelTable[
SeedRandom[ kk];
(*Print[kk];*)
iv=ta4[[kk,5;;6]];
zr00=simgill[iv,ta4[[kk,1;;4]],data[[i,1]]+39*7,{data[[-1,1]]-data[[i,1]],7},kk];
Table[  rrgen[  zr00[[j,4]]-zr00[[j-1,4]],absnoise   ],{j,2,Length[zr00]}],
{kk,1,Length[ta4]}];
];(*Print[timeB];*)
(**)
timeC=AbsoluteTiming[ tabforecast=Table[
Join[
data[[1;;i]],
Table[  {data[[ i+k,1]],ta7[[l,k]]},{k,1,Length[ta7[[1]]]}  ]
],
{l,1,Length[ta7]}];
];(*Print[timeC];*)
(**)
timeD = AbsoluteTiming[
  CalculateMetrics[tabforecast,ta7,data,i];
] ;
timeE=AbsoluteTiming[
Export[ StringJoin[{FOLDER,ToString[seas],"-",ToString[i] ,"_tab",".txt"}],  out ];
];
(*Print[{timeA,timeB,timeC,timeD,timeE}[[All,1]]]*)
}[[1]]


(* ::Subsubsection:: *)
(*Loop*)


loop[imax_,seas_,absnoise_]:={
data=SCAN[[seas,3,All,2;;3]];
timetable={{}};
For[ 
{ forwardIT=1,tab1f=grid[[1;;NUMBERGRIDPOINTS]],restab={{}}},
forwardIT< Min[imax,Length[data]],
SeedRandom[ forwardIT];

(*If[ Total[data[[1;;forwardIT,2]] ]> 50000, RANGE[[1]]={50,3650}   ]; *)

tab1f=forwardstep[data,forwardIT,tab1f,seas,absnoise];
restab=Join[restab, {ta8}];,
forwardIT++
];
Export[StringJoin[{FOLDER,ToString[seas],"-timetable.txt"}],timetable];
}[[1]]


(* ::Subsubsection::Closed:: *)
(*Function Q  *)


SeasonToCity[season_]:= {
zw1=SCAN[[season,1]];
zw2= StringReplace[  StringJoin[{"\"",StringTake[ zw1[[1]],{1,-5}],"\""}] ,
{"Piits"->"Pitts","St Pau"->"StPaul","St. Loui"->"StLouis","Washington, DC"->"Washington","Pompano Beach"->"PompanoBeach","Norfol"->"Norfolk","San Dieg"->"SanDiego"}] ;
ToExpression[  zw2  ]
}[[1]]


humidity[year_,city_]:={
zx1=Import[ StringJoin[{"../Weather_Output/weather_output_",year,".csv"}],"Table"];
If[ ToExpression[ year] == 1981, (* read error data *)
   zx2 = zx1981;,
   (*poss = Join[ {0}, StringPosition[ zx1[[98]], "\r" ][[1,All,1]] , {StringLength[ zx1[[98]]][[1]]+1 }  ];
   readerrorpart = Table[
         zz100=StringTake[  zx1[[98]], {poss[[i]]+1,poss[[i+1]]-1}][[1]] ;
         ToExpression[StringJoin[{"{", zz100, "}"}] ] ,
        {i,1,Length[poss]-1}
     ]; 
   zx1[[1]] = ToExpression[ StringReplace[ ToString[zx1[[1]]] ,{ ", ,"->",", "SanDiego, CA"->"SanDiego_CA","Norfolk, VA"->"Norfolk_VA","SanDiego CA"->"SanDiego_CA"}] ];
   zx2 = Join[ {zx1[[1]]}, ToExpression[ToString[ zx1[[2;;97]] ]], readerrorpart, ToExpression[ ToString[ zx1[[100;;-1]] ] ]  ];, (* if not 1981 *)
*)If[ ToExpression[year]<= 1982,
zx2=ToExpression[ StringReplace[ ToString[zx1] ,{ ", ,"->",", "SanDiego, CA"->"SanDiego_CA","Norfolk, VA"->"Norfolk_VA","SanDiego CA"->"SanDiego_CA"}] ];,
zx2=ToExpression[StringReplace[   ToString[ zx1],{"\""->"", "SanDiego, CA"->"SanDiego_CA","Norfolk, VA"->"Norfolk_VA","SanDiego CA"->"SanDiego_CA"}]  ];
];
];
zx3=Table[ StringTake[ ToString[zx2[[1,i]]],{1,-4}],{i,1,Length[zx2[[1]]]   }];
pos1=Position [  zx3 ,  StringReplace[ city," "->""]    ][[1,1]];
zx2[[2;;-1,pos1]]
}[[1]]


f[a_,b_,c_,d_,t_]:=a Sin[ b (t-c)]+d  


SetUpHumidFunc[city_]:={
zz1=Table[
zy1=humidity[ ToString[year],city];
If[ Length[ zy1]  == 366,  Drop[ zy1,{60} ] ,zy1  ],
{year,1979,2015}];
zz2=Mean[zz1];
er=FindMinimum[
Sum[ ( f[a,2.\[Pi]/365,cc,d,ti]-zz2[[ti]] )^2,{ti,1,365}],
{{a, 0.005},{cc, 50},{d,0.005}}];
q[t_]:=  f[ er[[2,1,2]],2.\[Pi]/365, er[[2,2,2]],er[[2,3,2]],t];
qtVAR=er[[2,All,2]];
ListLinePlot[
Join[
zz1,
{Table[ q[ti],{ti,1,365}]}
],PlotLabel-> StringJoin[{ "Humidity Data and interpolation for: ",city}]   ]
}[[1]]


(*er2={0.0053 ,0.01721 ,116.558,0.00736};*)


(*q[t_]:= f[0.0053,0.01721,116.558,0.00736 ,t  ]*)


zx1981 = {{Null,Allston_MA,Boston_MA,BrooklineVillage_MA,Somerville_MA,Providence_RI,Newark_NJ,Albany_NY,Bronx_NY,Buffalo_NY,NewYork_NY,Rochester_NY,Syracuse_NY,Philadelphia_PA,Pittsburgh_PA,StateCollege_PA,Chicago_IL,HarwoodHeights_IL,Indianapolis_IL,GrandRapids_MI,Cincinnati_OH,Cleveland_OH,Columbus_OH,Dayton_OH,Madison_WI,Milwaukee_WI,DesMoines_IA,Wichita_KA,Minneapolis_MN,StPaul_MN,KansasCity_MO,Springfield_MO,StLouis_MO,Lincoln_NE,Omaha_NE,Washington_DC,Gainesville_FL,Hialeah_FL,Jacksonville_FL,Miami_FL,Orlando_FL,PompanoBeach_FL,Tallahassee_FL,Tampa_FL,Atlanta_GA,Norcross_GA,Roswell_GA,Smyrna_GA,Baltimore_MD,TakomaPark_MD,Cary_NC,Charlotte_NC,Durham_NC,Greensboro_NC,Raleigh_NC,Columbia_SC,Greenville_SC,Arlington_VA,Ashburn_VA,Herndon_VA,Norfolk_VA,Reston_VA,Richmond_VA,Birmingham_AL,Lexington_KY,Louisville_KY,Jackson_MS,Knoxville_TN,Memphis_TN,Nashville_TN,LittleRock_AR,BatonRouge_LA,NewOrleans_LA,OklahomaCity_OK,Tulsa_OK,Addison_TX,Austin_TX,Dallas_TX,FtWorth_TX,Houston_TX,Irving_TX,Lubbock_TX,McNeil_TX,Plano_TX,SanAntonio_TX,Mesa_AZ,Phoenix_AZ,Scottsdale_AZ,Tempe_AZ,Tucson_AZ,ColoradoSprings_CO,Denver_CO,Boise_ID,Alburquerque_NM,LasVegas_NV,Reno_NV,Midvale_UT,SaltLakeCity_UT,Alameda_CA,Berkeley_CA,BeverlyHills_CA,Fresno_CA,Irvine_CA,LaJolla_CA,LosAngeles_CA,Oakland_CA,Piedmont_CA,Sacramento_CA,SanDiego_CA,SanFrancisco_CA,SanJose_CA,SantaClara_CA,Sunnyvale_CA,WestHollywood_CA,Beaverton_OR,Eugene_OR,Portland_OR,Bellevue_WA,Seattle_WA,Spokane_WA},{1/81,0.001208208`,0.001253617`,0.001253617`,0.001283275`,0.001235517`,0.001621`,0.001515992`,0.001475292`,0.001791842`,0.001580483`,0.001712417`,0.001385558`,0.0017054`,0.003520475`,0.002423525`,0.00310465`,0.003088908`,0.003228917`,0.002791492`,0.003496508`,0.002869258`,0.003507692`,0.003364058`,0.00281545`,0.002929967`,0.003046708`,0.003183542`,0.002274992`,0.002303733`,0.003253733`,0.003473175`,0.003783667`,0.002997117`,0.003012775`,0.003026008`,0.005003158`,0.00744755`,0.004999992`,0.007527558`,0.005685033`,0.007889625`,0.004859508`,0.007328217`,0.003845683`,0.003911808`,0.00379035`,0.003771458`,0.002770917`,0.003026008`,0.004181742`,0.004148625`,0.004197208`,0.004174792`,0.004139158`,0.004164608`,0.003968283`,0.003026008`,0.002938058`,0.00295345`,0.004203175`,0.002932742`,0.003082967`,0.004172825`,0.003614592`,0.003672267`,0.004254842`,0.004257217`,0.003983908`,0.0038397`,0.003873667`,0.005197208`,0.006138933`,0.003830458`,0.003396258`,0.004298467`,0.00454315`,0.004356375`,0.004369092`,0.004858317`,0.004380258`,0.003715058`,0.00449535`,0.004273417`,0.004547733`,0.003777217`,0.003809058`,0.003786175`,0.003786175`,0.003891175`,0.00304255`,0.00351255`,0.004418575`,0.003377483`,0.0028563`,0.002813583`,0.003451642`,0.003387617`,0.005136992`,0.0060232`,0.007154458`,0.005016942`,0.006897433`,0.007557408`,0.005494058`,0.0060232`,0.005136992`,0.005294775`,0.007398658`,0.0064142`,0.004256067`,0.004256067`,0.004171783`,0.00653915`,0.006523392`,0.006872842`,0.006566133`,0.006032217`,0.005904592`,0.005214292`},{1/162,0.002657433`,0.00270255`,0.00270255`,0.00269285`,0.002928042`,0.002901292`,0.002117575`,0.002896433`,0.001878717`,0.002914408`,0.001970467`,0.001919692`,0.002881083`,0.002607317`,0.002401317`,0.001792025`,0.0017722`,0.002091083`,0.001760667`,0.002562467`,0.002305442`,0.002520483`,0.002447258`,0.001482108`,0.001496858`,0.001957142`,0.002356192`,0.001027058`,0.000998458`,0.0025483`,0.0026847`,0.002493342`,0.002184075`,0.002142775`,0.003066058`,0.004497575`,0.008568225`,0.00475185`,0.008714417`,0.0051159`,0.008829158`,0.004074267`,0.006553958`,0.003285592`,0.00325665`,0.003243192`,0.003255192`,0.002983425`,0.003066058`,0.003156408`,0.00297725`,0.003128125`,0.002817542`,0.003159417`,0.003432617`,0.002969767`,0.003066058`,0.002929192`,0.002921683`,0.003655408`,0.002917367`,0.003005433`,0.003578267`,0.0026002`,0.002616792`,0.003556383`,0.003206508`,0.003342783`,0.003107592`,0.003158808`,0.0039978`,0.004820858`,0.002802092`,0.002751858`,0.003364158`,0.0040973`,0.003438675`,0.003541792`,0.004116742`,0.003492833`,0.00415235`,0.0040456`,0.003338783`,0.004110125`,0.00417625`,0.004225533`,0.004192375`,0.004192375`,0.003939592`,0.002498692`,0.002648033`,0.003502525`,0.003131775`,0.003312625`,0.002597508`,0.003632625`,0.003550017`,0.005451283`,0.006326658`,0.007694183`,0.005051458`,0.0075932`,0.007910367`,0.006290625`,0.006326658`,0.005451283`,0.005129017`,0.00767405`,0.006704983`,0.005517733`,0.005517733`,0.005395808`,0.00720865`,0.005241408`,0.0056952`,0.005274142`,0.00496865`,0.004935617`,0.004472592`},{1/243,0.00098315`,0.0009926`,0.0009926`,0.000973417`,0.001173525`,0.001756983`,0.000838658`,0.001670867`,0.000998658`,0.001757`,0.0008755`,0.000712208`,0.0020276`,0.001912067`,0.001637942`,0.001473225`,0.001446233`,0.001993925`,0.001193492`,0.0025537`,0.001597308`,0.002124517`,0.002203433`,0.0011341`,0.001026358`,0.001397142`,0.002917708`,0.0005182`,0.000526617`,0.002233967`,0.002719675`,0.002261925`,0.001806392`,0.001604008`,0.002548008`,0.003538033`,0.006620675`,0.003821925`,0.006726558`,0.003987233`,0.007039642`,0.00357235`,0.00520385`,0.002759542`,0.002741242`,0.002732533`,0.002741583`,0.002362192`,0.002548008`,0.002452983`,0.002586567`,0.002458883`,0.002306858`,0.002453258`,0.00273375`,0.002604492`,0.002548008`,0.002479642`,0.002455267`,0.002785058`,0.002448292`,0.002212667`,0.003082175`,0.002480775`,0.002567208`,0.003729725`,0.002744842`,0.003292292`,0.002790258`,0.003564767`,0.0046575`,0.005114358`,0.003481258`,0.003041375`,0.00396185`,0.005305942`,0.004037783`,0.004010633`,0.0061566`,0.004045183`,0.004227642`,0.005178683`,0.00391955`,0.005591675`,0.003958792`,0.004001358`,0.003971767`,0.003971767`,0.004015383`,0.002601617`,0.002396667`,0.003607817`,0.00351445`,0.003701183`,0.003176883`,0.003203233`,0.003151975`,0.006811808`,0.007472483`,0.007899908`,0.005880125`,0.008060383`,0.008724783`,0.007159675`,0.007472483`,0.006811808`,0.006000492`,0.00857615`,0.007642042`,0.007926033`,0.007926033`,0.007557517`,0.007684283`,0.004552408`,0.005194933`,0.004598217`,0.004475392`,0.004551817`,0.003979717`},{1/324,0.000792288`,0.000796321`,0.000796321`,0.000771613`,0.000954304`,0.001208671`,0.000608829`,0.001143246`,0.000683546`,0.001211146`,0.000669321`,0.000558088`,0.001313004`,0.000856071`,0.000768296`,0.000752254`,0.000730838`,0.000769771`,0.000746313`,0.001077904`,0.000737171`,0.000856696`,0.000909263`,0.000590371`,0.000569488`,0.000521221`,0.002332229`,0.000394588`,0.000408846`,0.000979229`,0.001360304`,0.000812504`,0.000908129`,0.000704113`,0.001490788`,0.004429188`,0.007443021`,0.004543213`,0.007567479`,0.004953021`,0.007906463`,0.004340579`,0.006728854`,0.002874688`,0.002852329`,0.002789438`,0.002806238`,0.001371154`,0.001490788`,0.002416213`,0.002576471`,0.002362821`,0.002181971`,0.002386229`,0.002823771`,0.002564679`,0.001490788`,0.001382004`,0.001380063`,0.002625721`,0.001368713`,0.001637154`,0.003109413`,0.001118413`,0.001052246`,0.003746571`,0.002451454`,0.002074813`,0.001829704`,0.002663054`,0.005879854`,0.006644013`,0.002140596`,0.001837738`,0.003077838`,0.005013896`,0.003178946`,0.003190554`,0.006305096`,0.003198871`,0.003525671`,0.004760429`,0.003078621`,0.005991496`,0.004155621`,0.004205079`,0.004171938`,0.004171938`,0.003952421`,0.002832463`,0.002781604`,0.003755754`,0.003334546`,0.004625013`,0.005134938`,0.003928521`,0.003906996`,0.006928963`,0.007643354`,0.008156746`,0.006604279`,0.008398254`,0.008675629`,0.007401263`,0.007643354`,0.006928963`,0.006449646`,0.008435404`,0.007834888`,0.007336879`,0.007336879`,0.006992688`,0.007927538`,0.005528679`,0.006658638`,0.005558746`,0.004554688`,0.004662363`,0.003633088`},{1/405,0.000838896`,0.000848279`,0.000848279`,0.000842279`,0.000912046`,0.001258396`,0.000913513`,0.001224846`,0.001220079`,0.001282613`,0.001295746`,0.001017746`,0.001142929`,0.001046363`,0.001121979`,0.000884279`,0.000882296`,0.000820179`,0.000938663`,0.000919379`,0.001087213`,0.000944979`,0.001007579`,0.000832013`,0.000750279`,0.000831029`,0.002354463`,0.000668046`,0.000647713`,0.001233846`,0.001117563`,0.000846813`,0.001193929`,0.001091863`,0.001102113`,0.004201579`,0.008180896`,0.004993563`,0.008356179`,0.005610679`,0.009175163`,0.002328479`,0.005904713`,0.001202379`,0.001144496`,0.001180496`,0.001204779`,0.001298363`,0.001102113`,0.000982063`,0.001027446`,0.000972013`,0.000869729`,0.000979379`,0.001363663`,0.001099813`,0.001102113`,0.001125829`,0.001078613`,0.001448479`,0.001080479`,0.000917546`,0.001372763`,0.000797513`,0.000782913`,0.001687746`,0.001002913`,0.001186313`,0.000943946`,0.001359079`,0.002964463`,0.004582879`,0.002292563`,0.001653563`,0.002568679`,0.004143563`,0.002637913`,0.002840379`,0.005092146`,0.002718063`,0.004784546`,0.004017246`,0.002530146`,0.004724579`,0.004102479`,0.004161996`,0.004122146`,0.004122146`,0.004005846`,0.002987396`,0.002877613`,0.003441129`,0.003969229`,0.004756363`,0.004137213`,0.004004046`,0.003990913`,0.005982113`,0.006743946`,0.006766613`,0.005962513`,0.006730196`,0.007722063`,0.005449579`,0.006743946`,0.005982113`,0.005747529`,0.007923746`,0.007002413`,0.005575129`,0.005575129`,0.005403513`,0.006311579`,0.005636679`,0.006100246`,0.005693263`,0.005334963`,0.005370529`,0.003843863`},{1/486,0.001355208`,0.001387592`,0.001387592`,0.001391383`,0.001620092`,0.001818617`,0.001424825`,0.001867467`,0.001601533`,0.0018816`,0.001800017`,0.001605875`,0.001802033`,0.001682075`,0.001624425`,0.002061508`,0.002070925`,0.001995217`,0.001918542`,0.001987083`,0.001824133`,0.001842733`,0.001904367`,0.001920342`,0.001969983`,0.002351058`,0.002816642`,0.002034758`,0.00201795`,0.002696642`,0.002400525`,0.002141167`,0.002782267`,0.002735142`,0.0018889`,0.005532483`,0.0103279`,0.006161533`,0.010410267`,0.006973158`,0.010166192`,0.003280567`,0.007054617`,0.0014585`,0.0014221`,0.001440725`,0.001464408`,0.001748875`,0.0018889`,0.001374142`,0.001342158`,0.0013586`,0.001250575`,0.0013733`,0.001552675`,0.001350133`,0.0018889`,0.001765067`,0.001762633`,0.00196815`,0.001753875`,0.001209058`,0.0022426`,0.001902142`,0.002107625`,0.003503925`,0.001806392`,0.002649233`,0.0021461`,0.002647475`,0.006677817`,0.007707567`,0.0033233`,0.002890692`,0.0046858`,0.008554192`,0.004888867`,0.004968175`,0.009289967`,0.004943942`,0.004992933`,0.00831355`,0.00460185`,0.0093239`,0.004106717`,0.004205675`,0.004134867`,0.004134867`,0.004394883`,0.002911883`,0.002854392`,0.0032391`,0.002900292`,0.003025208`,0.003470325`,0.0033199`,0.003289308`,0.0057907`,0.006558817`,0.006921075`,0.005747692`,0.006542492`,0.007216175`,0.004919242`,0.006558817`,0.0057907`,0.0054634`,0.007267008`,0.006830733`,0.004964867`,0.004964867`,0.0049104`,0.006164825`,0.005768658`,0.005728958`,0.005747267`,0.005317208`,0.0053988`,0.003642933`},{1/567,0.002993742`,0.003037608`,0.003037608`,0.003001008`,0.0034271`,0.0032938`,0.002325992`,0.003319008`,0.001880792`,0.003322042`,0.002094083`,0.002174392`,0.00308465`,0.002412108`,0.0022669`,0.001443675`,0.001419108`,0.001978242`,0.001550925`,0.002364583`,0.002054617`,0.002394108`,0.0022337`,0.001098083`,0.001204992`,0.00116745`,0.002371925`,0.00079675`,0.000809408`,0.002488`,0.0027656`,0.0020264`,0.002140142`,0.002029308`,0.003069533`,0.00781175`,0.010976958`,0.0076554`,0.011087075`,0.00840545`,0.0112647`,0.00695625`,0.009880425`,0.0038491`,0.003737992`,0.003686783`,0.003730167`,0.002948308`,0.003069533`,0.003546392`,0.003436992`,0.003438275`,0.002946167`,0.003544542`,0.004158725`,0.003254158`,0.003069533`,0.002827158`,0.002797033`,0.004213467`,0.0028149`,0.003053992`,0.004040042`,0.002595433`,0.002522275`,0.004591325`,0.003388933`,0.00312305`,0.00308245`,0.003287`,0.006811542`,0.007698058`,0.003045342`,0.003080808`,0.003506517`,0.004739708`,0.003566075`,0.00351595`,0.00620375`,0.003567442`,0.002891608`,0.004483483`,0.003518492`,0.005572808`,0.004634017`,0.004645983`,0.004635758`,0.004635758`,0.006010733`,0.002013083`,0.0019302`,0.003137567`,0.002996175`,0.002908042`,0.002890758`,0.00330355`,0.003276867`,0.0055935`,0.006395525`,0.006510642`,0.005252967`,0.006137842`,0.006879342`,0.004188717`,0.006395525`,0.0055935`,0.005254525`,0.007356925`,0.006707383`,0.004733858`,0.004733858`,0.004706633`,0.005633833`,0.005270717`,0.005981675`,0.005287025`,0.005286483`,0.0052704`,0.003615975`},{1/648,0.0012499`,0.001281583`,0.001281583`,0.001288708`,0.001358042`,0.001282392`,0.000966225`,0.001262092`,0.00104985`,0.001299375`,0.001089342`,0.0009909`,0.001225783`,0.001133667`,0.000988142`,0.001122658`,0.001114458`,0.001219767`,0.001150667`,0.001383892`,0.001144275`,0.001176708`,0.001181492`,0.000978817`,0.000910667`,0.00124525`,0.002428325`,0.001004608`,0.001006375`,0.002397983`,0.002643383`,0.001531267`,0.002040367`,0.002025658`,0.001345983`,0.004061583`,0.0104903`,0.004452692`,0.010609692`,0.005369825`,0.010403992`,0.0033763`,0.006391058`,0.002158342`,0.002131892`,0.00212765`,0.002130158`,0.0012941`,0.001345983`,0.001876475`,0.002051658`,0.001847033`,0.001736117`,0.00186365`,0.0026441`,0.002167075`,0.001345983`,0.001220233`,0.001237033`,0.002185608`,0.001223458`,0.001504608`,0.002076317`,0.001529675`,0.001511192`,0.003082917`,0.001997767`,0.00243235`,0.001710408`,0.003076275`,0.004170283`,0.0046997`,0.003339733`,0.003022533`,0.003923783`,0.004086242`,0.0040021`,0.003947692`,0.005091025`,0.004001508`,0.00404415`,0.00404225`,0.003911417`,0.004496658`,0.0065564`,0.006507908`,0.00653785`,0.00653785`,0.007261483`,0.002020775`,0.002106167`,0.003131242`,0.003944958`,0.00262465`,0.002654317`,0.003040525`,0.0030303`,0.00564115`,0.006437925`,0.007148317`,0.005057683`,0.0070427`,0.007776733`,0.005460167`,0.006437925`,0.00564115`,0.005123525`,0.007723217`,0.006743867`,0.005129133`,0.005129133`,0.005059158`,0.006493267`,0.0050882`,0.005380892`,0.005119883`,0.004853525`,0.004918425`,0.003513408`},{1/729,0.001072733`,0.001102167`,0.001102167`,0.001112367`,0.001223317`,0.001287767`,0.001103383`,0.001305508`,0.001267783`,0.001314133`,0.001338433`,0.001224558`,0.001230533`,0.001128483`,0.0011106`,0.001262992`,0.001263158`,0.001617375`,0.001376908`,0.001818667`,0.0011151`,0.001538325`,0.001588808`,0.001214058`,0.001128258`,0.001355617`,0.002646892`,0.001214942`,0.001219592`,0.00205355`,0.002290067`,0.001922083`,0.00190665`,0.002002525`,0.001540975`,0.003716725`,0.007763392`,0.004904133`,0.007936933`,0.00436175`,0.008597142`,0.002910758`,0.00480875`,0.002376167`,0.00243715`,0.002405767`,0.002377042`,0.001434892`,0.001540975`,0.001544358`,0.001806983`,0.0015055`,0.001422975`,0.00151065`,0.0021279`,0.002447233`,0.001540975`,0.001427692`,0.0014461`,0.00233345`,0.001443267`,0.001359417`,0.002577767`,0.002106517`,0.002128667`,0.0035681`,0.002542633`,0.003021675`,0.002312375`,0.003526192`,0.00499245`,0.005119892`,0.00356945`,0.002961033`,0.005685175`,0.005913242`,0.005811092`,0.005763017`,0.006732992`,0.005824917`,0.004818842`,0.005805225`,0.005655867`,0.006893517`,0.005147217`,0.005174008`,0.0051549`,0.0051549`,0.005457208`,0.001713567`,0.002149642`,0.003316342`,0.002988225`,0.002522758`,0.002706458`,0.003215408`,0.003240275`,0.005641042`,0.006494375`,0.006889375`,0.004827225`,0.006787825`,0.007417242`,0.005514508`,0.006494375`,0.005641042`,0.004935983`,0.007202033`,0.006850775`,0.00536905`,0.00536905`,0.005228067`,0.006333567`,0.006178908`,0.006856617`,0.006198475`,0.0060061`,0.006006158`,0.003908417`},{1/810,0.001556496`,0.001579854`,0.001579854`,0.001568504`,0.001732596`,0.001758663`,0.001397746`,0.001754221`,0.001324496`,0.001770788`,0.001407663`,0.001331354`,0.001738929`,0.001409263`,0.001399813`,0.001030363`,0.001018763`,0.001235254`,0.001210988`,0.001547504`,0.001351846`,0.001420388`,0.001413296`,0.000855896`,0.000824188`,0.000827346`,0.002320463`,0.000752788`,0.000760738`,0.001229313`,0.001713246`,0.001398838`,0.001104463`,0.001164788`,0.001891063`,0.003726388`,0.006862771`,0.004448346`,0.007146813`,0.004294504`,0.007962646`,0.003138313`,0.004890654`,0.002539546`,0.002521129`,0.002500763`,0.002501254`,0.001806721`,0.001891063`,0.001628404`,0.002061896`,0.001626438`,0.001674088`,0.001590579`,0.002367896`,0.002391088`,0.001891063`,0.001798479`,0.001795838`,0.002460821`,0.001792563`,0.001629863`,0.002496846`,0.001664163`,0.001623654`,0.003166154`,0.002165113`,0.002360071`,0.001831896`,0.002803563`,0.004155413`,0.004546354`,0.002897429`,0.002268888`,0.004659904`,0.006415988`,0.004880254`,0.005061846`,0.005903454`,0.004968588`,0.004875863`,0.006335496`,0.004596629`,0.006698563`,0.004549813`,0.004615779`,0.004570363`,0.004570363`,0.005017354`,0.002011963`,0.001986579`,0.003304288`,0.002889938`,0.002586871`,0.002967938`,0.003258671`,0.003263913`,0.004959496`,0.005842588`,0.006748171`,0.004553946`,0.006717304`,0.007100921`,0.005359629`,0.005842588`,0.004959496`,0.004826679`,0.006629546`,0.006251738`,0.004416238`,0.004416238`,0.004329354`,0.006234621`,0.005020771`,0.004877963`,0.005026729`,0.004912563`,0.004988554`,0.003642479`},{1/891,0.000858242`,0.000878425`,0.000878425`,0.000881258`,0.000914925`,0.001040975`,0.000673242`,0.001008792`,0.000844692`,0.001061825`,0.000786308`,0.000638308`,0.001091758`,0.001099208`,0.000923975`,0.000913975`,0.000907892`,0.001113508`,0.001112708`,0.001267358`,0.001113242`,0.001077775`,0.001142892`,0.000802525`,0.000740158`,0.000887625`,0.002312858`,0.000762475`,0.000762108`,0.001312992`,0.001550158`,0.001440025`,0.001343842`,0.001376975`,0.001275792`,0.003376608`,0.007337542`,0.004538175`,0.007620925`,0.004359175`,0.008033592`,0.002267742`,0.004416508`,0.001628025`,0.001588158`,0.001603208`,0.001618658`,0.001120658`,0.001275792`,0.001076892`,0.001220575`,0.001095558`,0.001076958`,0.001067392`,0.001556575`,0.001356808`,0.001275792`,0.001226408`,0.001201008`,0.001366875`,0.001203392`,0.001000225`,0.001790358`,0.001138492`,0.001319492`,0.002316425`,0.001431425`,0.001886008`,0.001466692`,0.002406542`,0.003125908`,0.003303525`,0.002726775`,0.002157292`,0.003948725`,0.005715175`,0.004087692`,0.004190875`,0.004919292`,0.004136508`,0.004653608`,0.005659958`,0.003916108`,0.005880958`,0.005835625`,0.005925775`,0.005860458`,0.005860458`,0.006492542`,0.002245375`,0.002272308`,0.003292308`,0.003363192`,0.002844792`,0.003041158`,0.003155308`,0.003138758`,0.004493425`,0.005432058`,0.007288225`,0.004272258`,0.007396042`,0.007679725`,0.006651942`,0.005432058`,0.004493425`,0.004644158`,0.007386392`,0.005897175`,0.003468158`,0.003468158`,0.003481275`,0.007143625`,0.004698042`,0.005014125`,0.004694925`,0.004367725`,0.004486625`,0.003329025`},{1/972,0.000746146`,0.000764313`,0.000764313`,0.000768163`,0.000829396`,0.000973346`,0.000670529`,0.000950679`,0.000875279`,0.000990196`,0.000849446`,0.000691396`,0.001028096`,0.001039579`,0.000820463`,0.001056013`,0.001060713`,0.000949596`,0.001181079`,0.001150229`,0.001158929`,0.001152463`,0.001092396`,0.001095229`,0.000986229`,0.001358046`,0.001997813`,0.001397163`,0.001358663`,0.001377979`,0.001182246`,0.001372946`,0.001627013`,0.001771579`,0.001107763`,0.002138246`,0.004764879`,0.002716479`,0.004998129`,0.002745813`,0.005919163`,0.001818613`,0.003541846`,0.001227029`,0.001211363`,0.001216963`,0.001210096`,0.001007446`,0.001107763`,0.000907963`,0.001031529`,0.000922613`,0.000871446`,0.000912713`,0.001423063`,0.001139829`,0.001107763`,0.001044079`,0.001034446`,0.001418446`,0.001028463`,0.000876529`,0.001401396`,0.001158779`,0.001169046`,0.001696146`,0.001073546`,0.001326179`,0.001104546`,0.001616146`,0.002434663`,0.002600413`,0.001957413`,0.001665363`,0.002383613`,0.003809679`,0.002461346`,0.002515346`,0.003990129`,0.002487579`,0.003017963`,0.003624513`,0.002388879`,0.004546963`,0.008767779`,0.008901929`,0.008809246`,0.008809246`,0.008406013`,0.001336229`,0.001270946`,0.002836396`,0.003540663`,0.005428079`,0.002885196`,0.003036463`,0.003030629`,0.004904846`,0.005727779`,0.008922263`,0.004949946`,0.009214563`,0.009286646`,0.008816713`,0.005727779`,0.004904846`,0.005008879`,0.009145279`,0.006093146`,0.005081779`,0.005081779`,0.004754296`,0.009014046`,0.004790696`,0.004579746`,0.004779063`,0.004479796`,0.004625713`,0.003278713`},{1/1053,0.001035487`,0.001073779`,0.001073779`,0.001082862`,0.001075796`,0.001038562`,0.000732887`,0.001036762`,0.001253321`,0.001074221`,0.001128362`,0.000743804`,0.001015771`,0.001198921`,0.001135687`,0.002010346`,0.001994362`,0.002132587`,0.002165321`,0.002092262`,0.001675096`,0.001960629`,0.002040204`,0.001821304`,0.002002062`,0.002317204`,0.001837687`,0.001793162`,0.001740112`,0.002508696`,0.002440012`,0.002369604`,0.002303921`,0.002350987`,0.001346654`,0.001646462`,0.004882429`,0.002292429`,0.005227329`,0.001886629`,0.006117446`,0.001726196`,0.002739346`,0.001354871`,0.001336279`,0.001345737`,0.001352637`,0.001202112`,0.001346654`,0.000946204`,0.001135554`,0.000965271`,0.001014396`,0.000941129`,0.001252304`,0.001235246`,0.001346654`,0.001313971`,0.001307387`,0.001402762`,0.001302304`,0.000870079`,0.001580687`,0.002037546`,0.002173854`,0.001964879`,0.001449029`,0.002287054`,0.001758662`,0.002654437`,0.002534587`,0.002745154`,0.003200412`,0.002616779`,0.003272271`,0.003756029`,0.003319354`,0.003349496`,0.003643029`,0.003333212`,0.004208896`,0.003688712`,0.003237404`,0.004162871`,0.008722029`,0.008794762`,0.008749654`,0.008749654`,0.007849587`,0.001012821`,0.001240712`,0.002792512`,0.004089562`,0.006338754`,0.003086271`,0.003053154`,0.003068262`,0.005070779`,0.006025729`,0.008831504`,0.005270854`,0.009109779`,0.009239004`,0.008631229`,0.006025729`,0.005070779`,0.005409179`,0.009129504`,0.006496304`,0.005835237`,0.005835237`,0.005363279`,0.008884946`,0.004561671`,0.004454337`,0.004574012`,0.004271746`,0.004382921`,0.003330321`},{1/1134,0.001017638`,0.001043554`,0.001043554`,0.001047446`,0.001250496`,0.001530054`,0.000882663`,0.001512063`,0.001666254`,0.001558054`,0.001272363`,0.000956638`,0.001638429`,0.002406638`,0.001938688`,0.002494329`,0.002481429`,0.002137146`,0.002573363`,0.002286929`,0.002426821`,0.002584404`,0.002437146`,0.001921429`,0.002607863`,0.002222388`,0.002259113`,0.002043063`,0.002006163`,0.002664746`,0.002812288`,0.002754754`,0.002542346`,0.002544854`,0.002163196`,0.003685996`,0.006966938`,0.003937654`,0.007183329`,0.002378363`,0.007159154`,0.004506588`,0.003812121`,0.002416913`,0.002392554`,0.002365571`,0.002381454`,0.002103204`,0.002163196`,0.001722913`,0.001737646`,0.001754738`,0.001676771`,0.001735071`,0.001998721`,0.002074146`,0.002163196`,0.002094196`,0.002099088`,0.002250629`,0.002086954`,0.001575079`,0.003138404`,0.002488354`,0.002535088`,0.004343538`,0.002499054`,0.003578988`,0.003141554`,0.003755763`,0.005162171`,0.005893713`,0.002890679`,0.002959321`,0.003963688`,0.005341729`,0.004053838`,0.004049188`,0.006445904`,0.004068996`,0.002914088`,0.005141379`,0.003925938`,0.005988713`,0.007650988`,0.007709979`,0.007669046`,0.007669046`,0.007274021`,0.001676871`,0.001983204`,0.002828096`,0.002473004`,0.005039221`,0.003348271`,0.002974704`,0.002965921`,0.005315104`,0.006300679`,0.008497704`,0.005273454`,0.008585679`,0.008711221`,0.007668213`,0.006300679`,0.005315104`,0.005072604`,0.008578863`,0.006780771`,0.005307746`,0.005307746`,0.005036588`,0.008269996`,0.004185879`,0.004514396`,0.004186054`,0.004022963`,0.004150729`,0.003330821`},{1/1215,0.001887879`,0.001914704`,0.001914704`,0.001883962`,0.002295437`,0.002857329`,0.001691004`,0.002756012`,0.002075579`,0.002851579`,0.001774929`,0.001645546`,0.002737487`,0.002781321`,0.002465662`,0.002468096`,0.002448854`,0.002744412`,0.002660454`,0.002997021`,0.002706321`,0.002967787`,0.002946471`,0.002042162`,0.002323654`,0.001965712`,0.002336112`,0.001571154`,0.001583979`,0.002647762`,0.002790496`,0.002931304`,0.002392671`,0.002275554`,0.003012712`,0.006732387`,0.009701779`,0.006673796`,0.009809937`,0.005787679`,0.009668312`,0.006726896`,0.007572637`,0.004285921`,0.004258871`,0.004193271`,0.004208429`,0.002921871`,0.003012712`,0.003350554`,0.003577004`,0.003329362`,0.003207554`,0.003337129`,0.003941571`,0.003970721`,0.003012712`,0.002901412`,0.002904737`,0.003491212`,0.002896754`,0.002824771`,0.004293287`,0.002972737`,0.003157721`,0.004827912`,0.003643954`,0.003225279`,0.003244662`,0.003137471`,0.005460571`,0.006317296`,0.002626696`,0.002750246`,0.003034862`,0.003392046`,0.003079029`,0.003038304`,0.004078779`,0.003077821`,0.002787521`,0.003336721`,0.003026762`,0.003396104`,0.007338404`,0.007404046`,0.007359054`,0.007359054`,0.006899646`,0.001777971`,0.002005012`,0.002657429`,0.002394696`,0.004806437`,0.003462071`,0.002899021`,0.002911479`,0.006248779`,0.007101521`,0.008438471`,0.005559862`,0.008563137`,0.008852587`,0.007710846`,0.007101521`,0.006248779`,0.005868112`,0.009006571`,0.007441621`,0.006801687`,0.006801687`,0.006484029`,0.008266546`,0.004037696`,0.004954437`,0.004031196`,0.003683587`,0.003817821`,0.003037796`},{1/1296,0.002212737`,0.002249662`,0.002249662`,0.002223796`,0.002519229`,0.003012671`,0.002120237`,0.002934271`,0.002229371`,0.003001812`,0.002015804`,0.001926904`,0.003064129`,0.002696971`,0.002827171`,0.001755104`,0.001739204`,0.001987321`,0.002298229`,0.002193912`,0.002499646`,0.002421121`,0.002273404`,0.001445354`,0.001732212`,0.000902012`,0.002575587`,0.001118121`,0.001122862`,0.001153746`,0.001644212`,0.001573946`,0.000961279`,0.000867954`,0.003094054`,0.006487979`,0.011299612`,0.006412562`,0.011434562`,0.008458362`,0.011281537`,0.004562546`,0.009332221`,0.003145704`,0.003164904`,0.003116779`,0.003100204`,0.003116704`,0.003094054`,0.003172029`,0.002812687`,0.003162929`,0.003019246`,0.003152196`,0.003107887`,0.002913379`,0.003094054`,0.002999287`,0.002989346`,0.003333221`,0.002982596`,0.002874221`,0.003220662`,0.002230662`,0.002359087`,0.003166096`,0.003232829`,0.002784262`,0.002583346`,0.002731704`,0.003835637`,0.004707254`,0.002350704`,0.002044329`,0.002888062`,0.003340746`,0.002944596`,0.002915162`,0.003547546`,0.002949871`,0.002953646`,0.003287054`,0.002876062`,0.003547996`,0.006609071`,0.006720954`,0.006641054`,0.006641054`,0.006592512`,0.002533279`,0.002844679`,0.002642879`,0.002839396`,0.005136979`,0.003610687`,0.002919137`,0.002902887`,0.007665329`,0.008246712`,0.008413329`,0.005921971`,0.008720704`,0.008961579`,0.008073846`,0.008246712`,0.007665329`,0.006837454`,0.008919496`,0.008293454`,0.008139837`,0.008139837`,0.007809079`,0.008398879`,0.004519012`,0.005660154`,0.004488412`,0.003578537`,0.003664496`,0.003014087`},{1/1377,0.002308525`,0.002334242`,0.002334242`,0.002304233`,0.0025193`,0.002344275`,0.001837008`,0.002352075`,0.00140995`,0.00236705`,0.001507217`,0.001446375`,0.002189858`,0.001659808`,0.001613183`,0.001385258`,0.001380542`,0.001706092`,0.001428775`,0.00189785`,0.001675725`,0.001824317`,0.001847583`,0.001283783`,0.0010969`,0.001058842`,0.002054483`,0.001612067`,0.001589225`,0.00118515`,0.001200967`,0.001490625`,0.001170033`,0.001158225`,0.0020047`,0.00317135`,0.008869342`,0.003801742`,0.009086408`,0.004355233`,0.009584358`,0.00262685`,0.004942458`,0.0018467`,0.00182855`,0.001826717`,0.0018222`,0.00195775`,0.0020047`,0.001765242`,0.001734883`,0.001750667`,0.001564942`,0.001761367`,0.002093775`,0.001712625`,0.0020047`,0.0018767`,0.001842142`,0.002325775`,0.001858733`,0.001646617`,0.001948558`,0.001681783`,0.00186135`,0.002048`,0.001683642`,0.00164925`,0.001711275`,0.001489358`,0.002511333`,0.002967217`,0.0014119`,0.001294883`,0.001595267`,0.002576458`,0.001631233`,0.001675708`,0.002733717`,0.001649175`,0.00239115`,0.002488608`,0.001609367`,0.002902808`,0.006858117`,0.0069656`,0.006889475`,0.006889475`,0.006143192`,0.002967083`,0.002648633`,0.003462417`,0.003290542`,0.005953658`,0.003896833`,0.003751242`,0.003784358`,0.007221567`,0.007909`,0.00764465`,0.005633958`,0.007901008`,0.00852345`,0.00708895`,0.007909`,0.007221567`,0.007158742`,0.00864985`,0.00806865`,0.007263308`,0.007263308`,0.006988283`,0.0075276`,0.005185083`,0.006507067`,0.005202783`,0.00418815`,0.004219267`,0.00285355`},{1/1458,0.001284471`,0.001311337`,0.001311337`,0.001313279`,0.001343721`,0.001584304`,0.001351904`,0.001576479`,0.001486371`,0.001615929`,0.001760804`,0.001520879`,0.001628396`,0.001460496`,0.001572137`,0.001984787`,0.001994187`,0.001925171`,0.001865754`,0.001899512`,0.001583421`,0.001720487`,0.001840854`,0.002086321`,0.001805796`,0.001917429`,0.002620112`,0.001916537`,0.001922854`,0.001929487`,0.001764879`,0.002125487`,0.002056179`,0.002052996`,0.001839846`,0.001817937`,0.006287179`,0.002553087`,0.006645254`,0.002074754`,0.007241671`,0.001806746`,0.002767146`,0.001713946`,0.001705362`,0.001733646`,0.001728387`,0.001719904`,0.001839846`,0.001569929`,0.001589612`,0.001586804`,0.001519296`,0.001572929`,0.001695087`,0.001579962`,0.001839846`,0.001778229`,0.001723629`,0.001813237`,0.001730254`,0.001410879`,0.001757221`,0.001750671`,0.001918929`,0.001840012`,0.001870796`,0.001747887`,0.001783862`,0.001649446`,0.002104204`,0.002775004`,0.001980029`,0.001638712`,0.001996704`,0.002353454`,0.002019871`,0.002093537`,0.002477871`,0.002041971`,0.003094496`,0.002345029`,0.001987696`,0.002355729`,0.004646404`,0.004792737`,0.004691121`,0.004691121`,0.004189929`,0.002895396`,0.002888937`,0.003995446`,0.003763246`,0.005381679`,0.003672204`,0.004274704`,0.004215521`,0.007393104`,0.008129104`,0.007445637`,0.005649296`,0.007613179`,0.007748496`,0.006598421`,0.008129104`,0.007393104`,0.007517996`,0.007495921`,0.008337929`,0.007560354`,0.007560354`,0.007314987`,0.007198287`,0.006158121`,0.007196396`,0.006212537`,0.005828829`,0.005802829`,0.003735596`},{1/1539,0.002212825`,0.002241667`,0.002241667`,0.002227208`,0.002450467`,0.002676817`,0.002363075`,0.002710583`,0.001954042`,0.002727267`,0.002726883`,0.00274355`,0.002595817`,0.001902117`,0.002422508`,0.002374058`,0.002384942`,0.002614017`,0.002210217`,0.002417858`,0.002204083`,0.002304783`,0.002400542`,0.002480117`,0.002055633`,0.003053117`,0.003634092`,0.0022167`,0.002196633`,0.003577258`,0.002852133`,0.002996383`,0.003238992`,0.003141592`,0.002449242`,0.002612683`,0.00434175`,0.003081467`,0.0045007`,0.002567742`,0.00494085`,0.002434483`,0.004196125`,0.002120542`,0.002131667`,0.002108725`,0.0021112`,0.002576908`,0.002449242`,0.0021812`,0.002096942`,0.0022112`,0.002097108`,0.002193592`,0.002132908`,0.002029017`,0.002449242`,0.002335258`,0.002284158`,0.002675733`,0.002278992`,0.002016658`,0.002293342`,0.002465317`,0.002595633`,0.002461583`,0.002164942`,0.002449858`,0.0023759`,0.002495508`,0.003476617`,0.003722308`,0.003639467`,0.003186033`,0.0035261`,0.00366835`,0.0035901`,0.003612908`,0.003939492`,0.003606883`,0.00339395`,0.003666683`,0.003502967`,0.00403895`,0.004222042`,0.004281317`,0.004237425`,0.004237425`,0.004000742`,0.002632975`,0.002560083`,0.00431505`,0.00350175`,0.004786258`,0.003572275`,0.004057783`,0.003932808`,0.007041775`,0.007927342`,0.007624508`,0.005499833`,0.007722583`,0.008279167`,0.006530292`,0.007927342`,0.007041775`,0.006943983`,0.008351725`,0.008297708`,0.0073919`,0.0073919`,0.00721235`,0.007250558`,0.006671142`,0.007451567`,0.006680875`,0.006403942`,0.006475058`,0.0042142`},{1/1620,0.002081337`,0.002108179`,0.002108179`,0.002084679`,0.002427321`,0.002866029`,0.002149412`,0.002891796`,0.001774462`,0.002929221`,0.002112196`,0.001907904`,0.002774737`,0.002511571`,0.002904646`,0.002852571`,0.002852962`,0.003436946`,0.002574154`,0.003302421`,0.002938996`,0.003140896`,0.003217662`,0.002477804`,0.002216646`,0.003059446`,0.002862212`,0.002029496`,0.002032696`,0.004115179`,0.004313754`,0.003984946`,0.002669271`,0.002652037`,0.003018912`,0.004998329`,0.008210821`,0.004987871`,0.008408012`,0.004507754`,0.008494429`,0.005413096`,0.006541696`,0.003637646`,0.003508546`,0.003574937`,0.003627104`,0.002982562`,0.003018912`,0.002698987`,0.003004846`,0.002709579`,0.002541054`,0.002691971`,0.003316837`,0.003158304`,0.003018912`,0.002973446`,0.002952379`,0.003590862`,0.002929079`,0.002825254`,0.004217437`,0.003292812`,0.003461737`,0.004621554`,0.003431846`,0.004279604`,0.003795804`,0.004432137`,0.005371546`,0.007330012`,0.004293012`,0.004293604`,0.004954804`,0.004821129`,0.005005262`,0.004807971`,0.005198171`,0.004967346`,0.003669237`,0.004769046`,0.004956287`,0.004921429`,0.004682929`,0.004764387`,0.004704221`,0.004704221`,0.004517046`,0.002143621`,0.002280404`,0.004365796`,0.003134637`,0.004183796`,0.003828154`,0.003856112`,0.003783429`,0.008041421`,0.008707129`,0.008164754`,0.005589604`,0.008277562`,0.008520671`,0.007409854`,0.008707129`,0.008041421`,0.007138596`,0.008334637`,0.008840029`,0.008658737`,0.008658737`,0.008383979`,0.007928821`,0.006505671`,0.006877687`,0.006525762`,0.006953837`,0.006993521`,0.004609187`},{1/1701,0.001332592`,0.001371842`,0.001371842`,0.001378592`,0.001537658`,0.002340142`,0.001428542`,0.002113658`,0.001482725`,0.002343125`,0.001407058`,0.001143475`,0.002671058`,0.003504825`,0.002572025`,0.002421642`,0.002427742`,0.003751175`,0.001918175`,0.003983975`,0.002779975`,0.003779942`,0.003792225`,0.002114525`,0.001698292`,0.002377975`,0.002313425`,0.001886842`,0.001903058`,0.002987092`,0.004289958`,0.004261258`,0.002132558`,0.002144542`,0.003573758`,0.006730392`,0.011965092`,0.006928858`,0.012105442`,0.008148025`,0.012150225`,0.006113658`,0.009620175`,0.005176758`,0.005236208`,0.005169142`,0.005145258`,0.003334008`,0.003573758`,0.004785425`,0.004873275`,0.004762775`,0.004495725`,0.004776142`,0.005487925`,0.005149592`,0.003573758`,0.003553708`,0.003572758`,0.005549442`,0.003539908`,0.004267258`,0.005336708`,0.004143008`,0.004221958`,0.004800808`,0.005269792`,0.004790392`,0.004856725`,0.004760758`,0.004798392`,0.005034892`,0.003489625`,0.003818642`,0.004382225`,0.004576042`,0.004405525`,0.004200625`,0.004806875`,0.004359808`,0.003128225`,0.004472175`,0.004402058`,0.004727292`,0.004896592`,0.004963358`,0.004917375`,0.004917375`,0.004565458`,0.001409258`,0.001603108`,0.004075425`,0.002835442`,0.003490475`,0.003685408`,0.003719592`,0.003663908`,0.008948975`,0.009383342`,0.008331542`,0.005964925`,0.008280575`,0.008514725`,0.007375642`,0.009383342`,0.008948975`,0.009011308`,0.008330758`,0.009265792`,0.009482142`,0.009482142`,0.009152275`,0.007990108`,0.007502258`,0.008362375`,0.007529358`,0.007863708`,0.007938708`,0.004853808`},{1/1782,0.001929583`,0.001965575`,0.001965575`,0.001963392`,0.002167258`,0.002386675`,0.002028258`,0.0022731`,0.001915892`,0.002407858`,0.002417042`,0.002196575`,0.002463567`,0.002678958`,0.002762133`,0.002642958`,0.002659317`,0.003009783`,0.002372075`,0.003328742`,0.002456242`,0.00295845`,0.003068542`,0.00236385`,0.002262958`,0.00222145`,0.002233025`,0.002233825`,0.002211658`,0.002670033`,0.003374967`,0.003324992`,0.002180458`,0.002194325`,0.003203467`,0.004889742`,0.008764233`,0.005388133`,0.008896067`,0.005360167`,0.008890017`,0.004799367`,0.006668783`,0.004965233`,0.0049746`,0.004934642`,0.004926833`,0.002967142`,0.003203467`,0.004518733`,0.0045936`,0.004542867`,0.004412042`,0.004499608`,0.004971417`,0.004817092`,0.003203467`,0.003115392`,0.003147025`,0.004456275`,0.003117558`,0.003911108`,0.005011608`,0.003640292`,0.003652583`,0.004999667`,0.004751383`,0.004741783`,0.004383575`,0.004490342`,0.005080883`,0.0049393`,0.002852383`,0.003158583`,0.00403415`,0.0045347`,0.004081733`,0.003924417`,0.004948292`,0.004048958`,0.002735633`,0.004454667`,0.004056508`,0.004285892`,0.00416975`,0.004253867`,0.004205033`,0.004205033`,0.002885742`,0.001461892`,0.001581692`,0.003747567`,0.002787692`,0.003291292`,0.003434392`,0.003029017`,0.002965808`,0.008461033`,0.008982217`,0.008595733`,0.006214408`,0.008673333`,0.008833233`,0.007728475`,0.008982217`,0.008461033`,0.008637708`,0.008705233`,0.008965242`,0.008978283`,0.008978283`,0.008649733`,0.008291142`,0.008203608`,0.008116583`,0.008222133`,0.007720833`,0.007804642`,0.005325675`},{1/1863,0.002589567`,0.002632425`,0.002632425`,0.002631233`,0.002904992`,0.003163617`,0.002849008`,0.003062275`,0.002928242`,0.00319005`,0.003125083`,0.003003608`,0.002964775`,0.003077583`,0.002993458`,0.002538558`,0.002545567`,0.00293625`,0.002494925`,0.003179625`,0.002649458`,0.002865192`,0.003001`,0.0022986`,0.002120542`,0.002522317`,0.00252975`,0.002320508`,0.002308642`,0.003016167`,0.003305442`,0.003138575`,0.002804558`,0.0028018`,0.003110858`,0.004681433`,0.007303958`,0.004815683`,0.007402183`,0.005274833`,0.007572867`,0.004755892`,0.006836375`,0.0041998`,0.004186592`,0.004101667`,0.004110467`,0.003129667`,0.003110858`,0.003408183`,0.003434742`,0.003401408`,0.003218275`,0.003404392`,0.003796325`,0.003530917`,0.003110858`,0.003061075`,0.003054317`,0.003796367`,0.003035208`,0.00307795`,0.004986442`,0.003423392`,0.003368967`,0.004870508`,0.003898458`,0.004242217`,0.00378915`,0.0040737`,0.004915858`,0.004993542`,0.003016358`,0.003191475`,0.003847442`,0.004241975`,0.003881342`,0.003614208`,0.005072283`,0.003812508`,0.002543542`,0.004131708`,0.003876992`,0.004356617`,0.003558008`,0.003611`,0.003576342`,0.003576342`,0.002679867`,0.001585783`,0.001768292`,0.004987358`,0.00276185`,0.003236642`,0.004381583`,0.002788008`,0.002679033`,0.006717992`,0.007109758`,0.008227392`,0.007321883`,0.008045675`,0.008753525`,0.007792925`,0.007109758`,0.006717992`,0.007366392`,0.008905692`,0.007045`,0.007013175`,0.007013175`,0.006651733`,0.008166692`,0.007524433`,0.007210258`,0.007551492`,0.007384933`,0.007403725`,0.005443875`},{1/1944,0.002489667`,0.002532525`,0.002532525`,0.002537392`,0.002441`,0.002823`,0.002536042`,0.002640858`,0.00291615`,0.002874958`,0.002560683`,0.002425458`,0.002762008`,0.002939642`,0.002892642`,0.002655983`,0.002652408`,0.002988633`,0.002490492`,0.003193308`,0.002676267`,0.002993775`,0.003080092`,0.002324767`,0.002225925`,0.002929358`,0.002281958`,0.00248475`,0.002449858`,0.003631067`,0.00355045`,0.003463375`,0.003231175`,0.00326725`,0.00285955`,0.005228458`,0.009328167`,0.005021042`,0.009459517`,0.006658933`,0.009325417`,0.004595917`,0.008123733`,0.00376625`,0.003781767`,0.003696525`,0.003702167`,0.002884342`,0.00285955`,0.00292015`,0.003050192`,0.002983583`,0.002940517`,0.002933733`,0.003356133`,0.003341542`,0.00285955`,0.002833108`,0.002817442`,0.0034877`,0.002805808`,0.002967125`,0.004261067`,0.003224808`,0.003336867`,0.00433485`,0.003579917`,0.004185533`,0.003585442`,0.004117808`,0.00496545`,0.005051692`,0.003256433`,0.003500708`,0.004049633`,0.004432783`,0.004072025`,0.003825242`,0.00561465`,0.004009708`,0.0033585`,0.004321208`,0.004095758`,0.004559558`,0.003720158`,0.00375335`,0.00373095`,0.00373095`,0.00320565`,0.0015174`,0.001714242`,0.005337125`,0.002839175`,0.003695367`,0.003793792`,0.003788067`,0.003827517`,0.005730408`,0.0060771`,0.006726817`,0.005303958`,0.007104942`,0.007728508`,0.006104417`,0.0060771`,0.005730408`,0.005927267`,0.007547833`,0.006027875`,0.006023725`,0.006023725`,0.005813492`,0.006550867`,0.005621567`,0.005518808`,0.005614492`,0.00563695`,0.005640533`,0.005942867`},{1/2025,0.002179963`,0.002217713`,0.002217713`,0.002224346`,0.002091421`,0.002320763`,0.002190038`,0.002120096`,0.002612854`,0.002272638`,0.002578871`,0.002264888`,0.002879446`,0.002679913`,0.002783979`,0.003450413`,0.003418188`,0.003683529`,0.003024521`,0.003672938`,0.003048238`,0.003404429`,0.003450713`,0.003323721`,0.002727971`,0.003753013`,0.002507629`,0.003420571`,0.003434763`,0.004190004`,0.004169421`,0.004549463`,0.003607646`,0.003681313`,0.002859446`,0.004129379`,0.008362988`,0.004861838`,0.008533496`,0.004793696`,0.008600071`,0.004297254`,0.005715946`,0.003566479`,0.003572438`,0.003556196`,0.003554571`,0.003070579`,0.002859446`,0.002996388`,0.003196071`,0.003066488`,0.003059696`,0.003008171`,0.003248863`,0.003406529`,0.002859446`,0.002785304`,0.002750913`,0.003334213`,0.002738021`,0.002793304`,0.004453738`,0.003738488`,0.003944521`,0.005618738`,0.003609738`,0.005250713`,0.004056421`,0.005176804`,0.006648546`,0.007255079`,0.003901913`,0.004145079`,0.004907579`,0.005509971`,0.004991596`,0.004705154`,0.007561404`,0.004931113`,0.003150546`,0.005373804`,0.004922513`,0.005329963`,0.003539279`,0.003566263`,0.003546846`,0.003546846`,0.003545179`,0.001306054`,0.001558663`,0.003240513`,0.002340654`,0.003150438`,0.003052679`,0.003654613`,0.003713663`,0.005183004`,0.005716813`,0.005757029`,0.004871788`,0.005996563`,0.007078896`,0.004806471`,0.005716813`,0.005183004`,0.004816346`,0.006878396`,0.005840488`,0.005344654`,0.005344654`,0.005223396`,0.005449921`,0.005134538`,0.005191313`,0.005141421`,0.005069663`,0.005092704`,0.004193588`},{1/2106,0.002886225`,0.002917208`,0.002917208`,0.002880975`,0.003272292`,0.003675892`,0.002871975`,0.0036355`,0.0035449`,0.0037022`,0.003495025`,0.003360708`,0.003549583`,0.003569442`,0.003576775`,0.003649475`,0.0036262`,0.004354717`,0.003821692`,0.004468425`,0.00410185`,0.004529208`,0.004503908`,0.003420483`,0.003511767`,0.00321395`,0.002348308`,0.002969425`,0.002986775`,0.003271958`,0.003620217`,0.00415165`,0.002888117`,0.002974358`,0.0036134`,0.004901733`,0.008133183`,0.005842817`,0.00840145`,0.005675267`,0.009538208`,0.004953042`,0.006037908`,0.004874108`,0.0048706`,0.004854133`,0.004854233`,0.003590717`,0.0036134`,0.0036422`,0.003768942`,0.003689975`,0.003569208`,0.003686508`,0.003890308`,0.004261275`,0.0036134`,0.003494558`,0.003476908`,0.004437075`,0.003461433`,0.0034388`,0.006335342`,0.005202933`,0.005094542`,0.007805683`,0.005182567`,0.006423233`,0.005771558`,0.00633805`,0.008515525`,0.008891167`,0.003144125`,0.003312183`,0.005417358`,0.007594092`,0.0056972`,0.005198775`,0.009780458`,0.005592892`,0.0033605`,0.007303492`,0.005482392`,0.007688692`,0.003261408`,0.003279233`,0.003266275`,0.003266275`,0.003870908`,0.001296625`,0.001479325`,0.002897117`,0.002033283`,0.002508692`,0.003168142`,0.002719642`,0.002776`,0.005373775`,0.006071658`,0.005604092`,0.004450925`,0.005659067`,0.00672115`,0.004252783`,0.006071658`,0.005373775`,0.004621375`,0.006482183`,0.006330158`,0.005349758`,0.005349758`,0.005300633`,0.005105033`,0.005371092`,0.005899042`,0.005391925`,0.0050992`,0.005161092`,0.00379875`},{1/2187,0.00354685`,0.003578292`,0.003578292`,0.0035435`,0.003889342`,0.003873667`,0.003359233`,0.0038709`,0.003560408`,0.003897758`,0.00365165`,0.003664175`,0.003883483`,0.003361867`,0.00375055`,0.003224758`,0.003236917`,0.003198858`,0.0032387`,0.003571183`,0.0036844`,0.003505233`,0.003458158`,0.002645758`,0.003013625`,0.002575533`,0.002303617`,0.001683933`,0.001769683`,0.00280595`,0.003001608`,0.0032954`,0.002456083`,0.0024675`,0.004269358`,0.006107508`,0.008386725`,0.006162975`,0.0086239`,0.00591295`,0.009272875`,0.007082767`,0.008061808`,0.007200575`,0.007208675`,0.007050025`,0.00704115`,0.00412075`,0.004269358`,0.005470867`,0.006228175`,0.005588733`,0.00580585`,0.00546365`,0.006148342`,0.0070797`,0.004269358`,0.004226775`,0.004227767`,0.005347725`,0.0042074`,0.004734617`,0.007868358`,0.003975158`,0.00387165`,0.008931592`,0.006695467`,0.005030808`,0.005272417`,0.00501925`,0.00957115`,0.0095296`,0.00275645`,0.002908492`,0.004413883`,0.007481475`,0.004570717`,0.0043484`,0.0108256`,0.004533508`,0.002526825`,0.007040967`,0.004444483`,0.007783517`,0.003047242`,0.003086392`,0.003058783`,0.003058783`,0.003325592`,0.001491383`,0.001632875`,0.00414365`,0.001557808`,0.002357508`,0.004297`,0.003003075`,0.003005533`,0.007698342`,0.008250792`,0.006940258`,0.00584845`,0.007258742`,0.007576808`,0.006426358`,0.008250792`,0.007698342`,0.006448617`,0.007454892`,0.008287658`,0.008443675`,0.008443675`,0.008167133`,0.00679625`,0.004880958`,0.005554308`,0.004897183`,0.004575025`,0.004605808`,0.003938908`},{1/2268,0.00303925`,0.003049183`,0.003049183`,0.003007883`,0.002990783`,0.003165575`,0.002620467`,0.003127417`,0.002868325`,0.003185058`,0.00273515`,0.002741058`,0.003084233`,0.003325808`,0.003081042`,0.001967108`,0.001905183`,0.002591192`,0.002507567`,0.002908592`,0.003366633`,0.003185`,0.002978017`,0.001321642`,0.001871992`,0.001840117`,0.0023683`,0.00107645`,0.001089625`,0.002596425`,0.002758008`,0.0027059`,0.002195733`,0.001997775`,0.003175475`,0.008118408`,0.010082642`,0.007950058`,0.010256367`,0.007734725`,0.010609683`,0.008407933`,0.009791633`,0.005442408`,0.0052549`,0.005190642`,0.005264383`,0.003133175`,0.003175475`,0.00521625`,0.005797558`,0.005044025`,0.00455095`,0.005178258`,0.006822983`,0.0050847`,0.003175475`,0.003127917`,0.003122983`,0.005096825`,0.003106992`,0.003886117`,0.004808933`,0.002805375`,0.002913867`,0.005053633`,0.003998192`,0.0035696`,0.003259458`,0.003391467`,0.007550258`,0.008398033`,0.003015942`,0.002925817`,0.003928067`,0.006767233`,0.004011767`,0.00388235`,0.008131008`,0.003993483`,0.002877542`,0.006471167`,0.003926475`,0.007033775`,0.003482392`,0.003629633`,0.003524917`,0.003524917`,0.00355955`,0.002303542`,0.002182675`,0.004851308`,0.0023884`,0.004331`,0.004106908`,0.003870417`,0.003856192`,0.006250383`,0.0066737`,0.006835142`,0.00736955`,0.006959617`,0.007377467`,0.006735225`,0.0066737`,0.006250383`,0.005541133`,0.007666825`,0.006679442`,0.006491633`,0.006491633`,0.006173267`,0.006894667`,0.005885475`,0.005758592`,0.005896958`,0.00532345`,0.005398917`,0.004407842`},{1/2349,0.002476196`,0.002489254`,0.002489254`,0.002450787`,0.002536246`,0.002835379`,0.002487704`,0.002759387`,0.002224679`,0.002829454`,0.002113562`,0.001985537`,0.002683154`,0.002330621`,0.002508979`,0.001281637`,0.001262821`,0.001566304`,0.001957221`,0.001952871`,0.002437604`,0.001851512`,0.001742837`,0.001094729`,0.001584487`,0.001218212`,0.002842546`,0.000957579`,0.001004312`,0.002091512`,0.003174054`,0.002019029`,0.001456171`,0.001298004`,0.002414029`,0.004197379`,0.009644671`,0.004834362`,0.009902879`,0.005027562`,0.010163354`,0.004229537`,0.005890954`,0.003260637`,0.003249746`,0.003245221`,0.003245004`,0.002478854`,0.002414029`,0.002831137`,0.002944637`,0.002793671`,0.002602696`,0.002818337`,0.003374787`,0.003041821`,0.002414029`,0.002377971`,0.002341204`,0.003203829`,0.002338562`,0.002470787`,0.003504046`,0.002266254`,0.002308296`,0.004628637`,0.003232362`,0.004112746`,0.003253196`,0.004809162`,0.006535004`,0.007517904`,0.004996379`,0.004185929`,0.007653046`,0.008256712`,0.007803262`,0.007417629`,0.009301379`,0.007710046`,0.003216587`,0.007340029`,0.007558554`,0.008536921`,0.004630154`,0.004750262`,0.004660862`,0.004660862`,0.004686229`,0.002604221`,0.002558354`,0.003813637`,0.003129371`,0.004841187`,0.003523496`,0.004034654`,0.004047987`,0.005798087`,0.006149179`,0.006837146`,0.006625979`,0.007088529`,0.007067921`,0.006928471`,0.006149179`,0.005798087`,0.005097296`,0.006925012`,0.006108887`,0.006187046`,0.006187046`,0.005847312`,0.006967946`,0.005164054`,0.005136729`,0.005154679`,0.005619471`,0.005624062`,0.005093871`},{1/2430,0.001457771`,0.001472438`,0.001472438`,0.001456454`,0.001337071`,0.001239438`,0.001276204`,0.001178371`,0.001583654`,0.001242671`,0.001613704`,0.001394338`,0.001358288`,0.001495654`,0.001340488`,0.001595638`,0.001578321`,0.001443321`,0.001686171`,0.001602671`,0.001688304`,0.001485054`,0.001512504`,0.001249071`,0.001640454`,0.001243854`,0.002250504`,0.001003438`,0.001011221`,0.002080538`,0.002626354`,0.002028904`,0.001189554`,0.001414488`,0.001458171`,0.004221571`,0.010647804`,0.004692554`,0.011021771`,0.005083304`,0.010965221`,0.005362354`,0.005915488`,0.004530121`,0.004446188`,0.004348721`,0.004384188`,0.001415338`,0.001458171`,0.002651188`,0.003207254`,0.002654954`,0.002629404`,0.002638188`,0.003666254`,0.003898454`,0.001458171`,0.001412604`,0.001408104`,0.002515371`,0.001401188`,0.001593271`,0.005574304`,0.001781338`,0.001901854`,0.007402304`,0.003691071`,0.003776621`,0.003238888`,0.004647488`,0.008876938`,0.009813471`,0.002959521`,0.002946054`,0.004781488`,0.007538371`,0.004957871`,0.004589454`,0.009323788`,0.004873988`,0.003002288`,0.007209971`,0.004824838`,0.008609771`,0.004099438`,0.004132538`,0.004107804`,0.004107804`,0.003636138`,0.002084054`,0.002111188`,0.004018154`,0.002375604`,0.004817571`,0.003310304`,0.004272554`,0.004262454`,0.004994471`,0.005275621`,0.005947171`,0.005339054`,0.006341171`,0.006784888`,0.005939171`,0.005275621`,0.004994471`,0.004629921`,0.006912938`,0.005216738`,0.005318721`,0.005318721`,0.005089738`,0.006016371`,0.004494738`,0.004701871`,0.004527471`,0.004913688`,0.004861604`,0.004309488`},{1/2511,0.001383304`,0.001404421`,0.001404421`,0.001401688`,0.001381796`,0.001156954`,0.001388204`,0.001102321`,0.001368954`,0.001166096`,0.001676054`,0.001409421`,0.001227088`,0.001399263`,0.001555046`,0.001989954`,0.001994054`,0.001505804`,0.001590746`,0.001560838`,0.001662104`,0.001604729`,0.001513496`,0.001500488`,0.001598263`,0.001893338`,0.002649371`,0.001655696`,0.001627946`,0.002537071`,0.002789896`,0.002188129`,0.002475696`,0.002459263`,0.001311646`,0.006532263`,0.011518254`,0.007187288`,0.011789921`,0.006720396`,0.011982221`,0.006394971`,0.007525754`,0.002823438`,0.002750038`,0.002735129`,0.002768513`,0.001298221`,0.001311646`,0.001733029`,0.002007071`,0.001746071`,0.001738871`,0.001728488`,0.002170896`,0.002189146`,0.001311646`,0.001250346`,0.001237813`,0.002169096`,0.001233338`,0.001334538`,0.003766046`,0.001706263`,0.002029621`,0.005141004`,0.002458654`,0.003154996`,0.002436396`,0.003448421`,0.007394663`,0.009067529`,0.003670213`,0.003341379`,0.004540004`,0.006272454`,0.004656496`,0.004548204`,0.007936113`,0.004644613`,0.003715179`,0.006103421`,0.004503588`,0.006995329`,0.003249029`,0.003248179`,0.003246946`,0.003246946`,0.003404663`,0.002641263`,0.002615346`,0.003935796`,0.002128346`,0.003005913`,0.002777246`,0.003621079`,0.003607904`,0.004747946`,0.005181621`,0.004446771`,0.004475804`,0.005018696`,0.005660463`,0.004369338`,0.005181621`,0.004747946`,0.003880913`,0.005723713`,0.005244096`,0.004871746`,0.004871746`,0.004702571`,0.004483346`,0.004602813`,0.004905629`,0.004614071`,0.005090046`,0.005050371`,0.003738654`},{2/81,0.001907908`,0.001941592`,0.001941592`,0.001929858`,0.002112825`,0.002119942`,0.001956158`,0.002113208`,0.002173808`,0.002170658`,0.002219692`,0.001915525`,0.002080675`,0.002317558`,0.002211142`,0.003077225`,0.003074842`,0.003246108`,0.002888608`,0.002975708`,0.002574708`,0.002753475`,0.002887658`,0.002590992`,0.002843842`,0.002530108`,0.002219658`,0.002106492`,0.002133708`,0.002848358`,0.003739158`,0.003774242`,0.002195675`,0.002191908`,0.001948775`,0.008220208`,0.013235258`,0.009523692`,0.013387425`,0.009121475`,0.013268692`,0.008209475`,0.009664625`,0.003181175`,0.002936892`,0.002919925`,0.003020142`,0.001956592`,0.001948775`,0.002904342`,0.002768808`,0.002812092`,0.002515925`,0.002939458`,0.003591075`,0.002709542`,0.001948775`,0.001686858`,0.001700142`,0.003448175`,0.001704458`,0.002123325`,0.005994342`,0.003357842`,0.003610742`,0.008562325`,0.003743475`,0.005975742`,0.004192808`,0.005736425`,0.009672208`,0.011142608`,0.003290742`,0.003231692`,0.005212942`,0.007548708`,0.005408092`,0.005183875`,0.009473108`,0.005364292`,0.002006758`,0.007276408`,0.005180575`,0.007860575`,0.002900942`,0.002964508`,0.002923992`,0.002923992`,0.002458042`,0.002127742`,0.002263992`,0.003289725`,0.002006275`,0.002510242`,0.002716058`,0.003315408`,0.003295008`,0.004732758`,0.005252875`,0.004797775`,0.004226792`,0.004820025`,0.005313008`,0.004135125`,0.005252875`,0.004732758`,0.003676108`,0.005094275`,0.005382742`,0.004647242`,0.004647242`,0.004575842`,0.004586375`,0.004196792`,0.004094992`,0.004181842`,0.004831258`,0.004909658`,0.003254958`},{1/81,0.00444395`,0.00443045`,0.00443045`,0.004330383`,0.004911133`,0.005753367`,0.004121867`,0.005742883`,0.003403617`,0.005684317`,0.0035507`,0.003823167`,0.005999317`,0.003293733`,0.0037363`,0.001458167`,0.001439017`,0.0017497`,0.002071417`,0.002366883`,0.002918417`,0.002697267`,0.002322783`,0.001038467`,0.001336867`,0.0009416`,0.00131485`,0.000704967`,0.000712117`,0.001206783`,0.001022467`,0.001381183`,0.00110665`,0.001039017`,0.0055641`,0.009134933`,0.014241217`,0.009095067`,0.014340967`,0.010213183`,0.0143644`,0.007757733`,0.011359617`,0.00448015`,0.004323617`,0.004162467`,0.004222217`,0.00588945`,0.0055641`,0.0049437`,0.00539315`,0.005612983`,0.005558933`,0.005268267`,0.006581733`,0.00448215`,0.0055641`,0.005418467`,0.005481683`,0.006904867`,0.005445233`,0.006317333`,0.00415095`,0.002546417`,0.0022549`,0.00342125`,0.003679083`,0.0020162`,0.002591917`,0.001799017`,0.003970783`,0.004910767`,0.00139165`,0.001213233`,0.001883517`,0.002536133`,0.001936867`,0.001954533`,0.003022933`,0.001954583`,0.00211315`,0.002460717`,0.001886583`,0.002590217`,0.0029356`,0.00300355`,0.002961`,0.002961`,0.002213083`,0.001671917`,0.001618917`,0.002820433`,0.001941867`,0.002467983`,0.002731133`,0.00280305`,0.00268855`,0.00527565`,0.0059345`,0.005967683`,0.004684533`,0.005720867`,0.006551433`,0.004373767`,0.0059345`,0.00527565`,0.004236117`,0.006438533`,0.00615845`,0.0048284`,0.0048284`,0.004801683`,0.0053859`,0.003892417`,0.003859417`,0.00390335`,0.0045022`,0.004589317`,0.0031605`},{2/243,0.002363033`,0.002395117`,0.002395117`,0.002385092`,0.002356558`,0.00132185`,0.001320883`,0.0013544`,0.001249225`,0.001352267`,0.001355175`,0.001489217`,0.001063558`,0.001055608`,0.00104755`,0.0008142`,0.000811258`,0.000791308`,0.000966808`,0.001037083`,0.000985808`,0.000965067`,0.0009269`,0.000762292`,0.00078025`,0.001024642`,0.0017329`,0.00082455`,0.000829492`,0.001218142`,0.001180042`,0.001276008`,0.001124583`,0.001045758`,0.000949242`,0.00276075`,0.007795833`,0.003046383`,0.00805625`,0.003311467`,0.008215175`,0.002456942`,0.004385875`,0.0014863`,0.001438192`,0.001398258`,0.001422258`,0.00097815`,0.000949242`,0.001651958`,0.001403925`,0.001537542`,0.001237242`,0.0016507`,0.001767175`,0.001380117`,0.000949242`,0.000880708`,0.000889467`,0.002046458`,0.0008835`,0.001282117`,0.001579408`,0.0009352`,0.00110905`,0.00197355`,0.001220917`,0.001564808`,0.0011698`,0.001654508`,0.002412308`,0.002713533`,0.001884542`,0.001463692`,0.002136383`,0.002430525`,0.002153242`,0.002155317`,0.002780842`,0.002164858`,0.002366417`,0.002405725`,0.002134083`,0.002713867`,0.003224333`,0.003316167`,0.003263392`,0.003263392`,0.0022232`,0.001811767`,0.0018592`,0.002756017`,0.002109783`,0.002484442`,0.002869333`,0.002607842`,0.002490042`,0.00549715`,0.0062776`,0.006327525`,0.004980708`,0.005923867`,0.007014167`,0.004326433`,0.0062776`,0.00549715`,0.004377092`,0.007378292`,0.006579867`,0.004838117`,0.004838117`,0.004889633`,0.005581767`,0.003806133`,0.004013658`,0.003821525`,0.004058383`,0.0040683`,0.00299945`},{1/162,0.00085455`,0.000887267`,0.000887267`,0.000900592`,0.000957467`,0.000758342`,0.000715842`,0.000747833`,0.001061525`,0.000784458`,0.001108083`,0.00109885`,0.0007738`,0.0011945`,0.00106485`,0.001035758`,0.001030267`,0.001011667`,0.0011117`,0.001414275`,0.001137717`,0.00128125`,0.001251525`,0.000949708`,0.000942083`,0.001073817`,0.00186525`,0.000903808`,0.000930617`,0.001230892`,0.00135585`,0.001507758`,0.001199517`,0.001069583`,0.000817375`,0.001878833`,0.006530733`,0.00255985`,0.006820067`,0.002272808`,0.007237358`,0.002076125`,0.002781125`,0.001824408`,0.001771533`,0.001762292`,0.001792308`,0.00086215`,0.000817375`,0.001335733`,0.001465858`,0.00132115`,0.001305475`,0.0013574`,0.001657883`,0.001546792`,0.000817375`,0.000812142`,0.000810308`,0.001515667`,0.000804633`,0.001111567`,0.002189483`,0.001299433`,0.001604125`,0.0028179`,0.001639242`,0.0019193`,0.001767267`,0.002132758`,0.003537308`,0.003933067`,0.001926408`,0.001831633`,0.00316025`,0.00542275`,0.003328342`,0.003392642`,0.005965008`,0.003370667`,0.003231108`,0.005248558`,0.003117142`,0.006082658`,0.002962808`,0.003075533`,0.003001933`,0.003001933`,0.00229625`,0.002151833`,0.002169817`,0.002825367`,0.002255458`,0.002419292`,0.003026017`,0.0023247`,0.002224725`,0.0060279`,0.006674583`,0.006615742`,0.005071825`,0.006709225`,0.007562925`,0.005456675`,0.006674583`,0.0060279`,0.004551583`,0.007484925`,0.006832058`,0.005522225`,0.005522225`,0.0055299`,0.006183958`,0.003498992`,0.004120292`,0.003505625`,0.003742967`,0.003820075`,0.002819717`},{2/405,0.001031388`,0.001062529`,0.001062529`,0.001079829`,0.001171438`,0.000746713`,0.000673421`,0.000729204`,0.000953563`,0.000769846`,0.001020921`,0.001011654`,0.000756146`,0.001222671`,0.001046521`,0.001108071`,0.001114588`,0.001022221`,0.001155221`,0.001381113`,0.001220746`,0.001219429`,0.001231954`,0.001067454`,0.001039863`,0.001384846`,0.002221938`,0.001095246`,0.001091854`,0.001620179`,0.001621229`,0.001478454`,0.001718379`,0.001609738`,0.000854913`,0.003016146`,0.008984729`,0.003650663`,0.009264604`,0.003570204`,0.009457946`,0.002979013`,0.003810979`,0.001613888`,0.001574929`,0.001585729`,0.001594071`,0.000858621`,0.000854913`,0.001358029`,0.001440321`,0.001360388`,0.001322921`,0.001358646`,0.001679629`,0.001355263`,0.000854913`,0.000862504`,0.000856879`,0.001618096`,0.000850404`,0.001040113`,0.001787588`,0.001193221`,0.001501063`,0.002738863`,0.001510121`,0.001669121`,0.001465679`,0.001986904`,0.004653271`,0.005768363`,0.002730146`,0.002569938`,0.003681129`,0.005422263`,0.003831888`,0.003840979`,0.006458821`,0.003859746`,0.003703896`,0.005225521`,0.003661846`,0.006452271`,0.003088979`,0.003174313`,0.003119288`,0.003119288`,0.002462563`,0.001872029`,0.001878646`,0.002894846`,0.002168213`,0.002344771`,0.003034179`,0.002637663`,0.002535946`,0.005954371`,0.006537579`,0.006665379`,0.004992038`,0.006645529`,0.007164863`,0.005668263`,0.006537579`,0.005954371`,0.004908263`,0.007098821`,0.006649688`,0.005494879`,0.005494879`,0.005448029`,0.006284579`,0.004725346`,0.005274838`,0.004731696`,0.003887538`,0.003925813`,0.002908821`},{1/243,0.001271258`,0.00128475`,0.00128475`,0.001265167`,0.001640592`,0.001565042`,0.001142125`,0.0015485`,0.001714942`,0.001585133`,0.001812608`,0.001581567`,0.001497467`,0.001954133`,0.001759858`,0.002170975`,0.002157158`,0.002290942`,0.002075792`,0.002560442`,0.00217055`,0.002398825`,0.002442808`,0.00196435`,0.002015633`,0.002420825`,0.002304533`,0.002101417`,0.0020757`,0.002684225`,0.002945217`,0.002693825`,0.002565067`,0.0025052`,0.00151125`,0.005589225`,0.0102089`,0.0061076`,0.010345308`,0.006589892`,0.010435417`,0.00497765`,0.006432508`,0.002847117`,0.002583208`,0.0025957`,0.002708883`,0.001573283`,0.00151125`,0.001871858`,0.0019008`,0.0017964`,0.001690458`,0.001872858`,0.002392142`,0.001949325`,0.00151125`,0.001424608`,0.001404192`,0.002642525`,0.001400475`,0.0014542`,0.003491708`,0.002383492`,0.002673708`,0.004696442`,0.00224545`,0.003135008`,0.002456975`,0.003431492`,0.00614655`,0.008479875`,0.00372905`,0.003526592`,0.004750608`,0.006084808`,0.004828825`,0.004888858`,0.00646785`,0.00487395`,0.004123925`,0.005897475`,0.004711083`,0.006903575`,0.002846967`,0.002934258`,0.002880633`,0.002880633`,0.002028967`,0.001887417`,0.001576208`,0.003665783`,0.002136308`,0.002341358`,0.003268408`,0.003020083`,0.00306415`,0.005789025`,0.006303792`,0.007244525`,0.005337717`,0.007424775`,0.007589033`,0.006465767`,0.006303792`,0.005789025`,0.005091858`,0.007430408`,0.006355767`,0.005728092`,0.005728092`,0.005493825`,0.006966908`,0.0041583`,0.004639192`,0.004162867`,0.003647433`,0.003699525`,0.002878525`},{2/567,0.002541192`,0.002572092`,0.002572092`,0.002554792`,0.002733467`,0.002768925`,0.002275158`,0.002657517`,0.002535608`,0.002815567`,0.002529175`,0.002517533`,0.002262725`,0.002910408`,0.002720117`,0.002658758`,0.002638358`,0.002917075`,0.002616217`,0.003148567`,0.002822642`,0.0030242`,0.003030158`,0.002449033`,0.002488108`,0.002469925`,0.002129875`,0.002196117`,0.002227842`,0.00284595`,0.003350158`,0.003086667`,0.002355283`,0.002299792`,0.00226045`,0.008837442`,0.011902592`,0.009324458`,0.012000492`,0.009809858`,0.012323175`,0.008019242`,0.010721625`,0.005180558`,0.005062617`,0.004992392`,0.005035492`,0.002337667`,0.00226045`,0.002925858`,0.003561225`,0.00289415`,0.0028966`,0.002900383`,0.004150942`,0.004140192`,0.00226045`,0.002111125`,0.002101967`,0.00308565`,0.002079908`,0.00209845`,0.005710833`,0.003007775`,0.003230267`,0.0063708`,0.003933767`,0.004536608`,0.003632125`,0.004999408`,0.007866667`,0.008468225`,0.00445815`,0.003801783`,0.005663825`,0.007123158`,0.005782483`,0.005557525`,0.007717575`,0.005735842`,0.003772183`,0.006929017`,0.005651925`,0.00738475`,0.003052992`,0.003191833`,0.003095483`,0.003095483`,0.003077025`,0.001895208`,0.001780433`,0.00350315`,0.001919417`,0.002499783`,0.003182675`,0.002964083`,0.002886383`,0.005701425`,0.006209383`,0.007517758`,0.005867333`,0.007479942`,0.007666967`,0.006597467`,0.006209383`,0.005701425`,0.005008283`,0.007398183`,0.00628695`,0.005670767`,0.005670767`,0.005515733`,0.0072008`,0.003733017`,0.004139158`,0.003757425`,0.003813617`,0.003800242`,0.002905683`},{1/324,0.003494396`,0.003520096`,0.003520096`,0.003473863`,0.003774529`,0.003886129`,0.003107863`,0.003913196`,0.002896613`,0.003927679`,0.003023913`,0.003149029`,0.003711663`,0.003261479`,0.003195613`,0.001741529`,0.001730879`,0.001952696`,0.002070746`,0.002620046`,0.002817879`,0.002937679`,0.002603013`,0.001528396`,0.001689713`,0.000932296`,0.001830479`,0.001284329`,0.001336463`,0.001564896`,0.001661179`,0.001680246`,0.000990313`,0.001038213`,0.003987313`,0.009777846`,0.014170846`,0.009550113`,0.014266779`,0.011984596`,0.014494613`,0.009162979`,0.012974779`,0.005656013`,0.005575879`,0.005485963`,0.005505096`,0.003856463`,0.003987313`,0.005158563`,0.005058746`,0.005170679`,0.004892163`,0.005170029`,0.005636063`,0.005184863`,0.003987313`,0.003843279`,0.003835063`,0.006185613`,0.003825496`,0.004629796`,0.005550813`,0.002902979`,0.002613446`,0.006279529`,0.004714813`,0.003566646`,0.003664996`,0.003905013`,0.007358546`,0.008481646`,0.002727496`,0.002501279`,0.005123346`,0.006533329`,0.005244679`,0.005064746`,0.007509829`,0.005221196`,0.003486129`,0.006259396`,0.005118463`,0.007228729`,0.003345179`,0.003455446`,0.003380946`,0.003380946`,0.002982229`,0.002018196`,0.002081863`,0.002871563`,0.001937963`,0.003105979`,0.002873429`,0.002840713`,0.002768429`,0.006111046`,0.006725479`,0.007720513`,0.006623979`,0.007664046`,0.007899913`,0.006615996`,0.006725479`,0.006111046`,0.005310329`,0.008023246`,0.006873413`,0.006359629`,0.006359629`,0.006038696`,0.007331879`,0.003749946`,0.003991113`,0.003778129`,0.003773413`,0.003789946`,0.003146029`},{2/729,0.002790362`,0.002855346`,0.002855346`,0.002903462`,0.002815129`,0.002276462`,0.002468629`,0.002296346`,0.001833879`,0.002289896`,0.002015812`,0.002151929`,0.002032196`,0.001681012`,0.001665496`,0.001720479`,0.001723079`,0.001512096`,0.001759029`,0.001399662`,0.001801296`,0.001651479`,0.001620679`,0.001435579`,0.001516179`,0.001184712`,0.002042662`,0.001021329`,0.001052412`,0.001929762`,0.002338412`,0.001779196`,0.001491229`,0.001378746`,0.001777046`,0.006132212`,0.012064312`,0.006069712`,0.012297262`,0.008337996`,0.012790946`,0.004626012`,0.008613179`,0.002498312`,0.002451312`,0.002446979`,0.002463046`,0.001838329`,0.001777046`,0.002179346`,0.002178862`,0.002139062`,0.001896679`,0.002179946`,0.002762212`,0.002287496`,0.001777046`,0.001722646`,0.001718762`,0.002797446`,0.001709162`,0.002128746`,0.002551446`,0.001512179`,0.001609812`,0.003883012`,0.002135912`,0.002650496`,0.002091462`,0.003342279`,0.005903529`,0.006801596`,0.003701596`,0.003051462`,0.005545512`,0.007419262`,0.005677329`,0.005585879`,0.007731879`,0.005678262`,0.003308446`,0.007229412`,0.005506796`,0.008072862`,0.006117379`,0.006241946`,0.006151329`,0.006151329`,0.005993696`,0.002539262`,0.002262496`,0.002993012`,0.003736729`,0.005899762`,0.004272429`,0.003483162`,0.003424646`,0.007403679`,0.007878912`,0.008642562`,0.008006762`,0.008847462`,0.008490346`,0.008626862`,0.007878912`,0.007403679`,0.006337612`,0.008169679`,0.007846096`,0.008181379`,0.008181379`,0.007771079`,0.008743279`,0.003763679`,0.004031996`,0.003784129`,0.003759279`,0.003775712`,0.002938429`},{1/405,0.001697529`,0.001790913`,0.001790913`,0.001859229`,0.001976496`,0.002303763`,0.002172596`,0.002204246`,0.002354446`,0.002288129`,0.002336496`,0.002212429`,0.002580363`,0.002447863`,0.002227679`,0.002414246`,0.002394229`,0.003206079`,0.002308079`,0.003118146`,0.002686146`,0.002978263`,0.003045696`,0.001513196`,0.001923979`,0.001321913`,0.001135863`,0.000733979`,0.000758096`,0.001976763`,0.003615446`,0.003580746`,0.001195813`,0.001155563`,0.002986796`,0.009120563`,0.014389246`,0.009871729`,0.014539863`,0.010792596`,0.014676363`,0.008199163`,0.010938129`,0.005271463`,0.004943346`,0.004901913`,0.005052763`,0.002875396`,0.002986796`,0.004012663`,0.003581146`,0.003957679`,0.003670079`,0.004008679`,0.005481396`,0.004053963`,0.002986796`,0.002822029`,0.002807013`,0.004399096`,0.002804746`,0.003219229`,0.005959646`,0.003510896`,0.003690646`,0.009307646`,0.003926479`,0.006659613`,0.004928763`,0.007299746`,0.011246879`,0.012364329`,0.003960063`,0.003686763`,0.007861563`,0.009888829`,0.008155946`,0.007783529`,0.010786979`,0.008079696`,0.004682663`,0.009691463`,0.007812263`,0.009395896`,0.007538479`,0.007424979`,0.007508546`,0.007508546`,0.006817296`,0.001942346`,0.001544646`,0.001953579`,0.004029446`,0.005506313`,0.003684613`,0.003048896`,0.003022663`,0.006946113`,0.007522329`,0.008419696`,0.007736546`,0.008629646`,0.008925779`,0.007918363`,0.007522329`,0.006946113`,0.006126879`,0.008776596`,0.007576429`,0.007091429`,0.007091429`,0.006722713`,0.008313163`,0.003999163`,0.004668229`,0.004005363`,0.002181713`,0.002249596`,0.001244646`},{2/891,0.004338662`,0.004343579`,0.004343579`,0.004236096`,0.005014396`,0.006185429`,0.004144062`,0.006021496`,0.004053246`,0.006000779`,0.004302046`,0.004533396`,0.007408196`,0.003947162`,0.005176379`,0.001376112`,0.001346079`,0.002076662`,0.001921296`,0.002930862`,0.003744596`,0.003577729`,0.002951246`,0.000819162`,0.001109862`,0.000523929`,0.000903096`,0.000446812`,0.000463946`,0.000632179`,0.000862629`,0.000969996`,0.000627696`,0.000568262`,0.007607812`,0.012613096`,0.015860712`,0.012727846`,0.016014179`,0.013234846`,0.016148112`,0.010183846`,0.013582496`,0.007576696`,0.007662679`,0.007398096`,0.007316996`,0.007925746`,0.007607812`,0.009997629`,0.008746479`,0.010056246`,0.009295579`,0.010095712`,0.009942662`,0.008109212`,0.007607812`,0.007539979`,0.007564029`,0.009887229`,0.007498512`,0.009177096`,0.005500846`,0.003261996`,0.002518762`,0.003431596`,0.005043362`,0.002051129`,0.003478229`,0.001414696`,0.004918762`,0.006651146`,0.000950362`,0.000761946`,0.000955012`,0.001926212`,0.000986212`,0.000954296`,0.002500529`,0.000982546`,0.000938912`,0.001825496`,0.000959962`,0.002302179`,0.006169462`,0.006203746`,0.006181779`,0.006181779`,0.005507846`,0.001305612`,0.001291512`,0.001433179`,0.001937879`,0.004842496`,0.003912462`,0.001886596`,0.002012029`,0.007072279`,0.007644346`,0.007941179`,0.007113762`,0.008114812`,0.008513996`,0.007553012`,0.007644346`,0.007072279`,0.006430129`,0.008420579`,0.007687662`,0.007401996`,0.007401996`,0.007065429`,0.007895212`,0.003899512`,0.005521562`,0.003880629`,0.002367746`,0.002384579`,0.001778912`},{1/486,0.003522213`,0.003466263`,0.003466263`,0.003318079`,0.003542096`,0.002735129`,0.001976113`,0.002759313`,0.000997479`,0.002716713`,0.001216896`,0.001564163`,0.002411863`,0.001024929`,0.001194479`,0.000592863`,0.000592613`,0.000740529`,0.000797929`,0.000793329`,0.000901213`,0.000874796`,0.000803613`,0.000698879`,0.000631729`,0.000959196`,0.001724979`,0.000630563`,0.000626279`,0.001144529`,0.001460896`,0.001075129`,0.001278296`,0.001226646`,0.001845596`,0.004253079`,0.012924229`,0.004485579`,0.013129179`,0.006492746`,0.013349529`,0.002130846`,0.006153379`,0.001212563`,0.001233813`,0.001244796`,0.001177513`,0.001882296`,0.001845596`,0.001964746`,0.001435079`,0.001889213`,0.001459229`,0.002004896`,0.001759163`,0.001131746`,0.001845596`,0.001666779`,0.001670563`,0.003504429`,0.001681796`,0.002055896`,0.001252479`,0.000763063`,0.001010779`,0.001260213`,0.000965113`,0.001323379`,0.000892413`,0.001088496`,0.001691979`,0.002619429`,0.001691163`,0.001471596`,0.001187396`,0.001943263`,0.001190929`,0.001191713`,0.002196213`,0.001194846`,0.001639713`,0.001968463`,0.001189996`,0.002176546`,0.005298196`,0.005362246`,0.005323146`,0.005323146`,0.004529096`,0.002269913`,0.002271413`,0.003771013`,0.002124163`,0.005032896`,0.004065913`,0.004004446`,0.003949129`,0.007221463`,0.007763896`,0.008150813`,0.007294229`,0.008356346`,0.008764496`,0.007644246`,0.007763896`,0.007221463`,0.005948146`,0.008687279`,0.007781663`,0.007024546`,0.007024546`,0.006733013`,0.008039529`,0.006636813`,0.007592096`,0.006643379`,0.004795029`,0.004670996`,0.003139063`},{2/1053,0.001032329`,0.001079638`,0.001079638`,0.001113971`,0.001110071`,0.001651113`,0.000880221`,0.001556688`,0.001233004`,0.001636254`,0.001331638`,0.001258846`,0.001386229`,0.001051563`,0.001135463`,0.001136829`,0.001140879`,0.001362529`,0.001357521`,0.001392371`,0.001267929`,0.001375229`,0.001398921`,0.001464696`,0.001429404`,0.001655996`,0.002034163`,0.001357929`,0.001356113`,0.001809804`,0.002231713`,0.001853888`,0.001980238`,0.001987154`,0.001140171`,0.007052429`,0.012152446`,0.007654821`,0.012293846`,0.008705613`,0.012403163`,0.003425688`,0.008436046`,0.001673579`,0.001658529`,0.001695379`,0.001653979`,0.001221063`,0.001140171`,0.001437979`,0.001251229`,0.001363154`,0.001049646`,0.001457438`,0.001976538`,0.001256354`,0.001140171`,0.001093021`,0.001092746`,0.002783654`,0.001083188`,0.001280738`,0.001833654`,0.001194288`,0.001686263`,0.002066971`,0.001891813`,0.002178021`,0.001617504`,0.001657396`,0.002806263`,0.004214004`,0.002331363`,0.002212813`,0.002389121`,0.003452446`,0.002424771`,0.002646129`,0.003436729`,0.002504329`,0.002483854`,0.003382021`,0.002341296`,0.004126546`,0.004966479`,0.004974329`,0.004980963`,0.004980963`,0.004318029`,0.002263504`,0.002354513`,0.004374396`,0.002526663`,0.003741404`,0.004148654`,0.003682704`,0.003614829`,0.007737854`,0.008128288`,0.007184304`,0.007929496`,0.007066613`,0.007645829`,0.005837596`,0.008128288`,0.007737854`,0.005839654`,0.007688513`,0.008012704`,0.007629496`,0.007629496`,0.007302429`,0.006735088`,0.006647538`,0.007089696`,0.006672188`,0.006322404`,0.006260071`,0.003939471`},{1/567,0.001767825`,0.001849933`,0.001849933`,0.00189955`,0.002032875`,0.002338858`,0.001223433`,0.002349842`,0.001997158`,0.002369675`,0.002044`,0.001815692`,0.00208245`,0.00182315`,0.001935592`,0.002011625`,0.002026067`,0.002065583`,0.002277617`,0.002385217`,0.001969225`,0.002213775`,0.002166967`,0.0023525`,0.002426192`,0.002515225`,0.002368325`,0.0021284`,0.002146792`,0.002398933`,0.002538683`,0.00233325`,0.002652917`,0.002686942`,0.001963558`,0.007975742`,0.012062158`,0.008544983`,0.012208008`,0.008994575`,0.012024`,0.005506708`,0.009083633`,0.003042183`,0.0029969`,0.0029555`,0.002988217`,0.002002692`,0.001963558`,0.002657175`,0.00242935`,0.002522942`,0.002024842`,0.002660842`,0.003364942`,0.002523242`,0.001963558`,0.0017608`,0.001785133`,0.003882242`,0.001775508`,0.002157858`,0.003632767`,0.0024737`,0.002581175`,0.0034651`,0.002954325`,0.002913808`,0.002969267`,0.002527333`,0.004321792`,0.006372033`,0.003504242`,0.002957308`,0.003750183`,0.004352158`,0.003783375`,0.003958592`,0.003768717`,0.003854592`,0.003041133`,0.004343075`,0.003704975`,0.004677133`,0.004092142`,0.004169283`,0.004122625`,0.004122625`,0.003496517`,0.001931867`,0.001872442`,0.00585555`,0.002547417`,0.003802483`,0.004849483`,0.0044679`,0.004342308`,0.008796767`,0.009119458`,0.007534158`,0.009159058`,0.007227442`,0.00752115`,0.006213225`,0.009119458`,0.008796767`,0.006471392`,0.0073476`,0.00889575`,0.009237892`,0.009237892`,0.008822842`,0.007112567`,0.007363942`,0.007494875`,0.007413108`,0.006856733`,0.006925917`,0.004628142`},{2/1215,0.0018705`,0.001902483`,0.001902483`,0.001901117`,0.002145692`,0.002755533`,0.001829433`,0.002660108`,0.002421842`,0.0027949`,0.002492358`,0.002327067`,0.002532817`,0.002273042`,0.002270883`,0.002385708`,0.00235635`,0.002936225`,0.002691433`,0.003143767`,0.002521867`,0.002718708`,0.002805783`,0.002741008`,0.002624492`,0.0032303`,0.003507467`,0.003350558`,0.003394017`,0.003113683`,0.003333933`,0.003334925`,0.003699067`,0.003786942`,0.002558325`,0.008856775`,0.011406817`,0.009135292`,0.011492`,0.009569117`,0.0118181`,0.007808658`,0.00985565`,0.004780317`,0.004736383`,0.004634058`,0.004653025`,0.0024931`,0.002558325`,0.00344385`,0.003831033`,0.003336733`,0.003249042`,0.003385417`,0.004943617`,0.004128567`,0.002558325`,0.002369908`,0.00237995`,0.004082042`,0.00236595`,0.002634925`,0.0053802`,0.003474575`,0.003651375`,0.00579845`,0.004216575`,0.004858992`,0.004543542`,0.004223767`,0.006885792`,0.008722283`,0.004452425`,0.003674908`,0.00459565`,0.0053862`,0.004685942`,0.004902117`,0.005041242`,0.004778617`,0.004381033`,0.005360133`,0.00452435`,0.005387825`,0.004432383`,0.00445725`,0.0044427`,0.0044427`,0.003965042`,0.002104842`,0.002294217`,0.004475717`,0.00258225`,0.004348458`,0.003981767`,0.004497817`,0.004394992`,0.007428258`,0.007909483`,0.008019008`,0.008147717`,0.008119375`,0.008415942`,0.006992092`,0.007909483`,0.007428258`,0.006547867`,0.008203058`,0.007861942`,0.007597967`,0.007597967`,0.0072541`,0.007722842`,0.006630492`,0.007113092`,0.006662392`,0.006296175`,0.006279633`,0.00479565`},{1/648,0.003102708`,0.003122742`,0.003122742`,0.003071567`,0.003481475`,0.003859717`,0.002788467`,0.003852817`,0.003153483`,0.003886817`,0.003005383`,0.002991558`,0.003749058`,0.002817742`,0.003025117`,0.003629117`,0.003569442`,0.004321692`,0.004070192`,0.004569858`,0.003807983`,0.00406235`,0.004179025`,0.003934808`,0.003709917`,0.004059025`,0.00330755`,0.003730208`,0.0037447`,0.004040683`,0.004940267`,0.005032375`,0.00388565`,0.0039029`,0.003740608`,0.009702492`,0.012666792`,0.009994375`,0.012768108`,0.010259917`,0.012698467`,0.009778867`,0.0105443`,0.007189267`,0.006972942`,0.006917667`,0.007025292`,0.003699042`,0.003740608`,0.004658267`,0.005346258`,0.004664117`,0.004674317`,0.004652267`,0.0068185`,0.005807175`,0.003740608`,0.0036073`,0.0035959`,0.005104742`,0.003583208`,0.0038117`,0.008068675`,0.005436033`,0.005918508`,0.008697217`,0.005964125`,0.006650842`,0.007063058`,0.006731417`,0.008364217`,0.009492392`,0.005034133`,0.004757083`,0.005430667`,0.005865292`,0.005500925`,0.005449783`,0.007297925`,0.005510575`,0.004730508`,0.0057419`,0.005405742`,0.005778467`,0.004928875`,0.004930683`,0.004931417`,0.004931417`,0.004397317`,0.002531167`,0.0024466`,0.005509258`,0.003339108`,0.003625892`,0.0045076`,0.004307433`,0.004231075`,0.0065374`,0.007255617`,0.007307225`,0.006928633`,0.007235042`,0.007824933`,0.005790133`,0.007255617`,0.0065374`,0.006788008`,0.007888042`,0.007463458`,0.006495`,0.006495`,0.006244925`,0.006778308`,0.00790475`,0.007856442`,0.00793135`,0.007419217`,0.007356375`,0.006116767`},{2/1377,0.005108388`,0.005108971`,0.005108971`,0.005004454`,0.005093096`,0.005134546`,0.004579863`,0.005216879`,0.004355046`,0.005132896`,0.004866821`,0.004400479`,0.005374688`,0.004421379`,0.004730113`,0.004104604`,0.004040746`,0.005468613`,0.004346046`,0.006816829`,0.004925013`,0.006055513`,0.005509096`,0.004451704`,0.003706196`,0.004872613`,0.004006521`,0.003897913`,0.003967188`,0.004680596`,0.006057196`,0.005802996`,0.004410879`,0.004577504`,0.005948804`,0.010886738`,0.013374288`,0.011300446`,0.013455188`,0.011332538`,0.013376729`,0.010844546`,0.011672588`,0.008354963`,0.008287213`,0.008129929`,0.008135654`,0.005852379`,0.005948804`,0.007445746`,0.007725604`,0.007481579`,0.007303304`,0.007431579`,0.008738713`,0.007773863`,0.005948804`,0.006132896`,0.006095746`,0.006911004`,0.006048504`,0.006168246`,0.008729238`,0.007735821`,0.007678288`,0.009364713`,0.007965421`,0.008722496`,0.008299946`,0.008598863`,0.008783213`,0.009970963`,0.005675038`,0.005924738`,0.006306079`,0.007113438`,0.006351113`,0.006128879`,0.008015213`,0.006311488`,0.005049646`,0.006887038`,0.006321404`,0.007734921`,0.005114313`,0.005116413`,0.005117371`,0.005117371`,0.004354504`,0.002925663`,0.003036004`,0.005465771`,0.003067754`,0.004181738`,0.005974563`,0.004890871`,0.004887321`,0.008101821`,0.008509963`,0.007619496`,0.008099179`,0.007542479`,0.007882204`,0.006370396`,0.008509963`,0.008101821`,0.006495304`,0.007777196`,0.008385963`,0.008650746`,0.008650746`,0.008249279`,0.007232038`,0.006638463`,0.006839788`,0.006660613`,0.006255879`,0.006295263`,0.005524613`},{1/729,0.005439679`,0.005424579`,0.005424579`,0.005295229`,0.005561313`,0.005979346`,0.005014046`,0.005914063`,0.005055346`,0.005879596`,0.005472679`,0.005604313`,0.006627613`,0.004690546`,0.005316213`,0.005214879`,0.005149179`,0.006461579`,0.005330163`,0.007365129`,0.005578896`,0.006934429`,0.006329529`,0.005388963`,0.004000579`,0.005437746`,0.004072513`,0.004681696`,0.004794079`,0.005626079`,0.006775313`,0.006250813`,0.004361413`,0.004538479`,0.007379646`,0.012035113`,0.014569596`,0.012488646`,0.014618063`,0.012968046`,0.014528213`,0.011391896`,0.013316829`,0.008914429`,0.008854896`,0.008732679`,0.008792546`,0.007214229`,0.007379646`,0.008021829`,0.008630396`,0.008113513`,0.007959529`,0.008015446`,0.009579346`,0.008639829`,0.007379646`,0.007401196`,0.007394913`,0.008017646`,0.007348779`,0.007666963`,0.009493129`,0.008008829`,0.007646929`,0.009716013`,0.008849546`,0.009491346`,0.008051163`,0.009224913`,0.008923613`,0.009692746`,0.006624913`,0.007082179`,0.007867563`,0.009197579`,0.008002629`,0.007873113`,0.009879613`,0.008004829`,0.005564179`,0.009022179`,0.007833929`,0.009358279`,0.005091213`,0.005098779`,0.005093813`,0.005093813`,0.004659763`,0.003195279`,0.003010129`,0.004334246`,0.003351163`,0.004643263`,0.004379863`,0.003689596`,0.003696646`,0.006764613`,0.007513096`,0.007916296`,0.007123546`,0.007999896`,0.008497196`,0.006890213`,0.007513096`,0.006764613`,0.005823546`,0.008407079`,0.007738463`,0.006534529`,0.006534529`,0.006354746`,0.007590146`,0.007537829`,0.007271196`,0.007565829`,0.006535929`,0.006540096`,0.005287646`},{2/1539,0.005902983`,0.005890967`,0.005890967`,0.005750567`,0.00601695`,0.0068618`,0.005492392`,0.006788117`,0.0062989`,0.006721167`,0.007129442`,0.006877925`,0.007321625`,0.004970025`,0.005893033`,0.005678708`,0.005620925`,0.006747583`,0.005715767`,0.008299575`,0.005723658`,0.007741633`,0.00744385`,0.004556375`,0.004241608`,0.003976483`,0.003539833`,0.003987317`,0.004046083`,0.004466625`,0.00636335`,0.005989575`,0.003434242`,0.003569192`,0.007822792`,0.012022158`,0.01320495`,0.011775308`,0.013205892`,0.012264592`,0.012969475`,0.010250433`,0.0125874`,0.009217708`,0.00924105`,0.009063783`,0.009016867`,0.007730675`,0.007822792`,0.0088128`,0.008448842`,0.008809858`,0.007962575`,0.008883283`,0.0095091`,0.008894792`,0.007822792`,0.007867683`,0.007829583`,0.006746208`,0.007790842`,0.008089592`,0.009705742`,0.008396692`,0.007964233`,0.0092234`,0.008651875`,0.008628692`,0.008683233`,0.008302067`,0.009608317`,0.009370108`,0.005369725`,0.006029425`,0.00840635`,0.010726333`,0.008633217`,0.008298633`,0.010936108`,0.008583067`,0.004098025`,0.0103921`,0.008403617`,0.0109376`,0.005399225`,0.005414242`,0.005408217`,0.005408217`,0.004622625`,0.002722658`,0.002851192`,0.00675325`,0.003078433`,0.004078967`,0.005355308`,0.004066858`,0.00404905`,0.008322375`,0.008743667`,0.007494767`,0.007314517`,0.00764575`,0.008201958`,0.006213983`,0.008743667`,0.008322375`,0.00610865`,0.007941175`,0.008631075`,0.008633408`,0.008633408`,0.008339033`,0.0070577`,0.007730967`,0.008001392`,0.007756058`,0.005677683`,0.005759208`,0.0060251`},{1/810,0.007406554`,0.007279871`,0.007279871`,0.006945763`,0.007284288`,0.006932521`,0.007093496`,0.006907154`,0.006028279`,0.006740221`,0.006819363`,0.007445738`,0.008507438`,0.005144021`,0.006919713`,0.004910771`,0.004869496`,0.005689871`,0.004690629`,0.006121679`,0.005282121`,0.006304446`,0.006044629`,0.004170854`,0.003461388`,0.003724504`,0.003758471`,0.003992521`,0.004055246`,0.003697746`,0.003821063`,0.004262054`,0.003031063`,0.003006379`,0.007505896`,0.009210629`,0.011322813`,0.008990229`,0.011426421`,0.009521671`,0.011436263`,0.008155104`,0.010790263`,0.007383729`,0.007395704`,0.007313446`,0.007295338`,0.006953221`,0.007505896`,0.008098746`,0.007121496`,0.008101321`,0.007445796`,0.008132946`,0.007822654`,0.007106929`,0.007505896`,0.008516054`,0.008507888`,0.006941104`,0.008438296`,0.008583279`,0.006856363`,0.006221038`,0.005928171`,0.008053971`,0.006932829`,0.005568604`,0.006108354`,0.005728896`,0.011231813`,0.010496063`,0.005056746`,0.005170588`,0.007223929`,0.009733179`,0.007458213`,0.006993088`,0.011990863`,0.007354404`,0.003503263`,0.009365554`,0.007244004`,0.009657329`,0.005252663`,0.005288996`,0.005267288`,0.005267288`,0.004041038`,0.002473938`,0.002657579`,0.004125571`,0.002655304`,0.004595638`,0.003332079`,0.003941254`,0.004001163`,0.005549388`,0.006096846`,0.007546371`,0.006873363`,0.007691046`,0.008524238`,0.006109963`,0.006096846`,0.005549388`,0.004779363`,0.008421496`,0.006209863`,0.005686346`,0.005686346`,0.005512788`,0.007067263`,0.005228163`,0.005156179`,0.005245613`,0.004372104`,0.004382571`,0.004023146`},{2/1701,0.006742167`,0.006618433`,0.006618433`,0.0063085`,0.007009767`,0.006486417`,0.00761615`,0.006548483`,0.005156817`,0.006380533`,0.005690167`,0.00649165`,0.007389083`,0.0044022`,0.006619517`,0.004075283`,0.004056533`,0.004621883`,0.004006917`,0.0046102`,0.0045113`,0.0045532`,0.004488767`,0.003815633`,0.002937217`,0.004953167`,0.003804517`,0.004304817`,0.004340017`,0.005500583`,0.006408083`,0.00522665`,0.00430125`,0.004271317`,0.0061031`,0.0065138`,0.0094717`,0.006157317`,0.00960795`,0.007232883`,0.00974185`,0.005867867`,0.0087723`,0.00527525`,0.0052314`,0.005240717`,0.005254833`,0.006132833`,0.0061031`,0.00577`,0.004830133`,0.005812667`,0.005238667`,0.005848233`,0.00493095`,0.004534567`,0.0061031`,0.006800283`,0.006691783`,0.005400483`,0.0067035`,0.006624183`,0.005347383`,0.004833067`,0.004995883`,0.007901583`,0.005049217`,0.006156567`,0.005209133`,0.00796185`,0.01012375`,0.010092617`,0.007084783`,0.007974467`,0.010199383`,0.011483967`,0.010395833`,0.009818567`,0.011941683`,0.010279467`,0.0042197`,0.011245633`,0.010220883`,0.011362783`,0.0033729`,0.00331265`,0.003357767`,0.003357767`,0.003389967`,0.003239167`,0.003500017`,0.00332105`,0.002342417`,0.001926617`,0.002214167`,0.003131433`,0.0031552`,0.0041009`,0.00486445`,0.0053509`,0.004463217`,0.00542215`,0.00577115`,0.00344975`,0.00486445`,0.0041009`,0.003930483`,0.005034633`,0.0052574`,0.003942783`,0.003942783`,0.003869867`,0.004622933`,0.005301783`,0.005078883`,0.00532435`,0.005517333`,0.005526483`,0.004039217`},{1/891,0.005392638`,0.005355629`,0.005355629`,0.005212488`,0.005814688`,0.006298796`,0.005549121`,0.006383063`,0.005035346`,0.006207638`,0.005736221`,0.006419763`,0.007068138`,0.004331188`,0.006872329`,0.005756938`,0.005702629`,0.005437554`,0.004951721`,0.005228679`,0.005306621`,0.005109529`,0.004893946`,0.005173871`,0.003963188`,0.005037396`,0.002699413`,0.004381046`,0.004438288`,0.004672463`,0.006172563`,0.007007929`,0.003589479`,0.003668029`,0.006453938`,0.006452763`,0.007800454`,0.006420396`,0.007982454`,0.006235996`,0.008534096`,0.007621821`,0.008218479`,0.006025596`,0.005790471`,0.005850896`,0.005968629`,0.005795663`,0.006453938`,0.006663721`,0.005312229`,0.006750663`,0.006087954`,0.006810438`,0.005187363`,0.004721729`,0.006453938`,0.007556604`,0.007502379`,0.006024771`,0.007460346`,0.007647454`,0.008581463`,0.005461821`,0.006086029`,0.009167796`,0.005477529`,0.008625321`,0.007155079`,0.008409363`,0.009461496`,0.010140404`,0.004022663`,0.004605529`,0.004528121`,0.005781688`,0.004605279`,0.004302154`,0.008327604`,0.004526904`,0.003166729`,0.005464971`,0.004620571`,0.005691554`,0.001884113`,0.001911671`,0.001893329`,0.001893329`,0.001724771`,0.002741771`,0.002802021`,0.003699004`,0.001947129`,0.002523196`,0.002902646`,0.003234954`,0.003302696`,0.005451513`,0.006125688`,0.004996863`,0.005247996`,0.004737379`,0.004261913`,0.003431729`,0.006125688`,0.005451513`,0.005066888`,0.002831246`,0.006319404`,0.004739029`,0.004739029`,0.004575229`,0.004424021`,0.005521213`,0.005626138`,0.005549921`,0.005356163`,0.005429163`,0.004275629`},{2/1863,0.004155921`,0.004162346`,0.004162346`,0.004102121`,0.004442246`,0.005571638`,0.005058988`,0.005440504`,0.006698638`,0.005479321`,0.006657313`,0.006444513`,0.006842954`,0.005077154`,0.005889513`,0.004687913`,0.004693596`,0.004670888`,0.005065554`,0.005438738`,0.006166354`,0.005522904`,0.005284504`,0.004596546`,0.003968871`,0.003375088`,0.002909829`,0.003302296`,0.003456321`,0.003013479`,0.003352029`,0.003964229`,0.002710613`,0.002753779`,0.006346713`,0.007116946`,0.009458854`,0.007387963`,0.009576938`,0.007250829`,0.010032521`,0.007455854`,0.009099963`,0.005859479`,0.005850171`,0.005791754`,0.005766821`,0.005352279`,0.006346713`,0.007323704`,0.006500796`,0.007408313`,0.006875746`,0.007446196`,0.006286521`,0.005759696`,0.006346713`,0.006976721`,0.006938579`,0.007339379`,0.006897971`,0.008141971`,0.005204938`,0.005364596`,0.005087004`,0.004267196`,0.005638538`,0.004466388`,0.004655013`,0.003928771`,0.005062488`,0.005623846`,0.003280729`,0.003399729`,0.003232563`,0.003658796`,0.003223563`,0.003046254`,0.004446663`,0.003179421`,0.002237404`,0.003590163`,0.003315888`,0.003558096`,0.002497863`,0.002519879`,0.002507354`,0.002507354`,0.001992196`,0.002442663`,0.002397696`,0.004330713`,0.002341821`,0.002415088`,0.002991646`,0.003360713`,0.003365471`,0.005849004`,0.006422213`,0.005997688`,0.005556521`,0.005774854`,0.005855454`,0.004231738`,0.006422213`,0.005849004`,0.005720679`,0.005389663`,0.006546596`,0.005123113`,0.005123113`,0.005020963`,0.005358888`,0.006037429`,0.006257463`,0.006049079`,0.005258796`,0.005346696`,0.004902704`},{1/972,0.005221213`,0.005172121`,0.005172121`,0.004978938`,0.005833188`,0.006150313`,0.005369429`,0.006160846`,0.004602704`,0.006070946`,0.005339013`,0.005705771`,0.006397738`,0.003990154`,0.004617363`,0.003908888`,0.003883254`,0.003882913`,0.004110788`,0.003936321`,0.004199804`,0.004104413`,0.003966929`,0.003537179`,0.003718429`,0.003377163`,0.002763163`,0.003023129`,0.003076563`,0.003574088`,0.003507388`,0.003512021`,0.003134429`,0.003164021`,0.004945288`,0.005300121`,0.007809021`,0.005105929`,0.007892571`,0.005487329`,0.008153038`,0.005116221`,0.007109279`,0.003574229`,0.003547796`,0.003560721`,0.003565754`,0.004946154`,0.004945288`,0.003875054`,0.003942713`,0.003930621`,0.003801146`,0.003907646`,0.003759413`,0.003812513`,0.004945288`,0.004787529`,0.004723613`,0.005326029`,0.004757471`,0.004623629`,0.003597771`,0.003850213`,0.003927963`,0.004254163`,0.004116004`,0.003886979`,0.003565963`,0.004121929`,0.005768688`,0.006645654`,0.003608638`,0.003896846`,0.003885938`,0.004781004`,0.003927379`,0.003727663`,0.006550246`,0.003886554`,0.002544179`,0.004617304`,0.003960713`,0.005052054`,0.003015113`,0.003036579`,0.003023129`,0.003023129`,0.002485996`,0.002146346`,0.002051554`,0.004270938`,0.001665279`,0.002621979`,0.003377813`,0.003143654`,0.003110029`,0.005779238`,0.006271754`,0.007396979`,0.005667346`,0.007500271`,0.007917163`,0.006439013`,0.006271754`,0.005779238`,0.005438338`,0.007693379`,0.006333138`,0.005856013`,0.005856013`,0.005556263`,0.007068488`,0.006127254`,0.006046913`,0.006129038`,0.006145788`,0.006185696`,0.005214046`},{2/2025,0.005114025`,0.005097525`,0.005097525`,0.004981933`,0.005422958`,0.004266783`,0.004732208`,0.004347608`,0.003549042`,0.0042954`,0.003850525`,0.004130375`,0.003893558`,0.003452033`,0.003448675`,0.003390542`,0.003373283`,0.00387725`,0.003074517`,0.003768025`,0.003551892`,0.00347835`,0.003631633`,0.002911017`,0.0029549`,0.003971817`,0.002725883`,0.002549333`,0.002608142`,0.004920758`,0.004845892`,0.0045293`,0.003983583`,0.003934575`,0.0036894`,0.0048812`,0.007589167`,0.005144833`,0.007708583`,0.005188317`,0.008142692`,0.004955067`,0.006177242`,0.004024675`,0.00401335`,0.0040063`,0.004004458`,0.0037321`,0.0036894`,0.003713417`,0.003629642`,0.003739925`,0.003619058`,0.003713558`,0.003819592`,0.003892333`,0.0036894`,0.003632042`,0.003605383`,0.004392733`,0.003592333`,0.003669442`,0.004143833`,0.0039093`,0.004031842`,0.005169958`,0.003928633`,0.004935742`,0.003878925`,0.005928375`,0.007133417`,0.00767735`,0.005778475`,0.0058143`,0.007404183`,0.009323092`,0.007613333`,0.0072179`,0.01006455`,0.00751595`,0.004215225`,0.009073267`,0.00734535`,0.009658717`,0.003368892`,0.003523417`,0.00341445`,0.00341445`,0.003397258`,0.001876508`,0.001902642`,0.00358665`,0.0019383`,0.0035347`,0.002806308`,0.002561033`,0.002571825`,0.004905842`,0.005162`,0.006692842`,0.005524333`,0.007106883`,0.007481492`,0.006722358`,0.005162`,0.004905842`,0.004729967`,0.007476158`,0.005094683`,0.005309675`,0.005309675`,0.005035592`,0.006797167`,0.0048871`,0.004725975`,0.004942783`,0.005406217`,0.005471842`,0.0050179`},{1/1053,0.004019467`,0.004037125`,0.004037125`,0.004001342`,0.004265633`,0.004079025`,0.004273108`,0.004138833`,0.003356833`,0.004115617`,0.003532242`,0.003761125`,0.003760658`,0.0027357`,0.003391633`,0.00304675`,0.00303515`,0.003458308`,0.002733725`,0.00338765`,0.002916367`,0.003010833`,0.003186658`,0.002739625`,0.002852233`,0.003643117`,0.0042593`,0.002672083`,0.002700492`,0.006716392`,0.008362875`,0.005367967`,0.004632817`,0.0042128`,0.003313625`,0.005521158`,0.009550175`,0.005918925`,0.009597167`,0.005570333`,0.0091432`,0.006346408`,0.006715167`,0.005084008`,0.005075967`,0.005047983`,0.005054067`,0.0035422`,0.003313625`,0.003142225`,0.003783425`,0.00315465`,0.003137875`,0.003125358`,0.004418542`,0.004514517`,0.003313625`,0.003259475`,0.003219042`,0.003856733`,0.003212717`,0.00310325`,0.005644583`,0.0038199`,0.004219692`,0.006099508`,0.00457095`,0.007346958`,0.005223075`,0.008691067`,0.00774765`,0.008065608`,0.009677925`,0.008378975`,0.010419775`,0.011079025`,0.010559567`,0.010365217`,0.011361092`,0.010536467`,0.005881775`,0.01094835`,0.010322775`,0.011135883`,0.005725583`,0.005760158`,0.005730017`,0.005730017`,0.006082292`,0.002171833`,0.002160317`,0.0034796`,0.002944525`,0.004414042`,0.002739425`,0.004275875`,0.004296442`,0.004884933`,0.005219817`,0.0060032`,0.005402592`,0.006342825`,0.006494058`,0.006090217`,0.005219817`,0.004884933`,0.004672192`,0.0065045`,0.005224275`,0.005192558`,0.005192558`,0.004950133`,0.006115817`,0.004855958`,0.004903508`,0.004849758`,0.00477255`,0.004843017`,0.003740992`},{2/2187,0.003757842`,0.003782758`,0.003782758`,0.0037557`,0.003945225`,0.003777067`,0.003379117`,0.003751867`,0.00275795`,0.003801575`,0.002895675`,0.002979092`,0.003554733`,0.002524467`,0.002960583`,0.0033683`,0.003365908`,0.003318508`,0.003025592`,0.003275983`,0.002995142`,0.003027783`,0.003058233`,0.003359608`,0.003298575`,0.00548145`,0.004235117`,0.003454317`,0.003416017`,0.007724308`,0.009488575`,0.005595808`,0.0063886`,0.006004925`,0.00332405`,0.005964733`,0.008943108`,0.006769867`,0.009035758`,0.005721008`,0.008960208`,0.006565092`,0.007290117`,0.005111692`,0.004928092`,0.005059883`,0.005160217`,0.003402408`,0.00332405`,0.002914608`,0.003070783`,0.002935433`,0.002776283`,0.002944042`,0.003744817`,0.0036985`,0.00332405`,0.003240608`,0.003213633`,0.004060058`,0.003207808`,0.003183142`,0.00651315`,0.003569242`,0.003944258`,0.006045275`,0.004290508`,0.00783475`,0.005604242`,0.008641025`,0.007712717`,0.00794445`,0.010746817`,0.009014175`,0.011097558`,0.011584625`,0.011218858`,0.011121292`,0.011638033`,0.011228675`,0.006904258`,0.011487733`,0.011011117`,0.011688267`,0.004824917`,0.004734142`,0.004793533`,0.004793533`,0.005807792`,0.002342592`,0.002322008`,0.003059158`,0.0031746`,0.003837367`,0.002882175`,0.004092592`,0.004148458`,0.005232833`,0.0058354`,0.005641792`,0.0043631`,0.005919333`,0.006631958`,0.00498565`,0.0058354`,0.005232833`,0.00503525`,0.006357942`,0.006043383`,0.005450633`,0.005450633`,0.005337133`,0.0054401`,0.00547165`,0.005570567`,0.005488333`,0.005180692`,0.005222483`,0.004066133`},{1/1134,0.002944188`,0.002986913`,0.002986913`,0.002991638`,0.003083071`,0.003253421`,0.002923729`,0.003194996`,0.004028071`,0.003275388`,0.003640829`,0.003293896`,0.003325363`,0.004050338`,0.003756146`,0.004233813`,0.004182446`,0.005837871`,0.004071813`,0.005972121`,0.004980963`,0.005200646`,0.005305688`,0.003870446`,0.003831729`,0.004131846`,0.003502038`,0.003457096`,0.003494679`,0.004877954`,0.007305071`,0.006924696`,0.003547613`,0.003534654`,0.003601763`,0.007384763`,0.009791221`,0.007830546`,0.009953188`,0.007458988`,0.010250371`,0.007097954`,0.008004663`,0.005743879`,0.005681138`,0.005810146`,0.005823254`,0.003498146`,0.003601763`,0.003541813`,0.004278221`,0.003598729`,0.003795029`,0.003524088`,0.004527504`,0.004840563`,0.003601763`,0.003632488`,0.003584529`,0.004004879`,0.003555796`,0.003259796`,0.006617571`,0.006640379`,0.007205538`,0.007809188`,0.005850588`,0.008879313`,0.007698396`,0.010077938`,0.009378463`,0.009509121`,0.007859629`,0.008181571`,0.011393579`,0.011853754`,0.011563388`,0.011676063`,0.011426613`,0.011637996`,0.008103529`,0.011764413`,0.011327346`,0.011795929`,0.005951888`,0.005917188`,0.005932863`,0.005932863`,0.006775879`,0.002437504`,0.002665204`,0.002982296`,0.003624721`,0.003716529`,0.002721821`,0.003773613`,0.003799296`,0.005371713`,0.006187196`,0.006872271`,0.004926904`,0.006990046`,0.007536154`,0.006365229`,0.006187196`,0.005371713`,0.005449721`,0.007379913`,0.006562213`,0.005710346`,0.005710346`,0.005593513`,0.006741013`,0.005041513`,0.005176204`,0.005051521`,0.005038688`,0.005143071`,0.003829146`},{1/27,0.003776983`,0.003808533`,0.003808533`,0.00378515`,0.003993108`,0.004242317`,0.003680767`,0.004110275`,0.003781675`,0.00420065`,0.00384155`,0.003971525`,0.004599967`,0.004199083`,0.004242183`,0.003574767`,0.003544542`,0.004218108`,0.003574792`,0.004764708`,0.0041786`,0.004609783`,0.004528075`,0.003137342`,0.003366483`,0.003049342`,0.003130817`,0.003000292`,0.00305785`,0.003464725`,0.003867417`,0.003958317`,0.002976833`,0.002938367`,0.005490283`,0.008783083`,0.010440567`,0.0087173`,0.010599567`,0.007933842`,0.010810267`,0.009485317`,0.010025025`,0.008067158`,0.00789645`,0.007804783`,0.007867183`,0.005115767`,0.005490283`,0.00671735`,0.007311692`,0.006715475`,0.006503858`,0.006701333`,0.007929175`,0.007409275`,0.005490283`,0.005460325`,0.005493058`,0.006469742`,0.005451792`,0.006237058`,0.008334575`,0.005360317`,0.005088958`,0.009848133`,0.007201417`,0.006475892`,0.006513433`,0.006778808`,0.011403625`,0.011764242`,0.004632275`,0.004396975`,0.0073074`,0.010872683`,0.007625975`,0.007420792`,0.011924642`,0.0076099`,0.006825967`,0.010434283`,0.007296942`,0.011617658`,0.006040467`,0.006154767`,0.006069192`,0.006069192`,0.005985642`,0.003871808`,0.003395042`,0.003484517`,0.004469217`,0.00602415`,0.003127917`,0.00382875`,0.003838508`,0.006797075`,0.007201417`,0.007493942`,0.007064733`,0.007739192`,0.008203283`,0.007601242`,0.007201417`,0.006797075`,0.007005225`,0.0084668`,0.007150358`,0.007110133`,0.007110133`,0.006735742`,0.007646067`,0.00489255`,0.005794617`,0.004891183`,0.004937933`,0.005063725`,0.003521258`},{1/54,0.003238438`,0.003266071`,0.003266071`,0.003254621`,0.003414854`,0.003811354`,0.003304821`,0.003713588`,0.003150888`,0.003794488`,0.003279221`,0.003463088`,0.003899871`,0.003666371`,0.003512038`,0.002600288`,0.002579254`,0.003193688`,0.002535571`,0.003798704`,0.003454088`,0.003705504`,0.003574188`,0.002143688`,0.002406454`,0.002558121`,0.004296871`,0.001478888`,0.001521071`,0.003542671`,0.004081904`,0.003492821`,0.002832888`,0.002615054`,0.004145888`,0.010824388`,0.011216471`,0.010435704`,0.011471471`,0.010493738`,0.011815154`,0.010035954`,0.011826488`,0.006528221`,0.006374921`,0.006238904`,0.006297721`,0.003990921`,0.004145888`,0.005836771`,0.006741021`,0.005683271`,0.005210104`,0.005850121`,0.008384271`,0.006617154`,0.004145888`,0.004150588`,0.004170804`,0.005662588`,0.004133571`,0.004960354`,0.005906188`,0.004006921`,0.003804504`,0.006673638`,0.005211004`,0.005149571`,0.004485871`,0.005146321`,0.009298788`,0.010182438`,0.004812388`,0.004658488`,0.006835121`,0.008522771`,0.007016371`,0.007126454`,0.009152904`,0.007085188`,0.007317321`,0.008368588`,0.006761238`,0.009316688`,0.006906388`,0.006831671`,0.006880688`,0.006880688`,0.006753004`,0.004183921`,0.004081271`,0.003638638`,0.004272871`,0.006298638`,0.004124538`,0.004958904`,0.004884471`,0.006833188`,0.007480754`,0.006350988`,0.006718288`,0.007018671`,0.006867471`,0.006771021`,0.007480754`,0.006833188`,0.006801154`,0.007027871`,0.007618754`,0.006761254`,0.006761254`,0.006414721`,0.006650604`,0.004972421`,0.005533554`,0.005070104`,0.005172321`,0.005190904`,0.003541354`},{1/81,0.002322658`,0.002354242`,0.002354242`,0.002334342`,0.002539158`,0.002324708`,0.001756375`,0.002226508`,0.001612325`,0.002298042`,0.001807008`,0.002056008`,0.002260458`,0.002206375`,0.001873925`,0.001813392`,0.001800892`,0.002114908`,0.001680575`,0.002515992`,0.001951058`,0.002019675`,0.002056592`,0.001729858`,0.001701942`,0.002124058`,0.005189892`,0.001928375`,0.001993692`,0.002984475`,0.003829892`,0.002650758`,0.002961875`,0.002506842`,0.002436208`,0.006386742`,0.011001475`,0.006199058`,0.011197325`,0.007591158`,0.011517542`,0.005355342`,0.008452008`,0.003838142`,0.003812592`,0.003811258`,0.003805342`,0.002282158`,0.002436208`,0.003168925`,0.003211525`,0.003153392`,0.003026642`,0.003147592`,0.003868842`,0.003377042`,0.002436208`,0.002301508`,0.002309042`,0.003951992`,0.002296325`,0.002835192`,0.004304308`,0.002933542`,0.002831425`,0.005475308`,0.003735442`,0.004895858`,0.003579675`,0.005441658`,0.007042075`,0.007962758`,0.006141392`,0.005600792`,0.007411092`,0.010059208`,0.007629108`,0.007845392`,0.009614025`,0.007743542`,0.007948792`,0.009732908`,0.007306508`,0.010567758`,0.006229892`,0.006176075`,0.006211808`,0.006211808`,0.006273792`,0.004658142`,0.004670892`,0.003352392`,0.005166792`,0.005210325`,0.003369358`,0.004822775`,0.004838125`,0.006828275`,0.007353108`,0.006669758`,0.006618758`,0.006981358`,0.006879208`,0.006617175`,0.007353108`,0.006828275`,0.006391408`,0.006775925`,0.007372692`,0.006848242`,0.006848242`,0.006572658`,0.006756725`,0.005335875`,0.006005492`,0.005484908`,0.005872342`,0.005925225`,0.004219658`},{1/108,0.001348667`,0.001376017`,0.001376017`,0.00138525`,0.001416283`,0.001741967`,0.001426283`,0.0016088`,0.002562217`,0.0016963`,0.002453867`,0.002315567`,0.002152267`,0.002606333`,0.0022303`,0.003544833`,0.003546817`,0.003481067`,0.003236267`,0.003157967`,0.00285415`,0.003038417`,0.003108417`,0.0031115`,0.003270083`,0.0040549`,0.0063234`,0.0027302`,0.002755933`,0.005723383`,0.006598133`,0.004802717`,0.004740917`,0.004304367`,0.0024428`,0.0075511`,0.012366367`,0.0076866`,0.0126201`,0.00797495`,0.012503783`,0.007960467`,0.00875755`,0.004824483`,0.004710583`,0.0046931`,0.00475075`,0.002332333`,0.0024428`,0.003720717`,0.00427845`,0.00369795`,0.003677467`,0.003659283`,0.004930267`,0.004401083`,0.0024428`,0.002355733`,0.00234415`,0.003305967`,0.002330467`,0.002451117`,0.005725283`,0.003631`,0.00399725`,0.009933183`,0.004302217`,0.007796267`,0.00473195`,0.008595783`,0.011506483`,0.012116833`,0.0072111`,0.007081833`,0.008749467`,0.01012175`,0.008937867`,0.008545217`,0.011639183`,0.008850633`,0.004223167`,0.009835883`,0.008677483`,0.0101817`,0.0059197`,0.005976783`,0.005933817`,0.005933817`,0.005854`,0.004162983`,0.004429567`,0.00305515`,0.00325955`,0.0053344`,0.003706017`,0.004143667`,0.0041281`,0.0068154`,0.007260083`,0.0074257`,0.006459167`,0.007900083`,0.008158317`,0.007233233`,0.007260083`,0.0068154`,0.006818433`,0.007955267`,0.007238583`,0.007022633`,0.007022633`,0.006662383`,0.007481117`,0.005572717`,0.0060074`,0.005748967`,0.005739317`,0.005709267`,0.005588517`},{1/135,0.002055408`,0.002083575`,0.002083575`,0.002070208`,0.002505758`,0.003496125`,0.002186225`,0.003435708`,0.003352208`,0.003489075`,0.003030258`,0.003120792`,0.003659975`,0.003826975`,0.003498392`,0.002891342`,0.002845708`,0.004004042`,0.002967075`,0.004275525`,0.003786658`,0.004032942`,0.003933158`,0.002228725`,0.002469442`,0.002770792`,0.003289058`,0.002148858`,0.002189975`,0.004026408`,0.005272492`,0.004480458`,0.003200125`,0.002766192`,0.004471292`,0.011076308`,0.014609775`,0.010798158`,0.014762758`,0.011204242`,0.014815008`,0.010593592`,0.012430825`,0.007229542`,0.007061492`,0.006920558`,0.006997325`,0.004142075`,0.004471292`,0.007223058`,0.006909342`,0.007076258`,0.006540125`,0.007196592`,0.008077942`,0.006785625`,0.004471292`,0.004434942`,0.004445358`,0.006990775`,0.004426925`,0.005279142`,0.008377675`,0.004919092`,0.005232842`,0.008967875`,0.006482958`,0.007121625`,0.006037158`,0.007272125`,0.009208625`,0.009939942`,0.004855575`,0.005056625`,0.005692125`,0.005613925`,0.005712692`,0.005527542`,0.006607425`,0.005672958`,0.003978225`,0.005552975`,0.005727275`,0.004998625`,0.006549325`,0.006610758`,0.006568558`,0.006568558`,0.006063492`,0.002753608`,0.002266025`,0.004557558`,0.003552625`,0.006302992`,0.004060725`,0.003765092`,0.003762458`,0.005606392`,0.005955925`,0.006194475`,0.006561775`,0.007131892`,0.007210525`,0.006577442`,0.005955925`,0.005606392`,0.006058058`,0.007344858`,0.005902108`,0.005930892`,0.005930892`,0.005662592`,0.006484492`,0.004566658`,0.004397492`,0.004589175`,0.004393892`,0.004321708`,0.004761658`},{1/162,0.002795467`,0.002891267`,0.002891267`,0.002965858`,0.002880517`,0.00295095`,0.0022038`,0.002948433`,0.002623042`,0.002978183`,0.002161067`,0.002106542`,0.002991183`,0.003171858`,0.0029966`,0.002256575`,0.0022359`,0.002647008`,0.002280975`,0.003207008`,0.00311585`,0.003048358`,0.002996275`,0.002001358`,0.0022717`,0.002212183`,0.003513475`,0.001422625`,0.001476567`,0.003144267`,0.003219108`,0.003210108`,0.002879775`,0.00248755`,0.003465683`,0.007408542`,0.010584517`,0.007287733`,0.010728942`,0.007695317`,0.01074145`,0.006464675`,0.009126758`,0.004377775`,0.004331858`,0.004309233`,0.004316133`,0.003359742`,0.003465683`,0.004070933`,0.003939575`,0.004019075`,0.003634083`,0.004104742`,0.004635058`,0.003937225`,0.003465683`,0.003436`,0.003428383`,0.004122542`,0.003407433`,0.0037375`,0.004473417`,0.003527783`,0.003433967`,0.005229658`,0.004241917`,0.00429785`,0.0037571`,0.004522667`,0.006818583`,0.007121442`,0.00378955`,0.003532633`,0.00549755`,0.006454842`,0.005582717`,0.0055243`,0.006854483`,0.005593225`,0.005079125`,0.006348692`,0.005474892`,0.006467417`,0.005181683`,0.005217958`,0.005193183`,0.005193183`,0.0050156`,0.003576167`,0.003284433`,0.004273108`,0.003950067`,0.005977775`,0.004082133`,0.004532358`,0.004581342`,0.005957767`,0.0064653`,0.006209067`,0.0062942`,0.006649442`,0.006365442`,0.006640917`,0.0064653`,0.005957767`,0.005504567`,0.006492008`,0.00653095`,0.006176758`,0.006176758`,0.005999433`,0.006513533`,0.003557392`,0.003558058`,0.0035449`,0.003887317`,0.0039512`,0.003172775`},{1/189,0.003732888`,0.003770129`,0.003770129`,0.003760221`,0.003665404`,0.003099521`,0.003264404`,0.003189921`,0.002488163`,0.003153171`,0.002752013`,0.003074921`,0.002764121`,0.002538996`,0.002382888`,0.002115754`,0.002070104`,0.002283963`,0.002183854`,0.002704838`,0.002589629`,0.002682721`,0.002707604`,0.001764829`,0.002187996`,0.001686529`,0.003868379`,0.001595246`,0.001676146`,0.002439346`,0.003031738`,0.002368688`,0.002146296`,0.001746154`,0.002439679`,0.005581521`,0.009089246`,0.005864729`,0.009348013`,0.006026979`,0.010030363`,0.005268704`,0.006971721`,0.003626571`,0.003533846`,0.003535129`,0.003569738`,0.002479596`,0.002439679`,0.002650004`,0.002872096`,0.002668163`,0.002627596`,0.002637563`,0.003487063`,0.003032621`,0.002439679`,0.002361563`,0.002358321`,0.003031771`,0.002338488`,0.002530288`,0.004009596`,0.002876413`,0.002755454`,0.005109804`,0.003406504`,0.003940871`,0.003343696`,0.004380613`,0.006723604`,0.007428188`,0.005540388`,0.004340296`,0.007005888`,0.008574754`,0.007100713`,0.007151654`,0.008849513`,0.007162329`,0.005012554`,0.008469121`,0.006935096`,0.008794379`,0.005069688`,0.005181463`,0.005106054`,0.005106054`,0.004911529`,0.003915538`,0.003859813`,0.003378621`,0.003285821`,0.006102663`,0.003794446`,0.004518963`,0.004537688`,0.006645804`,0.007232946`,0.007128104`,0.006468179`,0.007628129`,0.007426979`,0.007285088`,0.007232946`,0.006645804`,0.006396346`,0.007176113`,0.007315038`,0.006593921`,0.006593921`,0.006372013`,0.007310354`,0.004971954`,0.005312229`,0.004979138`,0.004557546`,0.004686504`,0.003236596`},{1/216,0.003432896`,0.003461288`,0.003461288`,0.003441513`,0.003527704`,0.003702888`,0.003641163`,0.003714113`,0.003445079`,0.003727821`,0.003680213`,0.003722154`,0.003599738`,0.003004779`,0.003187004`,0.002858388`,0.002832088`,0.002728563`,0.003193454`,0.002790813`,0.003270463`,0.003072546`,0.003058713`,0.002542029`,0.003113688`,0.002041871`,0.003045738`,0.002177704`,0.002272821`,0.002428146`,0.003058513`,0.002596563`,0.002067946`,0.001894563`,0.002993546`,0.006022013`,0.010499004`,0.006607746`,0.010715988`,0.006676304`,0.010803088`,0.005189154`,0.006604021`,0.003318929`,0.003209913`,0.003221188`,0.003264046`,0.003214488`,0.002993546`,0.002646679`,0.002522454`,0.002675654`,0.002487329`,0.002683146`,0.002872021`,0.002697496`,0.002993546`,0.002925996`,0.002898063`,0.003450738`,0.002886063`,0.002808513`,0.003646854`,0.002737596`,0.002757454`,0.004846279`,0.002729629`,0.003478538`,0.002847588`,0.003856771`,0.007718271`,0.008065954`,0.004772329`,0.004408071`,0.005882071`,0.007777971`,0.006008671`,0.006263271`,0.008346371`,0.006127204`,0.004036379`,0.007664221`,0.005782488`,0.006451346`,0.005099554`,0.005176863`,0.005122113`,0.005122113`,0.004999713`,0.003243663`,0.002829671`,0.003937763`,0.003399038`,0.005882429`,0.004091088`,0.003971271`,0.003968254`,0.006462421`,0.006992913`,0.007188888`,0.006268163`,0.007430413`,0.007689146`,0.006539321`,0.006992913`,0.006462421`,0.006440679`,0.007632913`,0.007027038`,0.006661038`,0.006661038`,0.006289779`,0.007024871`,0.005296238`,0.005281871`,0.005306879`,0.004980071`,0.005056471`,0.004418671`},{1/243,0.003310108`,0.003326833`,0.003326833`,0.003301842`,0.003440358`,0.003840517`,0.003884267`,0.003854308`,0.003406108`,0.003854525`,0.0035584`,0.00372135`,0.003725975`,0.003482783`,0.003392192`,0.003227858`,0.00321955`,0.003306867`,0.003370167`,0.003409508`,0.003414367`,0.003509158`,0.003413442`,0.003021708`,0.003285925`,0.002608192`,0.003105025`,0.002725367`,0.002811858`,0.0028309`,0.003416267`,0.003209292`,0.002916883`,0.002797908`,0.003550675`,0.007804883`,0.012415925`,0.008050058`,0.012500833`,0.009608075`,0.012485567`,0.005014908`,0.009350883`,0.003523033`,0.003422533`,0.003468283`,0.003498492`,0.003699308`,0.003550675`,0.003283717`,0.002877617`,0.003334558`,0.002976767`,0.003347933`,0.003106117`,0.002961708`,0.003550675`,0.003492567`,0.003468933`,0.003868942`,0.00345315`,0.003388542`,0.003741658`,0.003409783`,0.003466992`,0.004388225`,0.003349542`,0.003484283`,0.003524433`,0.00398585`,0.006067475`,0.006667683`,0.004260833`,0.004166192`,0.005730258`,0.006191892`,0.00580845`,0.0057976`,0.006331308`,0.005840708`,0.004242342`,0.006079825`,0.005671475`,0.006374575`,0.004774717`,0.004828658`,0.004791275`,0.004791275`,0.004576783`,0.003260308`,0.003199742`,0.003738192`,0.003164575`,0.0053261`,0.003700258`,0.004245525`,0.004228183`,0.006608858`,0.007217908`,0.007351083`,0.006764958`,0.00743175`,0.007739283`,0.006322425`,0.007217908`,0.006608858`,0.006903958`,0.007689067`,0.007316842`,0.006799708`,0.006799708`,0.006421675`,0.007047467`,0.005220867`,0.005655108`,0.005232942`,0.004951133`,0.00501315`,0.003824283`},{1/270,0.003174096`,0.003204204`,0.003204204`,0.003186838`,0.003365571`,0.003443721`,0.003245304`,0.003354554`,0.003739779`,0.003434846`,0.003694538`,0.003675171`,0.003601713`,0.003537663`,0.003473721`,0.003215096`,0.003184421`,0.003744629`,0.003460563`,0.003832296`,0.003611046`,0.003789154`,0.003850013`,0.002899538`,0.003235829`,0.002834404`,0.003057254`,0.002632904`,0.002729279`,0.003378904`,0.003768921`,0.003851013`,0.002993796`,0.002776696`,0.003268413`,0.005949246`,0.011676804`,0.006362604`,0.011664038`,0.007944504`,0.011400146`,0.004738371`,0.008171788`,0.003707204`,0.003711446`,0.003711046`,0.003699929`,0.003447129`,0.003268413`,0.003523296`,0.003182013`,0.003520279`,0.003236321`,0.003525046`,0.003513829`,0.003310621`,0.003268413`,0.003218579`,0.003190021`,0.003831513`,0.003171696`,0.003319271`,0.003835071`,0.003798079`,0.003931471`,0.004753429`,0.003878579`,0.004642646`,0.004037213`,0.004888313`,0.005616429`,0.006081313`,0.004334271`,0.004046529`,0.005350538`,0.006449954`,0.005406538`,0.005424996`,0.006435229`,0.005442346`,0.005623004`,0.006381938`,0.005329046`,0.006372913`,0.005064154`,0.005082288`,0.005068429`,0.005068429`,0.004873721`,0.003350679`,0.003635038`,0.003508313`,0.003672879`,0.004233938`,0.003603854`,0.004017896`,0.004043479`,0.006522938`,0.007167263`,0.007327096`,0.006771421`,0.007371063`,0.007888079`,0.006021904`,0.007167263`,0.006522938`,0.006858046`,0.008090104`,0.007302413`,0.006523296`,0.006523296`,0.006198271`,0.006901738`,0.006237379`,0.006633863`,0.006243104`,0.005294771`,0.005319971`,0.003453138`},{1/297,0.002995804`,0.003045971`,0.003045971`,0.003062029`,0.003242313`,0.003648579`,0.003235938`,0.003569688`,0.003273546`,0.003643621`,0.003262154`,0.003422154`,0.003624713`,0.003541171`,0.003500938`,0.003083688`,0.003062754`,0.003303746`,0.002930954`,0.003695721`,0.003447638`,0.003695996`,0.003648163`,0.002977163`,0.002963588`,0.002756338`,0.003239388`,0.002684563`,0.002781563`,0.003166138`,0.003202463`,0.003416604`,0.002849121`,0.002692579`,0.003442113`,0.005030454`,0.010916071`,0.005542563`,0.011120246`,0.005301096`,0.011288263`,0.005102513`,0.006301596`,0.004055971`,0.004044304`,0.004067779`,0.004070138`,0.003560588`,0.003442113`,0.003221946`,0.003317313`,0.003245396`,0.003243529`,0.003222646`,0.003719996`,0.003540921`,0.003442113`,0.003378029`,0.003348279`,0.003888113`,0.003327496`,0.003257429`,0.004590038`,0.003879913`,0.003830829`,0.005444996`,0.004228513`,0.004481596`,0.004408296`,0.004188821`,0.006478896`,0.006894121`,0.004099113`,0.003619371`,0.005581721`,0.006905271`,0.005679638`,0.005798246`,0.007780588`,0.005745629`,0.006187288`,0.006797363`,0.005512413`,0.007056679`,0.005107738`,0.005102679`,0.005103238`,0.005103238`,0.004753629`,0.003335021`,0.003514279`,0.003554796`,0.004661613`,0.004600763`,0.003164463`,0.003632913`,0.003619138`,0.007153246`,0.007648546`,0.007438638`,0.006831979`,0.007373079`,0.007801771`,0.005891738`,0.007648546`,0.007153246`,0.007152879`,0.008233304`,0.007631988`,0.007010138`,0.007010138`,0.006826554`,0.006878663`,0.006584563`,0.006647388`,0.006627496`,0.006297346`,0.006275729`,0.003885846`},{1/324,0.002845892`,0.002883258`,0.002883258`,0.002888375`,0.003068008`,0.003078542`,0.002833475`,0.002992008`,0.002993042`,0.003063083`,0.002876342`,0.002880358`,0.003013858`,0.00309685`,0.002862075`,0.003299383`,0.003287875`,0.003334358`,0.003295517`,0.003359942`,0.003245125`,0.003446858`,0.003505825`,0.003091258`,0.003240967`,0.002933692`,0.004049108`,0.003002808`,0.003135467`,0.0033998`,0.003117875`,0.003346542`,0.003305925`,0.00301775`,0.002814475`,0.005126225`,0.007617383`,0.005288208`,0.007739525`,0.005545975`,0.007610325`,0.004694558`,0.006363025`,0.003118492`,0.003091325`,0.00314975`,0.003144633`,0.002845892`,0.002814475`,0.003176233`,0.00314155`,0.003191508`,0.003087558`,0.003166067`,0.003412733`,0.003009158`,0.002814475`,0.002732508`,0.002727542`,0.003628975`,0.002706308`,0.002983725`,0.003276658`,0.003362792`,0.003417908`,0.004387675`,0.003266583`,0.003887175`,0.003322883`,0.003921575`,0.006494658`,0.007214958`,0.003993025`,0.0036921`,0.005164292`,0.007085433`,0.005346033`,0.005465275`,0.007734283`,0.005414433`,0.005839575`,0.00697665`,0.00509405`,0.007084483`,0.005259092`,0.005231733`,0.005250075`,0.005250075`,0.004754925`,0.003730025`,0.003941058`,0.003284483`,0.004551092`,0.004593642`,0.002932042`,0.003786458`,0.003766525`,0.007102725`,0.007541283`,0.007177725`,0.006256958`,0.007418542`,0.007967108`,0.006140067`,0.007541283`,0.007102725`,0.007033425`,0.008045067`,0.007471392`,0.007148725`,0.007148725`,0.006893658`,0.006815383`,0.006503925`,0.007009325`,0.006512667`,0.006213875`,0.006207575`,0.003940908`},{1/351,0.003285054`,0.003322304`,0.003322304`,0.003296479`,0.003675729`,0.003705421`,0.003383004`,0.003679846`,0.003111646`,0.003702871`,0.003481579`,0.003604421`,0.003638196`,0.003500446`,0.003554846`,0.002964854`,0.002945879`,0.003504096`,0.002823071`,0.003531613`,0.003562013`,0.003610596`,0.003615771`,0.002860446`,0.002897496`,0.002447113`,0.004163913`,0.002505421`,0.002637246`,0.004095579`,0.004383496`,0.003807279`,0.002626754`,0.002290479`,0.003357171`,0.005555529`,0.010891746`,0.005848104`,0.010972629`,0.005998979`,0.010783996`,0.006056596`,0.007209038`,0.003811838`,0.003782304`,0.003772021`,0.003782679`,0.003441204`,0.003357171`,0.003469479`,0.003661429`,0.003476029`,0.003367346`,0.003473263`,0.003862496`,0.003801429`,0.003357171`,0.003238221`,0.003210621`,0.003881863`,0.003195563`,0.003305871`,0.004268513`,0.003728504`,0.003858363`,0.005954921`,0.003818163`,0.004960296`,0.004081204`,0.004770713`,0.007891696`,0.009067754`,0.005426821`,0.004920796`,0.006386563`,0.007695754`,0.006550663`,0.006394521`,0.007415404`,0.006541229`,0.005533113`,0.007578021`,0.006362329`,0.007228638`,0.005181596`,0.005209896`,0.005185079`,0.005185079`,0.004941229`,0.003136863`,0.003097404`,0.002901638`,0.004264204`,0.004643421`,0.003845504`,0.003821321`,0.003803179`,0.006568513`,0.006994038`,0.007114388`,0.006428038`,0.007626354`,0.007879063`,0.006670138`,0.006994038`,0.006568513`,0.006731704`,0.007815221`,0.006970604`,0.006906879`,0.006906879`,0.006579221`,0.007033921`,0.006503554`,0.006674496`,0.006597679`,0.006416071`,0.006349979`,0.004510254`},{1/378,0.002833929`,0.002866413`,0.002866413`,0.002815396`,0.003083446`,0.002481221`,0.002064538`,0.002440196`,0.001853554`,0.002467063`,0.001813804`,0.001911238`,0.002308813`,0.002352654`,0.001809138`,0.002268921`,0.002257671`,0.002683979`,0.001868188`,0.002596029`,0.002001021`,0.002360996`,0.002380104`,0.002270821`,0.002288629`,0.002235663`,0.003146879`,0.002266663`,0.002311021`,0.002524538`,0.002769863`,0.002959471`,0.002281629`,0.002127488`,0.002479579`,0.006465929`,0.011537329`,0.006159788`,0.011651688`,0.007148629`,0.011204896`,0.005924513`,0.008391646`,0.004264638`,0.004143463`,0.004194963`,0.004221971`,0.002358004`,0.002479579`,0.003047321`,0.003404713`,0.003059513`,0.002989604`,0.003036738`,0.003759854`,0.003546346`,0.002479579`,0.002329538`,0.002354696`,0.003356888`,0.002332396`,0.002953238`,0.004674879`,0.002803479`,0.003063946`,0.005738413`,0.003980463`,0.004618779`,0.003859679`,0.004891271`,0.007482529`,0.008016279`,0.005674938`,0.004417688`,0.006499346`,0.007936871`,0.006620738`,0.006579204`,0.007771746`,0.006638863`,0.006005704`,0.007803521`,0.006461721`,0.007960379`,0.004671146`,0.004657113`,0.004660754`,0.004660754`,0.004384296`,0.003160538`,0.003026021`,0.003663888`,0.003582579`,0.003726713`,0.004046646`,0.004233329`,0.004235054`,0.006187079`,0.006614904`,0.006185413`,0.005982721`,0.006574263`,0.006690604`,0.006066671`,0.006614904`,0.006187079`,0.006093688`,0.006631354`,0.006595754`,0.006343896`,0.006343896`,0.006092613`,0.006225504`,0.006406646`,0.006291363`,0.006463846`,0.006514763`,0.006494504`,0.004867263`},{1/405,0.001907388`,0.001933729`,0.001933729`,0.001932979`,0.002095263`,0.002301688`,0.002218988`,0.002239779`,0.002893654`,0.002288138`,0.002825121`,0.002780646`,0.002459263`,0.002566321`,0.002454013`,0.003200279`,0.003192871`,0.003590696`,0.003161688`,0.003162179`,0.002947854`,0.003032713`,0.003215154`,0.003256163`,0.003247254`,0.003076238`,0.004320054`,0.003389029`,0.003467354`,0.003610221`,0.005170346`,0.004149596`,0.003452104`,0.003247821`,0.002247079`,0.005177788`,0.010435346`,0.005267954`,0.010581896`,0.005623346`,0.010459754`,0.005546854`,0.007133146`,0.003319329`,0.003262488`,0.003309863`,0.003338596`,0.002381596`,0.002247079`,0.002318229`,0.002556271`,0.002321421`,0.002248996`,0.002304721`,0.002973538`,0.002832713`,0.002247079`,0.002123888`,0.002083313`,0.002731554`,0.002074538`,0.002036604`,0.003931621`,0.003217404`,0.003659129`,0.006350838`,0.003031471`,0.004988504`,0.003859754`,0.005994179`,0.008165346`,0.008671663`,0.007236971`,0.006647629`,0.007415404`,0.008139613`,0.007452204`,0.007320879`,0.009023121`,0.007443288`,0.004572671`,0.007947329`,0.007365988`,0.008537246`,0.004212154`,0.004253354`,0.004220363`,0.004220363`,0.003723796`,0.002855196`,0.002926471`,0.003711263`,0.003582496`,0.004294613`,0.003846988`,0.004370846`,0.004372763`,0.006482779`,0.006906329`,0.007091338`,0.006097604`,0.007245138`,0.007520346`,0.006185129`,0.006906329`,0.006482779`,0.006409029`,0.007304546`,0.006881213`,0.006654596`,0.006654596`,0.006386846`,0.006804154`,0.006517629`,0.006625463`,0.006552754`,0.005002554`,0.005115279`,0.005188979`},{1/432,0.003348579`,0.003373704`,0.003373704`,0.003327129`,0.003779904`,0.003586538`,0.003223229`,0.003531454`,0.002635179`,0.003579079`,0.002816496`,0.003045479`,0.003675029`,0.003460454`,0.003324671`,0.002394496`,0.002367613`,0.003451629`,0.002171321`,0.004171454`,0.003295871`,0.003787346`,0.003738413`,0.002330079`,0.002277813`,0.002487413`,0.003024646`,0.002335263`,0.002365963`,0.002771204`,0.003552471`,0.003838163`,0.002606754`,0.002411454`,0.003622596`,0.007515838`,0.012522638`,0.007133763`,0.012707088`,0.007825888`,0.012657696`,0.007644713`,0.010310979`,0.005262721`,0.005174538`,0.005118371`,0.005172688`,0.003614313`,0.003622596`,0.004152446`,0.004581813`,0.004189938`,0.004056429`,0.004174788`,0.004874938`,0.004624946`,0.003622596`,0.003494679`,0.003462654`,0.004949454`,0.003447546`,0.003986779`,0.006038196`,0.004618229`,0.004560488`,0.006320213`,0.005236813`,0.005438404`,0.005222821`,0.004826571`,0.007476513`,0.008116254`,0.003988238`,0.003674063`,0.005286479`,0.006061788`,0.005359846`,0.005384904`,0.006171379`,0.005402438`,0.003993196`,0.005938021`,0.005268529`,0.005788496`,0.004458046`,0.004474204`,0.004459621`,0.004459621`,0.003887179`,0.002547688`,0.002743413`,0.004499471`,0.002908429`,0.004504021`,0.003771604`,0.004493754`,0.004516354`,0.006371738`,0.006888171`,0.007049088`,0.006858704`,0.007355821`,0.008105013`,0.006317213`,0.006888171`,0.006371738`,0.006951796`,0.008076321`,0.006924096`,0.006476163`,0.006476163`,0.006121529`,0.006862938`,0.006093504`,0.005931204`,0.006126271`,0.005894779`,0.005924454`,0.005563796`},{1/459,0.001565304`,0.001583304`,0.001583304`,0.001554921`,0.001809587`,0.001952337`,0.001591387`,0.001889237`,0.002008912`,0.001952954`,0.001869779`,0.001751754`,0.002034171`,0.002153787`,0.001931421`,0.002298762`,0.002300821`,0.002516637`,0.002071521`,0.002677371`,0.002432071`,0.002325479`,0.002478112`,0.002298537`,0.002393646`,0.002617662`,0.003938054`,0.002431787`,0.002472237`,0.004192604`,0.003842179`,0.003549304`,0.003579029`,0.003171037`,0.002201754`,0.003988904`,0.007358312`,0.004281596`,0.007469571`,0.004010771`,0.007623871`,0.004200154`,0.005342046`,0.003364004`,0.003330162`,0.003345496`,0.003356621`,0.002214337`,0.002201754`,0.002349404`,0.002595704`,0.002377021`,0.002336296`,0.002351654`,0.002908312`,0.002848854`,0.002201754`,0.002131162`,0.002109596`,0.002959721`,0.002100337`,0.002324904`,0.003804654`,0.003079321`,0.003301104`,0.004128362`,0.003224354`,0.004409079`,0.003529204`,0.004204637`,0.005342154`,0.006070204`,0.005500962`,0.004956771`,0.005058212`,0.005877821`,0.005075571`,0.005175754`,0.006165829`,0.005129746`,0.003994671`,0.005789671`,0.005040054`,0.006370371`,0.004163996`,0.004176804`,0.004164212`,0.004164212`,0.003946296`,0.002402554`,0.002672629`,0.003032521`,0.002708996`,0.003283512`,0.002620504`,0.003024871`,0.003077696`,0.004807837`,0.005469471`,0.007621354`,0.005946271`,0.008115229`,0.008518954`,0.006999046`,0.005469471`,0.004807837`,0.005081521`,0.008434262`,0.005723204`,0.005012271`,0.005012271`,0.004756212`,0.007445446`,0.004465646`,0.004443462`,0.004485979`,0.004579054`,0.004494712`,0.004067704`},{1/486,0.001419696`,0.001438471`,0.001438471`,0.001429796`,0.001582454`,0.001351071`,0.001246938`,0.001316188`,0.001625613`,0.001351346`,0.001440879`,0.001614529`,0.001550329`,0.001831704`,0.001376963`,0.001857963`,0.001829296`,0.002163238`,0.001924371`,0.002692071`,0.001800079`,0.002036104`,0.002080538`,0.001715554`,0.001885829`,0.001754679`,0.002329138`,0.001555288`,0.001592071`,0.002744063`,0.003477004`,0.002825388`,0.001738646`,0.001650921`,0.001944404`,0.007811646`,0.009876471`,0.007558796`,0.009898104`,0.007671529`,0.010032704`,0.008288679`,0.009906179`,0.005904304`,0.005774138`,0.005644546`,0.005726729`,0.001753729`,0.001944404`,0.004174496`,0.005019021`,0.004182379`,0.004248846`,0.004119929`,0.005342838`,0.004466779`,0.001944404`,0.001911629`,0.001935946`,0.004035454`,0.001918038`,0.002758213`,0.006650163`,0.003271238`,0.003322771`,0.007417354`,0.005239771`,0.005227871`,0.004643313`,0.005545613`,0.008389996`,0.009741004`,0.003825738`,0.004472229`,0.005090679`,0.006507229`,0.005212629`,0.004986754`,0.008008929`,0.005181563`,0.003168696`,0.006268304`,0.005134004`,0.006750404`,0.003625229`,0.003616896`,0.003621696`,0.003621696`,0.003738713`,0.003333854`,0.004151063`,0.003104896`,0.002083263`,0.002878663`,0.002262679`,0.002920529`,0.002970554`,0.005655746`,0.006223821`,0.007598563`,0.006511004`,0.008086229`,0.008412213`,0.007022654`,0.006223821`,0.005655746`,0.006008613`,0.008309429`,0.006368113`,0.005585688`,0.005585688`,0.005371538`,0.007417204`,0.004091288`,0.004092238`,0.004098413`,0.004573646`,0.004658446`,0.003760288`},{1/513,0.001319067`,0.001337158`,0.001337158`,0.001326058`,0.001510683`,0.001633408`,0.001484367`,0.001607925`,0.002087817`,0.0016456`,0.002017475`,0.002110833`,0.001751058`,0.002131667`,0.00207635`,0.001960033`,0.00193175`,0.002383925`,0.001879375`,0.0021274`,0.002352267`,0.002377467`,0.002042733`,0.001663275`,0.00189055`,0.001799642`,0.002121625`,0.00169395`,0.001690558`,0.002025725`,0.0021007`,0.002426617`,0.001804083`,0.001710708`,0.002252025`,0.008907425`,0.01225995`,0.008419792`,0.012339683`,0.010186233`,0.012392983`,0.007057817`,0.010815683`,0.004229183`,0.004165358`,0.00407445`,0.004093742`,0.001900508`,0.002252025`,0.003539075`,0.004037392`,0.003425658`,0.003185417`,0.003473992`,0.0049778`,0.003584867`,0.002252025`,0.002236408`,0.002290883`,0.003369975`,0.002266233`,0.002470333`,0.003671508`,0.00248105`,0.002343392`,0.003535783`,0.003208475`,0.002958067`,0.002798558`,0.00268315`,0.004500733`,0.004938925`,0.002569933`,0.00241945`,0.002880792`,0.003236692`,0.002915142`,0.00285605`,0.003679817`,0.002910258`,0.002705417`,0.003132167`,0.002893083`,0.003288617`,0.003375967`,0.003432475`,0.003390717`,0.003390717`,0.003219342`,0.003041092`,0.003764842`,0.003251058`,0.002161883`,0.003562`,0.004286208`,0.0030453`,0.003014192`,0.007107692`,0.007443575`,0.007104483`,0.008043542`,0.00797385`,0.008407883`,0.007052383`,0.007443575`,0.007107692`,0.007124467`,0.008349075`,0.0073161`,0.007613275`,0.007613275`,0.007156792`,0.007222542`,0.005533408`,0.0065624`,0.005478292`,0.004183967`,0.004246475`,0.003314275`},{1/540,0.002037129`,0.002095429`,0.002095429`,0.002124138`,0.002058854`,0.001868154`,0.001852538`,0.001864171`,0.002620379`,0.001872013`,0.002525163`,0.002361454`,0.001915029`,0.002573354`,0.002413979`,0.002828404`,0.002813238`,0.002702304`,0.003008454`,0.002834496`,0.002935221`,0.002925046`,0.002830846`,0.002440946`,0.002867954`,0.002054338`,0.003051029`,0.002108404`,0.002217904`,0.002561513`,0.002661838`,0.002832271`,0.002191071`,0.002057604`,0.001980346`,0.003868379`,0.007128654`,0.004043446`,0.007224721`,0.004428479`,0.007197871`,0.003695713`,0.005747088`,0.003197804`,0.003135613`,0.003139371`,0.003168204`,0.001998713`,0.001980346`,0.001965471`,0.002276371`,0.001982188`,0.001893904`,0.001949421`,0.002933229`,0.002846454`,0.001980346`,0.001889338`,0.001876279`,0.002455404`,0.001859454`,0.002051363`,0.003329396`,0.002679238`,0.002875888`,0.003416538`,0.002943396`,0.003381479`,0.003104388`,0.003265454`,0.003819488`,0.004292504`,0.003500929`,0.003236996`,0.003647713`,0.003869496`,0.003663913`,0.003590513`,0.004180979`,0.003659963`,0.003811271`,0.003812413`,0.003662613`,0.004053988`,0.004659363`,0.004669563`,0.004655546`,0.004655546`,0.004893663`,0.003153454`,0.003714996`,0.006101671`,0.003092879`,0.005074113`,0.003488129`,0.004661146`,0.004653754`,0.006226704`,0.006496413`,0.006685029`,0.007188146`,0.007418538`,0.007810888`,0.007036879`,0.006496413`,0.006226704`,0.006774879`,0.008148871`,0.006363129`,0.006614771`,0.006614771`,0.006283871`,0.006966963`,0.005554804`,0.006031929`,0.005553829`,0.005053196`,0.005088088`,0.003421938`},{1/567,0.003150225`,0.00320845`,0.00320845`,0.0032475`,0.002843475`,0.002442183`,0.002467183`,0.002379167`,0.002516617`,0.002438608`,0.002532758`,0.002571883`,0.002593242`,0.003245733`,0.002709433`,0.003057117`,0.00304395`,0.003125633`,0.00330715`,0.003372167`,0.003332142`,0.003371983`,0.003232783`,0.002925675`,0.003335133`,0.002558183`,0.004312317`,0.00225125`,0.002311875`,0.0039273`,0.004272583`,0.003642117`,0.00313245`,0.00265535`,0.002718558`,0.004394967`,0.006972867`,0.004508542`,0.007021292`,0.004875425`,0.007084992`,0.004921358`,0.006305942`,0.003869733`,0.003811792`,0.003801983`,0.00382595`,0.002755075`,0.002718558`,0.002873458`,0.003191058`,0.002913833`,0.002910717`,0.002857333`,0.003588533`,0.003555308`,0.002718558`,0.002642792`,0.002628858`,0.00305335`,0.002608892`,0.002619192`,0.00434645`,0.003355925`,0.0035238`,0.005322508`,0.003647042`,0.005181058`,0.003845867`,0.005747117`,0.007130275`,0.007806342`,0.004943208`,0.005520967`,0.006246492`,0.0082597`,0.006416083`,0.006068092`,0.009751092`,0.006345808`,0.003544875`,0.008007875`,0.00624335`,0.0086683`,0.004397833`,0.004347967`,0.004378875`,0.004378875`,0.005471158`,0.0033919`,0.004735442`,0.005219367`,0.002781242`,0.003420958`,0.003626467`,0.003701892`,0.003778208`,0.00684375`,0.007261867`,0.006827567`,0.006508925`,0.007304667`,0.007450808`,0.006840267`,0.007261867`,0.00684375`,0.007123575`,0.007270958`,0.007223858`,0.007225808`,0.007225808`,0.006849058`,0.006937392`,0.00571765`,0.005803208`,0.005741492`,0.006193383`,0.006231133`,0.004041817`},{1/594,0.003066433`,0.003109858`,0.003109858`,0.003124342`,0.003141867`,0.003186517`,0.003087758`,0.003178867`,0.00313145`,0.003215525`,0.003236525`,0.003229958`,0.003032425`,0.002398958`,0.002707183`,0.003166175`,0.003167375`,0.003207367`,0.002943842`,0.0035208`,0.002540408`,0.002941142`,0.003175383`,0.003087717`,0.003279317`,0.003295225`,0.004172517`,0.002783683`,0.002898525`,0.005000233`,0.005745333`,0.0043888`,0.004130283`,0.00352995`,0.0027221`,0.008671833`,0.011436958`,0.009096192`,0.011563258`,0.0090728`,0.011561083`,0.009354158`,0.010311108`,0.005659458`,0.005447517`,0.005463158`,0.005568592`,0.002836817`,0.0027221`,0.003223217`,0.0041945`,0.0031769`,0.003225725`,0.00315055`,0.005249633`,0.004676633`,0.0027221`,0.002585967`,0.002557058`,0.003543583`,0.002551525`,0.002636617`,0.007002092`,0.003921175`,0.004141733`,0.008634658`,0.005037467`,0.006797325`,0.0056866`,0.007381825`,0.00952445`,0.00979275`,0.005285708`,0.006105242`,0.005414767`,0.005264617`,0.005448333`,0.005287842`,0.008398233`,0.005416975`,0.004128383`,0.005174517`,0.005482225`,0.004941633`,0.003644892`,0.003667592`,0.003648883`,0.003648883`,0.003563267`,0.003674658`,0.003922967`,0.004738733`,0.002670858`,0.004710242`,0.003725483`,0.003531392`,0.003534667`,0.007088125`,0.007597833`,0.0079798`,0.0078164`,0.008546817`,0.008592808`,0.008060142`,0.007597833`,0.007088125`,0.006210733`,0.008631175`,0.007608667`,0.007144833`,0.007144833`,0.006773733`,0.008155308`,0.0063827`,0.00666045`,0.006411692`,0.006104625`,0.0061466`,0.004957008`},{1/621,0.002878717`,0.002915733`,0.002915733`,0.002929883`,0.002973525`,0.003529575`,0.003175375`,0.003472908`,0.003305667`,0.003526258`,0.003070008`,0.002975542`,0.003753933`,0.002970625`,0.003411117`,0.0031984`,0.003174633`,0.003054158`,0.003088633`,0.003523233`,0.003138983`,0.003331342`,0.003223458`,0.003142358`,0.003311058`,0.002944025`,0.003897592`,0.0026342`,0.002730717`,0.003746867`,0.00382625`,0.003585917`,0.003249617`,0.0028658`,0.00377425`,0.008659225`,0.0124577`,0.008115258`,0.012554142`,0.010073267`,0.012712217`,0.007312542`,0.010733192`,0.005186742`,0.005135917`,0.005146942`,0.005181433`,0.003741692`,0.00377425`,0.004739533`,0.004478992`,0.004655108`,0.003984083`,0.004776625`,0.005223892`,0.004685425`,0.00377425`,0.003708558`,0.003668767`,0.005709208`,0.003662267`,0.004328342`,0.006070467`,0.004294467`,0.003896125`,0.005505675`,0.005167867`,0.004623525`,0.0050675`,0.0049144`,0.006317608`,0.00665275`,0.004714542`,0.004551517`,0.00554065`,0.00564515`,0.005588158`,0.005503042`,0.0065437`,0.005583467`,0.004310067`,0.005530825`,0.005543792`,0.005242108`,0.004113733`,0.004171633`,0.004127892`,0.004127892`,0.0039318`,0.003080075`,0.003206075`,0.004472`,0.002529492`,0.005785492`,0.003903108`,0.004142617`,0.004184133`,0.006525308`,0.007130533`,0.007627467`,0.007330058`,0.008270367`,0.008918483`,0.0076225`,0.007130533`,0.006525308`,0.005297608`,0.008929383`,0.007238183`,0.006508558`,0.006508558`,0.00615305`,0.00776085`,0.005992092`,0.00652885`,0.006018042`,0.005464875`,0.005486617`,0.004267825`},{1/648,0.003120596`,0.003170329`,0.003170329`,0.003193263`,0.003223913`,0.003291088`,0.003349954`,0.003264454`,0.003584929`,0.003301779`,0.003600471`,0.003643304`,0.003380879`,0.003319979`,0.003429421`,0.003174754`,0.003156021`,0.003196854`,0.003186813`,0.003428146`,0.003321729`,0.003421313`,0.003307538`,0.002993871`,0.003207163`,0.003476004`,0.004287621`,0.002751479`,0.002776971`,0.004357463`,0.003764046`,0.003417863`,0.004643596`,0.004379179`,0.003403254`,0.006264938`,0.007628779`,0.006562704`,0.007724929`,0.006345979`,0.007928854`,0.006314771`,0.007076946`,0.005090713`,0.004991054`,0.004991904`,0.005023688`,0.003514104`,0.003403254`,0.003967996`,0.004024204`,0.003938963`,0.003595988`,0.003969071`,0.004708971`,0.004425971`,0.003403254`,0.003370163`,0.003344638`,0.004274429`,0.003319146`,0.003504504`,0.005123513`,0.003493046`,0.003451388`,0.004680046`,0.004603588`,0.004373188`,0.004219796`,0.004543763`,0.004974388`,0.005615754`,0.004936429`,0.004519146`,0.005111229`,0.005752021`,0.005147296`,0.005175554`,0.005807154`,0.005177338`,0.004562921`,0.005663329`,0.005076696`,0.005812196`,0.004453913`,0.004504838`,0.004465688`,0.004465688`,0.004075779`,0.003361229`,0.003785188`,0.004337379`,0.002666096`,0.004830296`,0.003427096`,0.004445663`,0.004447796`,0.006111179`,0.006776879`,0.007554721`,0.006517196`,0.008097554`,0.008815113`,0.007109888`,0.006776879`,0.006111179`,0.005102879`,0.008741979`,0.006949463`,0.006030279`,0.006030279`,0.005809321`,0.007491738`,0.006003288`,0.006309363`,0.006044004`,0.005144238`,0.005142888`,0.004689363`},{1/675,0.0034568`,0.003492075`,0.003492075`,0.003492117`,0.003612658`,0.003426825`,0.003840367`,0.003399833`,0.0035583`,0.003416258`,0.003530225`,0.00383665`,0.003533883`,0.003546917`,0.003470592`,0.003280783`,0.003260358`,0.003294375`,0.003226892`,0.003258817`,0.003562292`,0.0037014`,0.003275875`,0.002931567`,0.003158917`,0.004615283`,0.00556945`,0.003566217`,0.003570458`,0.006018392`,0.005063267`,0.0038415`,0.004711233`,0.004671992`,0.003377617`,0.006601283`,0.008094517`,0.006609267`,0.008250767`,0.007234975`,0.008696658`,0.006066433`,0.006719567`,0.0044187`,0.004358083`,0.00439185`,0.004403967`,0.00352275`,0.003377617`,0.00346385`,0.003603183`,0.003477492`,0.003239592`,0.003516975`,0.004643`,0.003996075`,0.003377617`,0.00333195`,0.003283033`,0.003903792`,0.003274`,0.003416333`,0.004351525`,0.0033093`,0.003451625`,0.0047299`,0.00405575`,0.004521833`,0.003835692`,0.005233558`,0.005434517`,0.006196583`,0.00622005`,0.005866167`,0.00595775`,0.00728955`,0.006007483`,0.006144783`,0.006846108`,0.006080583`,0.004858233`,0.007151075`,0.005891067`,0.007427933`,0.004540208`,0.004563625`,0.00454455`,0.00454455`,0.004508792`,0.003039567`,0.003509267`,0.005082217`,0.002849058`,0.004271383`,0.00489375`,0.003313383`,0.003332517`,0.008566317`,0.008909275`,0.008421742`,0.007657842`,0.008492742`,0.009037183`,0.007745775`,0.008909275`,0.008566317`,0.006098417`,0.009013167`,0.00873115`,0.009249875`,0.009249875`,0.008843608`,0.008234075`,0.007779092`,0.00806925`,0.007775817`,0.006633442`,0.006641417`,0.005802842`},{1/702,0.003601258`,0.003624342`,0.003624342`,0.003598683`,0.003816325`,0.003799075`,0.003637875`,0.003786158`,0.003379075`,0.003792508`,0.003148258`,0.00331965`,0.003768383`,0.003149608`,0.003326333`,0.00490195`,0.0049069`,0.004506333`,0.004676858`,0.004112875`,0.003742275`,0.0037302`,0.004047483`,0.004456325`,0.00444575`,0.004504617`,0.004821192`,0.003643092`,0.003836892`,0.00631395`,0.005892567`,0.005687425`,0.004677358`,0.004304083`,0.003591175`,0.007414308`,0.010489742`,0.00738885`,0.010590992`,0.008730625`,0.01081865`,0.005697467`,0.007963358`,0.004327825`,0.004272942`,0.004298458`,0.004315175`,0.003640892`,0.003591175`,0.004230783`,0.004079808`,0.0041935`,0.003973417`,0.004228175`,0.004289708`,0.004141517`,0.003591175`,0.003479475`,0.003442125`,0.004303033`,0.003439442`,0.00374375`,0.004610508`,0.004145092`,0.004591183`,0.00551845`,0.004159275`,0.005550333`,0.004998992`,0.005945008`,0.007290308`,0.0076586`,0.006544325`,0.006322217`,0.007288`,0.009692825`,0.007469883`,0.007488408`,0.009506717`,0.007518083`,0.005264667`,0.009404842`,0.007178058`,0.009993675`,0.00427675`,0.004324825`,0.004287883`,0.004287883`,0.003936808`,0.002705758`,0.003074842`,0.005761558`,0.002592983`,0.0048464`,0.003657458`,0.005135483`,0.005127417`,0.006001342`,0.006321933`,0.007433017`,0.007099108`,0.00831975`,0.008801025`,0.007669942`,0.006321933`,0.006001342`,0.005196492`,0.008896875`,0.006234492`,0.006335417`,0.006335417`,0.006041458`,0.0076715`,0.006410167`,0.006089308`,0.006433925`,0.006377417`,0.006381292`,0.006410858`},{1/729,0.004531525`,0.004564392`,0.004564392`,0.004523442`,0.004620658`,0.004497042`,0.004186692`,0.004464542`,0.004374392`,0.004479275`,0.004447042`,0.004540292`,0.004616692`,0.004536592`,0.004664792`,0.004112125`,0.004084525`,0.005337458`,0.004286692`,0.005944025`,0.004968325`,0.005133625`,0.005385175`,0.003961792`,0.003965458`,0.004600042`,0.007124525`,0.003977775`,0.004030008`,0.007905692`,0.007758975`,0.006235625`,0.006876958`,0.006006342`,0.004885675`,0.009242558`,0.011545092`,0.009114958`,0.011632392`,0.009311675`,0.011560358`,0.007192058`,0.009940175`,0.005189842`,0.005207525`,0.005194358`,0.005176925`,0.004710292`,0.004885675`,0.005097608`,0.005095442`,0.005076608`,0.004804792`,0.005174675`,0.005370158`,0.005233292`,0.004885675`,0.004863458`,0.004782292`,0.005956842`,0.004783242`,0.004990742`,0.005812225`,0.006017508`,0.006393275`,0.006866792`,0.005517325`,0.007232442`,0.005861958`,0.008220642`,0.008059708`,0.008865408`,0.008515342`,0.008434075`,0.009684692`,0.010711058`,0.009798808`,0.009708808`,0.010792608`,0.009821892`,0.006915208`,0.010604392`,0.009645458`,0.010741608`,0.003785208`,0.003815108`,0.003788425`,0.003788425`,0.004274775`,0.002932108`,0.003290792`,0.004758175`,0.003192642`,0.003959008`,0.003650558`,0.005049708`,0.005051508`,0.005744758`,0.006303125`,0.006044758`,0.005272775`,0.006420075`,0.006642275`,0.005904142`,0.006303125`,0.005744758`,0.004395592`,0.006710408`,0.006429175`,0.006068192`,0.006068192`,0.005879875`,0.006080808`,0.005657808`,0.005755342`,0.005699925`,0.006147308`,0.006147358`,0.005199275`},{1/756,0.003447213`,0.003490446`,0.003490446`,0.003477513`,0.003520596`,0.003653546`,0.003325529`,0.003587279`,0.003465696`,0.003658729`,0.003394529`,0.003655746`,0.003776463`,0.003434413`,0.003729279`,0.005077129`,0.005088613`,0.005289296`,0.004764446`,0.005046279`,0.004014463`,0.004610646`,0.004867546`,0.005160629`,0.004415246`,0.007274679`,0.008926613`,0.005988313`,0.005945596`,0.008531646`,0.007911579`,0.007301313`,0.008981963`,0.008686496`,0.003881063`,0.009200679`,0.011617013`,0.010388463`,0.011779329`,0.009949329`,0.012020246`,0.008366629`,0.010449229`,0.005690729`,0.005770296`,0.005779063`,0.005732613`,0.003903129`,0.003881063`,0.004461479`,0.005177079`,0.004472946`,0.004450996`,0.004439629`,0.005671079`,0.005720929`,0.003881063`,0.003776429`,0.003748163`,0.004872279`,0.003726463`,0.003879779`,0.006269679`,0.005508479`,0.006026379`,0.008545846`,0.006414279`,0.007473296`,0.006848446`,0.008622629`,0.009872563`,0.011447413`,0.009717579`,0.009005379`,0.010592729`,0.012054863`,0.010737029`,0.010859979`,0.011993679`,0.010828863`,0.007705513`,0.011931213`,0.010471713`,0.012046746`,0.003661129`,0.003694529`,0.003667179`,0.003667179`,0.003579913`,0.003443713`,0.003733179`,0.004523929`,0.003165996`,0.004644563`,0.003492346`,0.004860396`,0.004849063`,0.006332396`,0.007034246`,0.007107579`,0.006051846`,0.007365996`,0.007320313`,0.006633246`,0.007034246`,0.006332396`,0.004874363`,0.006986963`,0.007234713`,0.006211296`,0.006211296`,0.006069896`,0.007011346`,0.006178746`,0.006117513`,0.006216246`,0.006392513`,0.006406546`,0.004918613`},{1/783,0.004446083`,0.00449065`,0.00449065`,0.004481783`,0.00482385`,0.0048213`,0.0044859`,0.00480235`,0.004971567`,0.0047972`,0.004955217`,0.00485835`,0.004912433`,0.0040801`,0.004839317`,0.007683`,0.00769435`,0.007294867`,0.007542917`,0.007133883`,0.005947267`,0.006737017`,0.0070584`,0.00729165`,0.006841417`,0.007688783`,0.00511055`,0.00673375`,0.006793867`,0.008034717`,0.008681783`,0.0087305`,0.007890567`,0.007994617`,0.004823083`,0.010066283`,0.012784417`,0.010830033`,0.012880017`,0.010159317`,0.013032717`,0.0095862`,0.01033735`,0.008064617`,0.008000283`,0.00786115`,0.00790065`,0.004814817`,0.004823083`,0.005192767`,0.006083267`,0.00524025`,0.00540395`,0.005188417`,0.007023217`,0.007191533`,0.004823083`,0.004706333`,0.004642933`,0.005647133`,0.0046315`,0.004800767`,0.008825083`,0.006955333`,0.007439767`,0.0116068`,0.0075459`,0.010132683`,0.008050783`,0.010661183`,0.013194333`,0.01359555`,0.006207767`,0.008350617`,0.0095388`,0.010995683`,0.009621467`,0.0090597`,0.013230767`,0.00954495`,0.002876717`,0.01061075`,0.0096007`,0.0111127`,0.004059033`,0.004077267`,0.004058767`,0.004058767`,0.00397155`,0.003714317`,0.003821317`,0.005049617`,0.003481133`,0.004422217`,0.004588017`,0.005200833`,0.005065967`,0.00720335`,0.007597267`,0.007325717`,0.006158817`,0.0077543`,0.007843133`,0.00717555`,0.007597267`,0.00720335`,0.0053562`,0.0077326`,0.007490967`,0.007282383`,0.007282383`,0.007053017`,0.007373583`,0.006498267`,0.006456633`,0.00652525`,0.006320083`,0.0063606`,0.0054618`},{1/810,0.006788117`,0.0068418`,0.0068418`,0.006828633`,0.0065252`,0.0073351`,0.00716895`,0.00723915`,0.007300883`,0.00721515`,0.0075056`,0.0075527`,0.007902283`,0.005802183`,0.007377433`,0.007563433`,0.007568267`,0.00804015`,0.007756617`,0.008618183`,0.00763075`,0.008273467`,0.00844555`,0.0068288`,0.006996333`,0.005650967`,0.004234333`,0.006312317`,0.006484133`,0.005836833`,0.005608083`,0.00732185`,0.00562875`,0.005652567`,0.008160267`,0.0121803`,0.014729683`,0.012548233`,0.01485785`,0.01260775`,0.015015583`,0.011139833`,0.013071417`,0.009885117`,0.009971567`,0.009868667`,0.009814467`,0.007938733`,0.008160267`,0.00947045`,0.010077083`,0.009512967`,0.009293167`,0.00951025`,0.010726417`,0.010289383`,0.008160267`,0.008142617`,0.0081098`,0.00911505`,0.0080857`,0.008506083`,0.010007317`,0.008648333`,0.008581917`,0.009715783`,0.00936465`,0.00940425`,0.0092384`,0.008491233`,0.01172395`,0.01225575`,0.005694683`,0.00608285`,0.006729083`,0.005961517`,0.006692`,0.00624485`,0.009442667`,0.00660425`,0.003474033`,0.00574695`,0.006869217`,0.005287333`,0.00423395`,0.00430735`,0.004251333`,0.004251333`,0.004072717`,0.003219217`,0.0030276`,0.003490867`,0.003762033`,0.004174517`,0.003215133`,0.004677733`,0.004697`,0.005446067`,0.00595515`,0.0074478`,0.005375883`,0.00811605`,0.008382133`,0.007498033`,0.00595515`,0.005446067`,0.004137817`,0.008309583`,0.006042667`,0.00555305`,0.00555305`,0.005418017`,0.0075791`,0.005468317`,0.0054949`,0.005478567`,0.004798917`,0.004869417`,0.004449233`},{1/837,0.0072183`,0.00727175`,0.00727175`,0.007260217`,0.007000817`,0.007752733`,0.007423867`,0.0075724`,0.006252533`,0.007616833`,0.006462933`,0.006824267`,0.007879483`,0.005345417`,0.006600167`,0.0071986`,0.007209767`,0.006738733`,0.006996083`,0.00682655`,0.006964283`,0.007062917`,0.006963917`,0.0068716`,0.0062893`,0.005807567`,0.00345535`,0.0061865`,0.006320483`,0.005964383`,0.005649867`,0.0069874`,0.005932117`,0.005847383`,0.007713867`,0.012333567`,0.015739733`,0.012067033`,0.0159011`,0.014971133`,0.016166717`,0.011812683`,0.015195233`,0.00769995`,0.007609083`,0.007466117`,0.007505217`,0.00782035`,0.007713867`,0.007920583`,0.00803795`,0.0078912`,0.007570983`,0.0079473`,0.00866485`,0.007876433`,0.007713867`,0.007434233`,0.007397167`,0.0081789`,0.0073999`,0.007570717`,0.008715917`,0.007052083`,0.007250317`,0.010226017`,0.007390383`,0.008546617`,0.007442917`,0.00789735`,0.011711683`,0.01372865`,0.005421083`,0.006094467`,0.00683735`,0.009939267`,0.006974517`,0.006763`,0.01171095`,0.006979083`,0.0030824`,0.009576`,0.0069227`,0.010122933`,0.004161983`,0.00416795`,0.004161783`,0.004161783`,0.004349283`,0.001666`,0.002068067`,0.0038981`,0.002668733`,0.0023653`,0.00306135`,0.003297983`,0.003345017`,0.00584825`,0.006486117`,0.007029867`,0.0048778`,0.007444017`,0.00803485`,0.006612167`,0.006486117`,0.00584825`,0.0042394`,0.007988633`,0.00665135`,0.005682433`,0.005682433`,0.005546383`,0.0069415`,0.006136283`,0.006260633`,0.006148233`,0.005217283`,0.005248467`,0.00507675`},{4/81,0.005670371`,0.005675988`,0.005675988`,0.005620671`,0.005995971`,0.006689104`,0.006085154`,0.006610488`,0.006065271`,0.006591254`,0.006195288`,0.006469938`,0.007201838`,0.005128254`,0.006582121`,0.005466571`,0.005467488`,0.005725471`,0.006137388`,0.006466688`,0.005921321`,0.006790254`,0.006712788`,0.004820188`,0.004734721`,0.003695354`,0.003236171`,0.004903088`,0.005002638`,0.003968404`,0.003798454`,0.004628471`,0.003955488`,0.003783021`,0.007535054`,0.015313788`,0.015199038`,0.015233588`,0.015292554`,0.015619871`,0.015475504`,0.014531004`,0.015304538`,0.010617338`,0.010320154`,0.010151454`,0.010240221`,0.007553621`,0.007535054`,0.008093171`,0.008535754`,0.008092238`,0.007838204`,0.008119771`,0.009767571`,0.008682238`,0.007535054`,0.007411438`,0.007369621`,0.008319054`,0.007339571`,0.007438938`,0.011478104`,0.006464371`,0.006509654`,0.011790071`,0.008081504`,0.007690138`,0.007220888`,0.005968304`,0.013786754`,0.014818888`,0.003746521`,0.004149504`,0.005428721`,0.008790288`,0.005473421`,0.005323538`,0.011799588`,0.005466554`,0.002366938`,0.008157371`,0.005515754`,0.009250654`,0.003226471`,0.003286154`,0.003241904`,0.003241904`,0.003504171`,0.001645621`,0.002011638`,0.004752388`,0.002236654`,0.002931038`,0.003701671`,0.003539571`,0.003532071`,0.006231788`,0.006622554`,0.007470254`,0.006016671`,0.007743238`,0.007884188`,0.007063488`,0.006622554`,0.006231788`,0.005241338`,0.007737154`,0.006575204`,0.006440321`,0.006440321`,0.006146921`,0.007385538`,0.005225138`,0.005324388`,0.005257188`,0.004975504`,0.004987538`,0.004423204`},{2/81,0.005856038`,0.005832904`,0.005832904`,0.005707471`,0.006107754`,0.006195338`,0.006313338`,0.006135538`,0.004596538`,0.006107604`,0.004818938`,0.005600254`,0.006535138`,0.004531504`,0.005105438`,0.004504804`,0.004509704`,0.004280038`,0.004911304`,0.004556171`,0.005222854`,0.005063871`,0.004812104`,0.004644004`,0.004478088`,0.004271771`,0.004395471`,0.004858038`,0.004955421`,0.005406688`,0.004499938`,0.004807771`,0.005086871`,0.004798538`,0.006341854`,0.010877438`,0.014894354`,0.010455071`,0.015044421`,0.012198721`,0.015442554`,0.009963221`,0.013119804`,0.005617538`,0.005425038`,0.005499121`,0.005548721`,0.006202938`,0.006341854`,0.005906404`,0.005806671`,0.005807154`,0.005092304`,0.005910554`,0.006759754`,0.005445138`,0.006341854`,0.005983088`,0.005952404`,0.007159654`,0.005963938`,0.006269321`,0.005437221`,0.004584154`,0.004736521`,0.006222604`,0.004792754`,0.006204254`,0.005134271`,0.005490838`,0.009270921`,0.010833938`,0.005528338`,0.005521254`,0.006664938`,0.009182821`,0.006758704`,0.006831254`,0.010653738`,0.006832904`,0.005701054`,0.008918454`,0.006622554`,0.009550421`,0.004621821`,0.004689954`,0.004637138`,0.004637138`,0.004688604`,0.002410171`,0.002538854`,0.003584371`,0.002827371`,0.003710988`,0.003390838`,0.004727571`,0.004705254`,0.005487688`,0.006062971`,0.006853988`,0.006158754`,0.007324021`,0.007335138`,0.006832388`,0.006062971`,0.005487688`,0.004299954`,0.007286121`,0.006211654`,0.005824304`,0.005824304`,0.005628971`,0.006967038`,0.005079754`,0.005345038`,0.005105254`,0.004955221`,0.004883604`,0.003954838`},{4/243,0.004485313`,0.004531463`,0.004531463`,0.004524396`,0.004698779`,0.004944746`,0.005124946`,0.004853096`,0.005144313`,0.004887129`,0.004968829`,0.005167146`,0.005195229`,0.004569896`,0.004889113`,0.006947796`,0.006973396`,0.006499113`,0.006331196`,0.006091213`,0.005631846`,0.006444863`,0.006502196`,0.006906396`,0.005716046`,0.007969013`,0.006376429`,0.006753613`,0.006922596`,0.009235479`,0.008830213`,0.007811713`,0.008673129`,0.008451929`,0.005140896`,0.008089163`,0.014521713`,0.008915563`,0.014753763`,0.009341663`,0.015199063`,0.007747779`,0.009707396`,0.006440929`,0.006421163`,0.006428796`,0.006440446`,0.005139813`,0.005140896`,0.005034479`,0.005652829`,0.005068929`,0.004930079`,0.005061563`,0.005700879`,0.006067146`,0.005140896`,0.004919629`,0.004835363`,0.005811596`,0.004842846`,0.004751763`,0.008062279`,0.005859713`,0.006761629`,0.012054646`,0.005979829`,0.009683963`,0.007298329`,0.010090463`,0.013259813`,0.013376813`,0.011452879`,0.010570113`,0.013142963`,0.014059463`,0.013324213`,0.013280563`,0.013875629`,0.013376996`,0.007478979`,0.013916429`,0.013042679`,0.013533779`,0.004742096`,0.004678079`,0.004714946`,0.004714946`,0.004706413`,0.003272579`,0.004053163`,0.003178113`,0.003356063`,0.003574129`,0.002402813`,0.004042146`,0.004016863`,0.005914846`,0.006502213`,0.006564763`,0.005011929`,0.006934246`,0.007153413`,0.006439679`,0.006502213`,0.005914846`,0.004282946`,0.007201046`,0.006639863`,0.006040379`,0.006040379`,0.005859496`,0.006610513`,0.005527163`,0.005854463`,0.005545029`,0.005109796`,0.005099679`,0.004059413`},{1/81,0.006406263`,0.006437846`,0.006437846`,0.006376363`,0.006469646`,0.007366763`,0.007266279`,0.007237646`,0.006991329`,0.007215029`,0.006990079`,0.007214813`,0.008029563`,0.005714013`,0.006738413`,0.009688613`,0.009625363`,0.010561946`,0.009696963`,0.009991913`,0.008660379`,0.009510863`,0.009775796`,0.008941863`,0.007524179`,0.006488596`,0.003934229`,0.004327779`,0.004416263`,0.006285613`,0.007762896`,0.009660363`,0.005008946`,0.005365096`,0.007781563`,0.011302996`,0.015184096`,0.012439679`,0.015350663`,0.011300563`,0.015621429`,0.010727063`,0.011200179`,0.009389263`,0.009303079`,0.009324713`,0.009375779`,0.007455929`,0.007781563`,0.008948096`,0.008950329`,0.008905463`,0.008366546`,0.008968713`,0.010034663`,0.008898246`,0.007781563`,0.007605613`,0.007396846`,0.009024113`,0.007480646`,0.007981679`,0.011838129`,0.009533596`,0.010469679`,0.013602346`,0.009251696`,0.012494196`,0.010950829`,0.011490213`,0.013844629`,0.014514846`,0.004696063`,0.006241846`,0.008786663`,0.010469863`,0.009327496`,0.007614613`,0.012835813`,0.008868696`,0.002614929`,0.010324796`,0.008973463`,0.009601079`,0.004143746`,0.004129079`,0.004134413`,0.004134413`,0.004148446`,0.002668429`,0.003345396`,0.003253696`,0.002452296`,0.002503146`,0.002793913`,0.002895263`,0.002922779`,0.005788263`,0.006483196`,0.006921429`,0.005366963`,0.007128263`,0.007420429`,0.006263163`,0.006483196`,0.005788263`,0.004654129`,0.007397646`,0.006702646`,0.005720163`,0.005720163`,0.005545729`,0.006734029`,0.005234163`,0.005367029`,0.005258496`,0.005074279`,0.005057196`,0.003330796`},{4/405,0.008712467`,0.008768167`,0.008768167`,0.00877795`,0.007983917`,0.009190533`,0.009800283`,0.009048867`,0.0063049`,0.008983817`,0.00758245`,0.0089844`,0.009836483`,0.006119517`,0.008210867`,0.003748017`,0.003713883`,0.005340483`,0.003658967`,0.0071033`,0.007051117`,0.00784175`,0.006817467`,0.003272033`,0.00324065`,0.003496883`,0.0032374`,0.0029002`,0.002977967`,0.004110033`,0.003976133`,0.00478335`,0.003640317`,0.003562783`,0.0103402`,0.01308005`,0.014660733`,0.013727267`,0.014878917`,0.012649783`,0.015335983`,0.01247555`,0.012846283`,0.010118783`,0.010191183`,0.009948883`,0.009921717`,0.01009745`,0.0103402`,0.011297617`,0.0117166`,0.0114335`,0.011334483`,0.011298367`,0.01230885`,0.0111054`,0.0103402`,0.010365217`,0.010297433`,0.01072325`,0.0102835`,0.01102515`,0.009416967`,0.00710425`,0.006924133`,0.00916885`,0.009961567`,0.007160567`,0.008060317`,0.005206783`,0.010270583`,0.011409`,0.003966133`,0.004068733`,0.005290683`,0.005120983`,0.005355567`,0.0051739`,0.006088567`,0.00532025`,0.003498733`,0.0050641`,0.0053108`,0.00416605`,0.003162383`,0.003134283`,0.003152867`,0.003152867`,0.003343367`,0.001783383`,0.00230325`,0.003406467`,0.002095367`,0.002775867`,0.003350633`,0.0031174`,0.003114483`,0.006463`,0.007109983`,0.006822467`,0.0060612`,0.006405617`,0.006783767`,0.0050529`,0.007109983`,0.006463`,0.005555767`,0.00642735`,0.007265367`,0.006485967`,0.006485967`,0.0062015`,0.006172467`,0.0060079`,0.006037567`,0.006019083`,0.00598275`,0.006000533`,0.00454375`},{2/243,0.006272763`,0.006319046`,0.006319046`,0.006296879`,0.006171713`,0.005612229`,0.004671696`,0.005564046`,0.002950896`,0.005553063`,0.003119946`,0.003558946`,0.005343596`,0.003659046`,0.003605029`,0.002872363`,0.002849296`,0.003489413`,0.002775279`,0.003933646`,0.003268296`,0.003828396`,0.003801346`,0.002832179`,0.002858296`,0.003347929`,0.002832429`,0.003057946`,0.003074479`,0.003998146`,0.003656896`,0.004136146`,0.003634329`,0.003503429`,0.005085063`,0.008487679`,0.014839546`,0.008650896`,0.015072779`,0.009478063`,0.015531513`,0.007003813`,0.010062029`,0.004998779`,0.004978446`,0.004995579`,0.005004563`,0.004927596`,0.005085063`,0.006175079`,0.005418963`,0.006067363`,0.005267646`,0.006220863`,0.005840179`,0.004903379`,0.005085063`,0.004746513`,0.004717463`,0.006944629`,0.004725746`,0.005771163`,0.004773296`,0.004183379`,0.004222063`,0.005167396`,0.004897863`,0.004937129`,0.004506329`,0.004360029`,0.006025463`,0.006779863`,0.003744413`,0.003950513`,0.004764463`,0.005167229`,0.004793529`,0.004709996`,0.005461379`,0.004785279`,0.003597213`,0.005144429`,0.004774896`,0.005041879`,0.003131929`,0.003100213`,0.003119529`,0.003119529`,0.003088146`,0.002063196`,0.002629163`,0.003591479`,0.002125396`,0.002862646`,0.004262329`,0.003997163`,0.003964096`,0.006000313`,0.006521963`,0.007285463`,0.006482946`,0.006870596`,0.007263079`,0.005747696`,0.006521963`,0.006000313`,0.006059379`,0.007462079`,0.006582779`,0.006530479`,0.006530479`,0.006158896`,0.006756429`,0.004841079`,0.004846996`,0.004896129`,0.004574863`,0.004524596`,0.003395413`},{4/567,0.002820638`,0.002871871`,0.002871871`,0.002890221`,0.003039471`,0.003129888`,0.002995021`,0.003068254`,0.002939004`,0.003140671`,0.002977404`,0.003088138`,0.003110571`,0.002908104`,0.002779588`,0.004212054`,0.004221338`,0.004135621`,0.003901238`,0.003896054`,0.003342504`,0.003751304`,0.003887471`,0.004494454`,0.004232638`,0.005007071`,0.005003588`,0.004631438`,0.004759671`,0.005831171`,0.005611554`,0.005295671`,0.005181871`,0.004879771`,0.003041588`,0.006674288`,0.013116104`,0.007317354`,0.013230338`,0.007870354`,0.013076621`,0.005852671`,0.007701738`,0.004698688`,0.004581438`,0.004611771`,0.004661221`,0.003101021`,0.003041588`,0.003321104`,0.003658721`,0.003352438`,0.003284604`,0.003326588`,0.004329688`,0.003978588`,0.003041588`,0.002873121`,0.002844071`,0.003995221`,0.002836738`,0.003097638`,0.005395388`,0.003981921`,0.004322238`,0.006653038`,0.004194588`,0.006393921`,0.004871188`,0.006884704`,0.008056388`,0.008097288`,0.007059704`,0.006834454`,0.008153188`,0.009116438`,0.008276171`,0.008133538`,0.010803071`,0.008267104`,0.005581704`,0.008999938`,0.008133854`,0.008921454`,0.003161171`,0.003172671`,0.003161204`,0.003161204`,0.003453371`,0.002377521`,0.003278004`,0.002643154`,0.002784704`,0.003542754`,0.003311488`,0.004076454`,0.003974371`,0.005680271`,0.006233721`,0.007806004`,0.006247888`,0.008360821`,0.008676288`,0.007706221`,0.006233721`,0.005680271`,0.005506188`,0.008570371`,0.006342638`,0.006182171`,0.006182171`,0.005958271`,0.007869954`,0.005103604`,0.005161721`,0.005130021`,0.005049888`,0.005056638`,0.003473871`},{1/162,0.003946754`,0.003985471`,0.003985471`,0.003956571`,0.004535221`,0.004745354`,0.004232204`,0.004716438`,0.004476104`,0.004733754`,0.004172088`,0.004422171`,0.004917238`,0.004423354`,0.004167621`,0.007701871`,0.007729738`,0.007054371`,0.007249704`,0.006384654`,0.005537704`,0.006121154`,0.006495004`,0.007756588`,0.006945104`,0.007749371`,0.005475671`,0.003858938`,0.004148171`,0.009796671`,0.009340588`,0.008307754`,0.006215271`,0.005874554`,0.004826888`,0.009833438`,0.012197321`,0.010311671`,0.012268704`,0.009507338`,0.012277171`,0.008873904`,0.009841454`,0.007522204`,0.007373204`,0.007363088`,0.007430871`,0.004848871`,0.004826888`,0.005155121`,0.006045121`,0.005214521`,0.005265438`,0.005136088`,0.006857671`,0.006780454`,0.004826888`,0.004611838`,0.004544938`,0.005600771`,0.004548821`,0.004650988`,0.007863454`,0.006440771`,0.006998454`,0.010234471`,0.006293471`,0.008948188`,0.007075554`,0.009944304`,0.011759354`,0.012823104`,0.010179538`,0.010632221`,0.011801738`,0.011939554`,0.011929688`,0.011830388`,0.013080754`,0.011953171`,0.004888304`,0.011870088`,0.011739671`,0.011499154`,0.002839038`,0.002892121`,0.002850254`,0.002850254`,0.002964071`,0.003373621`,0.004530971`,0.002992171`,0.002417988`,0.003707654`,0.002817788`,0.003108871`,0.003043288`,0.006191988`,0.006561238`,0.007421554`,0.005863321`,0.007736688`,0.007742538`,0.007286438`,0.006561238`,0.006191988`,0.005076838`,0.007569071`,0.006451788`,0.006144121`,0.006144121`,0.005973354`,0.007490488`,0.005859971`,0.005918654`,0.005878621`,0.005657338`,0.005679371`,0.003978904`},{4/729,0.006483175`,0.006518525`,0.006518525`,0.006472142`,0.006489325`,0.007128942`,0.006888075`,0.007053892`,0.006346725`,0.007021725`,0.006474458`,0.006852292`,0.007618242`,0.004852642`,0.006876425`,0.006640142`,0.006609375`,0.008358475`,0.006431758`,0.008751575`,0.006102308`,0.008328675`,0.008482008`,0.005591108`,0.005382242`,0.004924675`,0.005335108`,0.003640042`,0.003742958`,0.006302108`,0.009353058`,0.008672175`,0.004623742`,0.004325242`,0.007956858`,0.010368992`,0.013422708`,0.010930042`,0.013551942`,0.010487375`,0.013652258`,0.010406142`,0.010724158`,0.009236042`,0.009306558`,0.009280775`,0.009260775`,0.007693092`,0.007956858`,0.009166975`,0.009257392`,0.009224508`,0.008785958`,0.009162208`,0.009383842`,0.009316092`,0.007956858`,0.008000642`,0.007890142`,0.009014908`,0.007898592`,0.008355175`,0.011194075`,0.009111275`,0.009249175`,0.012944908`,0.009656692`,0.012602875`,0.010435675`,0.012849508`,0.013486958`,0.013430625`,0.009345292`,0.010243158`,0.013315908`,0.013188242`,0.013389875`,0.013107575`,0.013641308`,0.013359392`,0.004135008`,0.013081758`,0.013265942`,0.012611308`,0.003246292`,0.003301292`,0.003260125`,0.003260125`,0.002978042`,0.003782392`,0.003870225`,0.004128492`,0.002683942`,0.003878958`,0.003964408`,0.004128908`,0.004083775`,0.005955308`,0.006498175`,0.007621675`,0.006065642`,0.008087875`,0.008161292`,0.007654992`,0.006498175`,0.005955308`,0.005624008`,0.008107725`,0.006576592`,0.006559958`,0.006559958`,0.006140625`,0.007751358`,0.005247725`,0.005546592`,0.005261258`,0.004804625`,0.004847225`,0.004379425`},{2/405,0.004943671`,0.004999071`,0.004999071`,0.004983621`,0.005048354`,0.005221171`,0.004843304`,0.005140854`,0.003878621`,0.005160054`,0.003751404`,0.004373388`,0.005523921`,0.004391854`,0.004077988`,0.006512038`,0.006518388`,0.007225688`,0.005326888`,0.007728554`,0.004502371`,0.005880654`,0.006545604`,0.006862804`,0.005450621`,0.008305054`,0.007194354`,0.005401371`,0.005583938`,0.010707388`,0.011802821`,0.009869054`,0.008125004`,0.007933788`,0.005616888`,0.011078271`,0.013804021`,0.011534138`,0.013975721`,0.011330954`,0.014207471`,0.011622021`,0.011455188`,0.010504221`,0.010596571`,0.010510871`,0.010495904`,0.005240438`,0.005616888`,0.008708371`,0.009229188`,0.008778954`,0.008953121`,0.008653321`,0.009677488`,0.010276438`,0.005616888`,0.005415821`,0.005448021`,0.007394738`,0.005421754`,0.006477754`,0.011956671`,0.008764988`,0.009062204`,0.012942288`,0.011029154`,0.013248988`,0.011999754`,0.013205154`,0.012244254`,0.012589038`,0.012400071`,0.012617004`,0.012528971`,0.012733204`,0.012610971`,0.012565638`,0.012812521`,0.012651821`,0.009402188`,0.012652904`,0.012487271`,0.012458521`,0.003690804`,0.003748488`,0.003703204`,0.003703204`,0.004245338`,0.002812988`,0.003318538`,0.003366204`,0.002399538`,0.003556154`,0.003803538`,0.005159054`,0.005170871`,0.005438488`,0.005974904`,0.007910988`,0.006165938`,0.008433221`,0.008463621`,0.008004521`,0.005974904`,0.005438488`,0.005231838`,0.008303538`,0.006074354`,0.005829438`,0.005829438`,0.005518138`,0.008076788`,0.005142771`,0.005079238`,0.005167888`,0.004741621`,0.004778854`,0.003687604`},{4/891,0.004901567`,0.004958717`,0.004958717`,0.0049399`,0.005473167`,0.005563233`,0.005734`,0.005811533`,0.007312383`,0.00565135`,0.006461533`,0.006258617`,0.0070911`,0.006788717`,0.00766525`,0.011140283`,0.011060533`,0.011971017`,0.00979895`,0.01184925`,0.010083567`,0.010787067`,0.011411033`,0.0092103`,0.00848015`,0.011161867`,0.00855035`,0.0038571`,0.00414235`,0.01204065`,0.010791767`,0.011482217`,0.010130433`,0.009308483`,0.007729767`,0.010994367`,0.01399505`,0.011944783`,0.014183067`,0.010156867`,0.0143237`,0.011293017`,0.00996585`,0.011282383`,0.011329517`,0.011281833`,0.011229117`,0.00763895`,0.007729767`,0.00978255`,0.010727467`,0.009886833`,0.010089333`,0.009720117`,0.010765`,0.011485267`,0.007729767`,0.007702533`,0.007659567`,0.008655383`,0.007590283`,0.0081515`,0.011067633`,0.012165033`,0.012364933`,0.01186895`,0.0119008`,0.012267433`,0.011992267`,0.011910917`,0.012484117`,0.0130774`,0.012448783`,0.011985767`,0.012875733`,0.013185533`,0.012999833`,0.012826983`,0.01378735`,0.013005733`,0.009581783`,0.013091267`,0.012833917`,0.01270695`,0.004622033`,0.004724183`,0.0046479`,0.0046479`,0.005139067`,0.00306115`,0.003986467`,0.00361595`,0.002929317`,0.003111`,0.0022958`,0.00555785`,0.005537917`,0.005571833`,0.0059841`,0.00779165`,0.004795367`,0.008347533`,0.008592883`,0.007675983`,0.0059841`,0.005571833`,0.004480133`,0.008491783`,0.00594085`,0.005562067`,0.005562067`,0.0054607`,0.007850367`,0.005081817`,0.0054628`,0.005225633`,0.005093933`,0.0051226`,0.004036933`},{1/243,0.005202367`,0.0052124`,0.0052124`,0.005124217`,0.005548817`,0.007873133`,0.0054567`,0.007732017`,0.0055396`,0.007821017`,0.004950133`,0.005369717`,0.009483933`,0.009878033`,0.008928183`,0.007182783`,0.00716355`,0.011637767`,0.006700317`,0.011742933`,0.009587783`,0.011859817`,0.011893283`,0.006133017`,0.0051164`,0.010159567`,0.0076063`,0.005304583`,0.005392467`,0.013089617`,0.01147785`,0.012144533`,0.011209817`,0.010492783`,0.0108754`,0.01030645`,0.012936717`,0.011500817`,0.01314535`,0.010056383`,0.01379845`,0.011107333`,0.010300633`,0.010848333`,0.011012133`,0.010871183`,0.01079105`,0.010412483`,0.0108754`,0.010726`,0.010946933`,0.010843633`,0.0106175`,0.01073195`,0.011122117`,0.0113452`,0.0108754`,0.01071405`,0.010698617`,0.010719683`,0.010674867`,0.0109401`,0.011806983`,0.0119101`,0.012407217`,0.013121717`,0.0114104`,0.013231267`,0.01202965`,0.013145517`,0.01319095`,0.013966567`,0.013142583`,0.012966933`,0.013061917`,0.012719083`,0.01312485`,0.012977283`,0.013609433`,0.013126933`,0.008008633`,0.012686167`,0.0130317`,0.012154733`,0.004856333`,0.004895267`,0.00486265`,0.00486265`,0.005295133`,0.003054333`,0.004190767`,0.0036173`,0.002883033`,0.003036333`,0.002325183`,0.004246067`,0.004235333`,0.005605033`,0.00616755`,0.007563683`,0.004649867`,0.008218533`,0.0086031`,0.007319783`,0.00616755`,0.005605033`,0.0048451`,0.008693867`,0.006248483`,0.005504667`,0.005504667`,0.005328767`,0.007544467`,0.004755183`,0.00531955`,0.004847117`,0.004323117`,0.004345867`,0.00378975`},{4/1053,0.0032218`,0.00325925`,0.00325925`,0.003257767`,0.003591567`,0.004274017`,0.00354175`,0.004213383`,0.00487335`,0.004249333`,0.0040563`,0.003932983`,0.004638`,0.008106817`,0.0051085`,0.0079493`,0.007913117`,0.010859383`,0.006421317`,0.0115378`,0.0075441`,0.01025665`,0.010444783`,0.007593517`,0.00656595`,0.01154465`,0.007972183`,0.008184017`,0.00814845`,0.013879033`,0.012277333`,0.012438067`,0.011821533`,0.011693033`,0.00558715`,0.0104498`,0.013820533`,0.01183395`,0.013957617`,0.009765683`,0.014081567`,0.011664867`,0.010525567`,0.010924967`,0.011047783`,0.010929033`,0.010883517`,0.005207983`,0.00558715`,0.009245283`,0.0110533`,0.0092373`,0.009540267`,0.009134667`,0.01124475`,0.011514033`,0.00558715`,0.00563825`,0.00568285`,0.00772125`,0.0056095`,0.006600917`,0.012393733`,0.012639883`,0.012818617`,0.0126093`,0.012091467`,0.012842383`,0.012472017`,0.012703417`,0.012622683`,0.01349445`,0.013363967`,0.013452183`,0.0125431`,0.012256783`,0.012544217`,0.01251555`,0.013175883`,0.012587183`,0.007431533`,0.0122122`,0.012517117`,0.01178975`,0.008447917`,0.008371867`,0.008419817`,0.008419817`,0.008000517`,0.0035558`,0.004184117`,0.003273667`,0.006620483`,0.002983583`,0.00288775`,0.0038059`,0.003800733`,0.005749533`},{2/567,0.004269654`,0.004290521`,0.004290521`,0.004247854`,0.004552938`,0.005799438`,0.004385021`,0.005612771`,0.006090238`,0.005690804`,0.005372988`,0.005216588`,0.006393754`,0.007145954`,0.005913638`,0.007704571`,0.007601221`,0.009850904`,0.006681521`,0.011045521`,0.008477854`,0.010615388`,0.010589471`,0.006073138`,0.005701604`,0.005261221`,0.004118304`,0.003276421`,0.003404821`,0.006917788`,0.009127704`,0.009629404`,0.004374238`,0.004218838`,0.006775438`,0.010633271`,0.013508654`,0.012241704`,0.013695354`,0.010127038`,0.014389904`,0.011892604`,0.010138771`,0.010968138`,0.011170438`,0.011151271`,0.011057521`,0.006565354`,0.006775438`,0.008453621`,0.010060088`,0.008462788`,0.008459054`,0.008383854`,0.011437588`,0.011534838`,0.006775438`,0.006671088`,0.006687371`,0.008827571`,0.006639638`,0.007509821`,0.011816104`,0.011115521`,0.011228554`,0.011954304`,0.012025704`,0.011703554`,0.011720271`,0.011647871`,0.011906471`,0.012386554`,0.009292354`,0.009622571`,0.011379338`,0.012508671`,0.011592638`,0.011280121`,0.012336221`,0.011555938`,0.008648288`,0.012437221`,0.011331238`,0.012142454`,0.005759921`,0.005804821`,0.005769254`,0.005769254`,0.006130271`,0.004402788`,0.004375521`,0.003003904`,0.005857438`,0.003359571`,0.003356188`,0.003523371`,0.003516604`,0.006374471`,0.006892021`,0.007443021`,0.005617738`,0.007816338`,0.008210571`,0.006929971`,0.006892021`,0.006374471`,0.006389404`,0.008198238`,0.006914421`,0.006107704`,0.006107704`,0.005937404`,0.007287271`,0.005148888`,0.005943821`,0.005112454`,0.004686154`,0.004802204`,0.003370704`},{4/1215,0.003436883`,0.0034629`,0.0034629`,0.003419733`,0.00365275`,0.004060917`,0.002948733`,0.003929383`,0.002598667`,0.004010283`,0.002468117`,0.002574117`,0.004339467`,0.003662317`,0.003189683`,0.003426867`,0.003424683`,0.003706783`,0.0030653`,0.0040266`,0.00327355`,0.004006533`,0.003825283`,0.003176417`,0.003045617`,0.003253417`,0.0031949`,0.0027915`,0.00282695`,0.003968317`,0.004004917`,0.004324417`,0.003318017`,0.003121317`,0.004650633`,0.011290317`,0.013734283`,0.012477`,0.014039433`,0.010447517`,0.01442425`,0.0130433`,0.01070795`,0.009868867`,0.009754267`,0.009792483`,0.00982335`,0.004403567`,0.004650633`,0.007038333`,0.00761495`,0.00701815`,0.006436433`,0.007011867`,0.00903465`,0.00848005`,0.004650633`,0.00435765`,0.00443355`,0.006435567`,0.004397617`,0.005678467`,0.010345867`,0.004333517`,0.00429815`,0.0112237`,0.007294367`,0.00619575`,0.005650433`,0.006717283`,0.01190755`,0.011523583`,0.005528067`,0.005134483`,0.0083346`,0.011672683`,0.0085763`,0.008391283`,0.0114118`,0.008568267`,0.0061197`,0.011408233`,0.0083165`,0.01147655`,0.005908567`,0.005968683`,0.0059197`,0.0059197`,0.006552033`,0.0041121`,0.0043895`,0.004203417`,0.005110033`,0.004552417`,0.00301915`,0.005293833`,0.0052843`,0.006333217`,0.006715833`,0.007592533`,0.0057762`,0.008055133`,0.008311483`,0.007271233`,0.006715833`,0.006333217`,0.0064573`,0.0082335`,0.006614867`,0.0059392`,0.0059392`,0.0058249`,0.007522767`,0.006449467`,0.006164417`,0.006464433`,0.006057467`,0.0061248`,0.0043465`},{1/324,0.002540817`,0.002557917`,0.002557917`,0.0025306`,0.002746167`,0.003319433`,0.002867617`,0.00319695`,0.003458433`,0.003296883`,0.003257083`,0.00322355`,0.003704133`,0.003774583`,0.003402583`,0.004779067`,0.0047712`,0.00494735`,0.004378333`,0.00499755`,0.0039551`,0.004573483`,0.00479915`,0.0048874`,0.00444905`,0.005881683`,0.005922967`,0.004846833`,0.004856017`,0.00683075`,0.006201867`,0.005558133`,0.006470833`,0.006125883`,0.004115617`,0.011503133`,0.013639683`,0.011778367`,0.01375055`,0.01144505`,0.0137275`,0.011869833`,0.011645417`,0.007545367`,0.007130767`,0.007208067`,0.007450383`,0.004081783`,0.004115617`,0.004020517`,0.0046396`,0.004028617`,0.00400335`,0.00402485`,0.00537375`,0.005386683`,0.004115617`,0.003927417`,0.003928383`,0.00464435`,0.003901717`,0.004058933`,0.009927583`,0.0054726`,0.00573`,0.011349167`,0.006287667`,0.008320683`,0.0071261`,0.007955033`,0.012078117`,0.013233267`,0.008557633`,0.0080471`,0.009644883`,0.01175115`,0.009780567`,0.00988495`,0.012119317`,0.00987435`,0.008074217`,0.011659217`,0.009599167`,0.0116631`,0.006165783`,0.006259233`,0.006189283`,0.006189283`,0.006283533`,0.004353533`,0.0047002`,0.0047875`,0.006313617`,0.0046011`,0.00323315`,0.00538645`,0.005380683`,0.006709033`,0.00711355`,0.007811633`,0.005450867`,0.008260733`,0.008348817`,0.007679417`,0.00711355`,0.006709033`,0.00630785`,0.008303217`,0.007023917`,0.006768733`,0.006768733`,0.00657755`,0.007835817`,0.006644067`,0.007487183`,0.006665883`,0.006315517`,0.0063644`,0.005130267`},{4/1377,0.005120533`,0.005130283`,0.005130283`,0.00503995`,0.00547705`,0.0061678`,0.00542575`,0.006135283`,0.006630467`,0.006118517`,0.005811417`,0.005524783`,0.006668733`,0.00728955`,0.006587967`,0.0093759`,0.009298183`,0.01072625`,0.009258333`,0.010217083`,0.00858655`,0.0095867`,0.010038267`,0.008297783`,0.008119217`,0.00813365`,0.005248817`,0.005941`,0.00605425`,0.010722283`,0.010933467`,0.010842367`,0.007725583`,0.007423433`,0.007298967`,0.010501383`,0.012902183`,0.011215067`,0.012989467`,0.01058185`,0.013043633`,0.0118588`,0.011040167`,0.010035183`,0.009859`,0.009839267`,0.0099141`,0.007003233`,0.007298967`,0.007679967`,0.008230817`,0.007774467`,0.007611167`,0.007719667`,0.008584883`,0.008398567`,0.007298967`,0.007228`,0.007185367`,0.008036633`,0.007160833`,0.007431783`,0.0124235`,0.010490817`,0.011570067`,0.013418967`,0.009805433`,0.012771133`,0.01203745`,0.012278067`,0.014029883`,0.014814117`,0.011179067`,0.011323433`,0.012078567`,0.012428567`,0.012150133`,0.012121817`,0.013622017`,0.01220525`,0.010123233`,0.012303683`,0.012049567`,0.0122513`,0.005743933`,0.005823167`,0.005760667`,0.005760667`,0.0065451`,0.003633717`,0.0039902`,0.00440095`,0.004516817`,0.00454815`,0.003856317`,0.00487305`,0.004856567`,0.007489733`,0.007570367`,0.008166817`,0.007165683`,0.008661`,0.00870075`,0.007929117`,0.007570367`,0.007489733`,0.007704133`,0.008658033`,0.007212833`,0.0085071`,0.0085071`,0.008034117`,0.008137967`,0.006275017`,0.007067033`,0.006268083`,0.00587105`,0.005883333`,0.004392483`},{2/729,0.007544175`,0.007575875`,0.007575875`,0.007483025`,0.007639692`,0.008205075`,0.007336575`,0.008109658`,0.007599008`,0.008060492`,0.007241775`,0.007860475`,0.008663892`,0.008480908`,0.008283275`,0.005912825`,0.005855042`,0.008248492`,0.006167742`,0.009860192`,0.008459375`,0.009125375`,0.009070892`,0.004968158`,0.004903358`,0.004770592`,0.008350058`,0.003986092`,0.004061442`,0.010325742`,0.011502275`,0.009427358`,0.005576408`,0.004467692`,0.008680342`,0.011047808`,0.014548192`,0.011534958`,0.014644358`,0.010403108`,0.014696725`,0.011359092`,0.011506575`,0.011857325`,0.011957892`,0.011966792`,0.011878208`,0.008790942`,0.008680342`,0.009489075`,0.010147225`,0.009626008`,0.009588592`,0.009519842`,0.010623625`,0.011279525`,0.008680342`,0.008567675`,0.008563025`,0.009676308`,0.008515308`,0.009095792`,0.012941125`,0.010743508`,0.010802775`,0.013424292`,0.012481175`,0.013107242`,0.012507825`,0.012821408`,0.014134042`,0.014296442`,0.011450242`,0.012145025`,0.012576542`,0.012778675`,0.012697092`,0.012260492`,0.013597592`,0.012623392`,0.010351075`,0.012627558`,0.012548992`,0.013104825`,0.006773592`,0.006824025`,0.006779692`,0.006779692`,0.007075125`,0.004712008`,0.005365975`,0.005007925`,0.005588142`,0.006264225`,0.005522592`,0.005856742`,0.005871075`,0.007219625`,0.007400392`,0.007541575`,0.007786525`,0.008530108`,0.008655842`,0.007926608`,0.007400392`,0.007219625`,0.007254742`,0.008656608`,0.007142858`,0.008063508`,0.008063508`,0.007662442`,0.007847258`,0.006153442`,0.007122675`,0.006150842`,0.005908425`,0.005972258`,0.004299208`},{4/1539,0.004118158`,0.004158658`,0.004158658`,0.004125925`,0.004268292`,0.004513425`,0.004035142`,0.004277942`,0.003816192`,0.004470825`,0.003791958`,0.003900958`,0.004931742`,0.004927825`,0.004425775`,0.005181258`,0.005178725`,0.006404425`,0.005223992`,0.006292792`,0.004376608`,0.005806058`,0.006079392`,0.005545425`,0.004656842`,0.007649342`,0.009651342`,0.005987325`,0.006090425`,0.011818975`,0.011848292`,0.009355258`,0.010035992`,0.009026225`,0.005134758`,0.010657092`,0.014133125`,0.012067742`,0.014271308`,0.010607258`,0.014558892`,0.011555542`,0.011776958`,0.011509808`,0.011651708`,0.011594125`,0.011480525`,0.005010308`,0.005134758`,0.006942158`,0.008943692`,0.006921175`,0.006984208`,0.006871108`,0.010778325`,0.010981008`,0.005134758`,0.004983858`,0.004961108`,0.006801758`,0.004935058`,0.005598758`,0.012248375`,0.006846992`,0.007366542`,0.013533308`,0.011122725`,0.013010042`,0.011746592`,0.013598308`,0.014753708`,0.014340158`,0.012233708`,0.012459075`,0.013220775`,0.013092708`,0.013300225`,0.013348725`,0.014156742`,0.013377342`,0.008722442`,0.013036158`,0.013139308`,0.013210692`,0.004821592`,0.004815525`,0.004812308`,0.004812308`,0.005003675`,0.006650025`,0.007293808`,0.007315225`,0.005425775`,0.004567008`,0.005700792`,0.006781908`,0.006766942`,0.006979192`,0.007116525`,0.005998225`,0.007608025`,0.006940325`,0.007373808`,0.006646392`,0.007116525`,0.006979192`,0.006830392`,0.007491692`,0.006834842`,0.007995642`,0.007995642`,0.007593625`,0.006410608`,0.007407425`,0.007886625`,0.007396492`,0.006554492`,0.006584225`,0.004728508`},{1/405,0.00367405`,0.003689733`,0.003689733`,0.0036271`,0.004254433`,0.00440605`,0.003884067`,0.004090517`,0.003667467`,0.00425515`,0.003599233`,0.00382515`,0.005513883`,0.005185217`,0.0043674`,0.004197667`,0.0041811`,0.0061287`,0.003845517`,0.006709333`,0.004596583`,0.005930333`,0.006010133`,0.003955117`,0.00359655`,0.00580065`,0.0086865`,0.0032141`,0.003234183`,0.007811267`,0.009484167`,0.007766683`,0.00714785`,0.0064866`,0.006059383`,0.010617367`,0.01398335`,0.01193995`,0.014139183`,0.010461733`,0.014887717`,0.011798667`,0.0117599`,0.012094333`,0.011881517`,0.0117845`,0.0118985`,0.005781183`,0.006059383`,0.009005717`,0.01048635`,0.008921283`,0.009011283`,0.008876133`,0.012022517`,0.011184667`,0.006059383`,0.005856117`,0.0058849`,0.008146067`,0.005853683`,0.0072071`,0.013382533`,0.00757095`,0.008242617`,0.013911467`,0.0117487`,0.01267215`,0.011503433`,0.013434667`,0.013546317`,0.0143372`,0.011810567`,0.012555`,0.012892133`,0.013465833`,0.01294035`,0.0125614`,0.013595983`,0.012878317`,0.006508883`,0.01339885`,0.0128648`,0.013360533`,0.004365067`,0.00440475`,0.004373617`,0.004373617`,0.00452995`,0.006152617`,0.00738975`,0.007647983`,0.00373685`,0.00477455`,0.004793267`,0.00457925`,0.00456075`,0.006377817`,0.006664533`,0.006959133`,0.00677125`,0.007519533`,0.007742583`,0.007071267`,0.006664533`,0.006377817`,0.006575383`,0.007695067`,0.006533117`,0.006907`,0.006907`,0.00660175`,0.00712385`,0.00635695`,0.00659205`,0.00635635`,0.006209233`,0.00617645`,0.00630955`},{4/1701,0.002470917`,0.002503617`,0.002503617`,0.00247415`,0.002587183`,0.00258095`,0.0020829`,0.002607217`,0.002030467`,0.002599367`,0.002167517`,0.001991667`,0.002669167`,0.002855883`,0.002405967`,0.0034084`,0.00341455`,0.003481833`,0.002932717`,0.003669083`,0.002764983`,0.003129117`,0.0032385`,0.00328955`,0.003197617`,0.004923783`,0.008209117`,0.00375745`,0.003591183`,0.007210633`,0.0077171`,0.00528295`,0.006800867`,0.00627405`,0.003013583`,0.012766667`,0.013647517`,0.013162067`,0.01385125`,0.01153595`,0.0141391`,0.01385595`,0.012889683`,0.009668517`,0.009370067`,0.009276517`,0.009398833`,0.00293645`,0.003013583`,0.005184783`,0.006859533`,0.005126883`,0.005164267`,0.005095067`,0.0082513`,0.008100517`,0.003013583`,0.002802667`,0.00281815`,0.004532867`,0.002793967`,0.003529883`,0.010657367`,0.004289733`,0.004664467`,0.01339045`,0.0075754`,0.0083807`,0.006774733`,0.009342017`,0.014654483`,0.014554733`,0.009776033`,0.009475367`,0.012308617`,0.012649733`,0.0123605`,0.012225183`,0.013387833`,0.012368733`,0.010667217`,0.012628867`,0.012272967`,0.012321633`,0.004315367`,0.004440683`,0.00434835`,0.00434835`,0.00437585`,0.00438315`,0.0052462`,0.005807467`,0.003954233`,0.0046492`,0.005754967`,0.005905733`,0.00594485`,0.0067624`,0.006991783`,0.007617067`,0.007294667`,0.00790035`,0.008447583`,0.00727415`,0.006991783`,0.0067624`,0.007122183`,0.008691333`,0.006781417`,0.0073926`,0.0073926`,0.007047233`,0.0075999`,0.006593483`,0.006955683`,0.006592067`,0.006468767`,0.006511`,0.005350933`},{2/891,0.002008342`,0.002031808`,0.002031808`,0.002021508`,0.002237025`,0.002807175`,0.002153825`,0.002772158`,0.002557675`,0.002816458`,0.002369742`,0.002194058`,0.003156092`,0.004130975`,0.003030808`,0.006197892`,0.006214058`,0.006583225`,0.004734392`,0.005228108`,0.004036608`,0.004407192`,0.005386542`,0.006694608`,0.005059225`,0.008256408`,0.008440858`,0.006960358`,0.006915108`,0.010638108`,0.011136708`,0.009600675`,0.009101092`,0.009043175`,0.004219525`,0.011667442`,0.014439258`,0.012089358`,0.014615642`,0.011939158`,0.014936592`,0.012123058`,0.012400475`,0.009181242`,0.009144175`,0.009069008`,0.009097708`,0.003986525`,0.004219525`,0.005521592`,0.006897542`,0.005561275`,0.005718308`,0.005449042`,0.008769608`,0.008409758`,0.004219525`,0.004056058`,0.004074392`,0.004948208`,0.004041525`,0.004463125`,0.011118275`,0.007690275`,0.007995825`,0.014300175`,0.009166825`,0.011510692`,0.010139258`,0.011917142`,0.014654925`,0.014988625`,0.011712375`,0.012305292`,0.013107942`,0.013186542`,0.012945092`,0.013037375`,0.013598058`,0.013021858`,0.008802842`,0.013097792`,0.013114225`,0.013677392`,0.004276275`,0.004387842`,0.004304225`,0.004304225`,0.004182608`,0.003962758`,0.004929358`,0.005855775`,0.004378992`,0.004688675`,0.006025008`,0.005445758`,0.005457658`,0.007945375`,0.008016725`,0.008300842`,0.008800242`,0.008647425`,0.008800208`,0.007956458`,0.008016725`,0.007945375`,0.008706725`,0.008750075`,0.007647342`,0.009236275`,0.009236275`,0.008716942`,0.008271425`,0.008455858`,0.009088058`,0.008461008`,0.008207558`,0.008187358`,0.006712425`},{4/1863,0.003417083`,0.003425067`,0.003425067`,0.003327883`,0.004281467`,0.005776817`,0.003825117`,0.005274367`,0.00531945`,0.005692683`,0.0047354`,0.004383717`,0.007386883`,0.008463717`,0.007689767`,0.008148317`,0.0080662`,0.009240567`,0.007639767`,0.009641817`,0.008429083`,0.009164133`,0.0095165`,0.007126`,0.006707483`,0.005671583`,0.00495735`,0.00554185`,0.005715233`,0.0065311`,0.008124317`,0.0091564`,0.00518065`,0.005097767`,0.0091472`,0.01215365`,0.0153613`,0.012677567`,0.015527217`,0.01212315`,0.016018617`,0.013394817`,0.012541467`,0.011903917`,0.011744833`,0.011697817`,0.011775767`,0.008666533`,0.0091472`,0.010124133`,0.010489633`,0.010189133`,0.0100503`,0.010130017`,0.011153233`,0.011030617`,0.0091472`,0.009144817`,0.009111533`,0.00952985`,0.009076733`,0.009007083`,0.013539783`,0.010546017`,0.010732567`,0.01369875`,0.010874067`,0.011711983`,0.011882983`,0.011231117`,0.014155917`,0.015005083`,0.00632925`,0.0076005`,0.011298967`,0.013411133`,0.01147975`,0.011409067`,0.01451195`,0.011524967`,0.006530767`,0.013200783`,0.011272617`,0.013847467`,0.004812733`,0.0048606`,0.004822117`,0.004822117`,0.00526135`,0.003810567`,0.004251417`,0.007056267`,0.00447295`,0.0041338`,0.005972083`,0.0052203`,0.005249617`,0.008878233`,0.00871755`,0.008569433`,0.010059717`,0.0088236`,0.009062383`,0.008247933`,0.00871755`,0.008878233`,0.009976083`,0.009196217`,0.008112683`,0.01015205`,0.01015205`,0.009613633`,0.008533683`,0.010037017`,0.010461183`,0.010052667`,0.009734667`,0.0097489`,0.008426817`},{1/486,0.006220863`,0.006185879`,0.006185879`,0.006041946`,0.007017346`,0.007768613`,0.006459163`,0.007646796`,0.006217263`,0.007652813`,0.005984529`,0.006613679`,0.008420163`,0.006695729`,0.006874629`,0.004897463`,0.004886713`,0.005334063`,0.004816479`,0.005752863`,0.006253579`,0.006166479`,0.005830396`,0.004755579`,0.004465646`,0.004169129`,0.005778379`,0.004378363`,0.004487196`,0.005184979`,0.005743279`,0.005579196`,0.004632096`,0.004160946`,0.007838329`,0.012700013`,0.013515296`,0.012747279`,0.013811513`,0.011360129`,0.014547346`,0.012729479`,0.013337563`,0.009369879`,0.009207746`,0.009100829`,0.009186679`,0.007851029`,0.007838329`,0.009401846`,0.009371646`,0.009409263`,0.008582929`,0.009420596`,0.009959946`,0.008866546`,0.007838329`,0.007508629`,0.007465479`,0.010092863`,0.007477863`,0.009064529`,0.009084346`,0.006214696`,0.006139779`,0.009437646`,0.008169413`,0.007587413`,0.007036713`,0.007469279`,0.012062829`,0.012905413`,0.006071163`,0.006865063`,0.007393263`,0.010488746`,0.007426596`,0.007351363`,0.011469196`,0.007434596`,0.005286229`,0.010212196`,0.007392013`,0.011630579`,0.005470479`,0.005517929`,0.005479029`,0.005479029`,0.006145313`,0.004048613`,0.004784629`,0.007306113`,0.004816446`,0.004259129`,0.005608963`,0.005939413`,0.005972596`,0.007506763`,0.007690446`,0.008405146`,0.008719929`,0.008847329`,0.008960496`,0.008390013`,0.007690446`,0.007506763`,0.008188079`,0.009015729`,0.007421046`,0.008231329`,0.008231329`,0.007897346`,0.008495846`,0.007245296`,0.007609163`,0.007214379`,0.006916646`,0.006916479`,0.007143396`},{4/2025,0.005594183`,0.00558315`,0.00558315`,0.005520383`,0.006021567`,0.005130883`,0.005263733`,0.005165683`,0.004106917`,0.00513145`,0.00440595`,0.004894233`,0.004943267`,0.0048844`,0.0044167`,0.0049338`,0.004962533`,0.005266367`,0.00391655`,0.005331183`,0.004518633`,0.004776567`,0.004964783`,0.004817617`,0.004369333`,0.0059189`,0.005913833`,0.00524885`,0.005170417`,0.006967`,0.0067125`,0.006285383`,0.006845767`,0.006333117`,0.0048351`,0.008400667`,0.01356545`,0.00826565`,0.013846933`,0.008812433`,0.0141553`,0.007643067`,0.010708383`,0.00603895`,0.0060414`,0.006037183`,0.00603835`,0.004835067`,0.0048351`,0.004768333`,0.005032083`,0.004856167`,0.004754967`,0.004776933`,0.00558565`,0.005455967`,0.0048351`,0.004671367`,0.004635983`,0.005393433`,0.004610633`,0.004658733`,0.006489533`,0.005541483`,0.00596445`,0.00828935`,0.006183067`,0.0072055`,0.0064489`,0.008384917`,0.010164167`,0.010665233`,0.007531367`,0.008690267`,0.00809795`,0.010196`,0.00813515`,0.008046717`,0.011588533`,0.008134933`,0.006310267`,0.009963017`,0.0080734`,0.011307067`,0.0050139`,0.00502695`,0.005013833`,0.005013833`,0.005211383`,0.0041154`,0.004497067`,0.0071841`,0.004463183`,0.004058817`,0.004563983`,0.006187267`,0.006155767`,0.0067438`,0.007050967`,0.008241217`,0.00746585`,0.008610767`,0.008835233`,0.0081374`,0.007050967`,0.0067438`,0.007091033`,0.0089791`,0.006910833`,0.007303133`,0.007303133`,0.007001917`,0.0082909`,0.00531835`,0.006093217`,0.005314717`,0.005265767`,0.005170167`,0.0038`},{2/1053,0.005135154`,0.005172738`,0.005172738`,0.005151204`,0.005241204`,0.004832854`,0.005178371`,0.004874271`,0.004368354`,0.004846721`,0.004511871`,0.005013154`,0.004731888`,0.004974988`,0.004336154`,0.006229871`,0.006253421`,0.007622721`,0.004710038`,0.006895104`,0.004888054`,0.005939104`,0.006306604`,0.006371288`,0.004823688`,0.008842571`,0.006735371`,0.006785204`,0.006774004`,0.009458371`,0.008904738`,0.009490138`,0.008504488`,0.008298221`,0.004679121`,0.007027104`,0.015318488`,0.008458221`,0.015519638`,0.006720871`,0.015366821`,0.007887238`,0.008157654`,0.007382654`,0.007438054`,0.007408404`,0.007412821`,0.004615904`,0.004679121`,0.004906121`,0.005590154`,0.005056221`,0.005192721`,0.004908804`,0.006127771`,0.006658338`,0.004679121`,0.004571121`,0.004561988`,0.005709088`,0.004525538`,0.005122988`,0.008044771`,0.007482854`,0.008276354`,0.009721504`,0.007629471`,0.009434471`,0.008645421`,0.009783471`,0.011295438`,0.011879454`,0.009117854`,0.009481921`,0.010519304`,0.012070321`,0.010628554`,0.010661904`,0.012627954`,0.010672521`,0.007958838`,0.011931521`,0.010407254`,0.012905671`,0.004134938`,0.004103504`,0.004121938`,0.004121938`,0.004466504`,0.003744104`,0.004294904`,0.007163988`,0.004082754`,0.003492888`,0.004744388`,0.005076321`,0.005048504`,0.006018471`,0.006421338`,0.008151088`,0.007924038`,0.008776471`,0.009012071`,0.008280104`,0.006421338`,0.006018471`,0.006714838`,0.009037854`,0.006387804`,0.006390871`,0.006390871`,0.006116138`,0.008335238`,0.005866804`,0.006628438`,0.005877038`,0.005317354`,0.005367021`,0.004042904`},{4/2187,0.005062346`,0.005117879`,0.005117879`,0.005128179`,0.005228029`,0.005699179`,0.005254196`,0.005604079`,0.005384629`,0.005638113`,0.005123563`,0.005421479`,0.006163946`,0.007094463`,0.005872946`,0.007873946`,0.007893713`,0.010744446`,0.006583629`,0.010623846`,0.006527063`,0.009055579`,0.010099179`,0.008056329`,0.005895829`,0.011081913`,0.008429396`,0.008208946`,0.008203363`,0.011376129`,0.010635046`,0.010703296`,0.010912563`,0.010922129`,0.006781079`,0.008647079`,0.014815796`,0.010050763`,0.015059746`,0.009243796`,0.015276679`,0.009527396`,0.010352996`,0.008951329`,0.009296946`,0.009249413`,0.009082029`,0.006579879`,0.006781079`,0.008208296`,0.009062046`,0.008503246`,0.008709679`,0.008266263`,0.008863363`,0.009673296`,0.006781079`,0.006724446`,0.006728713`,0.008131763`,0.006676879`,0.007695879`,0.009101963`,0.010684713`,0.010819079`,0.009567579`,0.010678179`,0.010701079`,0.010392279`,0.011184196`,0.009511846`,0.012400246`,0.011174163`,0.011389579`,0.012092696`,0.012657829`,0.012148846`,0.012137713`,0.013385279`,0.012182463`,0.009444296`,0.012537313`,0.012023813`,0.013129479`,0.003680446`,0.003665463`,0.003671363`,0.003671363`,0.004504846`,0.003338413`,0.003634846`,0.005945279`,0.004170329`,0.003762113`,0.004279446`,0.005915263`,0.005936963`,0.006206146`,0.006615796`,0.007862863`,0.006311429`,0.008295929`,0.008464746`,0.007758529`,0.006615796`,0.006206146`,0.006385963`,0.008256663`,0.006538813`,0.006372329`,0.006372329`,0.006114329`,0.007936896`,0.006049346`,0.006273779`,0.006079496`,0.006104213`,0.006136229`,0.004676579`},{1/567,0.005471217`,0.005504633`,0.005504633`,0.005471683`,0.005810267`,0.006397133`,0.00567765`,0.006267217`,0.00637765`,0.00632965`,0.00606785`,0.005976617`,0.007516133`,0.009224667`,0.007223583`,0.01102385`,0.0108849`,0.01215645`,0.00888035`,0.011689267`,0.008983583`,0.011527067`,0.012032333`,0.0089681`,0.006581117`,0.010222667`,0.008720067`,0.007643767`,0.00776525`,0.011052333`,0.0116583`,0.0122341`,0.009330517`,0.009172233`,0.008582183`,0.008927567`,0.014307767`,0.010858933`,0.0145403`,0.00946895`,0.014711717`,0.010590683`,0.010391183`,0.009502333`,0.0097976`,0.009665283`,0.0095678`,0.008176633`,0.008582183`,0.009476317`,0.00994205`,0.009724633`,0.009463317`,0.00962565`,0.00978635`,0.010505033`,0.008582183`,0.008477333`,0.008493767`,0.00962785`,0.008429533`,0.0092954`,0.009729567`,0.0112629`,0.011673417`,0.011162817`,0.011007933`,0.011846283`,0.01085895`,0.012349933`,0.01303125`,0.0139558`,0.01117515`,0.01192085`,0.012929433`,0.01371365`,0.01298815`,0.012903217`,0.015177233`,0.013001783`,0.0105604`,0.013529383`,0.012848383`,0.01411925`,0.004747367`,0.004751017`,0.0047421`,0.0047421`,0.005308183`,0.0054897`,0.00621865`,0.0056286`,0.004385467`,0.003997117`,0.003979883`,0.005623917`,0.005603717`,0.007189183`,0.0075831`,0.00821155`,0.006875633`,0.008252767`,0.0090354`,0.007388167`,0.0075831`,0.007189183`,0.0075974`,0.00926915`,0.007466367`,0.007324583`,0.007324583`,0.00710065`,0.007962333`,0.007979583`,0.008625367`,0.00798605`,0.0079687`,0.00794595`,0.0068108`},{4/2349,0.008639892`,0.008630725`,0.008630725`,0.008446525`,0.008903375`,0.009165258`,0.008346908`,0.009220225`,0.007052958`,0.009020558`,0.007037458`,0.007991175`,0.010270642`,0.010556492`,0.010042375`,0.006699008`,0.006723408`,0.010000942`,0.007025725`,0.011008308`,0.009855675`,0.010728958`,0.010488575`,0.006824042`,0.005618275`,0.006937742`,0.008081042`,0.006783958`,0.006816708`,0.008464075`,0.010080158`,0.010245708`,0.006799008`,0.006481542`,0.010849092`,0.010477742`,0.014102292`,0.012239475`,0.014274742`,0.010607592`,0.015060375`,0.011864275`,0.011574075`,0.010740875`,0.010750142`,0.010597092`,0.010612608`,0.010613208`,0.010849092`,0.009323075`,0.010265308`,0.009630042`,0.009729258`,0.009390925`,0.010157758`,0.010541875`,0.010849092`,0.010401925`,0.010303375`,0.010807358`,0.010357158`,0.010672942`,0.012279292`,0.010991658`,0.011260942`,0.015024658`,0.011162758`,0.013033008`,0.011815225`,0.013096625`,0.015385675`,0.016130358`,0.010441908`,0.011145342`,0.013746675`,0.015151475`,0.013766625`,0.013591992`,0.015402758`,0.013763992`,0.010690308`,0.014913608`,0.013775958`,0.015830542`,0.005290158`,0.005380575`,0.005310375`,0.005310375`,0.005586908`,0.004781458`,0.004905858`,0.007741592`,0.005931358`,0.003929358`,0.005722308`,0.005991692`,0.006009558`,0.008928608`,0.008891325`,0.008813408`,0.008438492`,0.009227642`,0.009393508`,0.008334058`,0.008891325`,0.008928608`,0.009941642`,0.009442558`,0.008416958`,0.009638292`,0.009638292`,0.009300892`,0.008697975`,0.010521575`,0.010991708`,0.010514458`,0.009355492`,0.009379342`,0.008149375`},{2/1215,0.008157896`,0.008161063`,0.008161063`,0.007977346`,0.008252546`,0.008038413`,0.007089046`,0.007992829`,0.005577863`,0.007944896`,0.005681479`,0.006349729`,0.008151479`,0.006717863`,0.006182263`,0.006302329`,0.006312196`,0.007616346`,0.005048396`,0.007774929`,0.006429813`,0.007013146`,0.007251246`,0.006250663`,0.005751613`,0.005430413`,0.007367046`,0.006329663`,0.006384579`,0.006723929`,0.009241446`,0.008715779`,0.005407379`,0.005117646`,0.008016829`,0.011625313`,0.014775863`,0.013082063`,0.014950196`,0.010591796`,0.015278613`,0.013994846`,0.012719313`,0.011739913`,0.011771729`,0.011624946`,0.011615263`,0.007639263`,0.008016829`,0.009726913`,0.010344863`,0.009862379`,0.009500246`,0.009737146`,0.010986729`,0.010787363`,0.008016829`,0.007749913`,0.007735813`,0.009827979`,0.007723013`,0.009086046`,0.012807829`,0.008561296`,0.008927763`,0.014262046`,0.011146546`,0.010959079`,0.009607263`,0.012744346`,0.015584579`,0.015823496`,0.011834813`,0.011610063`,0.014412746`,0.015164513`,0.014423479`,0.014215763`,0.015455579`,0.014413679`,0.010702346`,0.014960913`,0.014390379`,0.016029429`,0.006414079`,0.006561446`,0.006449646`,0.006449646`,0.007193096`,0.005197479`,0.005991579`,0.007651579`,0.005372179`,0.004841746`,0.006331946`,0.006508279`,0.006521546`,0.009227513`,0.008913479`,0.009075329`,0.008909229`,0.009756579`,0.010042079`,0.008966713`,0.008913479`,0.009227513`,0.011239379`,0.010347579`,0.008179063`,0.010720029`,0.010720029`,0.010220413`,0.009168796`,0.011247663`,0.011370746`,0.011287279`,0.010361029`,0.010378779`,0.008524813`},{5/81,0.006936788`,0.006989104`,0.006989104`,0.006929054`,0.007145371`,0.006607921`,0.005505554`,0.006591571`,0.004934721`,0.006586821`,0.004683521`,0.005022671`,0.006757338`,0.005652421`,0.005455854`,0.006095804`,0.006086038`,0.006527654`,0.005666721`,0.007083804`,0.004977354`,0.006432771`,0.006263788`,0.005794388`,0.005527304`,0.005004604`,0.007085204`,0.004906288`,0.005004121`,0.006241654`,0.006776188`,0.006725871`,0.004900854`,0.004475171`,0.007362588`,0.011948438`,0.014744504`,0.012704121`,0.015018021`,0.012370288`,0.015715038`,0.014241438`,0.013299271`,0.008591254`,0.008324771`,0.008418188`,0.008525004`,0.007082721`,0.007362588`,0.008250338`,0.007383471`,0.008309921`,0.007495571`,0.008382654`,0.008539671`,0.007217838`,0.007362588`,0.007436321`,0.007426671`,0.009018904`,0.007372804`,0.007727488`,0.009214488`,0.007357071`,0.007113254`,0.012342238`,0.007164204`,0.008905721`,0.007434704`,0.009750338`,0.015218771`,0.015658221`,0.008604688`,0.008204421`,0.013442421`,0.015538638`,0.013558604`,0.013728004`,0.015417321`,0.013701471`,0.011446538`,0.015243988`,0.013329971`,0.015945038`,0.008477188`,0.008415538`,0.008451421`,0.008451421`,0.009496154`,0.007025771`,0.007032921`,0.006890854`,0.005661054`,0.004993304`,0.006161221`,0.006416854`,0.006362204`,0.007904438`,0.007908638`,0.009255888`,0.010027821`,0.009951538`,0.009987421`,0.009583888`,0.007908638`,0.007904438`,0.009442888`,0.010098204`,0.007471538`,0.009222888`,0.009222888`,0.008681221`,0.009537354`,0.008320221`,0.008680204`,0.008294638`,0.007907821`,0.007946754`,0.008659538`},{5/162,0.006143167`,0.006177783`,0.006177783`,0.00612885`,0.00635925`,0.006646433`,0.005410183`,0.0065949`,0.003977533`,0.006619533`,0.004070183`,0.0047358`,0.006482317`,0.004179067`,0.00479225`,0.0041086`,0.004125683`,0.005007033`,0.0040259`,0.005610967`,0.0039025`,0.004943383`,0.005434283`,0.005024533`,0.0041192`,0.005265367`,0.007479933`,0.0049641`,0.004977833`,0.0055712`,0.005230967`,0.006022383`,0.00540685`,0.005138533`,0.005885733`,0.008533333`,0.015555733`,0.009108133`,0.015661167`,0.010709967`,0.015707267`,0.009079117`,0.011944167`,0.006556`,0.006431167`,0.006540967`,0.006587517`,0.0060608`,0.005885733`,0.004443467`,0.005067667`,0.004589417`,0.004482783`,0.004520167`,0.006069883`,0.005564983`,0.005885733`,0.005676583`,0.005635`,0.006729283`,0.005637617`,0.005351483`,0.0071709`,0.005860317`,0.00591275`,0.00775115`,0.00643465`,0.006462267`,0.0062516`,0.006366633`,0.011362617`,0.012467533`,0.007557133`,0.006596633`,0.009705767`,0.015043333`,0.009839033`,0.0102125`,0.014875833`,0.010012567`,0.010900233`,0.0145123`,0.009612033`,0.015509733`,0.008480817`,0.00842005`,0.008453183`,0.008453183`,0.009110467`,0.006335183`,0.006262667`,0.0073743`,0.0077406`,0.00665385`,0.00501395`,0.006892817`,0.0067412`,0.0066337`,0.00697385`,0.00881955`,0.006856383`,0.00955135`,0.009687033`,0.009206867`,0.00697385`,0.0066337`,0.006877267`,0.009814233`,0.006800817`,0.0067763`,0.0067763`,0.0065859`,0.009119383`,0.00591935`,0.006495733`,0.0059626`,0.005949917`,0.005984183`,0.00456205`},{5/243,0.005463488`,0.005536821`,0.005536821`,0.005564188`,0.005675888`,0.005689071`,0.005347904`,0.005663304`,0.003915354`,0.005691088`,0.003796971`,0.004378438`,0.005488638`,0.004408588`,0.004214621`,0.005764521`,0.005777504`,0.005922338`,0.005718088`,0.005672688`,0.004222921`,0.005051254`,0.005555621`,0.006789888`,0.005977321`,0.008200804`,0.010071204`,0.008835321`,0.008849038`,0.008255654`,0.007206604`,0.006730488`,0.009226738`,0.009129354`,0.004802688`,0.006885121`,0.013803938`,0.008375471`,0.013964454`,0.007860971`,0.013817871`,0.007249188`,0.007893638`,0.006105088`,0.005987088`,0.006050954`,0.006096154`,0.004995654`,0.004802688`,0.003878688`,0.004305471`,0.004033854`,0.003861354`,0.004031538`,0.004762121`,0.005121754`,0.004802688`,0.004528754`,0.004488071`,0.005795154`,0.004485638`,0.004419338`,0.007211404`,0.005926271`,0.006270088`,0.007459238`,0.006208054`,0.007139121`,0.006636404`,0.007342238`,0.009586638`,0.010066604`,0.009927538`,0.008810588`,0.010940938`,0.013245204`,0.011161388`,0.011381354`,0.014380121`,0.011272871`,0.010850488`,0.013033938`,0.010790388`,0.013625821`,0.006378604`,0.006341821`,0.006362038`,0.006362038`,0.007060304`,0.006670521`,0.007855888`,0.004059054`,0.007210004`,0.004180004`,0.003615121`,0.006698804`,0.006647154`,0.006372371`,0.006727004`,0.008034638`,0.005271471`,0.008787471`,0.008996471`,0.008048454`,0.006727004`,0.006372371`,0.006124554`,0.008984871`,0.006590471`,0.006650854`,0.006650854`,0.006425304`,0.008141488`,0.006076971`,0.006324754`,0.006114421`,0.005789188`,0.005788721`,0.004585304`},{5/324,0.005706175`,0.005752058`,0.005752058`,0.005740658`,0.005986225`,0.005798392`,0.004971908`,0.005832142`,0.005128908`,0.005828508`,0.004888442`,0.005260225`,0.005688275`,0.005772608`,0.005092408`,0.007304875`,0.007286342`,0.008108258`,0.008352042`,0.007311225`,0.006235958`,0.006622042`,0.007176242`,0.009515975`,0.008471925`,0.010894442`,0.009623142`,0.009582225`,0.009992375`,0.011298458`,0.010329792`,0.008763342`,0.010837392`,0.011052908`,0.005571042`,0.007489125`,0.012257292`,0.008906275`,0.012388442`,0.008246558`,0.012247558`,0.009337475`,0.008401192`,0.007510325`,0.007488892`,0.007510892`,0.007513675`,0.005542208`,0.005571042`,0.004495458`,0.005566092`,0.004723458`,0.004938975`,0.004582608`,0.005754192`,0.006657508`,0.005571042`,0.005369642`,0.005345258`,0.006067242`,0.005312508`,0.005066392`,0.009214925`,0.007407342`,0.006818492`,0.010846975`,0.007732208`,0.009821425`,0.008442508`,0.011419942`,0.013242658`,0.014322575`,0.012237325`,0.012224492`,0.012898092`,0.013149908`,0.012858308`,0.012406825`,0.014279908`,0.012766592`,0.010000408`,0.012991142`,0.012882442`,0.013262592`,0.005102342`,0.005165458`,0.005114525`,0.005114525`,0.006114725`,0.006121442`,0.007356658`,0.003653908`,0.004257458`,0.003044308`,0.003593942`,0.004186658`,0.004115225`,0.006399475`,0.006730325`,0.007967158`,0.005853208`,0.008361542`,0.008345408`,0.007769992`,0.006730325`,0.006399475`,0.006189225`,0.008173258`,0.006567075`,0.006677242`,0.006677242`,0.006416958`,0.007984508`,0.005434842`,0.005678508`,0.005456758`,0.005277092`,0.005311708`,0.004992175`},{1/81,0.007552871`,0.007575071`,0.007575071`,0.007538638`,0.007658954`,0.007925171`,0.007944254`,0.008054238`,0.006724421`,0.007907371`,0.006438771`,0.007060338`,0.007952971`,0.007562854`,0.007096588`,0.010315804`,0.010296388`,0.010791121`,0.010164421`,0.009586671`,0.008752521`,0.008769604`,0.009586671`,0.009622454`,0.009490971`,0.008109654`,0.006345704`,0.006627304`,0.006934821`,0.009171288`,0.011379171`,0.011596171`,0.006710271`,0.006750471`,0.007471638`,0.007016304`,0.010280488`,0.009113488`,0.010350854`,0.007322588`,0.010975054`,0.010846154`,0.008932588`,0.009549271`,0.009622521`,0.009514621`,0.009515654`,0.007581921`,0.007471638`,0.005966721`,0.007385538`,0.006224938`,0.006570804`,0.006106854`,0.007608321`,0.008935671`,0.007471638`,0.007346771`,0.007309838`,0.007748688`,0.007277354`,0.006957738`,0.011686088`,0.009780721`,0.010591288`,0.013495604`,0.010445588`,0.011862488`,0.010694621`,0.012624388`,0.012310204`,0.014780938`,0.010619088`,0.011414188`,0.013385621`,0.013266188`,0.013492754`,0.013296338`,0.014421838`,0.013514621`,0.010255371`,0.013116738`,0.013332571`,0.013693521`,0.004809721`,0.004902471`,0.004831571`,0.004831571`,0.005327904`,0.006068471`,0.006696838`,0.003601521`,0.005681654`,0.003270221`,0.003250404`,0.004726554`,0.004680854`,0.005930471`,0.006480938`,0.008125354`,0.004920388`,0.008610388`,0.008635304`,0.008035488`,0.006480938`,0.005930471`,0.005553821`,0.008615921`,0.006596554`,0.005856354`,0.005856354`,0.005761604`,0.008195221`,0.005537538`,0.005732704`,0.005538054`,0.005001238`,0.005045821`,0.003983104`},{5/486,0.008299579`,0.008280063`,0.008280063`,0.008173563`,0.008411246`,0.008369846`,0.009347529`,0.008485763`,0.006911413`,0.008356663`,0.006781629`,0.007354813`,0.008765196`,0.009220413`,0.008508829`,0.004783496`,0.004766513`,0.007878213`,0.004910013`,0.010070729`,0.007734196`,0.008890329`,0.009145263`,0.004626463`,0.004363413`,0.005492429`,0.007276529`,0.004477963`,0.004541713`,0.007134779`,0.008598096`,0.007721846`,0.005891529`,0.005571446`,0.009153096`,0.009425696`,0.012659279`,0.010936579`,0.012824329`,0.008556063`,0.013080513`,0.011693396`,0.012539796`,0.011703363`,0.011797263`,0.011818346`,0.011789946`,0.009178429`,0.009153096`,0.008717079`,0.010094979`,0.009040413`,0.009318479`,0.008778279`,0.010496213`,0.010988179`,0.009153096`,0.009379763`,0.009284613`,0.008020313`,0.009234596`,0.009021713`,0.012247479`,0.010326946`,0.010395529`,0.012430946`,0.011338029`,0.012076196`,0.011989463`,0.011897546`,0.013334046`,0.013524046`,0.007604729`,0.008993513`,0.011618079`,0.012241029`,0.011756029`,0.011646463`,0.014017413`,0.011793046`,0.008918996`,0.012072279`,0.011559563`,0.012751163`,0.004000163`,0.004116946`,0.004030646`,0.004030646`,0.004247246`,0.006346946`,0.007053779`,0.003714546`,0.005552929`,0.002579246`,0.002254329`,0.005005163`,0.005036996`,0.005507746`,0.006283779`,0.007877863`,0.004773813`,0.008354563`,0.008455996`,0.007603096`,0.006283779`,0.005507746`,0.005119763`,0.008384596`,0.006604729`,0.005310329`,0.005310329`,0.005251763`,0.007838996`,0.005486129`,0.005673396`,0.005510829`,0.005249813`,0.005176613`,0.004897096`},{5/567,0.005560496`,0.005580429`,0.005580429`,0.005495696`,0.005750563`,0.005331829`,0.004765696`,0.005348463`,0.003617563`,0.005312529`,0.003764529`,0.004171746`,0.005268513`,0.004472029`,0.004201346`,0.004171229`,0.004136046`,0.004513929`,0.003956296`,0.004908579`,0.004041529`,0.004493696`,0.004461363`,0.003775913`,0.003887629`,0.003980696`,0.007208696`,0.004594946`,0.004629463`,0.004945829`,0.006375279`,0.005074329`,0.004655613`,0.004140429`,0.005671029`,0.013482379`,0.016296279`,0.013904096`,0.016505979`,0.013176696`,0.016811263`,0.013318979`,0.014572279`,0.011094713`,0.010930013`,0.010794046`,0.010881113`,0.005373596`,0.005671029`,0.008719579`,0.009438879`,0.008735596`,0.008527813`,0.008658813`,0.010754429`,0.010110946`,0.005671029`,0.005456129`,0.005519729`,0.007748063`,0.005463946`,0.006667796`,0.011193013`,0.005503213`,0.005731279`,0.011066663`,0.009556896`,0.008562979`,0.008017063`,0.008462813`,0.012690613`,0.012511863`,0.007737963`,0.008104629`,0.009895896`,0.012372563`,0.009995179`,0.009918579`,0.013966413`,0.010019096`,0.010519196`,0.012098996`,0.009860529`,0.013443996`,0.003641529`,0.003698663`,0.003655313`,0.003655313`,0.003901446`,0.004806346`,0.005992779`,0.003592913`,0.003514963`,0.001613146`,0.002583146`,0.003176379`,0.003247246`,0.005785679`,0.006633629`,0.008160879`,0.004398229`,0.008434579`,0.008593079`,0.007659913`,0.006633629`,0.005785679`,0.005062596`,0.008572963`,0.007001196`,0.005397213`,0.005397213`,0.005410279`,0.008014846`,0.006235946`,0.006276646`,0.006297046`,0.006235079`,0.006250446`,0.004881796`},{5/648,0.004099158`,0.004139708`,0.004139708`,0.004147392`,0.004110225`,0.004387425`,0.004407825`,0.004347725`,0.004125442`,0.004421958`,0.004275525`,0.004555892`,0.004599392`,0.004646158`,0.004341542`,0.004789975`,0.004786475`,0.005541242`,0.004944142`,0.005714975`,0.004522142`,0.005306575`,0.005601425`,0.004710592`,0.004371925`,0.005965325`,0.007588158`,0.005397508`,0.005447342`,0.007001542`,0.007984608`,0.006253592`,0.007031008`,0.006660158`,0.004539825`,0.011696425`,0.015742942`,0.012158142`,0.015952125`,0.012630408`,0.016429425`,0.010684975`,0.012483692`,0.007562958`,0.007474958`,0.007467692`,0.007543508`,0.004657475`,0.004539825`,0.005849292`,0.006026008`,0.005788758`,0.005259358`,0.005862375`,0.007304942`,0.006442925`,0.004539825`,0.004275792`,0.004267675`,0.007203958`,0.004250542`,0.004711775`,0.009695158`,0.006036692`,0.006291025`,0.010383375`,0.007892058`,0.008980058`,0.008489825`,0.009362342`,0.011115492`,0.012556842`,0.010664692`,0.010061258`,0.012374075`,0.013243708`,0.012632425`,0.013163392`,0.013850825`,0.012858292`,0.010043475`,0.013132575`,0.012250175`,0.013478275`,0.003743058`,0.003800475`,0.003756508`,0.003756508`,0.004282492`,0.003694258`,0.003968692`,0.004039675`,0.002804542`,0.001974542`,0.003249325`,0.003854525`,0.003866308`,0.006282242`,0.006811008`,0.008204308`,0.004833858`,0.008429058`,0.008541225`,0.007721475`,0.006811008`,0.006282242`,0.006289075`,0.008640775`,0.006830358`,0.005991342`,0.005991342`,0.006005825`,0.008064892`,0.006314325`,0.006298675`,0.006328142`,0.006017742`,0.005994058`,0.005185442`},{5/729,0.004939383`,0.004982217`,0.004982217`,0.004932267`,0.005280783`,0.005850967`,0.004973633`,0.005817383`,0.005203917`,0.005869383`,0.005108967`,0.005221817`,0.0061052`,0.005855617`,0.005545133`,0.00687875`,0.00683195`,0.009412583`,0.006914717`,0.008725517`,0.006232333`,0.007201733`,0.0081782`,0.0061928`,0.005881517`,0.007197117`,0.007589333`,0.0062805`,0.006389667`,0.00851345`,0.009644267`,0.009622783`,0.007661617`,0.007634417`,0.006440283`,0.010967383`,0.01589765`,0.012137267`,0.01609925`,0.010655067`,0.015988717`,0.0109016`,0.010725583`,0.0084605`,0.008197933`,0.008105967`,0.008268117`,0.006361067`,0.006440283`,0.008140367`,0.007781967`,0.008083867`,0.007397`,0.008176983`,0.008927567`,0.0077032`,0.006440283`,0.006245683`,0.0062029`,0.009299867`,0.006194183`,0.006902483`,0.009644717`,0.0085907`,0.009883017`,0.0122967`,0.007629133`,0.01164265`,0.009460967`,0.011587817`,0.013396317`,0.013827067`,0.010459783`,0.0102841`,0.013763133`,0.0145536`,0.014194817`,0.0143574`,0.015484317`,0.014317683`,0.004561917`,0.014391383`,0.01363145`,0.014718767`,0.002849867`,0.002861233`,0.002852867`,0.002852867`,0.003657433`,0.003470783`,0.00386825`,0.003802783`,0.002598383`,0.00255165`,0.00452575`,0.00361375`,0.003611467`,0.007703883`,0.007884617`,0.008397483`,0.006743867`,0.008551783`,0.00877075`,0.008013083`,0.007884617`,0.007703883`,0.008318133`,0.008829267`,0.007533567`,0.00825435`,0.00825435`,0.007970833`,0.008309133`,0.007687683`,0.0079313`,0.0076807`,0.006860133`,0.006867017`,0.00526545`},{1/162,0.007254`,0.007255067`,0.007255067`,0.007122517`,0.007522717`,0.00769065`,0.007177833`,0.007698983`,0.007551183`,0.007654517`,0.00764665`,0.0078476`,0.008342467`,0.0084142`,0.008647333`,0.005902667`,0.005870517`,0.010755883`,0.006466567`,0.010596317`,0.009207567`,0.0099755`,0.010299533`,0.005201117`,0.004939833`,0.00477135`,0.004271183`,0.003377183`,0.0033919`,0.0063469`,0.008297767`,0.009010033`,0.003796167`,0.00375185`,0.0090551`,0.010617233`,0.0170187`,0.0119791`,0.017208317`,0.01100905`,0.01755905`,0.01228655`,0.011732333`,0.011203717`,0.01128725`,0.011168933`,0.011139867`,0.009045083`,0.0090551`,0.009801517`,0.01144115`,0.0097074`,0.0098981`,0.009711333`,0.01213815`,0.0113543`,0.0090551`,0.009385517`,0.009259483`,0.010878717`,0.009208683`,0.00927925`,0.011821417`,0.010466083`,0.01117605`,0.01192855`,0.011004217`,0.0119705`,0.011329633`,0.010151683`,0.012717583`,0.014525783`,0.00591405`,0.007393117`,0.0072253`,0.00675125`,0.007320667`,0.00696405`,0.01115755`,0.007234683`,0.004332333`,0.00651905`,0.007286283`,0.006720183`,0.002468833`,0.0024695`,0.002468283`,0.002468283`,0.002871517`,0.00374035`,0.004106167`,0.0052147`,0.003141983`,0.002969267`,0.0044481`,0.0040129`,0.0040224`,0.007267967`,0.007493783`,0.008896633`,0.006769567`,0.00920865`,0.009396`,0.008669383`,0.007493783`,0.007267967`,0.0081151`,0.00947905`,0.007207967`,0.00718855`,0.00718855`,0.007126317`,0.008892`,0.005714133`,0.006126783`,0.0057287`,0.006523067`,0.0065351`,0.006239933`},{5/891,0.009316738`,0.009265988`,0.009265988`,0.009102821`,0.009284804`,0.009694271`,0.010754521`,0.009672104`,0.009495421`,0.009556921`,0.009739971`,0.010134288`,0.009665221`,0.010233654`,0.009255688`,0.005070504`,0.005062054`,0.008291638`,0.005643638`,0.009389671`,0.010106721`,0.010155121`,0.009597471`,0.003849804`,0.004522421`,0.003379038`,0.004909388`,0.003289971`,0.003266354`,0.004496104`,0.005390054`,0.005825988`,0.003485921`,0.003424304`,0.010211921`,0.010471638`,0.016673138`,0.012298954`,0.017010288`,0.010334321`,0.016901071`,0.011250021`,0.013175254`,0.010026921`,0.010081554`,0.009897621`,0.009867821`,0.009674121`,0.010211921`,0.011988771`,0.011875604`,0.012139821`,0.011506171`,0.012023838`,0.012338154`,0.011548871`,0.010211921`,0.010134171`,0.010154721`,0.012739004`,0.010109671`,0.011138038`,0.008741504`,0.009046471`,0.008422688`,0.007791321`,0.009777188`,0.006993771`,0.007846138`,0.006776371`,0.008550488`,0.008676354`,0.004965304`,0.005553688`,0.005958771`,0.005035988`,0.006001604`,0.005839538`,0.007384104`,0.005980621`,0.005149588`,0.004987804`,0.005986638`,0.005721488`,0.002930921`,0.002955171`,0.002935404`,0.002935404`,0.003291004`,0.004138104`,0.004269738`,0.004737388`,0.003239171`,0.003508538`,0.003659454`,0.005083271`,0.005099554`,0.006945021`,0.007369238`,0.008537988`,0.006083688`,0.009087388`,0.009415638`,0.008320904`,0.007369238`,0.006945021`,0.007878771`,0.009559804`,0.007272238`,0.007075571`,0.007075571`,0.006829054`,0.008532604`,0.006577354`,0.007051154`,0.006573354`,0.006455521`,0.006440838`,0.005998704`},{5/972,0.009723588`,0.009694304`,0.009694304`,0.009491921`,0.009662504`,0.009846838`,0.010833004`,0.009961321`,0.007505988`,0.009785754`,0.008356754`,0.009781021`,0.009258788`,0.007457671`,0.008163304`,0.004227288`,0.004205404`,0.005292438`,0.004649338`,0.006678421`,0.006406988`,0.006877154`,0.006413054`,0.003688554`,0.003976004`,0.004857688`,0.006774321`,0.003619621`,0.003598588`,0.006644388`,0.006476288`,0.006364271`,0.005893088`,0.005499838`,0.009817988`,0.007427354`,0.015342654`,0.008572504`,0.015649971`,0.007788221`,0.015262454`,0.008325154`,0.010388788`,0.007629321`,0.007569071`,0.007566854`,0.007594888`,0.009715254`,0.009817988`,0.008284404`,0.007581038`,0.008434321`,0.007714138`,0.008334821`,0.007515021`,0.007275171`,0.009817988`,0.009466154`,0.009501338`,0.011539454`,0.009485421`,0.010399888`,0.007758421`,0.006502871`,0.006340504`,0.007837038`,0.007454354`,0.007252354`,0.007001871`,0.007526554`,0.008827738`,0.009664554`,0.008119038`,0.007691404`,0.008241671`,0.008807004`,0.008292004`,0.008510504`,0.010135688`,0.008400621`,0.006626804`,0.008707071`,0.008173304`,0.009881588`,0.003707004`,0.003744354`,0.003713804`,0.003713804`,0.004301988`,0.003231871`,0.003509404`,0.004302821`,0.003440821`,0.003878521`,0.003573321`,0.003984138`,0.004013571`,0.006870838`,0.007329038`,0.008497471`,0.006053188`,0.008972188`,0.009018104`,0.008313971`,0.007329038`,0.006870838`,0.007188254`,0.008996038`,0.007255921`,0.006861688`,0.006861688`,0.006803488`,0.008520388`,0.006313554`,0.006315554`,0.006308338`,0.006828138`,0.006820138`,0.005905321`},{5/1053,0.007743863`,0.007820279`,0.007820279`,0.007845879`,0.007602363`,0.006695363`,0.006436479`,0.006767546`,0.005015263`,0.006701179`,0.005212263`,0.005737213`,0.006328929`,0.006210113`,0.005780046`,0.005316763`,0.005345046`,0.006542929`,0.004735796`,0.006911596`,0.005497696`,0.006245229`,0.006344579`,0.005373979`,0.004551796`,0.007104696`,0.006799513`,0.004360513`,0.004371979`,0.009497863`,0.010253746`,0.008546396`,0.007320613`,0.007136296`,0.006135979`,0.008221679`,0.013402029`,0.009940813`,0.013928879`,0.008425229`,0.015024779`,0.009550779`,0.009078913`,0.007847396`,0.007853229`,0.007799146`,0.007785629`,0.006139396`,0.006135979`,0.006627813`,0.006981079`,0.006682046`,0.006318913`,0.006699396`,0.007659229`,0.007760663`,0.006135979`,0.005864646`,0.005851563`,0.008088613`,0.005822846`,0.006558913`,0.008430013`,0.006968313`,0.007512363`,0.010355346`,0.007680863`,0.009586529`,0.008177329`,0.010890046`,0.011698496`,0.011490463`,0.011965113`,0.011713646`,0.013285363`,0.012744529`,0.013359179`,0.013393496`,0.014551329`,0.013416829`,0.006136629`,0.012676813`,0.013189579`,0.012912413`,0.004194813`,0.004220929`,0.004198479`,0.004198479`,0.004693713`,0.004926979`,0.005536629`,0.004401396`,0.003781813`,0.003665596`,0.003857029`,0.003946063`,0.003945813`,0.007310646`,0.007580096`,0.008331696`,0.006310613`,0.008748579`,0.008725379`,0.008071846`,0.007580096`,0.007310646`,0.007861546`,0.008651629`,0.007322179`,0.007727829`,0.007727829`,0.007471046`,0.008317796`,0.007012013`,0.007307846`,0.007040063`,0.007826313`,0.007872779`,0.005756413`},{5/1134,0.006603221`,0.006657671`,0.006657671`,0.006624104`,0.007080438`,0.008015454`,0.006650554`,0.007963204`,0.005291221`,0.007935954`,0.005614454`,0.006197204`,0.008826871`,0.007477238`,0.007072354`,0.006074804`,0.006046788`,0.008650138`,0.005631388`,0.009155521`,0.006272238`,0.008270788`,0.008379888`,0.005344121`,0.005027021`,0.006474188`,0.005045238`,0.004657804`,0.004731754`,0.007603071`,0.008047888`,0.009342021`,0.005634888`,0.005627704`,0.009127604`,0.010016104`,0.016182388`,0.011568821`,0.016449821`,0.011084954`,0.017132021`,0.010032838`,0.011270138`,0.009173504`,0.009260354`,0.009280104`,0.009236821`,0.008888338`,0.009127604`,0.008000871`,0.008656421`,0.008224738`,0.008261621`,0.008084871`,0.009024471`,0.009596488`,0.009127604`,0.008874121`,0.008803371`,0.010083971`,0.008804888`,0.008590988`,0.010923304`,0.009385538`,0.007099471`,0.012779804`,0.009724588`,0.010991288`,0.010060571`,0.010787321`,0.014105121`,0.014589421`,0.006567538`,0.007427971`,0.009325838`,0.011344288`,0.009505054`,0.009273054`,0.015016138`,0.009469571`,0.005954388`,0.010938588`,0.009359454`,0.012644988`,0.004458054`,0.004476504`,0.004460321`,0.004460321`,0.004779638`,0.004798271`,0.005405654`,0.006277238`,0.004438754`,0.003725488`,0.005567404`,0.004478504`,0.004513654`,0.007512654`,0.007664871`,0.008379404`,0.006471154`,0.008843254`,0.008842638`,0.008230588`,0.007664871`,0.007512654`,0.008256138`,0.008764321`,0.007281121`,0.008111738`,0.008111738`,0.007745288`,0.008423554`,0.007741021`,0.008032471`,0.007748971`,0.007458454`,0.007481371`,0.006642204`},{1/243,0.010230121`,0.010250154`,0.010250154`,0.010125954`,0.010367988`,0.010365504`,0.009661654`,0.010381304`,0.007431204`,0.010208838`,0.008266921`,0.009084888`,0.011328638`,0.008681254`,0.009882654`,0.006283304`,0.006280638`,0.007198104`,0.006541688`,0.007903721`,0.007809488`,0.008801554`,0.008093154`,0.005400704`,0.005582088`,0.005201204`,0.006396454`,0.005006404`,0.005119738`,0.006574804`,0.006409288`,0.006569721`,0.005103721`,0.005135671`,0.011674538`,0.010123054`,0.014688671`,0.012007588`,0.015023871`,0.010531738`,0.015832054`,0.011548538`,0.012384554`,0.009321938`,0.009307771`,0.009314721`,0.009266538`,0.011686088`,0.011674538`,0.010184021`,0.009399921`,0.010306354`,0.009746938`,0.010331938`,0.009443304`,0.009115004`,0.011674538`,0.011450521`,0.011292338`,0.012357621`,0.011319288`,0.010853638`,0.008391288`,0.007697404`,0.007548521`,0.007854654`,0.008954171`,0.007430621`,0.007617171`,0.007159871`,0.009971321`,0.011718921`,0.006809271`,0.006945921`,0.007961188`,0.009472054`,0.008088871`,0.008098104`,0.011195871`,0.008125671`,0.007912238`,0.009231221`,0.007922488`,0.010597371`,0.004578254`,0.004692671`,0.004607421`,0.004607421`,0.004837221`,0.005153004`,0.005806238`,0.005719254`,0.004379654`,0.004430288`,0.004769654`,0.006208721`,0.006207338`,0.006677438`,0.007022438`,0.008195254`,0.005407204`,0.008908888`,0.009091538`,0.008397788`,0.007022438`,0.006677438`,0.007269104`,0.009157421`,0.006916054`,0.007490154`,0.007490154`,0.007217671`,0.008410954`,0.006327988`,0.006725371`,0.006301504`,0.006303421`,0.006293171`,0.006633771`},{5/1296,0.010278313`,0.010336579`,0.010336579`,0.010308913`,0.010007213`,0.009301813`,0.009557063`,0.009356179`,0.007421913`,0.009207096`,0.008051929`,0.008677863`,0.009739496`,0.007117946`,0.007145663`,0.006240929`,0.006263179`,0.006093663`,0.006005029`,0.006856013`,0.007222296`,0.007056613`,0.006437429`,0.005768929`,0.005960579`,0.006971713`,0.008891929`,0.005936729`,0.005945763`,0.007735879`,0.007537263`,0.007374179`,0.007783979`,0.007167546`,0.008242229`,0.008495546`,0.013905996`,0.009484613`,0.014262796`,0.009234846`,0.014994446`,0.008202213`,0.011924579`,0.007062796`,0.007109079`,0.007070046`,0.007048313`,0.008528429`,0.008242229`,0.006832863`,0.006515196`,0.007024346`,0.006569529`,0.006899313`,0.006621396`,0.006853346`,0.008242229`,0.007545129`,0.007551713`,0.009887013`,0.007550313`,0.008168146`,0.007501763`,0.007018763`,0.007380946`,0.009363729`,0.007933029`,0.007912346`,0.007484246`,0.008968046`,0.011692379`,0.012058863`,0.009800163`,0.009738329`,0.011406296`,0.015134779`,0.011650763`,0.011652329`,0.016158646`,0.011707663`,0.009123979`,0.014559096`,0.011333863`,0.014314663`,0.005339296`,0.005294713`,0.005321679`,0.005321679`,0.005670029`,0.005157213`,0.006396796`,0.004542746`,0.005192379`,0.004294279`,0.003669713`,0.006238163`,0.006150946`,0.005871146`,0.006365779`,0.008202929`,0.005587313`,0.008941379`,0.009055929`,0.008207296`,0.006365779`,0.005871146`,0.006122779`,0.009084746`,0.006414879`,0.006393579`,0.006393579`,0.006161896`,0.008323696`,0.005816563`,0.006297213`,0.005801213`,0.006321946`,0.006274413`,0.005973996`},{5/1377,0.007104421`,0.007189771`,0.007189771`,0.007178004`,0.007303804`,0.006517171`,0.006010471`,0.006514971`,0.004951754`,0.006510554`,0.004854838`,0.005131771`,0.006766354`,0.006589838`,0.005886954`,0.006768004`,0.006751354`,0.006902338`,0.006386338`,0.007209871`,0.006063221`,0.006897021`,0.006986004`,0.006216754`,0.005746788`,0.007999921`,0.009446404`,0.006871638`,0.006833754`,0.009124404`,0.009820038`,0.008748538`,0.008106488`,0.008145688`,0.006891088`,0.008978321`,0.015093204`,0.011351454`,0.015495571`,0.010131721`,0.016465738`,0.009879254`,0.010326154`,0.008709371`,0.008783254`,0.008833804`,0.008814488`,0.006812254`,0.006891088`,0.007073871`,0.007714104`,0.007279504`,0.007110021`,0.007071754`,0.008002954`,0.008890204`,0.006891088`,0.006749438`,0.006728271`,0.007754738`,0.006689804`,0.006885321`,0.010088721`,0.007157271`,0.007669071`,0.012676171`,0.008813721`,0.010671404`,0.008800871`,0.011962971`,0.015069838`,0.016151721`,0.012794838`,0.011555271`,0.016267238`,0.016354421`,0.016573821`,0.016400804`,0.017090921`,0.016603054`,0.005103938`,0.016116571`,0.016118704`,0.014221854`,0.005045221`,0.004981721`,0.005021788`,0.005021788`,0.006205138`,0.004850121`,0.006888788`,0.005161071`,0.004358354`,0.003409521`,0.003682921`,0.006256071`,0.006268138`,0.006200921`,0.006956388`,0.007679004`,0.004077421`,0.007925754`,0.008115004`,0.007226321`,0.006956388`,0.006200921`,0.005662071`,0.008127321`,0.007229138`,0.006029588`,0.006029588`,0.005971354`,0.007572671`,0.006864438`,0.007077054`,0.006879421`,0.007113338`,0.007101571`,0.006701721`},{5/1458,0.004348742`,0.004375975`,0.004375975`,0.004333342`,0.004639292`,0.004662275`,0.004046892`,0.004620025`,0.003621475`,0.004689008`,0.003635558`,0.003781258`,0.004999475`,0.005505992`,0.004367458`,0.005603142`,0.005595908`,0.007055992`,0.004784625`,0.007444742`,0.004824008`,0.006764842`,0.006888208`,0.004440858`,0.004853692`,0.006357058`,0.008553108`,0.004916642`,0.004880692`,0.008618542`,0.013721308`,0.008534942`,0.007433175`,0.006930025`,0.006121558`,0.011931608`,0.016122075`,0.014278492`,0.016493308`,0.012669058`,0.017144275`,0.011183342`,0.012252358`,0.010149925`,0.010281025`,0.010275475`,0.010240092`,0.005642075`,0.006121558`,0.009473892`,0.010012975`,0.009689525`,0.009760775`,0.009384442`,0.010437908`,0.010858375`,0.006121558`,0.005945525`,0.006001925`,0.007922258`,0.005959842`,0.006979325`,0.012293125`,0.008508342`,0.008811008`,0.014874925`,0.011435042`,0.015286625`,0.011633075`,0.016700692`,0.015848092`,0.016555725`,0.012037142`,0.014911675`,0.014667458`,0.015656525`,0.014770775`,0.014434642`,0.017466758`,0.014772625`,0.004610625`,0.015227425`,0.014778325`,0.014036158`,0.003500508`,0.003482792`,0.003494358`,0.003494358`,0.004123492`,0.005746942`,0.006589542`,0.006627308`,0.004260042`,0.003096808`,0.005986608`,0.006123425`,0.006063942`,0.007729992`,0.007753942`,0.008296825`,0.006690525`,0.008471825`,0.008600558`,0.007780158`,0.007753942`,0.007729992`,0.008784642`,0.008625042`,0.007321975`,0.009347692`,0.009347692`,0.008887925`,0.008166075`,0.008743675`,0.008645258`,0.008770875`,0.008219575`,0.008285458`,0.007690558`},{5/1539,0.004337917`,0.00438315`,0.00438315`,0.0043775`,0.004574817`,0.0048334`,0.0044267`,0.0047245`,0.003826367`,0.0048335`,0.004141217`,0.00429825`,0.005554683`,0.0055266`,0.00438095`,0.0050977`,0.005052633`,0.005831317`,0.004591183`,0.006692483`,0.0048138`,0.006379933`,0.006236617`,0.004010217`,0.004712667`,0.0039083`,0.005579417`,0.004325533`,0.004380667`,0.005943917`,0.007978833`,0.006532333`,0.005105833`,0.004551167`,0.006402817`,0.011153717`,0.016771117`,0.01413675`,0.017081767`,0.012317683`,0.017306333`,0.0142503`,0.012998883`,0.012418433`,0.0122768`,0.012270933`,0.012337233`,0.006196333`,0.006402817`,0.011561883`,0.011773167`,0.011036133`,0.010583867`,0.011303733`,0.012279333`,0.011760767`,0.006402817`,0.006348433`,0.0063448`,0.00981115`,0.006304217`,0.006935383`,0.014134417`,0.0074484`,0.007453033`,0.015791433`,0.012455183`,0.013315317`,0.0126836`,0.011898983`,0.0164189`,0.017241133`,0.00652875`,0.007546267`,0.007855167`,0.009591433`,0.007958`,0.007848067`,0.014557583`,0.0079467`,0.005306733`,0.008964383`,0.0078779`,0.009748733`,0.003462033`,0.00348125`,0.003464083`,0.003464083`,0.0041564`,0.005592967`,0.006207333`,0.007801217`,0.004130717`,0.003993183`,0.00469345`,0.006452083`,0.0064036`,0.00649735`,0.006970133`,0.008610933`,0.006566983`,0.008598383`,0.00891475`,0.008124517`,0.006970133`,0.00649735`,0.006917117`,0.009011467`,0.006972883`,0.00678045`,0.00678045`,0.006432767`,0.008522417`,0.007781283`,0.007603783`,0.007834383`,0.008472733`,0.008527367`,0.008535317`},{1/324,0.005007375`,0.005045125`,0.005045125`,0.004999825`,0.005560875`,0.005848692`,0.004829675`,0.005792408`,0.004223358`,0.005859625`,0.004686158`,0.004850775`,0.006137242`,0.005261825`,0.004718442`,0.004930858`,0.004931342`,0.005304358`,0.005248742`,0.006103292`,0.004644925`,0.005648375`,0.005440492`,0.004837708`,0.004849108`,0.004317975`,0.005443025`,0.004769192`,0.004889525`,0.005877142`,0.005913358`,0.005935792`,0.005037675`,0.004807942`,0.006545225`,0.013339858`,0.017698775`,0.013913692`,0.017899642`,0.013916242`,0.018320892`,0.014735375`,0.015165025`,0.011803758`,0.011752375`,0.011572842`,0.011566358`,0.006461108`,0.006545225`,0.007836558`,0.009037875`,0.007721592`,0.007240158`,0.007792592`,0.010965325`,0.010475742`,0.006545225`,0.006410992`,0.006385392`,0.008130992`,0.006366525`,0.006669842`,0.010964442`,0.006830325`,0.006642658`,0.009615592`,0.009980258`,0.007724375`,0.008487508`,0.007688258`,0.010718142`,0.012202892`,0.005450925`,0.006026392`,0.007472142`,0.007931792`,0.007568975`,0.007417075`,0.008701392`,0.007573325`,0.005993125`,0.007817408`,0.007468325`,0.007438025`,0.004438092`,0.004505158`,0.004455558`,0.004455558`,0.004309175`,0.005727108`,0.006406392`,0.008209058`,0.005119875`,0.004699625`,0.004601475`,0.007357458`,0.007295975`,0.006299458`,0.006732975`,0.007605592`,0.006115758`,0.007851592`,0.008043225`,0.007508658`,0.006732975`,0.006299458`,0.006811208`,0.008073492`,0.006722908`,0.006837858`,0.006837858`,0.006580858`,0.007699658`,0.007962108`,0.007789592`,0.007964308`,0.008323925`,0.008392858`,0.008351375`},{5/1701,0.005966317`,0.006021517`,0.006021517`,0.006003033`,0.006089467`,0.006070367`,0.005717633`,0.006108117`,0.005554217`,0.006143533`,0.00576755`,0.0059648`,0.0061289`,0.005586983`,0.00527215`,0.006200717`,0.006227283`,0.006126183`,0.0068183`,0.0061086`,0.005164233`,0.0058346`,0.00581505`,0.005982467`,0.006202017`,0.006191383`,0.00750655`,0.0058179`,0.005909517`,0.00758465`,0.006889783`,0.006923517`,0.007401667`,0.007112383`,0.006110667`,0.01109895`,0.017145383`,0.0119769`,0.017375983`,0.013491767`,0.0177828`,0.010710317`,0.014087517`,0.00877115`,0.00868685`,0.008660833`,0.008714883`,0.006069533`,0.006110667`,0.00672825`,0.0069096`,0.006761617`,0.006590617`,0.006722383`,0.0075938`,0.008047217`,0.006110667`,0.00575265`,0.00573185`,0.00782315`,0.005733667`,0.00644215`,0.008661967`,0.006354317`,0.006481683`,0.008506633`,0.008398167`,0.007192917`,0.00735275`,0.0074724`,0.008998383`,0.0093268`,0.007513683`,0.007286733`,0.008711967`,0.009622183`,0.0088336`,0.008936167`,0.010192817`,0.008902467`,0.0079353`,0.009492583`,0.008620983`,0.009894733`,0.0039691`,0.003903367`,0.003947567`,0.003947567`,0.004673933`,0.005159033`,0.00550435`,0.007145917`,0.003608117`,0.004603233`,0.005153533`,0.006838217`,0.006821967`,0.0072209`,0.007467867`,0.007721933`,0.005922067`,0.007937017`,0.007964367`,0.0072762`,0.007467867`,0.0072209`,0.00741735`,0.007827117`,0.007185517`,0.0074428`,0.0074428`,0.007140133`,0.0076428`,0.007709517`,0.007916517`,0.00774585`,0.007938683`,0.007923167`,0.0084404`},{5/1782,0.006613767`,0.0066556`,0.0066556`,0.006635067`,0.006819617`,0.006951683`,0.007095667`,0.007006917`,0.006814267`,0.006991383`,0.007198717`,0.007718717`,0.0071419`,0.007007233`,0.006723783`,0.007622817`,0.007633767`,0.0076108`,0.007685033`,0.00752155`,0.006961917`,0.007331733`,0.0074063`,0.007403567`,0.00728715`,0.009433783`,0.0083862`,0.008806883`,0.008766333`,0.010432967`,0.009175767`,0.008778867`,0.010022033`,0.009960533`,0.007168833`,0.007436767`,0.0146046`,0.008747233`,0.01478955`,0.009970817`,0.0150283`,0.009072767`,0.009613833`,0.008023333`,0.00796315`,0.0079945`,0.00803395`,0.007207467`,0.007168833`,0.006164733`,0.006286783`,0.006314533`,0.006170983`,0.006200667`,0.00611015`,0.007095167`,0.007168833`,0.006755733`,0.006741367`,0.00760565`,0.0067225`,0.006628567`,0.009150633`,0.007473767`,0.00792205`,0.009186283`,0.00793055`,0.008854`,0.008283883`,0.00901815`,0.00986965`,0.01063195`,0.011435483`,0.01056955`,0.012340617`,0.01408915`,0.012537033`,0.012756`,0.01359555`,0.012655283`,0.007455917`,0.01393505`,0.01215655`,0.014146767`,0.003537733`,0.00357165`,0.003545433`,0.003545433`,0.00392575`,0.003947933`,0.004347367`,0.006823583`,0.003207167`,0.003981533`,0.005386267`,0.006910833`,0.0069102`,0.00712755`,0.007361333`,0.008261`,0.006723833`,0.00872955`,0.008809583`,0.0081285`,0.007361333`,0.00712755`,0.00822`,0.0086893`,0.007148867`,0.007954833`,0.007954833`,0.007560517`,0.0083253`,0.0078974`,0.008176467`,0.007918483`,0.007901133`,0.007874567`,0.007438967`},{5/1863,0.006185792`,0.006265225`,0.006265225`,0.006302208`,0.006367642`,0.007195325`,0.006773858`,0.007247825`,0.007072275`,0.007239658`,0.007244608`,0.007277158`,0.007391708`,0.007814708`,0.006903742`,0.010103575`,0.010167958`,0.010018508`,0.009590908`,0.009303375`,0.008114842`,0.008895725`,0.009146592`,0.010188908`,0.009810425`,0.012793942`,0.006896075`,0.011315058`,0.011166992`,0.014123975`,0.012653008`,0.011578592`,0.011640692`,0.012050092`,0.007597442`,0.006956325`,0.014274975`,0.008515925`,0.014440342`,0.009150192`,0.014253558`,0.010112675`,0.009017808`,0.008839308`,0.008991042`,0.008988092`,0.008912092`,0.007487992`,0.007597442`,0.007064825`,0.007518208`,0.007281808`,0.007221808`,0.007089292`,0.007160425`,0.008806408`,0.007597442`,0.007329658`,0.007304758`,0.008194975`,0.007270892`,0.007399225`,0.010024575`,0.009282975`,0.010031542`,0.012061025`,0.009583358`,0.011383958`,0.010193942`,0.012321825`,0.012646792`,0.012803725`,0.013871442`,0.014297708`,0.014991892`,0.015258558`,0.015066408`,0.015218492`,0.016152258`,0.015170258`,0.004407642`,0.015038792`,0.014930458`,0.014850108`,0.003887025`,0.003931692`,0.003897775`,0.003897775`,0.004017492`,0.005024142`,0.005866375`,0.007397458`,0.003817958`,0.004336925`,0.006534092`,0.007095892`,0.007098292`,0.007612508`,0.007776058`,0.008686208`,0.007623258`,0.009219092`,0.009159592`,0.008740875`,0.007776058`,0.007612508`,0.009022975`,0.009092158`,0.007494192`,0.008757942`,0.008757942`,0.008324492`,0.008841792`,0.009254042`,0.009620758`,0.009232725`,0.008677375`,0.008682325`,0.007938525`},{5/1944,0.005934183`,0.006003467`,0.006003467`,0.00602875`,0.0061425`,0.006779467`,0.006862083`,0.006731767`,0.007994783`,0.006759617`,0.0075377`,0.007537833`,0.007365283`,0.010227483`,0.007710333`,0.011761367`,0.0117679`,0.012383583`,0.0118162`,0.011548183`,0.01057565`,0.011347467`,0.01152785`,0.011686367`,0.0116716`,0.009009917`,0.007683983`,0.0099268`,0.010123717`,0.010680267`,0.01308635`,0.013177567`,0.007481417`,0.007506917`,0.008398033`,0.009102133`,0.014966067`,0.011095867`,0.0150786`,0.01051805`,0.0149553`,0.012302783`,0.010799`,0.009824933`,0.009921367`,0.009907567`,0.009870417`,0.008026917`,0.008398033`,0.008252967`,0.008679033`,0.0084635`,0.00851025`,0.008290333`,0.008339367`,0.009843867`,0.008398033`,0.0081147`,0.00812385`,0.009261617`,0.008072717`,0.00853705`,0.01126615`,0.011401117`,0.012258867`,0.013092417`,0.010614983`,0.013739117`,0.011748317`,0.014939083`,0.013856617`,0.014555967`,0.011929983`,0.014339717`,0.014423133`,0.014842383`,0.01461645`,0.014648017`,0.015407117`,0.014698117`,0.006080433`,0.0146767`,0.014406883`,0.015117917`,0.004602633`,0.004737467`,0.004638583`,0.004638583`,0.0050901`,0.00664655`,0.00674175`,0.007535033`,0.004550467`,0.004649433`,0.007325733`,0.0072518`,0.007206567`,0.00858705`,0.008496183`,0.00909435`,0.00856325`,0.00968705`,0.009507417`,0.00922225`,0.008496183`,0.00858705`,0.010181617`,0.009558717`,0.0079587`,0.010256`,0.010256`,0.009789183`,0.009276083`,0.0110954`,0.010843583`,0.0111058`,0.010518333`,0.010535817`,0.008779233`},{1/405,0.007925304`,0.008006521`,0.008006521`,0.008022954`,0.008606838`,0.009100288`,0.009486988`,0.009137188`,0.010541838`,0.009005471`,0.009987304`,0.010414604`,0.009856238`,0.011459004`,0.009986754`,0.009932188`,0.009860104`,0.012406771`,0.010904421`,0.012501604`,0.011796388`,0.011843021`,0.012221788`,0.008900988`,0.009347688`,0.008448304`,0.009017688`,0.008365638`,0.008477888`,0.010208821`,0.009303421`,0.010282021`,0.008329004`,0.007882104`,0.010420704`,0.010018071`,0.015805754`,0.012514454`,0.015944771`,0.010916388`,0.016033454`,0.012837171`,0.011515504`,0.010686071`,0.010692804`,0.010663271`,0.010647921`,0.010201288`,0.010420704`,0.009315738`,0.009590254`,0.009599371`,0.009596854`,0.009352688`,0.009725838`,0.010510938`,0.010420704`,0.010059938`,0.010000104`,0.010687004`,0.009969371`,0.009928638`,0.013493238`,0.012405838`,0.013396338`,0.015451538`,0.011114338`,0.014212321`,0.013859904`,0.013304904`,0.015752371`,0.016226788`,0.011476104`,0.011630588`,0.013613304`,0.014476338`,0.013586654`,0.013547171`,0.015251954`,0.013628888`,0.007767388`,0.014244638`,0.013589304`,0.014021738`,0.004997804`,0.005191721`,0.005050221`,0.005050221`,0.005493254`,0.006315138`,0.006914304`,0.009447121`,0.004472121`,0.004863371`,0.007857371`,0.008302854`,0.008388404`,0.008916554`,0.008724721`,0.009070838`,0.009002121`,0.009765588`,0.009689754`,0.009350288`,0.008724721`,0.008916554`,0.010860654`,0.009663521`,0.008116438`,0.010952771`,0.010952771`,0.010451188`,0.009328138`,0.009596604`,0.009732354`,0.009606821`,0.009506288`,0.009565421`,0.009869788`},{5/2106,0.010917871`,0.010977188`,0.010977188`,0.010910354`,0.011332754`,0.011902604`,0.011832704`,0.011885471`,0.010389271`,0.011750454`,0.010808488`,0.011925671`,0.012825054`,0.011731221`,0.011310488`,0.011418654`,0.011385404`,0.011680321`,0.010756704`,0.012257221`,0.010835704`,0.012091338`,0.011883638`,0.009482454`,0.009431554`,0.009354938`,0.010129438`,0.009113938`,0.009119571`,0.012041438`,0.010740788`,0.011969404`,0.009507921`,0.008932454`,0.012602488`,0.013796221`,0.016224021`,0.015149454`,0.016328638`,0.014324204`,0.016614438`,0.014577554`,0.014514271`,0.012332971`,0.012337504`,0.012243221`,0.012203521`,0.012632571`,0.012602488`,0.011081438`,0.011002804`,0.011300321`,0.010877688`,0.011168904`,0.011437754`,0.011970288`,0.012602488`,0.012116821`,0.011978171`,0.012472004`,0.011992521`,0.011520704`,0.012808538`,0.012530354`,0.012872554`,0.015260804`,0.012359288`,0.014590371`,0.012860038`,0.013171804`,0.015772054`,0.015336454`,0.010952338`,0.011807871`,0.013817588`,0.014337138`,0.013890388`,0.013690071`,0.015100704`,0.013899904`,0.008010354`,0.014137754`,0.013793804`,0.013683354`,0.005688438`,0.005823721`,0.005723638`,0.005723638`,0.006179488`,0.006989171`,0.008159188`,0.007516621`,0.004939604`,0.006676921`,0.007578021`,0.009588454`,0.009571221`,0.008139454`,0.008158504`,0.009175554`,0.010554271`,0.010292988`,0.010148021`,0.009868238`,0.008158504`,0.008139454`,0.010006871`,0.010177221`,0.007725904`,0.009569654`,0.009569654`,0.009021838`,0.009642421`,0.007863671`,0.008574271`,0.007798038`,0.007542338`,0.007469554`,0.007384071`},{5/2187,0.012702358`,0.012736858`,0.012736858`,0.012604792`,0.012726808`,0.012665642`,0.012410642`,0.012804675`,0.010492142`,0.012534058`,0.010932642`,0.011808425`,0.013105658`,0.012277025`,0.011698458`,0.009870008`,0.009847958`,0.011984942`,0.009593392`,0.012572358`,0.011609725`,0.012662575`,0.012104525`,0.009481858`,0.008503175`,0.009637792`,0.011902892`,0.009153675`,0.009181308`,0.012381008`,0.011446358`,0.011937908`,0.010204858`,0.009591208`,0.012884175`,0.015314492`,0.016454742`,0.015494792`,0.016562392`,0.015385775`,0.016470625`,0.015399875`,0.016129392`,0.013454358`,0.013383425`,0.013319125`,0.013323458`,0.012694525`,0.012884175`,0.012622092`,0.012463408`,0.012645558`,0.012078342`,0.012635308`,0.013601458`,0.013013325`,0.012884175`,0.012676108`,0.012553408`,0.012658675`,0.012548842`,0.012489058`,0.013410442`,0.012659108`,0.012867092`,0.013971958`,0.012159658`,0.012680658`,0.012279108`,0.012542308`,0.016881725`,0.016912192`,0.012159875`,0.011977575`,0.016112408`,0.015173825`,0.016188592`,0.016349425`,0.015411975`,0.016302242`,0.008313458`,0.015021542`,0.016004125`,0.014232825`,0.006655425`,0.006675592`,0.006655875`,0.006655875`,0.007211592`,0.007787842`,0.008719725`,0.006128675`,0.005297725`,0.008712275`,0.006732558`,0.009005708`,0.008898042`,0.008235358`,0.008490358`,0.009098342`,0.007782192`,0.010141692`,0.010088008`,0.009588408`,0.008490358`,0.008235358`,0.009147425`,0.010263242`,0.008257042`,0.008542492`,0.008542492`,0.008211975`,0.009459492`,0.006922242`,0.008311325`,0.006908242`,0.007707542`,0.007632142`,0.006337775`},{5/2268,0.011995467`,0.012067517`,0.012067517`,0.01205455`,0.011845767`,0.0118846`,0.012583817`,0.0119492`,0.0118224`,0.011770017`,0.012238633`,0.013048383`,0.012641317`,0.011597883`,0.011763583`,0.008298067`,0.008250617`,0.0100357`,0.00904035`,0.01138435`,0.011741`,0.011688617`,0.010999333`,0.009082717`,0.007824967`,0.011269283`,0.013291783`,0.00988005`,0.009818017`,0.013028617`,0.01237375`,0.01284715`,0.011712767`,0.011666283`,0.012742133`,0.014376767`,0.018039967`,0.014687333`,0.0182105`,0.015367217`,0.018670183`,0.01490455`,0.0166443`,0.011935933`,0.011877517`,0.01190905`,0.0119243`,0.012459117`,0.012742133`,0.0132318`,0.01187955`,0.013188883`,0.011996683`,0.013266367`,0.012861833`,0.010951617`,0.012742133`,0.012809567`,0.01271425`,0.01379575`,0.0126799`,0.013120417`,0.012090083`,0.01145035`,0.011173983`,0.012739567`,0.011446567`,0.01249705`,0.012353683`,0.013561567`,0.015226933`,0.015906233`,0.015168417`,0.0147216`,0.0161624`,0.015791033`,0.0161358`,0.016186`,0.0167598`,0.016197733`,0.0094539`,0.01555785`,0.016107717`,0.01543105`,0.007810367`,0.007894383`,0.007828583`,0.007828583`,0.00761915`,0.00898705`,0.009768867`,0.005807217`,0.005855383`,0.008554783`,0.0051447`,0.008434183`,0.00838675`,0.00833725`,0.008508017`,0.009019233`,0.008894333`,0.0097592`,0.009884183`,0.0094295`,0.008508017`,0.00833725`,0.010052333`,0.010010567`,0.008194217`,0.008824317`,0.008824317`,0.008407133`,0.00936555`,0.008288467`,0.0094026`,0.008265683`,0.008163317`,0.008160083`,0.006657167`},{5/2349,0.011556779`,0.011564396`,0.011564396`,0.011501613`,0.011557563`,0.011522313`,0.011798379`,0.011400946`,0.011978529`,0.011402479`,0.012288263`,0.011731729`,0.012339129`,0.011969029`,0.011640963`,0.011441829`,0.011484829`,0.010865979`,0.010324179`,0.011466746`,0.011133863`,0.011609729`,0.011104429`,0.012551113`,0.011069396`,0.012152163`,0.011693829`,0.010325546`,0.010550363`,0.013576779`,0.013746413`,0.013973529`,0.011512329`,0.011553379`,0.012501563`,0.012491996`,0.017814079`,0.012424679`,0.018073196`,0.012990846`,0.018285663`,0.013317363`,0.015080879`,0.011587063`,0.011459196`,0.011434363`,0.011515363`,0.012288129`,0.012501563`,0.012122346`,0.011070579`,0.012231979`,0.011450763`,0.012228213`,0.010725479`,0.010411913`,0.012501563`,0.012567579`,0.012504079`,0.014111563`,0.012484429`,0.013311963`,0.013328946`,0.011144896`,0.011369079`,0.014252479`,0.011666146`,0.014650846`,0.012101396`,0.015990113`,0.014773046`,0.015710129`,0.015024963`,0.015925929`,0.016284446`,0.016544413`,0.016362429`,0.016064213`,0.017708946`,0.016333213`,0.011103163`,0.016190013`,0.016318313`,0.016262663`,0.006789729`,0.006846479`,0.006799729`,0.006799729`,0.006869646`,0.008902079`,0.009684213`,0.006115913`,0.005656313`,0.007200813`,0.005551513`,0.007949729`,0.007941563`,0.007937679`,0.008261579`,0.008793929`,0.007193979`,0.009601563`,0.009830446`,0.009115979`,0.008261579`,0.007937679`,0.009034729`,0.009948646`,0.008097779`,0.008042846`,0.008042846`,0.007830863`,0.009076863`,0.010451213`,0.010550563`,0.010463029`,0.010064013`,0.010102346`,0.006889113`},{1/486,0.012584279`,0.012581213`,0.012581213`,0.012451413`,0.012496313`,0.012899496`,0.012723946`,0.012965379`,0.011083579`,0.012815779`,0.011623763`,0.012067996`,0.013523313`,0.012338563`,0.011633029`,0.011660546`,0.011510996`,0.013951696`,0.011243079`,0.014182396`,0.012270163`,0.013271829`,0.013602496`,0.008698713`,0.009687763`,0.007772979`,0.009343663`,0.006860063`,0.006940946`,0.012281329`,0.013307729`,0.014409213`,0.007795329`,0.007688513`,0.012980496`,0.013119179`,0.018208229`,0.014086496`,0.018384013`,0.013393446`,0.018757879`,0.016197479`,0.015350096`,0.014817813`,0.014771596`,0.014783529`,0.014847546`,0.013053813`,0.012980496`,0.011765029`,0.012228296`,0.011922129`,0.011703396`,0.011830179`,0.011400079`,0.012946513`,0.012980496`,0.012481863`,0.012442979`,0.013435163`,0.012441396`,0.013079863`,0.015548746`,0.014028646`,0.014730846`,0.014495929`,0.014373513`,0.015523629`,0.015765263`,0.016365029`,0.015396163`,0.016091146`,0.013163613`,0.014362379`,0.014995663`,0.015068863`,0.014960929`,0.014668029`,0.017047796`,0.014928446`,0.010376346`,0.014661029`,0.015074413`,0.015567979`,0.006888696`,0.006932896`,0.006894046`,0.006894046`,0.007010679`,0.007903463`,0.008283813`,0.007887213`,0.006226429`,0.006540979`,0.006965396`,0.007862679`,0.007809846`,0.008280763`,0.008603063`,0.008838179`,0.006908929`,0.009450013`,0.009593196`,0.009074446`,0.008603063`,0.008280763`,0.008982146`,0.009684846`,0.008431046`,0.008739379`,0.008739379`,0.008405863`,0.009078163`,0.009251629`,0.009635646`,0.009309429`,0.009828396`,0.009867729`,0.008338079`},{5/2511,0.012793821`,0.012846571`,0.012846571`,0.012757388`,0.012505238`,0.012734488`,0.011915804`,0.012777621`,0.007495621`,0.012590338`,0.008495954`,0.010345321`,0.013314871`,0.010160338`,0.010573671`,0.006993304`,0.007024671`,0.009245888`,0.006107938`,0.011774204`,0.007848604`,0.010573304`,0.010332571`,0.006793538`,0.006549971`,0.007199071`,0.008886321`,0.006758221`,0.006726588`,0.009688138`,0.011746771`,0.010023254`,0.007472854`,0.007530638`,0.013388854`,0.014206354`,0.018380488`,0.016068421`,0.018495321`,0.015653554`,0.019162504`,0.015409271`,0.016442304`,0.015875421`,0.015681104`,0.015623688`,0.015706988`,0.013164204`,0.013388854`,0.013191204`,0.014239321`,0.013260621`,0.012931321`,0.013207104`,0.014857054`,0.014593854`,0.013388854`,0.013095771`,0.013078938`,0.014444554`,0.013058838`,0.013840788`,0.016054338`,0.012805488`,0.012789788`,0.015778838`,0.015168071`,0.016454054`,0.015397588`,0.015790388`,0.016365521`,0.017089421`,0.011704838`,0.012164438`,0.014005204`,0.014479971`,0.014086921`,0.013835588`,0.017458638`,0.014060988`,0.010006638`,0.014094604`,0.014002238`,0.014588838`,0.006748288`,0.006716254`,0.006730971`,0.006730971`,0.006746704`,0.007560804`,0.008040671`,0.007085454`,0.006763038`,0.006184538`,0.005706971`,0.008446654`,0.008463621`,0.008109038`,0.008377804`,0.009062438`,0.006887821`,0.009707154`,0.009698004`,0.009276671`,0.008377804`,0.008109038`,0.008844938`,0.009734271`,0.008168554`,0.008635304`,0.008635304`,0.008260138`,0.009285588`,0.007121904`,0.007974738`,0.007085871`,0.007464421`,0.007399054`,0.006744671`},{2/27,0.007627667`,0.007630967`,0.007630967`,0.007516733`,0.008071183`,0.007533883`,0.0072703`,0.007465667`,0.00570835`,0.007545333`,0.006306`,0.006848283`,0.00807`,0.007466767`,0.006830483`,0.008114033`,0.008108783`,0.009665783`,0.0075088`,0.010417383`,0.006166583`,0.008685833`,0.0090705`,0.00837945`,0.007551533`,0.008818467`,0.01067965`,0.00901555`,0.009073117`,0.010096233`,0.01088835`,0.011260783`,0.009395433`,0.009280033`,0.009089683`,0.0157672`,0.0175502`,0.01653055`,0.0176287`,0.017807733`,0.0180537`,0.0153556`,0.017659133`,0.015689`,0.015620667`,0.0157258`,0.0157647`,0.008325617`,0.009089683`,0.013870283`,0.0151286`,0.01401945`,0.013590317`,0.013882233`,0.016326667`,0.015078783`,0.009089683`,0.008828117`,0.008940717`,0.012376117`,0.008865617`,0.01128735`,0.016524533`,0.011313483`,0.011883133`,0.016302083`,0.014977617`,0.015876567`,0.0152779`,0.015258983`,0.016443467`,0.017240417`,0.01188695`,0.011784217`,0.015297783`,0.017148967`,0.015535217`,0.0155633`,0.017162383`,0.015631467`,0.011169467`,0.016720333`,0.015237333`,0.017280667`,0.006979117`,0.00694475`,0.006962367`,0.006962367`,0.007093083`,0.007970533`,0.0079476`,0.0056205`,0.0062629`,0.006221033`,0.005427033`,0.006235433`,0.006219833`,0.00795395`,0.008244983`,0.009060533`,0.006899317`,0.009719467`,0.009757483`,0.0091083`,0.008244983`,0.00795395`,0.008810883`,0.009742967`,0.008045617`,0.008377817`,0.008377817`,0.008030367`,0.009194317`,0.0073538`,0.00813425`,0.00735515`,0.007779333`,0.007721467`,0.006350733`},{1/27,0.008250321`,0.008297854`,0.008297854`,0.008288704`,0.008431104`,0.009707171`,0.008134121`,0.009593971`,0.008253154`,0.009686338`,0.008436738`,0.008504521`,0.010464871`,0.011107604`,0.010303354`,0.012095754`,0.012007021`,0.013895154`,0.010249721`,0.013532604`,0.010468521`,0.012787088`,0.012757821`,0.010971704`,0.010364638`,0.011661521`,0.012007838`,0.010372771`,0.010489638`,0.012408471`,0.012086438`,0.013370238`,0.012322354`,0.012342354`,0.011347704`,0.016585088`,0.016811138`,0.017581621`,0.016875038`,0.017100104`,0.017178338`,0.016965421`,0.017181304`,0.015047671`,0.014832254`,0.014811121`,0.014863938`,0.010801054`,0.011347704`,0.014972604`,0.015547954`,0.015096538`,0.014647038`,0.014922788`,0.016340454`,0.014741804`,0.011347704`,0.011315604`,0.011328404`,0.013684738`,0.011229121`,0.012294354`,0.015639838`,0.013847754`,0.014353271`,0.016931538`,0.014851121`,0.016356988`,0.014876504`,0.015426138`,0.017411038`,0.016984371`,0.015509321`,0.014833904`,0.016243071`,0.017378554`,0.016451738`,0.016505254`,0.017623671`,0.016540371`,0.010987271`,0.017034988`,0.016234604`,0.017181338`,0.006536538`,0.006562471`,0.006537621`,0.006537621`,0.006223754`,0.007015421`,0.007314021`,0.006363688`,0.005998721`,0.005694321`,0.005198288`,0.007029721`,0.007015838`,0.007575854`,0.008107188`,0.008875571`,0.005511621`,0.009593204`,0.009630421`,0.009152021`,0.008107188`,0.007575854`,0.007856821`,0.009610471`,0.008149504`,0.007732188`,0.007732188`,0.007553138`,0.009145554`,0.008579604`,0.008989838`,0.008546621`,0.008461854`,0.008397871`,0.007479354`},{2/81,0.009651038`,0.009673554`,0.009673554`,0.009598788`,0.009772754`,0.010800138`,0.010692938`,0.010648088`,0.011637671`,0.010682788`,0.011006988`,0.010657571`,0.011951004`,0.013617054`,0.011637154`,0.013611771`,0.013486904`,0.014536838`,0.014141721`,0.014563454`,0.013794771`,0.014198071`,0.014172921`,0.012038871`,0.012921804`,0.010522888`,0.011644871`,0.009742054`,0.009982988`,0.014009904`,0.014562271`,0.014831304`,0.009803271`,0.009618688`,0.013506471`,0.016390688`,0.016159171`,0.017433071`,0.016192604`,0.017118821`,0.016315071`,0.016793738`,0.017697871`,0.015490788`,0.015425238`,0.015349854`,0.015372121`,0.012774488`,0.013506471`,0.015699238`,0.015651121`,0.015803388`,0.015189204`,0.015675538`,0.016438888`,0.015177671`,0.013506471`,0.013484538`,0.013504704`,0.015279971`,0.013388438`,0.014926454`,0.015968038`,0.014584421`,0.015133104`,0.016656571`,0.014638571`,0.016051821`,0.015238188`,0.015883338`,0.017472188`,0.017666038`,0.014839254`,0.015084004`,0.015818621`,0.016704721`,0.016064688`,0.016184121`,0.017029271`,0.016178088`,0.011581704`,0.016475588`,0.015795554`,0.016403471`,0.005656104`,0.005703538`,0.005664354`,0.005664354`,0.005380088`,0.009035871`,0.009510071`,0.006350938`,0.005624704`,0.004590804`,0.006069621`,0.008155238`,0.008215238`,0.008079071`,0.008540554`,0.009103121`,0.005784538`,0.009601238`,0.009668938`,0.008827954`,0.008540554`,0.008079071`,0.008168488`,0.009768671`,0.008507521`,0.008393621`,0.008393621`,0.008122088`,0.009079021`,0.009218838`,0.009470738`,0.009233138`,0.008711654`,0.008760971`,0.007248954`},{1/54,0.012638229`,0.012687029`,0.012687029`,0.012629263`,0.012571496`,0.013484679`,0.012741146`,0.013254696`,0.012688213`,0.013258879`,0.012254229`,0.012661296`,0.014891463`,0.013898679`,0.013073246`,0.010943379`,0.010862729`,0.014908429`,0.011226563`,0.015048529`,0.013517363`,0.014310913`,0.014368396`,0.009888096`,0.010307913`,0.008855896`,0.011070229`,0.009333096`,0.009384796`,0.013571196`,0.013950363`,0.014806629`,0.009669213`,0.009549079`,0.015826546`,0.017129363`,0.017481979`,0.017488696`,0.017548513`,0.016962763`,0.017654896`,0.017320879`,0.018647046`,0.016126146`,0.016004763`,0.015913229`,0.015968713`,0.015570029`,0.015826546`,0.016173246`,0.016299063`,0.016313279`,0.015570863`,0.016159196`,0.017159129`,0.016272379`,0.015826546`,0.015526896`,0.015404013`,0.015884913`,0.015400929`,0.015859363`,0.017522563`,0.014898413`,0.015544629`,0.017842046`,0.015500429`,0.016973429`,0.016092463`,0.015871813`,0.018731829`,0.018751063`,0.014204379`,0.014845479`,0.015140879`,0.015786346`,0.015347013`,0.015046929`,0.017274946`,0.015322296`,0.012217213`,0.015555379`,0.015126163`,0.015818446`,0.005020063`,0.005034379`,0.005020129`,0.005020129`,0.005000263`,0.008457996`,0.008676413`,0.006271363`,0.005533413`,0.005399996`,0.006259946`,0.006581829`,0.006523013`,0.008159896`,0.008683046`,0.009387329`,0.006917163`,0.009669246`,0.009886263`,0.009151063`,0.008683046`,0.008159896`,0.008878196`,0.009933079`,0.008722363`,0.008473646`,0.008473646`,0.008197563`,0.009383196`,0.009026813`,0.010089879`,0.009063329`,0.007865063`,0.007999413`,0.007612146`},{2/135,0.011797779`,0.011942863`,0.011942863`,0.011962996`,0.012228379`,0.012151396`,0.012229563`,0.012210546`,0.010462279`,0.012059946`,0.010733263`,0.011794896`,0.012700563`,0.012990346`,0.012163279`,0.012755046`,0.012685896`,0.015355513`,0.011397129`,0.014855246`,0.012158646`,0.014650546`,0.015001363`,0.011316279`,0.011248529`,0.011703179`,0.010440729`,0.010076113`,0.010221779`,0.015724479`,0.014986013`,0.016300879`,0.011768829`,0.011815679`,0.014065179`,0.017969279`,0.016630563`,0.018366713`,0.016669396`,0.017445246`,0.017077696`,0.018027563`,0.018087563`,0.017305729`,0.017180763`,0.017184979`,0.017224379`,0.013755496`,0.014065179`,0.016022729`,0.015937263`,0.016017146`,0.014964679`,0.016048813`,0.017839396`,0.016106313`,0.014065179`,0.013732213`,0.013610546`,0.016817713`,0.013607079`,0.014988063`,0.018592379`,0.014924213`,0.015568429`,0.017522546`,0.015790879`,0.017993446`,0.017026379`,0.017838046`,0.017248713`,0.017324513`,0.014540429`,0.014900379`,0.012412679`,0.014768996`,0.012581046`,0.013543779`,0.014729829`,0.012927563`,0.011730896`,0.014481946`,0.012253329`,0.014947046`,0.005053813`,0.005124796`,0.005071663`,0.005071663`,0.004954063`,0.008789463`,0.009054796`,0.008917746`,0.006769479`,0.005711863`,0.007182346`,0.007599879`,0.007601479`,0.009479563`,0.009672496`,0.009916696`,0.007737279`,0.010484613`,0.010505679`,0.009917813`,0.009672496`,0.009479563`,0.010197613`,0.010540846`,0.009389146`,0.010145013`,0.010145013`,0.009841179`,0.010033496`,0.010370796`,0.011475113`,0.010324229`,0.008711229`,0.008776079`,0.008455813`},{1/81,0.012534742`,0.012545808`,0.012545808`,0.012419425`,0.012577308`,0.013262425`,0.012361992`,0.013289892`,0.011355642`,0.013118775`,0.011283292`,0.011843925`,0.014298442`,0.014888008`,0.013646775`,0.012593508`,0.012476675`,0.015302025`,0.011911875`,0.016155508`,0.013606225`,0.016182642`,0.016228275`,0.009653292`,0.010308442`,0.008129075`,0.011595075`,0.007712858`,0.007964342`,0.014235808`,0.014483042`,0.015687892`,0.008925108`,0.008565242`,0.014628025`,0.018115858`,0.018175925`,0.018734208`,0.018320958`,0.017940742`,0.018852092`,0.018324442`,0.018676542`,0.017000325`,0.016937242`,0.016818892`,0.016803775`,0.014651308`,0.014628025`,0.017796542`,0.017708375`,0.017902108`,0.017449375`,0.017715658`,0.017779492`,0.017158842`,0.014628025`,0.014292875`,0.014273025`,0.017596508`,0.014190125`,0.016355992`,0.017339908`,0.016535825`,0.017191792`,0.016592275`,0.016971992`,0.014954858`,0.016701142`,0.013945408`,0.017325125`,0.017629392`,0.014618425`,0.014728042`,0.013924225`,0.018402075`,0.014200108`,0.014523642`,0.018145208`,0.014357925`,0.011624742`,0.017835125`,0.013788692`,0.018050925`,0.005877392`,0.005971075`,0.005899925`,0.005899925`,0.005940975`,0.008681308`,0.009061792`,0.008696192`,0.007656858`,0.005344692`,0.006753008`,0.008448542`,0.008461642`,0.009199608`,0.009415092`,0.010018158`,0.007138025`,0.010741725`,0.010541458`,0.010238725`,0.009415092`,0.009199608`,0.009854892`,0.010648025`,0.009150208`,0.009849225`,0.009849225`,0.009547625`,0.010249692`,0.008764325`,0.009708075`,0.008719975`,0.008297242`,0.008332258`,0.009204092`},{2/189,0.010671517`,0.010716517`,0.010716517`,0.010530733`,0.011322183`,0.01110275`,0.010125533`,0.01106865`,0.007789533`,0.011006733`,0.008194633`,0.009038`,0.011346767`,0.010415783`,0.00922455`,0.008291983`,0.0082593`,0.009596033`,0.008940567`,0.01193255`,0.009260583`,0.009867567`,0.009629383`,0.0079368`,0.0083703`,0.00932595`,0.011589133`,0.0092348`,0.009337783`,0.013414617`,0.0136288`,0.012964017`,0.0105846`,0.010477633`,0.0119884`,0.017622933`,0.01752405`,0.017796267`,0.017614433`,0.017633133`,0.0180958`,0.018363883`,0.017742867`,0.01601415`,0.015682117`,0.015493883`,0.015719567`,0.0114038`,0.0119884`,0.015115333`,0.015586733`,0.015040083`,0.014122967`,0.015097017`,0.017074933`,0.015185367`,0.0119884`,0.0114197`,0.011484433`,0.01591105`,0.011426183`,0.014368067`,0.016995867`,0.014356617`,0.014933333`,0.017622567`,0.012708267`,0.015993233`,0.014424417`,0.01576455`,0.01790735`,0.017800833`,0.014625367`,0.014626367`,0.01543355`,0.018617483`,0.0155786`,0.01521055`,0.019167283`,0.015519933`,0.0112814`,0.01820925`,0.01545585`,0.018077217`,0.006167017`,0.006229383`,0.00617975`,0.00617975`,0.00626395`,0.0078338`,0.008020167`,0.00789175`,0.006752333`,0.004875367`,0.006135433`,0.008768183`,0.0088782`,0.0071041`,0.00778515`,0.009539167`,0.005024933`,0.010278967`,0.0103099`,0.00978995`,0.00778515`,0.0071041`,0.007080917`,0.010420117`,0.0079773`,0.006718`,0.006718`,0.00675835`,0.009761883`,0.008284033`,0.008445833`,0.008247767`,0.007462117`,0.007413117`,0.006624083`},{1/108,0.007246963`,0.007308879`,0.007308879`,0.007301179`,0.007526446`,0.008531863`,0.007650829`,0.008400096`,0.008695546`,0.008516913`,0.008168763`,0.008172979`,0.009493513`,0.010799896`,0.009253146`,0.012800013`,0.012720946`,0.013926729`,0.012084096`,0.013025696`,0.011212796`,0.011758313`,0.012313596`,0.011826779`,0.010951063`,0.014901763`,0.011411513`,0.010263413`,0.010674846`,0.016267263`,0.015131479`,0.015960846`,0.014156129`,0.013722313`,0.010758996`,0.017255479`,0.016552679`,0.017726646`,0.016647146`,0.016614696`,0.017188079`,0.018128679`,0.017022113`,0.016658946`,0.016568646`,0.016437196`,0.016515563`,0.010230229`,0.010758996`,0.015148313`,0.015745479`,0.014941529`,0.014271829`,0.015146096`,0.016544963`,0.016008096`,0.010758996`,0.010521696`,0.010485046`,0.014362963`,0.010446746`,0.012048063`,0.017726546`,0.013571846`,0.014462746`,0.018620979`,0.015205579`,0.017120779`,0.015561996`,0.016896363`,0.019152563`,0.018614896`,0.016274929`,0.015879729`,0.017222829`,0.018814113`,0.017502779`,0.017121796`,0.020425179`,0.017448479`,0.010548579`,0.018365213`,0.017152279`,0.018096129`,0.005448179`,0.005475096`,0.005451663`,0.005451663`,0.005749063`,0.005890129`,0.006636829`,0.008530179`,0.005383379`,0.004844446`,0.007191379`,0.008400829`,0.008455896`,0.009928829`,0.010038646`,0.009147296`,0.007605229`,0.009691929`,0.009920696`,0.009207746`,0.010038646`,0.009928829`,0.010143479`,0.010048196`,0.009646729`,0.011020279`,0.011020279`,0.010541729`,0.009296146`,0.009180079`,0.009703696`,0.009230963`,0.007902679`,0.007917096`,0.007443929`},{2/243,0.010763213`,0.010761496`,0.010761496`,0.010578229`,0.011468963`,0.012539229`,0.010928563`,0.012442296`,0.011563246`,0.012406846`,0.011144996`,0.011225663`,0.013761596`,0.013687996`,0.013174846`,0.011059163`,0.010936579`,0.014314129`,0.010920896`,0.016631929`,0.013427063`,0.014842096`,0.015190963`,0.009906779`,0.009939363`,0.011426046`,0.013512496`,0.008785246`,0.008838529`,0.018988529`,0.017994413`,0.017562996`,0.012340329`,0.011963229`,0.014890079`,0.017251479`,0.017660863`,0.017510546`,0.017819146`,0.017104146`,0.018333146`,0.018556029`,0.017688229`,0.017447596`,0.017744663`,0.017694796`,0.017523829`,0.014419913`,0.014890079`,0.016274296`,0.016496729`,0.016496479`,0.016229729`,0.016347779`,0.016706329`,0.017325929`,0.014890079`,0.014608413`,0.014527946`,0.016623196`,0.014542213`,0.015859679`,0.018983463`,0.017003379`,0.017724546`,0.019181696`,0.018524679`,0.019302529`,0.018752529`,0.019071896`,0.018006379`,0.017534846`,0.017877613`,0.018531163`,0.018634563`,0.018725313`,0.018741163`,0.018423046`,0.019695296`,0.018726813`,0.009369896`,0.018377729`,0.018638229`,0.018074913`,0.005291879`,0.005348229`,0.005303496`,0.005303496`,0.005775579`,0.006094979`,0.007101546`,0.007294713`,0.004764563`,0.005436513`,0.006783646`,0.008754763`,0.008788329`,0.008908046`,0.009184079`,0.009703429`,0.007279829`,0.010378196`,0.010291413`,0.009947779`,0.009184079`,0.008908046`,0.009221879`,0.010415029`,0.008970346`,0.009417396`,0.009417396`,0.009097546`,0.009933629`,0.007833013`,0.008206863`,0.007831963`,0.007400546`,0.007469163`,0.006846863`},{1/135,0.008622471`,0.008659604`,0.008659604`,0.008604788`,0.009245021`,0.010213988`,0.008930738`,0.009996921`,0.009619271`,0.010142638`,0.009040921`,0.009192388`,0.011330488`,0.011735154`,0.010151771`,0.010288188`,0.010254438`,0.013095204`,0.010546954`,0.016924404`,0.010883638`,0.012639321`,0.013433571`,0.010193154`,0.009956404`,0.009535538`,0.011452304`,0.009062154`,0.009245704`,0.014424371`,0.018076704`,0.016731588`,0.009664821`,0.009201938`,0.013098721`,0.017582638`,0.018298571`,0.017907954`,0.018416804`,0.017731521`,0.019052171`,0.018362088`,0.018011921`,0.017267604`,0.017297471`,0.017266438`,0.017291271`,0.012404254`,0.013098721`,0.016502771`,0.017031704`,0.016790338`,0.016690721`,0.016561071`,0.017073804`,0.016988938`,0.013098721`,0.013028104`,0.013060854`,0.016724621`,0.012972988`,0.015347304`,0.019352121`,0.018296471`,0.019009104`,0.018718738`,0.018756171`,0.019573938`,0.018719121`,0.019464104`,0.017924988`,0.018172904`,0.019297704`,0.019433704`,0.019316621`,0.019278638`,0.019464021`,0.019315388`,0.018702471`,0.019495821`,0.011881288`,0.019132004`,0.019300671`,0.018811338`,0.005569338`,0.005643538`,0.005586204`,0.005586204`,0.005517221`,0.008839238`,0.010911488`,0.005401238`,0.004970971`,0.005500421`,0.004900854`,0.008399621`,0.008295021`,0.007503938`,0.008067671`,0.009659604`,0.005431438`,0.010485621`,0.010442354`,0.009851938`,0.008067671`,0.007503938`,0.007574938`,0.010576704`,0.008141988`,0.007411021`,0.007411021`,0.007300471`,0.009851804`,0.007563921`,0.008091538`,0.007554138`,0.007428288`,0.007417204`,0.006600554`},{2/297,0.009457613`,0.009484846`,0.009484846`,0.009343596`,0.010106979`,0.010048646`,0.009256413`,0.009984596`,0.008647313`,0.010033696`,0.008595179`,0.009199579`,0.010398346`,0.010578396`,0.009299596`,0.010045246`,0.009980513`,0.010577296`,0.009475963`,0.011227246`,0.010305963`,0.011094646`,0.011208579`,0.009015596`,0.009179563`,0.008707263`,0.011971313`,0.008807396`,0.009012496`,0.011820329`,0.016120579`,0.012097879`,0.009160979`,0.008800063`,0.010863763`,0.017712846`,0.017714729`,0.017968163`,0.017915729`,0.017870879`,0.018899529`,0.017847379`,0.017775696`,0.017013329`,0.016817779`,0.016721213`,0.016895129`,0.010574613`,0.010863763`,0.014373913`,0.015068313`,0.014389913`,0.013570146`,0.014369979`,0.015766379`,0.015433696`,0.010863763`,0.010399063`,0.010454896`,0.014404513`,0.010411696`,0.012700596`,0.018344346`,0.011573563`,0.011800946`,0.017178929`,0.016818846`,0.018908729`,0.016786046`,0.019044679`,0.017787013`,0.017759396`,0.017478179`,0.017767063`,0.017025579`,0.014956929`,0.016995063`,0.017230629`,0.017454796`,0.017131346`,0.014868229`,0.014538346`,0.016981713`,0.015124996`,0.006513713`,0.006575279`,0.006524729`,0.006524729`,0.007323146`,0.008874413`,0.010882596`,0.006534646`,0.005723863`,0.004932829`,0.005289746`,0.007549446`,0.007508596`,0.007337746`,0.007983679`,0.009565963`,0.005457863`,0.010227479`,0.010203096`,0.009672679`,0.007983679`,0.007337746`,0.007449513`,0.010276346`,0.008133796`,0.007425396`,0.007425396`,0.007215913`,0.009722579`,0.006947046`,0.007743879`,0.006929563`,0.006938363`,0.006915196`,0.005905879`},{1/162,0.008660463`,0.008718163`,0.008718163`,0.008702996`,0.009060513`,0.009278479`,0.009290213`,0.009182329`,0.009705279`,0.009245929`,0.009263796`,0.009634763`,0.010180346`,0.011666346`,0.010096429`,0.011600379`,0.011567063`,0.013786696`,0.011321446`,0.014722746`,0.011565496`,0.013505313`,0.013466196`,0.011087596`,0.011159163`,0.012051146`,0.014330413`,0.011797779`,0.011918213`,0.016648746`,0.016142813`,0.016774879`,0.013689629`,0.013601113`,0.010693763`,0.017288046`,0.018987629`,0.017984429`,0.019207613`,0.018020896`,0.020090946`,0.018187946`,0.018419346`,0.016976363`,0.016727346`,0.016619829`,0.016796496`,0.010593063`,0.010693763`,0.014718196`,0.015599896`,0.014680113`,0.014052179`,0.014661679`,0.016913829`,0.015538813`,0.010693763`,0.010524046`,0.010505296`,0.012303496`,0.010429663`,0.011746779`,0.017860846`,0.014917463`,0.015768846`,0.017546763`,0.016362079`,0.018301196`,0.017434913`,0.017662596`,0.018113396`,0.018058929`,0.015496213`,0.015645129`,0.015438679`,0.015941313`,0.015566196`,0.015280546`,0.017401013`,0.015540146`,0.012871829`,0.015550396`,0.015425346`,0.015176646`,0.006902413`,0.006903496`,0.006895763`,0.006895763`,0.007755746`,0.008467346`,0.011023563`,0.006940979`,0.004650029`,0.004947163`,0.005356679`,0.007239113`,0.007252896`,0.006614513`,0.007389846`,0.009404063`,0.005171229`,0.010202079`,0.010344213`,0.009692729`,0.007389846`,0.006614513`,0.006640946`,0.010416846`,0.007669946`,0.006579129`,0.006579129`,0.006406396`,0.009672263`,0.007698446`,0.007310846`,0.007704929`,0.007524496`,0.007468863`,0.006025829`},{2/351,0.0099794`,0.010035083`,0.010035083`,0.010015333`,0.008480683`,0.0114665`,0.010731733`,0.0114045`,0.01050595`,0.011387833`,0.010309667`,0.010597383`,0.0122328`,0.014116967`,0.012635367`,0.015342567`,0.015248883`,0.017429683`,0.013157083`,0.016901083`,0.013454617`,0.016415667`,0.016627367`,0.014762617`,0.013708567`,0.0162488`,0.013484717`,0.01552975`,0.0155215`,0.016900867`,0.015659767`,0.0177886`,0.01513905`,0.015409517`,0.01455335`,0.016478517`,0.019315167`,0.017554933`,0.019569317`,0.016756667`,0.020180067`,0.018250067`,0.017438817`,0.016035583`,0.015921983`,0.015929833`,0.016008367`,0.0139254`,0.01455335`,0.01641245`,0.017218867`,0.01669805`,0.016249867`,0.01640555`,0.017525867`,0.01658445`,0.01455335`,0.014689333`,0.014739167`,0.01678885`,0.014617917`,0.016228267`,0.016984767`,0.016871133`,0.0177954`,0.017956533`,0.0165986`,0.0185332`,0.017408933`,0.0188518`,0.01908545`,0.018662233`,0.0155188`,0.01539135`,0.015782867`,0.01496405`,0.015925183`,0.015809167`,0.016407833`,0.0159555`,0.0138641`,0.0146872`,0.015736583`,0.01484175`,0.006436383`,0.006386167`,0.006415083`,0.006415083`,0.007523667`,0.004956833`,0.005034733`,0.004817283`,0.004625517`,0.0031962`,0.00319375`,0.005870333`,0.006000683`,0.005629733`,0.006567`,0.00850225`,0.003828983`,0.008929383`,0.009766367`,0.007407383`,0.006567`,0.005629733`,0.005012567`,0.009795183`,0.0070266`,0.00542145`,0.00542145`,0.00537325`,0.008125067`,0.00660495`,0.006714983`,0.006618717`,0.006616317`,0.006577267`,0.005811483`},{1/189,0.009723104`,0.009785771`,0.009785771`,0.009842204`,0.007657071`,0.011774971`,0.011989138`,0.011681304`,0.013191021`,0.011727471`,0.012250338`,0.011470771`,0.013532104`,0.017266688`,0.015095454`,0.017622471`,0.017559288`,0.018025354`,0.017118638`,0.018319738`,0.017031071`,0.018411138`,0.018348404`,0.017136171`,0.016702738`,0.016368938`,0.013741938`,0.017436721`,0.017501238`,0.016766471`,0.015951471`,0.017539538`,0.015618621`,0.016027471`,0.016048271`,0.016794104`,0.018355021`,0.017496738`,0.018561954`,0.015949254`,0.019194488`,0.017870671`,0.016877571`,0.014956071`,0.014859871`,0.014781471`,0.014867704`,0.015183221`,0.016048271`,0.016584471`,0.016466421`,0.016971921`,0.016396338`,0.016646488`,0.016263604`,0.015476838`,0.016048271`,0.016114338`,0.016146988`,0.017852488`,0.016013538`,0.017286371`,0.016671554`,0.017179738`,0.017797304`,0.017372938`,0.016385404`,0.017580604`,0.016341804`,0.018329438`,0.018330404`,0.018216138`,0.015323854`,0.015328188`,0.015408204`,0.014444104`,0.015520121`,0.015099354`,0.016363704`,0.015452771`,0.014397238`,0.014174454`,0.015411671`,0.014318554`,0.006013338`,0.005947121`,0.005989654`,0.005989654`,0.007770838`,0.004533071`,0.007444454`,0.004305788`,0.004687671`,0.002355571`,0.003209538`,0.004408138`,0.004461238`,0.005779854`,0.006776038`,0.007999271`,0.003910454`,0.007667471`,0.009055754`,0.005736871`,0.006776038`,0.005779854`,0.005196638`,0.009257304`,0.007286454`,0.005660104`,0.005660104`,0.005588454`,0.007132238`,0.007023088`,0.006968004`,0.007049138`,0.007488804`,0.007454788`,0.006622054`},{2/405,0.010131017`,0.010248617`,0.010248617`,0.010367317`,0.007558017`,0.012674883`,0.012942967`,0.012517867`,0.0166976`,0.012549417`,0.015956833`,0.015705333`,0.014413883`,0.01819975`,0.016537083`,0.017689617`,0.017611233`,0.017749967`,0.0183287`,0.018098283`,0.018550233`,0.0189291`,0.018728433`,0.016533833`,0.016932167`,0.014484583`,0.008599717`,0.011921283`,0.0123939`,0.015944267`,0.016063017`,0.016935633`,0.010492017`,0.011027833`,0.017307967`,0.015704417`,0.01825785`,0.016462867`,0.018571533`,0.014793083`,0.019579583`,0.016392083`,0.015875633`,0.014408933`,0.014447467`,0.014388067`,0.014408367`,0.016787667`,0.017307967`,0.014962367`,0.014592317`,0.015367667`,0.015081433`,0.015105083`,0.014178417`,0.0140054`,0.017307967`,0.01714375`,0.017098317`,0.017177783`,0.017003767`,0.017032633`,0.016057217`,0.016914433`,0.0170776`,0.017202867`,0.015693183`,0.0174595`,0.016255683`,0.018987333`,0.018715617`,0.01920245`,0.015342017`,0.015388117`,0.016700683`,0.016666717`,0.0168119`,0.016410817`,0.017494433`,0.016748267`,0.01295105`,0.0164079`,0.01669665`,0.015897467`,0.003838817`,0.003701967`,0.003798517`,0.003798517`,0.00519405`,0.004453383`,0.005060383`,0.0056238`,0.003163783`,0.002259483`,0.003244933`,0.0046523`,0.004792983`,0.005602517`,0.00678005`,0.007442367`,0.003886467`,0.006814917`,0.007513367`,0.005199133`,0.00678005`,0.005602517`,0.005611217`,0.007312983`,0.0074666`,0.00506825`,0.00506825`,0.005035183`,0.006553967`,0.0077783`,0.008299683`,0.007763717`,0.008293467`,0.00827975`,0.00689065`},{1/216,0.0151211`,0.015184433`,0.015184433`,0.01519165`,0.014180483`,0.016793533`,0.018314133`,0.01674165`,0.016441317`,0.016534667`,0.01629195`,0.017471717`,0.018487317`,0.01722555`,0.01663095`,0.01274885`,0.0126248`,0.0154088`,0.013241`,0.016053133`,0.016847867`,0.016770983`,0.016136`,0.010612183`,0.0114812`,0.008263367`,0.0053968`,0.007956933`,0.008096567`,0.0098845`,0.011603767`,0.013185767`,0.006316833`,0.006557733`,0.018319883`,0.016268617`,0.018592167`,0.016415967`,0.018839067`,0.015581017`,0.0190507`,0.0179797`,0.017519083`,0.014502633`,0.014603583`,0.014561833`,0.014568767`,0.0185271`,0.018319883`,0.01433465`,0.014003767`,0.014732717`,0.014045683`,0.014603683`,0.01372305`,0.013644183`,0.018319883`,0.017802917`,0.0176653`,0.018523433`,0.01770835`,0.017708317`,0.016411517`,0.015705983`,0.015712117`,0.01809075`,0.016257133`,0.016405717`,0.0165432`,0.016409267`,0.019557183`,0.0187473`,0.009416833`,0.01032745`,0.012849217`,0.0136882`,0.013181133`,0.012746517`,0.0179024`,0.013123817`,0.006857083`,0.01355165`,0.0128787`,0.013964267`,0.002342917`,0.002352067`,0.002346567`,0.002346567`,0.002930317`,0.003630733`,0.00396115`,0.005711933`,0.00306315`,0.002821467`,0.00457375`,0.004492733`,0.00456355`,0.007099483`,0.007999467`,0.00600335`,0.004413117`,0.005728017`,0.00551965`,0.004695933`,0.007999467`,0.007099483`,0.00658395`,0.004730567`,0.008418633`,0.006741067`,0.006741067`,0.0067073`,0.005493783`,0.00916775`,0.009529817`,0.009168033`,0.008301433`,0.00832115`,0.007180967`},{2/459,0.015440875`,0.015495925`,0.015495925`,0.015437525`,0.014963658`,0.015397625`,0.014729192`,0.015229608`,0.010785108`,0.015209342`,0.011666842`,0.013204592`,0.016137242`,0.012415892`,0.012755908`,0.008988008`,0.008955075`,0.009401658`,0.009251908`,0.010340425`,0.010768758`,0.010882025`,0.010209492`,0.008500258`,0.008734408`,0.007885075`,0.006016108`,0.008625425`,0.008631525`,0.008895442`,0.008573175`,0.009191142`,0.006926458`,0.007069575`,0.015751925`,0.018014992`,0.018944358`,0.017703042`,0.019149475`,0.017631858`,0.019683542`,0.017662525`,0.019095275`,0.014600258`,0.014552142`,0.014698792`,0.014785242`,0.015432342`,0.015751925`,0.014493125`,0.014261842`,0.014690942`,0.013790275`,0.014703625`,0.013843775`,0.013309925`,0.015751925`,0.014649475`,0.014606075`,0.018335875`,0.014696642`,0.016459608`,0.016418625`,0.010877992`,0.010418342`,0.016167042`,0.015480692`,0.011358158`,0.012293092`,0.011245525`,0.018637858`,0.018811175`,0.009524658`,0.009745158`,0.012054625`,0.014539708`,0.012313942`,0.011776375`,0.017194492`,0.012209058`,0.005515675`,0.014177308`,0.012074525`,0.014867742`,0.002983625`,0.003032908`,0.002996192`,0.002996192`,0.003525608`,0.003628058`,0.003923425`,0.004983675`,0.003541358`,0.003049708`,0.004983142`,0.005343575`,0.005398042`,0.007168742`,0.007937975`,0.008144858`,0.004992758`,0.007553425`,0.007373542`,0.006616792`,0.007937975`,0.007168742`,0.006951975`,0.007198042`,0.008208258`,0.006821808`,0.006821808`,0.006781842`,0.007576025`,0.006919558`,0.007134575`,0.006981325`,0.006989558`,0.007021242`,0.005679558`},{1/243,0.010244617`,0.010264233`,0.010264233`,0.010217533`,0.008688883`,0.009894433`,0.010843117`,0.0099105`,0.00864895`,0.00993495`,0.00911485`,0.00975485`,0.0103425`,0.010696717`,0.009970667`,0.0106028`,0.01061115`,0.009834433`,0.01021245`,0.010445783`,0.009279817`,0.00992255`,0.009711783`,0.009715583`,0.010137833`,0.008928483`,0.007823733`,0.008330033`,0.0086077`,0.012023683`,0.012059233`,0.01010875`,0.00757675`,0.007482733`,0.0113694`,0.01834515`,0.019082717`,0.01856395`,0.019186767`,0.01734125`,0.019545017`,0.018337583`,0.019429833`,0.014146533`,0.014073083`,0.01401715`,0.014062467`,0.010834317`,0.0113694`,0.016168417`,0.016153067`,0.016181017`,0.014768267`,0.016213833`,0.015379817`,0.014396667`,0.0113694`,0.010913117`,0.01095305`,0.01532935`,0.010891483`,0.013452333`,0.014045817`,0.010534117`,0.010553483`,0.015194867`,0.013117417`,0.0117016`,0.011191167`,0.013706533`,0.017780717`,0.017905283`,0.014254717`,0.013846467`,0.015793883`,0.016134933`,0.015916917`,0.015594383`,0.017877367`,0.015875633`,0.00947095`,0.015821317`,0.015737233`,0.016020233`,0.0039113`,0.0039498`,0.003920867`,0.003920867`,0.00395835`,0.0045968`,0.005655333`,0.004532233`,0.002974017`,0.003295633`,0.004786017`,0.004865717`,0.004854167`,0.006609483`,0.007471783`,0.00949435`,0.005038683`,0.009711233`,0.009762667`,0.008669633`,0.007471783`,0.006609483`,0.00661515`,0.00990825`,0.00782805`,0.0060486`,0.0060486`,0.005999567`,0.00925115`,0.00790245`,0.007673033`,0.007929983`,0.00770085`,0.00776995`,0.006197`},{2/513,0.010591921`,0.010593238`,0.010593238`,0.010543021`,0.009279704`,0.011409221`,0.013272304`,0.011340171`,0.010928804`,0.011406821`,0.011667421`,0.012998221`,0.012583088`,0.012294054`,0.013339804`,0.010600938`,0.010467438`,0.011079504`,0.010253271`,0.011152354`,0.011268571`,0.011569304`,0.010799971`,0.008034704`,0.008328254`,0.007498154`,0.009349304`,0.007348688`,0.007431621`,0.013386038`,0.016323121`,0.013658288`,0.006683488`,0.006284654`,0.014776171`,0.018490404`,0.018083854`,0.018721688`,0.018122921`,0.017307154`,0.018236021`,0.018705388`,0.019181221`,0.013416454`,0.013578671`,0.013508154`,0.013471854`,0.014338704`,0.014776171`,0.016150304`,0.016491988`,0.016356821`,0.015785671`,0.016125304`,0.017085488`,0.015874804`,0.014776171`,0.014989738`,0.014884321`,0.016010271`,0.014826338`,0.015340521`,0.013423538`,0.011840638`,0.012941488`,0.016227104`,0.014576388`,0.015850421`,0.013298421`,0.017330238`,0.018836971`,0.018152404`,0.015750921`,0.016766988`,0.015037654`,0.015831488`,0.015158438`,0.014883604`,0.017342971`,0.015141004`,0.011056571`,0.015487354`,0.015004321`,0.015917321`,0.004335871`,0.004449771`,0.004367721`,0.004367721`,0.004596121`,0.004929371`,0.005419938`,0.008162038`,0.004192421`,0.003541304`,0.007522171`,0.006225071`,0.006297138`,0.008927138`,0.009252621`,0.009860154`,0.006385871`,0.010043088`,0.010155221`,0.008979938`,0.009252621`,0.008927138`,0.009583738`,0.010317204`,0.009107571`,0.009627088`,0.009627088`,0.009305121`,0.009577888`,0.009442104`,0.010870704`,0.009389738`,0.008441138`,0.008575338`,0.008445754`},{1/270,0.011479821`,0.011572721`,0.011572721`,0.011675271`,0.008851404`,0.013325338`,0.013927454`,0.013218754`,0.009275004`,0.013232438`,0.010841104`,0.013209071`,0.014235971`,0.012751271`,0.013928388`,0.010597388`,0.010557938`,0.012874238`,0.009604638`,0.013142854`,0.012059354`,0.012793071`,0.012510804`,0.010647404`,0.008953288`,0.011465588`,0.012692388`,0.010063788`,0.010048288`,0.016523638`,0.016931688`,0.015189738`,0.011531371`,0.011039754`,0.015786388`,0.018401921`,0.018239188`,0.018496704`,0.018323871`,0.017334021`,0.018532371`,0.018804071`,0.018009004`,0.014305104`,0.014480804`,0.014537554`,0.014491971`,0.015400721`,0.015786388`,0.016348154`,0.016235738`,0.016557988`,0.015598004`,0.016320954`,0.016550454`,0.014575371`,0.015786388`,0.015772604`,0.015657604`,0.016232888`,0.015600738`,0.016522954`,0.016260238`,0.013869304`,0.014127621`,0.016845171`,0.015310688`,0.016582154`,0.016515304`,0.016426788`,0.017678571`,0.018111788`,0.014916988`,0.016570804`,0.015376404`,0.016846388`,0.015541121`,0.015232371`,0.017952704`,0.015516871`,0.011849304`,0.016489188`,0.015348754`,0.016851804`,0.004815271`,0.004917271`,0.004844138`,0.004844138`,0.005149221`,0.005530454`,0.006264488`,0.007830871`,0.003581154`,0.003687404`,0.007073404`,0.007776954`,0.007864371`,0.009226021`,0.009535171`,0.009620554`,0.007869888`,0.009679988`,0.009982521`,0.008599204`,0.009535171`,0.009226021`,0.009788671`,0.010240604`,0.009368171`,0.009964588`,0.009964588`,0.009578288`,0.009290021`,0.010004054`,0.011400354`,0.009981171`,0.008342221`,0.008317854`,0.007511838`},{2/567,0.013352363`,0.013349529`,0.013349529`,0.013189046`,0.011525846`,0.013868129`,0.012495896`,0.013774629`,0.010407729`,0.013783863`,0.010485746`,0.011299513`,0.014829746`,0.013731879`,0.012537313`,0.012772163`,0.012673029`,0.015466129`,0.011808046`,0.015682913`,0.013508196`,0.015359496`,0.015215479`,0.011247713`,0.011188379`,0.011263046`,0.014032863`,0.010085829`,0.009990146`,0.018189529`,0.016734829`,0.017387446`,0.011476096`,0.010984229`,0.014707579`,0.017855763`,0.018076413`,0.018124346`,0.018263713`,0.017801179`,0.018994813`,0.019012663`,0.017749363`,0.015778363`,0.015942713`,0.016054696`,0.015997929`,0.014611229`,0.014707579`,0.014798296`,0.015333179`,0.014843613`,0.014063013`,0.014861363`,0.016079296`,0.015235996`,0.014707579`,0.013996613`,0.013992779`,0.017173546`,0.013962879`,0.015434696`,0.016494179`,0.016176663`,0.016599413`,0.015730963`,0.017234196`,0.016421096`,0.017935646`,0.016440763`,0.017603396`,0.018585946`,0.016304013`,0.016622046`,0.017278079`,0.017899946`,0.017454546`,0.017215179`,0.018734396`,0.017459563`,0.012205363`,0.017680696`,0.017216096`,0.017365346`,0.005386229`,0.005513396`,0.005418829`,0.005418829`,0.005872913`,0.005727329`,0.006354746`,0.005721279`,0.004742929`,0.005011846`,0.005215613`,0.007518213`,0.007584813`,0.008170479`,0.008668729`,0.009411129`,0.007567863`,0.009566329`,0.009885729`,0.008901029`,0.008668729`,0.008170479`,0.008667063`,0.010133879`,0.008674413`,0.008302263`,0.008302263`,0.008043146`,0.009344763`,0.008409879`,0.008578513`,0.008471279`,0.007705246`,0.007693963`,0.006231346`},{1/297,0.014082388`,0.014119404`,0.014119404`,0.014007704`,0.010881904`,0.016210254`,0.013821504`,0.016207871`,0.011772021`,0.016034138`,0.012323804`,0.012940671`,0.016734754`,0.014443788`,0.013773454`,0.011875454`,0.011801088`,0.014591388`,0.010607704`,0.015172254`,0.013389688`,0.015365254`,0.015087504`,0.010566704`,0.010099854`,0.009290188`,0.012577438`,0.009540104`,0.009538871`,0.015124771`,0.017052271`,0.015534021`,0.008302938`,0.008314538`,0.016357221`,0.018121838`,0.018089854`,0.017851971`,0.018269721`,0.017575821`,0.018834754`,0.019210088`,0.017969271`,0.015749088`,0.015755954`,0.015746304`,0.015789071`,0.016414838`,0.016357221`,0.015204154`,0.014823271`,0.015487104`,0.014838171`,0.015302054`,0.015217154`,0.014753704`,0.016357221`,0.015656371`,0.015575788`,0.017840554`,0.015605704`,0.016297304`,0.016714554`,0.015662738`,0.015790288`,0.017276254`,0.017125521`,0.017513954`,0.017241004`,0.017909388`,0.018865571`,0.019895721`,0.016108054`,0.017248238`,0.016904971`,0.017302721`,0.017045304`,0.016748238`,0.019361004`,0.017025771`,0.013585521`,0.017039238`,0.016879354`,0.016823471`,0.006747771`,0.006883221`,0.006781438`,0.006781438`,0.007402138`,0.007737571`,0.007958271`,0.006443271`,0.004815671`,0.005204104`,0.005906438`,0.007236238`,0.007265154`,0.008468571`,0.008888488`,0.009924704`,0.007475221`,0.010376954`,0.010462588`,0.009971238`,0.008888488`,0.008468571`,0.009146204`,0.010704038`,0.008827338`,0.009053088`,0.009053088`,0.008705471`,0.010114238`,0.009701871`,0.010364438`,0.009672638`,0.008856138`,0.008905154`,0.008020554`},{2/621,0.010627058`,0.010688192`,0.010688192`,0.010637925`,0.009124392`,0.010320658`,0.010046325`,0.010330858`,0.008707158`,0.010353875`,0.008924458`,0.009263792`,0.010311542`,0.010884575`,0.009339708`,0.010026842`,0.009979542`,0.010115575`,0.009720125`,0.010729575`,0.010538108`,0.011337425`,0.010713842`,0.009420875`,0.009698458`,0.009346175`,0.014005242`,0.009874525`,0.009694525`,0.013275258`,0.015280025`,0.011901308`,0.009685542`,0.009693108`,0.010918442`,0.018151358`,0.017498392`,0.018172508`,0.017563908`,0.018159608`,0.017908358`,0.019433192`,0.017843308`,0.015028025`,0.014963792`,0.015080558`,0.015141092`,0.010658658`,0.010918442`,0.012813658`,0.013833792`,0.013236775`,0.013057875`,0.012903725`,0.014152592`,0.013925675`,0.010918442`,0.010525858`,0.010529458`,0.013701342`,0.010444125`,0.011683075`,0.016397308`,0.010664392`,0.010616092`,0.016791575`,0.014977092`,0.016330342`,0.014433808`,0.016687625`,0.017748392`,0.017733508`,0.015136708`,0.015908008`,0.016564508`,0.016820775`,0.016750425`,0.016446875`,0.018353408`,0.016748975`,0.012331542`,0.016586992`,0.016517875`,0.016739908`,0.007328042`,0.007427842`,0.007350942`,0.007350942`,0.008043342`,0.008793675`,0.007264975`,0.006793458`,0.007058908`,0.005277692`,0.004792525`,0.007413225`,0.007474008`,0.008043658`,0.008575225`,0.009941842`,0.006649708`,0.010545208`,0.010674042`,0.010113642`,0.008575225`,0.008043658`,0.008246292`,0.010914542`,0.008617958`,0.008088058`,0.008088058`,0.007987825`,0.010182458`,0.008356725`,0.008887092`,0.008383708`,0.007772525`,0.007745558`,0.007188558`},{1/324,0.007874929`,0.007900496`,0.007900496`,0.007843196`,0.007362129`,0.009776896`,0.008134879`,0.009517313`,0.009621546`,0.009751179`,0.009081813`,0.008989113`,0.010972446`,0.011308846`,0.010421013`,0.013011863`,0.013047929`,0.012372896`,0.012215779`,0.012340513`,0.011084779`,0.012004646`,0.012240629`,0.013768996`,0.012520829`,0.016789646`,0.010732279`,0.011971513`,0.012086963`,0.017457979`,0.016504146`,0.015319879`,0.013724429`,0.014136713`,0.012847296`,0.017631913`,0.017584196`,0.018250813`,0.017663996`,0.017354963`,0.018036096`,0.018655046`,0.017794313`,0.013773579`,0.013749963`,0.013704096`,0.013715179`,0.012208429`,0.012847296`,0.014497896`,0.016417946`,0.014896229`,0.014550629`,0.014383013`,0.018295546`,0.015243463`,0.012847296`,0.012563713`,0.012518179`,0.013623213`,0.012469463`,0.012863596`,0.015135996`,0.012377129`,0.013078046`,0.017667013`,0.013445263`,0.016217296`,0.014178829`,0.016775363`,0.017394079`,0.017251913`,0.015578913`,0.015984196`,0.016641513`,0.016748463`,0.016766763`,0.016699146`,0.017396413`,0.016820529`,0.011212263`,0.016513346`,0.016585379`,0.016985696`,0.007459779`,0.007582213`,0.007489313`,0.007489313`,0.008258679`,0.007657513`,0.007487046`,0.005340779`,0.006327796`,0.005650579`,0.004882429`,0.006596663`,0.006571563`,0.007731246`,0.008248863`,0.010139363`,0.005313213`,0.010833046`,0.011003713`,0.010234613`,0.008248863`,0.007731246`,0.007766429`,0.011203079`,0.008265846`,0.007173096`,0.007173096`,0.007379829`,0.010298696`,0.008479529`,0.009140946`,0.008487613`,0.008276029`,0.008199163`,0.006422029`},{2/675,0.011953633`,0.011994133`,0.011994133`,0.011918267`,0.0097141`,0.014502067`,0.012811067`,0.014491967`,0.011971483`,0.014405867`,0.0120725`,0.012229767`,0.015220333`,0.0143009`,0.013362633`,0.013131833`,0.01301565`,0.014839483`,0.0128434`,0.015825733`,0.01428095`,0.015542683`,0.015261767`,0.01048875`,0.010910017`,0.011110017`,0.01121075`,0.0087067`,0.008833833`,0.017038883`,0.016372717`,0.016333383`,0.009275367`,0.00811615`,0.015556483`,0.01734615`,0.016957767`,0.017271817`,0.0169969`,0.01702695`,0.0175347`,0.017276033`,0.018301433`,0.01570635`,0.0154723`,0.015474267`,0.0156531`,0.015634517`,0.015556483`,0.01623045`,0.01703205`,0.016658667`,0.0161234`,0.01631625`,0.0172169`,0.015907833`,0.015556483`,0.015205817`,0.015029983`,0.017301617`,0.01505635`,0.015515483`,0.017088817`,0.016061267`,0.0166459`,0.017285667`,0.016138867`,0.018085583`,0.017166633`,0.017355533`,0.017602533`,0.01727985`,0.015254417`,0.015992717`,0.016159083`,0.01663885`,0.0162796`,0.015948317`,0.016832317`,0.016249133`,0.0119684`,0.016328833`,0.016156183`,0.01639975`,0.0078719`,0.00798135`,0.0078973`,0.0078973`,0.008635417`,0.0093765`,0.009513167`,0.006455367`,0.00829055`,0.0046785`,0.005494717`,0.00727455`,0.007266233`,0.00834855`,0.008655617`,0.009606167`,0.00538875`,0.01009605`,0.0106768`,0.009052867`,0.008655617`,0.00834855`,0.008948983`,0.010821433`,0.00846715`,0.008558467`,0.008558467`,0.008403533`,0.009440917`,0.010508933`,0.0112883`,0.010486367`,0.009724583`,0.009635267`,0.00727505`},{1/351,0.011248921`,0.011324304`,0.011324304`,0.011305304`,0.008564054`,0.011893854`,0.010428654`,0.011723871`,0.007203454`,0.011810938`,0.007980671`,0.008901104`,0.012020404`,0.009451671`,0.008939021`,0.010036838`,0.009994238`,0.010054638`,0.007394771`,0.010441721`,0.008970804`,0.009423904`,0.009647921`,0.009486471`,0.008938604`,0.008867304`,0.012566538`,0.009414321`,0.009494504`,0.013145404`,0.013766621`,0.011321138`,0.010076671`,0.008740304`,0.011378638`,0.018066971`,0.016586954`,0.018251921`,0.016565304`,0.017655104`,0.017021621`,0.018410621`,0.018777371`,0.015106221`,0.014943138`,0.015121738`,0.015116471`,0.011273104`,0.011378638`,0.013842304`,0.014649621`,0.013861854`,0.012798304`,0.013825404`,0.015571654`,0.013695788`,0.011378638`,0.010784104`,0.010784071`,0.015174771`,0.010777521`,0.011888071`,0.015440188`,0.010863021`,0.010778721`,0.017073121`,0.014349704`,0.014376904`,0.013551671`,0.016084221`,0.018503921`,0.017961838`,0.014669371`,0.016940971`,0.016103204`,0.016957754`,0.016249021`,0.016126271`,0.017987904`,0.016288154`,0.012221204`,0.016695371`,0.016070321`,0.016356671`,0.008250821`,0.008405421`,0.008291188`,0.008291188`,0.008994971`,0.008844471`,0.008915004`,0.008058704`,0.008246804`,0.005193438`,0.006183538`,0.007542904`,0.007531571`,0.008475654`,0.008786054`,0.009498188`,0.006268521`,0.009984604`,0.010547921`,0.009083304`,0.008786054`,0.008475654`,0.009477821`,0.010723404`,0.008607804`,0.008810288`,0.008810288`,0.008562838`,0.009408638`,0.008834921`,0.010221804`,0.008809688`,0.009840071`,0.009733304`,0.007716371`},{2/729,0.008388417`,0.008457683`,0.008457683`,0.0084688`,0.007379133`,0.008573933`,0.00858015`,0.008610617`,0.007355917`,0.008605833`,0.00781305`,0.008574283`,0.00848275`,0.0076364`,0.007858367`,0.00898465`,0.0090258`,0.0091171`,0.007269867`,0.009356`,0.00735865`,0.007738317`,0.008167383`,0.009612267`,0.008716467`,0.011475317`,0.010442`,0.010686383`,0.010602983`,0.014958683`,0.01194795`,0.011232167`,0.014295133`,0.013293867`,0.00795485`,0.017724167`,0.01669425`,0.018095967`,0.0166619`,0.01767845`,0.0167803`,0.018054533`,0.0183085`,0.011426267`,0.011238083`,0.011184633`,0.0112536`,0.008470117`,0.00795485`,0.007785617`,0.009577333`,0.008055`,0.007991283`,0.007895417`,0.012351217`,0.010464117`,0.00795485`,0.007690733`,0.007624567`,0.009860783`,0.0075687`,0.007759217`,0.010597567`,0.010356483`,0.010788933`,0.011405017`,0.010615433`,0.01080555`,0.01167645`,0.011250467`,0.018022633`,0.017728733`,0.014597433`,0.0154484`,0.015518167`,0.017191933`,0.01578295`,0.015907717`,0.018252217`,0.015915133`,0.01251105`,0.016850833`,0.015415967`,0.016724833`,0.008563483`,0.0087383`,0.008606183`,0.008606183`,0.00962345`,0.007817583`,0.007642267`,0.006309267`,0.0088632`,0.006772417`,0.005280683`,0.007857983`,0.007790517`,0.00817215`,0.0085719`,0.009619817`,0.006665983`,0.010391417`,0.010550983`,0.009526367`,0.0085719`,0.00817215`,0.009278867`,0.010683033`,0.0084818`,0.008225567`,0.008225567`,0.00804705`,0.009660933`,0.0073481`,0.00820895`,0.0073667`,0.00835775`,0.008294383`,0.006581767`},{1/378,0.00837065`,0.008398617`,0.008398617`,0.008392017`,0.007795967`,0.008744933`,0.008637267`,0.0088092`,0.008110183`,0.00883025`,0.008122517`,0.008680833`,0.008979117`,0.008908267`,0.008612183`,0.01133`,0.01140955`,0.0106232`,0.00984555`,0.010418767`,0.008692883`,0.009632067`,0.009753817`,0.0127475`,0.0111672`,0.014960867`,0.010018833`,0.0150469`,0.014876417`,0.015199883`,0.012383417`,0.01323595`,0.01468425`,0.014561917`,0.0086371`,0.01629315`,0.016871167`,0.016246133`,0.01679655`,0.01630435`,0.016508433`,0.017529783`,0.0180007`,0.014170417`,0.01369465`,0.013724933`,0.013981633`,0.009069617`,0.0086371`,0.006369283`,0.008992533`,0.006817`,0.00750465`,0.006376333`,0.011077983`,0.010673317`,0.0086371`,0.008246217`,0.008142217`,0.008925433`,0.00814015`,0.00752525`,0.01443205`,0.01117565`,0.011742933`,0.012817533`,0.011348483`,0.0121341`,0.013115983`,0.0121631`,0.018382933`,0.017278933`,0.012240567`,0.011698133`,0.01497025`,0.016720383`,0.015422883`,0.015248733`,0.01721695`,0.015458617`,0.01242045`,0.016426567`,0.014788583`,0.016749117`,0.009494033`,0.00953955`,0.009499433`,0.009499433`,0.010990667`,0.008276883`,0.007720933`,0.004360967`,0.008507017`,0.006699767`,0.005082583`,0.00781005`,0.00766175`,0.008380467`,0.008744783`,0.0098543`,0.006017567`,0.010719`,0.010777667`,0.0099271`,0.008744783`,0.008380467`,0.008990917`,0.010793083`,0.008609133`,0.00882`,0.00882`,0.0085469`,0.010009967`,0.008171167`,0.008976433`,0.0081569`,0.00857685`,0.008499033`,0.00587685`},{2/783,0.009015629`,0.009054896`,0.009054896`,0.009086546`,0.008536663`,0.008824296`,0.009464246`,0.008893513`,0.010619529`,0.008899063`,0.010269363`,0.010110963`,0.009193529`,0.011470029`,0.010292646`,0.014197813`,0.014204063`,0.014641913`,0.013931763`,0.014266179`,0.012445863`,0.013094296`,0.013913929`,0.015356796`,0.013980979`,0.016631546`,0.012067813`,0.014737629`,0.015052746`,0.016332413`,0.013517879`,0.014242179`,0.014888029`,0.015723329`,0.009263996`,0.013508313`,0.016789746`,0.013638796`,0.016874446`,0.014324896`,0.017314779`,0.013728796`,0.015491763`,0.011186946`,0.011228179`,0.011365513`,0.011350546`,0.009552963`,0.009263996`,0.006014146`,0.008026163`,0.006539046`,0.007382579`,0.006079079`,0.008260529`,0.010016646`,0.009263996`,0.008952229`,0.008822629`,0.009188363`,0.008810246`,0.007836763`,0.014317629`,0.013718979`,0.014761313`,0.017210946`,0.012930246`,0.015147063`,0.015453063`,0.014486179`,0.017795246`,0.016928096`,0.014886013`,0.013422996`,0.016732979`,0.016974879`,0.016893196`,0.016410179`,0.017528563`,0.016814946`,0.012845346`,0.016674079`,0.016724679`,0.016882746`,0.009556846`,0.009512679`,0.009536313`,0.009536313`,0.011124796`,0.009670596`,0.010033179`,0.005065196`,0.009584246`,0.005799846`,0.005592996`,0.005925429`,0.005788013`,0.008104129`,0.008547813`,0.009583446`,0.006340013`,0.010252763`,0.010431279`,0.009349463`,0.008547813`,0.008104129`,0.008573796`,0.010494329`,0.008491596`,0.008441713`,0.008441713`,0.008201729`,0.009586429`,0.009294763`,0.009872179`,0.009319913`,0.010259479`,0.010208046`,0.006326613`},{1/405,0.009558879`,0.009594813`,0.009594813`,0.009574463`,0.008871313`,0.010350663`,0.011395929`,0.010407329`,0.014500063`,0.010467763`,0.014135513`,0.013903563`,0.010407413`,0.014548246`,0.013082913`,0.015602863`,0.015557596`,0.016226329`,0.015171863`,0.015719896`,0.015158796`,0.015432396`,0.015730563`,0.013274213`,0.013496563`,0.013918246`,0.013250796`,0.010311796`,0.010501146`,0.017599579`,0.016336929`,0.016286763`,0.012676263`,0.012245013`,0.010921146`,0.011001363`,0.016274379`,0.011736146`,0.016354779`,0.012748363`,0.016115879`,0.012111579`,0.013016829`,0.010744646`,0.011007179`,0.011185163`,0.011110679`,0.010961563`,0.010921146`,0.008054196`,0.009783796`,0.008632946`,0.009516146`,0.008040629`,0.009272229`,0.010898663`,0.010921146`,0.010686079`,0.010610029`,0.010436963`,0.010571346`,0.009282713`,0.013036929`,0.014604596`,0.015655779`,0.016484229`,0.014235413`,0.017841479`,0.015071363`,0.018175263`,0.017711496`,0.017174196`,0.016714263`,0.016606546`,0.016820146`,0.016914296`,0.016917979`,0.016390129`,0.017525496`,0.016830063`,0.013201763`,0.016533879`,0.016840146`,0.016878596`,0.008261463`,0.008077463`,0.008198779`,0.008198779`,0.010032996`,0.010209163`,0.009773729`,0.006357863`,0.010420429`,0.005716413`,0.006472263`,0.007300113`,0.007250929`,0.008039829`,0.008561463`,0.009580729`,0.006663546`,0.010074063`,0.010400896`,0.009127846`,0.008561463`,0.008039829`,0.008540279`,0.010518863`,0.008587846`,0.008203313`,0.008203313`,0.007978296`,0.009484363`,0.010518663`,0.011370296`,0.010497879`,0.010424863`,0.010365096`,0.008008779`},{7/81,0.012609842`,0.012608942`,0.012608942`,0.012504792`,0.010612925`,0.013292425`,0.012761842`,0.013356475`,0.012695658`,0.013324075`,0.013375142`,0.013661342`,0.012719642`,0.013675225`,0.012283942`,0.012541508`,0.012455392`,0.015014142`,0.012338775`,0.015866158`,0.014083308`,0.015156258`,0.015416892`,0.010040625`,0.010581092`,0.014100292`,0.014037092`,0.010715692`,0.010514608`,0.017093558`,0.016417092`,0.016894575`,0.011772008`,0.011756892`,0.012453042`,0.011135075`,0.015714792`,0.012229792`,0.015832675`,0.012023958`,0.015468175`,0.012590975`,0.012747358`,0.013334092`,0.013195142`,0.013418858`,0.013501425`,0.012575525`,0.012453042`,0.011441342`,0.011930758`,0.011611325`,0.011466442`,0.011422575`,0.012104558`,0.012911992`,0.012453042`,0.012361358`,0.012191225`,0.012956008`,0.012203375`,0.012321308`,0.015123275`,0.015327758`,0.015323508`,0.018649275`,0.014846992`,0.017157992`,0.015577942`,0.018280925`,0.017817342`,0.016116175`,0.016917558`,0.016986808`,0.016496842`,0.017512792`,0.016627542`,0.016084675`,0.017947542`,0.016535875`,0.012550125`,0.017159842`,0.016489408`,0.017427392`,0.008133742`,0.007929192`,0.008065525`,0.008065525`,0.009794625`,0.011228708`,0.010126542`,0.007269708`,0.011534042`,0.005017792`,0.005644508`,0.007602725`,0.007576725`,0.008365525`,0.008735892`,0.009328492`,0.005975975`,0.009922692`,0.010298242`,0.008946708`,0.008735892`,0.008365525`,0.008707075`,0.010414525`,0.008608475`,0.008692692`,0.008692692`,0.008421142`,0.009266608`,0.008601575`,0.009438308`,0.008577542`,0.008894525`,0.008802492`,0.007139542`},{7/162,0.012998896`,0.012959496`,0.012959496`,0.012783679`,0.013508596`,0.013505113`,0.012230363`,0.013531096`,0.012074129`,0.013476163`,0.012522929`,0.012565013`,0.013629529`,0.012123513`,0.011689046`,0.013421729`,0.013403946`,0.013506329`,0.013313413`,0.013111063`,0.012485213`,0.012623396`,0.012711929`,0.012164763`,0.012404596`,0.014336296`,0.015293629`,0.011568046`,0.011521613`,0.016247946`,0.015797313`,0.016062313`,0.013538813`,0.014118629`,0.013480063`,0.013860463`,0.017191513`,0.014628196`,0.017384679`,0.014364996`,0.017601546`,0.015321829`,0.014561929`,0.014172029`,0.013862679`,0.013874846`,0.014031729`,0.013321096`,0.013480063`,0.013392346`,0.013314963`,0.013317446`,0.012465979`,0.013281696`,0.014762429`,0.013274646`,0.013480063`,0.013291179`,0.013189346`,0.013590213`,0.013185929`,0.013642013`,0.014989363`,0.013572763`,0.014051096`,0.016898529`,0.013575696`,0.015797013`,0.014826146`,0.017487913`,0.017920996`,0.017362129`,0.016977863`,0.017087379`,0.017303863`,0.017363046`,0.017420029`,0.017146446`,0.018532763`,0.017429646`,0.011871596`,0.016997779`,0.017263529`,0.017386179`,0.008017813`,0.008057163`,0.008020963`,0.008020963`,0.009769813`,0.010970196`,0.011278279`,0.006025829`,0.009936779`,0.004687746`,0.005595496`,0.008628129`,0.008582513`,0.007698513`,0.008237379`,0.009562029`,0.005542313`,0.009499463`,0.009957396`,0.008582013`,0.008237379`,0.007698513`,0.007851213`,0.010014396`,0.008275879`,0.007521763`,0.007521763`,0.007491563`,0.009183329`,0.009633463`,0.010327146`,0.009664013`,0.010008346`,0.009923129`,0.007128029`},{7/243,0.013108696`,0.013054596`,0.013054596`,0.012847613`,0.013532279`,0.013984929`,0.012252163`,0.014003529`,0.011650396`,0.013975513`,0.012521296`,0.012644513`,0.014116563`,0.012461529`,0.012489496`,0.013183329`,0.013222979`,0.012797763`,0.013177963`,0.013109363`,0.012737513`,0.012912863`,0.012899546`,0.012945463`,0.012573413`,0.014727046`,0.015401696`,0.013580329`,0.013460113`,0.016759179`,0.015829696`,0.015984763`,0.015197046`,0.015760213`,0.014174296`,0.015438846`,0.018458946`,0.016040363`,0.018550229`,0.015855063`,0.018659013`,0.015428163`,0.016480646`,0.013909079`,0.013781896`,0.013681946`,0.013802229`,0.013862579`,0.014174296`,0.014614829`,0.013592346`,0.014550879`,0.013406979`,0.014590679`,0.014996296`,0.012914946`,0.014174296`,0.013985896`,0.013879646`,0.015744196`,0.013910879`,0.014696529`,0.014927029`,0.013068029`,0.013636179`,0.015556279`,0.012444496`,0.016369329`,0.014777729`,0.017112479`,0.016943829`,0.015957596`,0.016514579`,0.016578463`,0.017464463`,0.016720396`,0.017642063`,0.017295329`,0.018435446`,0.017614896`,0.012843363`,0.016459346`,0.017427846`,0.016546779`,0.006237746`,0.006201696`,0.006223829`,0.006223829`,0.007536046`,0.010829363`,0.011124213`,0.007020129`,0.008603563`,0.004246946`,0.006198979`,0.007931096`,0.007971163`,0.007766379`,0.008321996`,0.008823096`,0.006198529`,0.008964246`,0.010092046`,0.007935479`,0.008321996`,0.007766379`,0.008381246`,0.010374913`,0.008379279`,0.007440363`,0.007440363`,0.007316496`,0.008561863`,0.011563629`,0.013042846`,0.011558246`,0.011565646`,0.011453663`,0.007243346`},{7/324,0.014511417`,0.0145515`,0.0145515`,0.014366467`,0.014516467`,0.014371083`,0.01388045`,0.014413217`,0.012651133`,0.014389533`,0.01292125`,0.013081367`,0.014289983`,0.013209483`,0.0126014`,0.014132133`,0.014122733`,0.014366367`,0.01388985`,0.01409035`,0.013291933`,0.0134646`,0.013626817`,0.014107583`,0.013335983`,0.016033817`,0.01239505`,0.013987833`,0.014089083`,0.0166355`,0.0155245`,0.0160539`,0.01330015`,0.013065767`,0.0143313`,0.015983833`,0.017552033`,0.01633855`,0.017565817`,0.016607067`,0.01781505`,0.016481867`,0.017000033`,0.014583983`,0.014543517`,0.01456845`,0.014563633`,0.014435967`,0.0143313`,0.015001467`,0.013789`,0.01503795`,0.013546317`,0.0150096`,0.014827983`,0.013281817`,0.0143313`,0.014270133`,0.014218217`,0.015928083`,0.014163017`,0.014718033`,0.015512467`,0.013872683`,0.01452835`,0.016976333`,0.013932483`,0.016770733`,0.0155408`,0.017417483`,0.01749125`,0.016723067`,0.016319433`,0.015941433`,0.018735183`,0.017918717`,0.018942967`,0.018687483`,0.01867255`,0.018974`,0.01398825`,0.017606`,0.018626583`,0.01737265`,0.006825517`,0.0070892`,0.006895233`,0.006895233`,0.0085145`,0.00988845`,0.009052033`,0.006329033`,0.007737617`,0.004042017`,0.0068887`,0.006844767`,0.0068949`,0.008052783`,0.008616333`,0.01075415`,0.005586333`,0.010673`,0.010968467`,0.009776567`,0.008616333`,0.008052783`,0.008206433`,0.0110796`,0.008687467`,0.008124417`,0.008124417`,0.008005567`,0.010394233`,0.011792`,0.01339105`,0.01179515`,0.0120234`,0.0118649`,0.007809483`},{7/405,0.01466865`,0.014765783`,0.014765783`,0.014723517`,0.0145333`,0.01466285`,0.013936967`,0.014728183`,0.013153733`,0.014644617`,0.013529533`,0.013142767`,0.01452155`,0.014209617`,0.013189767`,0.01460475`,0.01457455`,0.015743133`,0.01408605`,0.016063933`,0.014424917`,0.015331167`,0.015569217`,0.014784683`,0.014119867`,0.01490285`,0.011656017`,0.011890517`,0.012056667`,0.0154631`,0.015255017`,0.016278767`,0.012241267`,0.012963017`,0.014826967`,0.016160817`,0.017392833`,0.0171321`,0.017403833`,0.017066683`,0.017965017`,0.016600667`,0.0176138`,0.015674683`,0.015515267`,0.0154508`,0.015492783`,0.0148497`,0.014826967`,0.016248017`,0.015842367`,0.01624755`,0.015389867`,0.016230433`,0.016336233`,0.0152621`,0.014826967`,0.01451195`,0.01440395`,0.016594483`,0.014400983`,0.015408317`,0.016481367`,0.01524125`,0.015732683`,0.017290567`,0.015062083`,0.01755205`,0.016069783`,0.017015983`,0.018128783`,0.01773505`,0.0135857`,0.013939183`,0.01786005`,0.017542483`,0.01795515`,0.017101617`,0.01859805`,0.017785967`,0.013073883`,0.0171106`,0.017946`,0.017681633`,0.00813245`,0.008308133`,0.008176417`,0.008176417`,0.009171783`,0.007648233`,0.007670467`,0.007843233`,0.007969183`,0.006470133`,0.0070229`,0.00621795`,0.00624275`,0.00972`,0.009844933`,0.011166283`,0.007005017`,0.011022517`,0.01109915`,0.010527417`,0.009844933`,0.00972`,0.009982383`,0.01130805`,0.0095035`,0.011170717`,0.011170717`,0.010647833`,0.010999117`,0.011496367`,0.011929083`,0.011342583`,0.0110175`,0.0109633`,0.00962755`},{7/486,0.01438085`,0.014411967`,0.014411967`,0.014284233`,0.0150066`,0.015080467`,0.014742033`,0.01500135`,0.0136276`,0.014989617`,0.0137902`,0.014283833`,0.015593767`,0.014846617`,0.01343075`,0.01345135`,0.013389433`,0.015519867`,0.013985583`,0.015565567`,0.013774017`,0.0157542`,0.0156661`,0.012997217`,0.0124856`,0.013979667`,0.01063855`,0.012344583`,0.01249615`,0.0152054`,0.015205967`,0.016460183`,0.011457283`,0.0118716`,0.01612735`,0.016806883`,0.016912667`,0.01771665`,0.016903617`,0.0173453`,0.017349883`,0.017263033`,0.017993283`,0.015907483`,0.015855683`,0.01573075`,0.015784433`,0.01579125`,0.01612735`,0.017570033`,0.0164537`,0.01746975`,0.015974033`,0.017558633`,0.017071667`,0.015753567`,0.01612735`,0.015571917`,0.015534833`,0.0176402`,0.0155605`,0.017386683`,0.016543917`,0.015240333`,0.015551917`,0.01687525`,0.015442233`,0.017561467`,0.016022583`,0.01692925`,0.017799567`,0.01810725`,0.0139361`,0.01389505`,0.016666617`,0.016377083`,0.017045683`,0.0162556`,0.017413033`,0.0169082`,0.0111683`,0.016040067`,0.016673133`,0.016278367`,0.009018817`,0.009251667`,0.009078333`,0.009078333`,0.01035185`,0.007978117`,0.006900567`,0.0099596`,0.008264983`,0.007412467`,0.007484683`,0.007766267`,0.007803467`,0.00939395`,0.009395367`,0.011544667`,0.00837995`,0.011603217`,0.0118661`,0.011331183`,0.009395367`,0.00939395`,0.0112981`,0.012180217`,0.008903067`,0.010370683`,0.010370683`,0.0097617`,0.011570967`,0.00839105`,0.008991017`,0.008418617`,0.007866133`,0.007816733`,0.010577433`},{1/81,0.015530158`,0.015552942`,0.015552942`,0.015407192`,0.016282342`,0.014940925`,0.015860458`,0.015031458`,0.012843208`,0.014877942`,0.013447125`,0.014148492`,0.015274758`,0.015800275`,0.013700542`,0.014553158`,0.014468142`,0.016141758`,0.014069508`,0.017076992`,0.014232425`,0.017043442`,0.016807875`,0.013650092`,0.013256825`,0.014914258`,0.012470942`,0.014162825`,0.014219592`,0.016527258`,0.015597492`,0.017337192`,0.013404875`,0.014034408`,0.015530225`,0.017409742`,0.017373358`,0.017870992`,0.017395242`,0.017910792`,0.017711258`,0.017214458`,0.018857525`,0.016300158`,0.016308008`,0.016281042`,0.016282925`,0.015384842`,0.015530225`,0.016544642`,0.015842308`,0.016527475`,0.015507992`,0.016513425`,0.016367142`,0.015243442`,0.015530225`,0.015088692`,0.015027042`,0.017089275`,0.015042592`,0.015933542`,0.016786225`,0.016620142`,0.017369842`,0.017073658`,0.016471425`,0.017914092`,0.017014825`,0.017322925`,0.019023542`,0.019100142`,0.015049308`,0.015751342`,0.016600058`,0.016795342`,0.016687775`,0.016346158`,0.018028075`,0.016675358`,0.011965492`,0.016409508`,0.016575208`,0.016554908`,0.010595808`,0.010804075`,0.010648442`,0.010648442`,0.012191875`,0.009462742`,0.007932442`,0.006793542`,0.008645925`,0.007089025`,0.005604492`,0.008043058`,0.007947725`,0.007020992`,0.007723225`,0.011659092`,0.006219542`,0.011974108`,0.012002642`,0.011841775`,0.007723225`,0.007020992`,0.007110242`,0.012190258`,0.007928508`,0.006635175`,0.006635175`,0.006579458`,0.011846542`,0.006996758`,0.007189942`,0.006988792`,0.006844442`,0.006819158`,0.006522608`},{7/648,0.014680646`,0.014644963`,0.014644963`,0.014481079`,0.015887979`,0.015186796`,0.015644896`,0.015322079`,0.014524296`,0.015155329`,0.014887363`,0.015384746`,0.015229529`,0.015550913`,0.014633446`,0.017948129`,0.017877479`,0.017480346`,0.016867713`,0.017634213`,0.015960796`,0.016870463`,0.017226529`,0.017104229`,0.016835263`,0.017153929`,0.012712046`,0.016148113`,0.016174329`,0.016979513`,0.015632279`,0.017396379`,0.014803196`,0.015527596`,0.014446146`,0.018454279`,0.018158263`,0.018806779`,0.018206446`,0.017770396`,0.018615779`,0.018982979`,0.019115863`,0.016079513`,0.016107529`,0.016240179`,0.016264079`,0.014873463`,0.014446146`,0.016582729`,0.015711263`,0.016631113`,0.015622446`,0.016617613`,0.016733496`,0.015397879`,0.014446146`,0.014091796`,0.013967729`,0.016576346`,0.013963963`,0.014747129`,0.016253996`,0.017298396`,0.017628079`,0.017955829`,0.017749563`,0.017652596`,0.017752596`,0.018100979`,0.019942529`,0.019368946`,0.015394879`,0.015444646`,0.017021479`,0.017863746`,0.017178879`,0.016498696`,0.018710396`,0.017052313`,0.012940946`,0.017480463`,0.017021346`,0.017740829`,0.011312929`,0.011429546`,0.011337546`,0.011337546`,0.012409679`,0.008863146`,0.008391813`,0.003961629`,0.008684846`,0.006561546`,0.003492429`,0.006453213`,0.006322129`,0.006257613`,0.007299013`,0.011698579`,0.005218246`,0.011899129`,0.011821229`,0.011597629`,0.007299013`,0.006257613`,0.005783779`,0.012001263`,0.007827663`,0.005433696`,0.005433696`,0.005427046`,0.011752613`,0.007387613`,0.007719296`,0.007412496`,0.007644029`,0.007567746`,0.004974679`},{7/729,0.016583`,0.016663733`,0.016663733`,0.016649733`,0.0169966`,0.017007`,0.016823433`,0.016998233`,0.016789117`,0.016889033`,0.016415217`,0.016767033`,0.017437667`,0.017368033`,0.017006317`,0.01781555`,0.0177571`,0.018663183`,0.0176574`,0.018133983`,0.017512617`,0.018248667`,0.0182146`,0.015041333`,0.016486117`,0.015605433`,0.013299083`,0.0103177`,0.010778733`,0.01762415`,0.0161464`,0.0181198`,0.013123733`,0.012929983`,0.016846367`,0.017473833`,0.018142267`,0.0175746`,0.01821105`,0.01787`,0.01861305`,0.019445717`,0.018528467`,0.016374667`,0.016292533`,0.016369817`,0.016451617`,0.017278733`,0.016846367`,0.015984883`,0.015793467`,0.015968933`,0.015192917`,0.0159396`,0.0177068`,0.0159233`,0.016846367`,0.016651883`,0.01649625`,0.016873883`,0.016466667`,0.01614735`,0.017328433`,0.017683033`,0.018000467`,0.018780417`,0.017885783`,0.017853917`,0.0179752`,0.017343167`,0.020474933`,0.020033183`,0.014891683`,0.014722117`,0.017164317`,0.017677833`,0.017325517`,0.016624433`,0.0181488`,0.01719935`,0.012578517`,0.017394383`,0.017171833`,0.017304183`,0.011270133`,0.011422833`,0.011304967`,0.011304967`,0.012671067`,0.008485567`,0.007235`,0.004316583`,0.010013783`,0.0082767`,0.003821717`,0.007985217`,0.007861183`,0.00711765`,0.007883217`,0.011707733`,0.005237783`,0.01177475`,0.011460617`,0.0112251`,0.007883217`,0.00711765`,0.00633635`,0.01156565`,0.00813915`,0.006409167`,0.006409167`,0.006578467`,0.011554417`,0.007505933`,0.0084863`,0.007527733`,0.00780095`,0.007695683`,0.0062983`},{7/810,0.014498613`,0.014530113`,0.014530113`,0.014450113`,0.015574146`,0.016542463`,0.015786913`,0.016449779`,0.011622563`,0.016406129`,0.013539046`,0.015793296`,0.016991163`,0.015838579`,0.014491779`,0.012639513`,0.012573796`,0.017096946`,0.010183213`,0.018005013`,0.013018913`,0.017195379`,0.017226896`,0.009273629`,0.010668729`,0.013392379`,0.013076929`,0.009657029`,0.009624313`,0.017261396`,0.016558479`,0.018176446`,0.012606763`,0.012640513`,0.016684613`,0.016522696`,0.017742579`,0.016612929`,0.017720346`,0.017804663`,0.017922096`,0.018855646`,0.018563996`,0.016129296`,0.015969729`,0.016098563`,0.016117263`,0.016698513`,0.016684613`,0.017132513`,0.015960763`,0.017041479`,0.016114946`,0.017121913`,0.017637679`,0.015420396`,0.016684613`,0.016438679`,0.016310513`,0.018918346`,0.016282796`,0.016731063`,0.017473429`,0.018037179`,0.018618679`,0.017922613`,0.018702979`,0.018093129`,0.019263096`,0.017567529`,0.020403663`,0.020239046`,0.015354263`,0.014568663`,0.017253763`,0.017631379`,0.017380879`,0.016662979`,0.019466029`,0.017251663`,0.012793513`,0.017266496`,0.017273463`,0.017073063`,0.011323013`,0.011553613`,0.011379496`,0.011379496`,0.013504179`,0.010045163`,0.009158229`,0.005572796`,0.010497979`,0.007120346`,0.004117879`,0.008068479`,0.007860479`,0.007312779`,0.007942113`,0.011230963`,0.004267379`,0.011518996`,0.011486863`,0.010777896`,0.007942113`,0.007312779`,0.006764396`,0.011622229`,0.008069046`,0.006939713`,0.006939713`,0.006992796`,0.011078963`,0.007293013`,0.008040113`,0.007257063`,0.007429946`,0.007437396`,0.006963363`},{7/891,0.011358529`,0.011296679`,0.011296679`,0.011117179`,0.012537763`,0.012855963`,0.012362013`,0.012831513`,0.009968313`,0.012872879`,0.011275429`,0.012049063`,0.012617329`,0.010448479`,0.010320063`,0.011615179`,0.011634713`,0.012207313`,0.011184613`,0.013504663`,0.009745513`,0.011073746`,0.011559029`,0.012407413`,0.011353663`,0.018254163`,0.012240113`,0.016374329`,0.016027963`,0.018184746`,0.016840179`,0.015330863`,0.014422246`,0.014447829`,0.012369896`,0.018143946`,0.017130513`,0.018302996`,0.017120879`,0.018610146`,0.017268613`,0.018457796`,0.018721546`,0.016298229`,0.016425146`,0.016464046`,0.016358846`,0.012045479`,0.012369896`,0.017624446`,0.017961963`,0.017504213`,0.016548813`,0.017503263`,0.018913646`,0.017430213`,0.012369896`,0.012014579`,0.012005413`,0.018000129`,0.011975096`,0.014733979`,0.017001979`,0.015772579`,0.015604979`,0.018141696`,0.017831429`,0.018608813`,0.017423796`,0.017597979`,0.020220863`,0.018605529`,0.014179796`,0.014340363`,0.016213146`,0.016475746`,0.016341429`,0.015633879`,0.019098129`,0.016219696`,0.011523629`,0.016087746`,0.016246563`,0.016602913`,0.012574346`,0.012736429`,0.012609046`,0.012609046`,0.013787329`,0.009445329`,0.008564446`,0.006114863`,0.010428013`,0.006925929`,0.003611446`,0.007530079`,0.007383596`,0.007202879`,0.007853979`,0.010782746`,0.003422779`,0.011083546`,0.011211946`,0.009970413`,0.007853979`,0.007202879`,0.006279279`,0.011276646`,0.007997013`,0.006803413`,0.006803413`,0.006877429`,0.010455763`,0.007599313`,0.008322213`,0.007596663`,0.007526979`,0.007494863`,0.005776179`},{7/972,0.011681571`,0.011603638`,0.011603638`,0.011444588`,0.012362688`,0.012230738`,0.013029938`,0.012280271`,0.011350004`,0.012237771`,0.012028638`,0.012717254`,0.012450354`,0.012235638`,0.012061388`,0.015725521`,0.015812704`,0.014136354`,0.014220371`,0.014130121`,0.011695671`,0.012752971`,0.013026504`,0.017437771`,0.015361371`,0.018528588`,0.011706654`,0.017906654`,0.017855154`,0.018208604`,0.016417454`,0.018218454`,0.013932538`,0.013893888`,0.012359471`,0.018103771`,0.017982238`,0.018680721`,0.018058471`,0.017938838`,0.018135871`,0.017944888`,0.018047388`,0.017458554`,0.017560754`,0.017626538`,0.017538488`,0.012362271`,0.012359471`,0.017719021`,0.018296021`,0.017712204`,0.017275421`,0.017600554`,0.019124821`,0.017558638`,0.012359471`,0.012005238`,0.012029688`,0.014401354`,0.011971621`,0.013940104`,0.017795438`,0.015892254`,0.016163621`,0.017616438`,0.017973121`,0.017928004`,0.016751754`,0.018480371`,0.018734971`,0.017776404`,0.014161321`,0.013929654`,0.016194138`,0.016823638`,0.016414438`,0.015819288`,0.019065721`,0.016348954`,0.011156721`,0.016465938`,0.016203354`,0.016503488`,0.013247154`,0.013260888`,0.013232821`,0.013232821`,0.013932404`,0.010099621`,0.009294388`,0.005457354`,0.009522738`,0.010193971`,0.002795938`,0.007777004`,0.007584688`,0.007397938`,0.007985138`,0.010698771`,0.003763621`,0.011039588`,0.011350938`,0.010044021`,0.007985138`,0.007397938`,0.006628104`,0.011501821`,0.008064104`,0.007065888`,0.007065888`,0.007055754`,0.010454921`,0.008058321`,0.008624871`,0.008039004`,0.008425838`,0.008444138`,0.007009588`},{7/1053,0.014213942`,0.014223292`,0.014223292`,0.014128342`,0.014925308`,0.014821492`,0.014276525`,0.014816592`,0.013593592`,0.014779075`,0.013536142`,0.013698808`,0.015247892`,0.014960675`,0.015145142`,0.020263142`,0.020159875`,0.018970525`,0.018068642`,0.017254792`,0.016020525`,0.016719925`,0.017290275`,0.018917008`,0.018495042`,0.018905842`,0.011439292`,0.015464975`,0.015461458`,0.018440442`,0.016630342`,0.019707392`,0.013574108`,0.013891008`,0.015574108`,0.018465692`,0.017892458`,0.018595758`,0.017946075`,0.017884092`,0.018248275`,0.019766892`,0.019177692`,0.016464192`,0.016634908`,0.016750842`,0.016629525`,0.015653425`,0.015574108`,0.017829258`,0.017641175`,0.017918542`,0.017198208`,0.017730742`,0.018459275`,0.015969075`,0.015574108`,0.015084775`,0.015044908`,0.017437058`,0.015050475`,0.016317358`,0.018353892`,0.017727208`,0.018532242`,0.018268592`,0.017445892`,0.018962492`,0.017744825`,0.019405375`,0.018978492`,0.018654125`,0.014844492`,0.014792608`,0.017146308`,0.017784492`,0.017404175`,0.016629592`,0.018162475`,0.017292025`,0.010956958`,0.017500525`,0.017209158`,0.017375725`,0.011767325`,0.011876708`,0.011782858`,0.011782858`,0.012155358`,0.009595525`,0.010940208`,0.004998142`,0.008490542`,0.010499675`,0.003042692`,0.008636158`,0.008514592`,0.007086475`,0.007803642`,0.010643258`,0.003340525`,0.010875192`,0.011197308`,0.009685808`,0.007803642`,0.007086475`,0.006110258`,0.011408875`,0.008014192`,0.006216558`,0.006216558`,0.006441742`,0.010241642`,0.008724558`,0.008875375`,0.008794108`,0.009204658`,0.009216925`,0.007653158`},{1/162,0.0117012`,0.011772383`,0.011772383`,0.011665167`,0.01254915`,0.013122967`,0.011528417`,0.0128737`,0.010477`,0.013084917`,0.011463083`,0.0120663`,0.0141754`,0.014600217`,0.012943917`,0.0145289`,0.014532633`,0.0182641`,0.01055575`,0.018122333`,0.013409967`,0.01673975`,0.016878583`,0.013540533`,0.01229995`,0.018313417`,0.01168425`,0.013839183`,0.013571083`,0.018169183`,0.017934917`,0.01901065`,0.012713583`,0.01323415`,0.01473445`,0.019634467`,0.01789825`,0.018929733`,0.0179347`,0.0190402`,0.018469467`,0.019714683`,0.020242417`,0.015724967`,0.0157236`,0.015903083`,0.015849417`,0.014573867`,0.01473445`,0.016892`,0.015487967`,0.016847383`,0.015642233`,0.016823533`,0.01682555`,0.0151228`,0.01473445`,0.014402417`,0.014437617`,0.017744583`,0.014363917`,0.015772183`,0.017948917`,0.0186786`,0.019776333`,0.0184513`,0.017900283`,0.0200774`,0.01811365`,0.01997585`,0.0190185`,0.0190169`,0.014917717`,0.01515215`,0.016831883`,0.017649483`,0.017021083`,0.0163984`,0.018548683`,0.01694825`,0.011717383`,0.01725335`,0.0168908`,0.017221583`,0.010404767`,0.01049555`,0.010415733`,0.010415733`,0.011248033`,0.009512867`,0.010087233`,0.004900483`,0.00888055`,0.008640283`,0.00389375`,0.00541745`,0.005297483`,0.0071821`,0.00797845`,0.010641517`,0.004229683`,0.0106453`,0.011155117`,0.009442183`,0.00797845`,0.0071821`,0.006378367`,0.011377933`,0.008264017`,0.006494933`,0.006494933`,0.006544083`,0.010125967`,0.00921955`,0.009846067`,0.009227617`,0.009458783`,0.009383017`,0.007033567`},{7/1215,0.009814683`,0.009867767`,0.009867767`,0.009840583`,0.010273233`,0.010162517`,0.01027235`,0.010111717`,0.00928465`,0.010234283`,0.010207017`,0.010760667`,0.0099199`,0.009493117`,0.009431717`,0.013191783`,0.013156783`,0.013769917`,0.010461833`,0.012339117`,0.009506317`,0.010262883`,0.010925883`,0.011966283`,0.011188367`,0.017868667`,0.012406`,0.013053317`,0.012682817`,0.018644783`,0.017899833`,0.0193764`,0.015945183`,0.015658583`,0.009593283`,0.019481533`,0.01858235`,0.018905683`,0.018609233`,0.0192302`,0.019256217`,0.021053583`,0.020614117`,0.0169278`,0.016987417`,0.017222417`,0.017194517`,0.00977995`,0.009593283`,0.012701717`,0.014285767`,0.012655017`,0.012475767`,0.012434117`,0.016425917`,0.015084133`,0.009593283`,0.0090903`,0.009112167`,0.012972583`,0.009063217`,0.010459883`,0.018166583`,0.014467383`,0.01667605`,0.018513767`,0.018146017`,0.019685583`,0.0197894`,0.0189496`,0.018850083`,0.01914905`,0.014307567`,0.01485`,0.016019383`,0.017128033`,0.016194583`,0.0154311`,0.0184385`,0.016061517`,0.01155475`,0.016689533`,0.016093217`,0.016779683`,0.01111865`,0.01125325`,0.011143133`,0.011143133`,0.0120846`,0.008632933`,0.008011767`,0.005209983`,0.008905217`,0.008535667`,0.00414615`,0.0049476`,0.00483745`,0.007521583`,0.008220233`,0.0110033`,0.00432035`,0.011023833`,0.011317783`,0.010161683`,0.008220233`,0.007521583`,0.00652435`,0.011475133`,0.008407683`,0.0064697`,0.0064697`,0.006795733`,0.010695`,0.010094633`,0.011095383`,0.010130017`,0.01048095`,0.0103755`,0.00799095`},{7/1296,0.009285158`,0.009294992`,0.009294992`,0.009241108`,0.009851708`,0.009656792`,0.009517125`,0.009492558`,0.009110292`,0.009689992`,0.009520375`,0.009871575`,0.010589408`,0.011701208`,0.010237742`,0.013758308`,0.013659925`,0.015582075`,0.011617408`,0.014649975`,0.011177375`,0.012324392`,0.013631025`,0.011840408`,0.012181192`,0.014700425`,0.013652042`,0.012856558`,0.012677175`,0.018722358`,0.018269825`,0.018405992`,0.017022458`,0.015735542`,0.011056775`,0.020245425`,0.019064408`,0.019379292`,0.019193925`,0.019557442`,0.019657342`,0.021193058`,0.020477908`,0.017841942`,0.017774358`,0.017950508`,0.017987875`,0.011353208`,0.011056775`,0.014510258`,0.016774042`,0.014435042`,0.014262508`,0.014300325`,0.018551392`,0.016477742`,0.011056775`,0.010757608`,0.010741275`,0.012257342`,0.010683725`,0.011534608`,0.018656775`,0.016079675`,0.017348042`,0.017782258`,0.018147808`,0.019089992`,0.019155825`,0.017802325`,0.018417025`,0.019592942`,0.013181292`,0.013885592`,0.015338275`,0.016567042`,0.015542692`,0.014607442`,0.018755975`,0.015355758`,0.011179758`,0.016197492`,0.015407558`,0.015890292`,0.012455075`,0.011931842`,0.012283575`,0.012283575`,0.012368808`,0.010044842`,0.009686708`,0.005256358`,0.009562775`,0.009114708`,0.004788092`,0.006293008`,0.006141742`,0.007898308`,0.008399558`,0.011240525`,0.004792725`,0.011600725`,0.011799108`,0.010999558`,0.008399558`,0.007898308`,0.007162008`,0.011995258`,0.008395208`,0.007678475`,0.007678475`,0.007697542`,0.011208758`,0.011057342`,0.011688825`,0.011098308`,0.011880592`,0.011731858`,0.008113608`},{7/1377,0.010078254`,0.010059738`,0.010059738`,0.009959388`,0.010756704`,0.011241671`,0.009948421`,0.010865871`,0.010616904`,0.011193088`,0.010066104`,0.009910521`,0.012856221`,0.012112338`,0.010957638`,0.013089071`,0.013084254`,0.014102288`,0.012260088`,0.016252821`,0.011689904`,0.013421654`,0.014874721`,0.013179204`,0.013535554`,0.014783354`,0.013810971`,0.014936604`,0.014839821`,0.017635904`,0.017566321`,0.017266971`,0.016425254`,0.015284571`,0.013602854`,0.020185804`,0.019563888`,0.020490888`,0.019669204`,0.019234454`,0.020029921`,0.021067938`,0.020069488`,0.017418688`,0.017153654`,0.017375654`,0.017446188`,0.013477521`,0.013602854`,0.016293438`,0.016539121`,0.016217654`,0.015138171`,0.016227854`,0.018713154`,0.015745454`,0.013602854`,0.013214188`,0.013219421`,0.015859838`,0.013192388`,0.014424638`,0.018920871`,0.017329888`,0.017108338`,0.018011904`,0.016971638`,0.018985838`,0.018659121`,0.017533971`,0.019742371`,0.020007154`,0.012575721`,0.014058021`,0.015317854`,0.017271221`,0.015624488`,0.014577571`,0.019343871`,0.015405104`,0.011351688`,0.016859688`,0.015329938`,0.016620671`,0.010847771`,0.010680304`,0.010784221`,0.010784221`,0.012136154`,0.010993838`,0.010186154`,0.005982088`,0.009977004`,0.009880404`,0.004174704`,0.008685888`,0.008504904`,0.008108204`,0.008567838`,0.010875171`,0.004880288`,0.011244621`,0.011394304`,0.010604588`,0.008567838`,0.008108204`,0.007453738`,0.011482288`,0.008512954`,0.008027871`,0.008027871`,0.007950971`,0.010840238`,0.011501404`,0.011471904`,0.011546004`,0.012420388`,0.012339621`,0.008164571`},{7/1458,0.012373496`,0.012426679`,0.012426679`,0.012369179`,0.012943996`,0.013285229`,0.011626946`,0.013248346`,0.011926946`,0.013345013`,0.011313763`,0.010917463`,0.013431796`,0.012601279`,0.011403813`,0.014028229`,0.014031546`,0.014095413`,0.013654763`,0.015139196`,0.012794713`,0.013765129`,0.014559646`,0.014241546`,0.014456229`,0.015971463`,0.015467363`,0.013017296`,0.013241329`,0.018334979`,0.017256263`,0.016729379`,0.017031229`,0.017061079`,0.013800263`,0.019522696`,0.019183429`,0.020001096`,0.019217663`,0.019319596`,0.019467896`,0.021317796`,0.020008796`,0.017268063`,0.017370379`,0.017317346`,0.017221579`,0.013661929`,0.013800263`,0.014608563`,0.015395163`,0.014602829`,0.013446213`,0.014790613`,0.018199879`,0.016952296`,0.013800263`,0.013295446`,0.013277946`,0.015574179`,0.013270729`,0.014715879`,0.017174979`,0.015705229`,0.016142313`,0.019257363`,0.016330629`,0.018139096`,0.016968129`,0.017803413`,0.020104113`,0.019999163`,0.012670979`,0.013485513`,0.015730896`,0.017456846`,0.016002446`,0.014766763`,0.019416646`,0.015734496`,0.011347679`,0.017007529`,0.015794646`,0.016941729`,0.011384563`,0.011239629`,0.011326429`,0.011326429`,0.012815479`,0.010908363`,0.011171179`,0.006028996`,0.008502529`,0.007755079`,0.004160663`,0.007822896`,0.007711413`,0.008026963`,0.008459046`,0.010529279`,0.005208246`,0.010759113`,0.010994113`,0.009985863`,0.008459046`,0.008026963`,0.007492096`,0.011146513`,0.008385646`,0.007860029`,0.007860029`,0.007766213`,0.010367346`,0.010777963`,0.010844563`,0.010821529`,0.011379329`,0.011316579`,0.008214696`},{7/1539,0.014208692`,0.014228758`,0.014228758`,0.014116308`,0.014436325`,0.014259542`,0.013157292`,0.014247125`,0.013704542`,0.014312742`,0.012886642`,0.012965325`,0.014259592`,0.014042808`,0.012608092`,0.016660908`,0.016577642`,0.016205875`,0.015068008`,0.015259542`,0.014130325`,0.013919425`,0.014730842`,0.015782175`,0.015821758`,0.015977858`,0.014450075`,0.013282542`,0.013306508`,0.018842592`,0.017235692`,0.018418175`,0.016332792`,0.016193425`,0.013653892`,0.019563425`,0.018788742`,0.019952942`,0.018854792`,0.019390058`,0.019140375`,0.020137625`,0.019423492`,0.016677325`,0.017039125`,0.016986142`,0.016787808`,0.013720958`,0.013653892`,0.016012292`,0.016364108`,0.016072908`,0.015643658`,0.015809658`,0.017180342`,0.016737758`,0.013653892`,0.013190192`,0.013163625`,0.014720442`,0.013151092`,0.014040608`,0.017471008`,0.015753125`,0.016295275`,0.018678425`,0.017400025`,0.019487475`,0.017450908`,0.018067025`,0.020189108`,0.020156342`,0.013362208`,0.013856258`,0.016637925`,0.017764308`,0.016893308`,0.015745875`,0.019184025`,0.016653758`,0.011467692`,0.017390625`,0.016739875`,0.017412775`,0.011198142`,0.011007525`,0.011126825`,0.011126825`,0.013523275`,0.009377942`,0.009108408`,0.005567742`,0.007048958`,0.005816442`,0.003595492`,0.007335125`,0.007279275`,0.007912425`,0.008411875`,0.010325342`,0.005084208`,0.010558075`,0.011020142`,0.009477258`,0.008411875`,0.007912425`,0.007235108`,0.011177592`,0.008403008`,0.007229308`,0.007229308`,0.007397808`,0.009994275`,0.010369692`,0.011170858`,0.010433758`,0.011128142`,0.011019408`,0.008062308`},{7/1620,0.014495538`,0.014431988`,0.014431988`,0.014124354`,0.015199021`,0.015957138`,0.014883204`,0.016066288`,0.014571054`,0.015969471`,0.015034904`,0.014780038`,0.015955971`,0.016683021`,0.015731838`,0.015186504`,0.015206804`,0.017480721`,0.015391054`,0.017587738`,0.015855388`,0.017108471`,0.017026938`,0.015288254`,0.015811904`,0.014771738`,0.013431788`,0.014008521`,0.013855954`,0.017875204`,0.017889671`,0.019196288`,0.016192271`,0.015581171`,0.016648321`,0.018767121`,0.018951588`,0.019105171`,0.019083004`,0.018237854`,0.019349054`,0.019749704`,0.018330088`,0.017608788`,0.017646838`,0.017774488`,0.017748138`,0.016607454`,0.016648321`,0.017458838`,0.018020304`,0.017651554`,0.017365371`,0.017412004`,0.018350538`,0.017230871`,0.016648321`,0.016220921`,0.016122088`,0.017074004`,0.016116354`,0.016040421`,0.018835354`,0.017630454`,0.018552138`,0.017689988`,0.017915271`,0.019550138`,0.018676871`,0.018484371`,0.019382671`,0.019993554`,0.012995171`,0.014106588`,0.016218804`,0.017187354`,0.016399788`,0.015305954`,0.019554021`,0.016171938`,0.011575871`,0.016797588`,0.016291438`,0.016975371`,0.010829571`,0.010805188`,0.010810054`,0.010810054`,0.012990988`,0.005976254`,0.005369104`,0.005210271`,0.006743654`,0.005498354`,0.004155638`,0.005226504`,0.005231388`,0.007944921`,0.008568321`,0.010096604`,0.004997171`,0.010265071`,0.011089188`,0.009183254`,0.008568321`,0.007944921`,0.006975254`,0.011355488`,0.008681838`,0.007555871`,0.007555871`,0.007632854`,0.009742621`,0.010407888`,0.011298354`,0.010403354`,0.011437638`,0.011364771`,0.008074654`},{1/243,0.015732863`,0.015747946`,0.015747946`,0.015492746`,0.016581846`,0.017180946`,0.014750446`,0.016997913`,0.014306529`,0.017044779`,0.014545496`,0.013330979`,0.017781979`,0.015005963`,0.014628746`,0.013379363`,0.013272929`,0.015060763`,0.012748946`,0.015275479`,0.014501863`,0.015148963`,0.014828429`,0.011720446`,0.012136729`,0.012238879`,0.013965613`,0.012112696`,0.011965729`,0.015188663`,0.014841779`,0.015957363`,0.013593263`,0.012764063`,0.016716196`,0.018430113`,0.018106113`,0.018649063`,0.018200029`,0.017875629`,0.018554946`,0.020065696`,0.017767379`,0.016326229`,0.016480729`,0.016638779`,0.016544229`,0.017064529`,0.016716196`,0.017834496`,0.016433779`,0.017820363`,0.016134979`,0.017827879`,0.017071496`,0.015245413`,0.016716196`,0.016063879`,0.015875346`,0.019446396`,0.015975379`,0.017304679`,0.017541929`,0.015908046`,0.015992563`,0.018461313`,0.017066846`,0.020503679`,0.017228696`,0.019606113`,0.019129629`,0.019335229`,0.012460896`,0.015219213`,0.015576296`,0.017201063`,0.015814746`,0.014443429`,0.018908613`,0.015509263`,0.010352263`,0.016825396`,0.015664779`,0.016787129`,0.010727813`,0.010659229`,0.010693746`,0.010693746`,0.012387696`,0.005432263`,0.004817863`,0.005857479`,0.005895679`,0.006043729`,0.004279279`,0.005961196`,0.005984513`,0.008026713`,0.008597396`,0.010701429`,0.004974929`,0.010905229`,0.011295746`,0.009691579`,0.008597396`,0.008026713`,0.006854213`,0.011527879`,0.008661629`,0.007518879`,0.007518879`,0.007633496`,0.010294596`,0.009424746`,0.010413996`,0.009465946`,0.010286096`,0.010169246`,0.007843079`},{7/1782,0.014313275`,0.014379725`,0.014379725`,0.014185558`,0.015151308`,0.013825925`,0.012428008`,0.013716125`,0.009330425`,0.013812092`,0.010124158`,0.011235408`,0.013654942`,0.011645975`,0.011238342`,0.009801758`,0.009778158`,0.011306525`,0.007816342`,0.013272758`,0.010718542`,0.012580308`,0.012537658`,0.009655325`,0.009180375`,0.012744992`,0.014679075`,0.011180225`,0.010942575`,0.016112175`,0.015340825`,0.015115625`,0.013626258`,0.012416825`,0.012897725`,0.018536742`,0.017689425`,0.018963808`,0.017721642`,0.017424025`,0.017828342`,0.020118325`,0.017144825`,0.014438742`,0.014394358`,0.014623425`,0.014622758`,0.013155842`,0.012897725`,0.013254942`,0.012355075`,0.013273258`,0.012411342`,0.013246792`,0.013453025`,0.012432242`,0.012897725`,0.012439442`,0.012346692`,0.017144125`,0.012335342`,0.012996308`,0.016651842`,0.013968108`,0.013834758`,0.016670875`,0.015620842`,0.016814958`,0.015165808`,0.017683575`,0.020173342`,0.019588592`,0.010662092`,0.016714642`,0.015421592`,0.017067925`,0.015640508`,0.014118792`,0.019260492`,0.015288975`,0.009004175`,0.016630608`,0.015534975`,0.016904975`,0.010262692`,0.010028125`,0.010177675`,0.010177675`,0.011854425`,0.005974375`,0.005847558`,0.004960875`,0.005960075`,0.006647142`,0.004119325`,0.005827525`,0.005848542`,0.007589625`,0.008249158`,0.010879392`,0.004372625`,0.011090892`,0.011345008`,0.009978442`,0.008249158`,0.007589625`,0.006186475`,0.011571025`,0.008401458`,0.006525558`,0.006525558`,0.006898225`,0.010530392`,0.009518708`,0.010126908`,0.009507142`,0.010901692`,0.010756075`,0.006850792`},{7/1863,0.010297913`,0.010295596`,0.010295596`,0.010119896`,0.011120996`,0.009462563`,0.008682296`,0.009425796`,0.007154996`,0.009534946`,0.007845396`,0.008354379`,0.009768863`,0.008590079`,0.007871629`,0.010006963`,0.009969679`,0.010679713`,0.008944763`,0.011296096`,0.008029846`,0.010705396`,0.010488296`,0.009971529`,0.009836196`,0.014089246`,0.016194046`,0.012646496`,0.012502279`,0.017515896`,0.017240163`,0.015170396`,0.015664996`,0.014409346`,0.010436696`,0.018903929`,0.018172979`,0.019200129`,0.018210396`,0.018379013`,0.018673996`,0.020450279`,0.018288996`,0.012153396`,0.012313313`,0.012265763`,0.012160896`,0.010087829`,0.010436696`,0.014679513`,0.014314679`,0.014626646`,0.013895146`,0.014588913`,0.016035596`,0.014237996`,0.010436696`,0.009896846`,0.009937813`,0.015155413`,0.009907746`,0.012497296`,0.013590129`,0.012730346`,0.012990679`,0.016560629`,0.013794729`,0.017146396`,0.013944096`,0.018327196`,0.020628429`,0.020079296`,0.011260163`,0.014250479`,0.015037513`,0.017054729`,0.015142096`,0.013773329`,0.018812646`,0.014821596`,0.009619463`,0.016601379`,0.015177246`,0.017018663`,0.009793829`,0.009550013`,0.009708363`,0.009708363`,0.011498796`,0.006948646`,0.007207013`,0.004410896`,0.006709113`,0.006477646`,0.004269196`,0.005729496`,0.005676479`,0.008112246`,0.008586746`,0.010535246`,0.004488446`,0.010796863`,0.011059129`,0.009587529`,0.008586746`,0.008112246`,0.006989979`,0.011189279`,0.008558446`,0.007759979`,0.007759979`,0.007911296`,0.010150229`,0.009801863`,0.010479763`,0.009823613`,0.010676163`,0.010622696`,0.008092229`},{7/1944,0.008979546`,0.008972596`,0.008972596`,0.008861463`,0.009883813`,0.010698629`,0.009349979`,0.010487829`,0.008550479`,0.010734429`,0.008774979`,0.008646546`,0.010997329`,0.010539346`,0.009421813`,0.012389179`,0.012396429`,0.013393329`,0.010540779`,0.013972546`,0.010203379`,0.012409729`,0.012999579`,0.012083663`,0.011765879`,0.014034996`,0.014412946`,0.014276196`,0.014249229`,0.017560896`,0.017274113`,0.016138529`,0.015563013`,0.015181513`,0.010858063`,0.018153763`,0.018213713`,0.018841796`,0.018274813`,0.017591246`,0.018681529`,0.018385913`,0.017578113`,0.014469263`,0.014916596`,0.014673896`,0.014484963`,0.010640113`,0.010858063`,0.015222396`,0.015814196`,0.015380729`,0.015186679`,0.015027629`,0.017873896`,0.016668913`,0.010858063`,0.010258579`,0.010384546`,0.013120663`,0.010312013`,0.012448663`,0.015268313`,0.014939713`,0.014939146`,0.017534896`,0.016153863`,0.019962113`,0.017014113`,0.018801446`,0.019799179`,0.019650246`,0.010666929`,0.012602629`,0.014308113`,0.015241429`,0.014415596`,0.013003946`,0.018251829`,0.014083379`,0.009895029`,0.014889446`,0.014280163`,0.014847746`,0.010019546`,0.009891796`,0.009967996`,0.009967996`,0.012532296`,0.008356363`,0.007210713`,0.004177196`,0.007532579`,0.005272129`,0.004170013`,0.006315613`,0.006283096`,0.008158546`,0.008604013`,0.010548863`,0.005156296`,0.010826513`,0.011035563`,0.009667979`,0.008604013`,0.008158546`,0.007408013`,0.011111796`,0.008538046`,0.007821296`,0.007821296`,0.007885496`,0.010194779`,0.009748413`,0.010333963`,0.009771713`,0.010788696`,0.010699063`,0.008702163`},{7/2025,0.009897804`,0.009877204`,0.009877204`,0.009724438`,0.010812288`,0.012093671`,0.010661054`,0.012064854`,0.011301988`,0.012184888`,0.011718404`,0.011420088`,0.012120488`,0.013958488`,0.011298788`,0.013981621`,0.013958954`,0.015270571`,0.012403338`,0.016342654`,0.012754821`,0.014780488`,0.015326488`,0.014220404`,0.013943121`,0.015337238`,0.013144854`,0.013232354`,0.013431171`,0.018322654`,0.016777821`,0.017436571`,0.015933421`,0.015644904`,0.013349504`,0.017836138`,0.018461871`,0.018088654`,0.018557254`,0.018180654`,0.019095171`,0.018683304`,0.018509588`,0.016201388`,0.016209471`,0.016306471`,0.016263571`,0.013449738`,0.013349504`,0.016097488`,0.017688738`,0.016074504`,0.015862838`,0.015919571`,0.018801721`,0.017418738`,0.013349504`,0.012529954`,0.012658371`,0.015903721`,0.012627738`,0.014344571`,0.017605121`,0.016801171`,0.015956771`,0.017882154`,0.017170721`,0.018484654`,0.017219888`,0.019907738`,0.018829388`,0.018096788`,0.011466271`,0.012501971`,0.015276354`,0.017284904`,0.015415538`,0.014049638`,0.019542388`,0.015099371`,0.009501888`,0.016873838`,0.015325304`,0.016858004`,0.011287138`,0.011184304`,0.011242521`,0.011242521`,0.014374588`,0.009311304`,0.009681071`,0.005930471`,0.007734888`,0.005194371`,0.003640421`,0.006533471`,0.006520088`,0.007907538`,0.008407054`,0.010718971`,0.005326721`,0.011021104`,0.011141354`,0.009927871`,0.008407054`,0.007907538`,0.006867071`,0.011164988`,0.008398804`,0.007287621`,0.007287621`,0.007465404`,0.010415421`,0.011096421`,0.011547904`,0.011148038`,0.012642221`,0.012500121`,0.008278921`},{7/2106,0.0108927`,0.010915217`,0.010915217`,0.010848833`,0.011441133`,0.014345667`,0.01210315`,0.014118283`,0.01361955`,0.014305083`,0.013643067`,0.012627817`,0.015122017`,0.016019833`,0.01326395`,0.01535455`,0.0152814`,0.01735155`,0.013922283`,0.016843667`,0.015624683`,0.0172624`,0.01723485`,0.0135361`,0.013621033`,0.013386283`,0.0138131`,0.00876345`,0.008781233`,0.017503267`,0.016830933`,0.018840017`,0.013292017`,0.012407933`,0.016120283`,0.018224117`,0.01667435`,0.018451267`,0.016664517`,0.017909917`,0.017149233`,0.018475483`,0.018465117`,0.015729717`,0.0157205`,0.015699617`,0.015662383`,0.015772883`,0.016120283`,0.016748467`,0.01779085`,0.0170112`,0.0166598`,0.016623083`,0.01838545`,0.0169647`,0.016120283`,0.0158564`,0.015889183`,0.017163283`,0.015813033`,0.016726533`,0.016759967`,0.01684935`,0.017092017`,0.01804815`,0.016895767`,0.018824917`,0.017149867`,0.019083983`,0.01844195`,0.018083833`,0.01310965`,0.01375675`,0.016008`,0.01681015`,0.016138367`,0.0150042`,0.017750267`,0.015885183`,0.012002033`,0.016503533`,0.016128217`,0.016633567`,0.010333383`,0.010170467`,0.010271867`,0.010271867`,0.012442733`,0.0111563`,0.01095285`,0.006432917`,0.008446867`,0.005776267`,0.004486083`,0.006615383`,0.0065602`,0.0084105`,0.008821133`,0.010739283`,0.005411433`,0.010963333`,0.011069433`,0.0098742`,0.008821133`,0.0084105`,0.0071548`,0.01112255`,0.0087191`,0.0081806`,0.0081806`,0.008250883`,0.01041105`,0.01232725`,0.012852333`,0.012402567`,0.0133477`,0.013267467`,0.008464683`},{7/2187,0.013213521`,0.013207138`,0.013207138`,0.013024721`,0.013970054`,0.015424238`,0.012786338`,0.015196038`,0.011360938`,0.015308471`,0.012581338`,0.011985021`,0.016022021`,0.014212671`,0.013527988`,0.010772121`,0.010749488`,0.016220354`,0.008366104`,0.017013788`,0.013109188`,0.015540288`,0.015952954`,0.009333271`,0.009456571`,0.010907988`,0.013069438`,0.008075104`,0.008092604`,0.015963121`,0.016941188`,0.019032588`,0.011373421`,0.010781004`,0.015989838`,0.017637538`,0.016667771`,0.017568671`,0.016664871`,0.018109088`,0.016727288`,0.018088288`,0.018433171`,0.016708754`,0.016875771`,0.016779621`,0.016624904`,0.015880838`,0.015989838`,0.016776838`,0.017762304`,0.017049254`,0.016941404`,0.016612138`,0.018322971`,0.017197938`,0.015989838`,0.015368304`,0.015398088`,0.017971888`,0.015392188`,0.016657371`,0.016660404`,0.017610354`,0.018175738`,0.017432638`,0.018053721`,0.017969554`,0.017915288`,0.018330454`,0.018350454`,0.017671171`,0.014972071`,0.016014004`,0.016247871`,0.016240421`,0.016325671`,0.015405738`,0.017165488`,0.016124421`,0.012465838`,0.015992288`,0.016343988`,0.015930471`,0.009851704`,0.009704421`,0.009793104`,0.009793104`,0.012435004`,0.010469721`,0.010458671`,0.006645654`,0.008221838`,0.004747271`,0.004952404`,0.006468888`,0.006476854`,0.008704721`,0.009059738`,0.010554104`,0.006285721`,0.010744221`,0.010751521`,0.009659121`,0.009059738`,0.008704721`,0.007924971`,0.010810854`,0.008899821`,0.008834204`,0.008834204`,0.008693304`,0.010198271`,0.012900538`,0.013752721`,0.012941121`,0.013920921`,0.013933238`,0.007834788`},{1/324,0.009141667`,0.009124033`,0.009124033`,0.00899325`,0.0097244`,0.01151185`,0.009429133`,0.011234567`,0.010484483`,0.011513967`,0.010180433`,0.00947715`,0.01245275`,0.0140803`,0.011588167`,0.010527817`,0.010486833`,0.01636715`,0.009679267`,0.016873033`,0.013433`,0.0165741`,0.016539017`,0.0084021`,0.009748767`,0.00966635`,0.013916817`,0.008521583`,0.008599467`,0.014023583`,0.016241033`,0.0172342`,0.0102203`,0.010212317`,0.01430455`,0.017495933`,0.01698975`,0.017420667`,0.0169714`,0.017640317`,0.017472033`,0.01859275`,0.0180381`,0.016040967`,0.016087617`,0.015996033`,0.016017067`,0.013267367`,0.01430455`,0.017147183`,0.017771467`,0.017425133`,0.01740075`,0.01709885`,0.0174671`,0.016381583`,0.01430455`,0.013918817`,0.014117533`,0.018622167`,0.014003983`,0.01737275`,0.016992433`,0.017169717`,0.017331167`,0.01808625`,0.017202517`,0.018264967`,0.017653783`,0.01766325`,0.018769533`,0.0181417`,0.017661433`,0.017907467`,0.015713217`,0.016452833`,0.015829033`,0.0155957`,0.017511183`,0.015849267`,0.01395425`,0.016097367`,0.015742817`,0.016283517`,0.01007525`,0.009930333`,0.010018967`,0.010018967`,0.012417483`,0.009876533`,0.00955895`,0.005138083`,0.008326483`,0.004780567`,0.005390267`,0.005533283`,0.005528067`,0.0088434`,0.009157783`,0.010396717`,0.006817683`,0.010597817`,0.010733467`,0.009488383`,0.009157783`,0.0088434`,0.008140967`,0.010768183`,0.008959217`,0.00902115`,0.00902115`,0.008855167`,0.010035667`,0.01106235`,0.012500867`,0.0110259`,0.012088533`,0.011968383`,0.008357767`},{7/2349,0.012449463`,0.012501096`,0.012501096`,0.012341513`,0.013498179`,0.014190313`,0.011586663`,0.014065663`,0.010077329`,0.014182796`,0.009977679`,0.010573763`,0.014455579`,0.012816446`,0.012165696`,0.009546613`,0.009488946`,0.010587513`,0.009066363`,0.011669979`,0.011547213`,0.011804646`,0.011191513`,0.008569296`,0.009600879`,0.009362613`,0.014477879`,0.009144613`,0.009195229`,0.011883996`,0.012581279`,0.011374046`,0.011311513`,0.010628713`,0.015340679`,0.018556013`,0.017653296`,0.018494863`,0.017619379`,0.018302463`,0.017771479`,0.018685763`,0.018825596`,0.016740446`,0.016658846`,0.016642313`,0.016729963`,0.014820813`,0.015340679`,0.016829879`,0.016589613`,0.016930346`,0.015937513`,0.016869779`,0.017480996`,0.015445846`,0.015340679`,0.014789329`,0.014847329`,0.018224163`,0.014831079`,0.016384746`,0.017720263`,0.012790163`,0.012321763`,0.017927863`,0.016836429`,0.016368946`,0.015967946`,0.017161296`,0.019319063`,0.018966913`,0.016622329`,0.015822046`,0.015323879`,0.016551763`,0.015435796`,0.014601029`,0.018688163`,0.015288496`,0.014578446`,0.016186179`,0.015460246`,0.016205929`,0.010418979`,0.010562196`,0.010449496`,0.010449496`,0.012711646`,0.008566813`,0.007594829`,0.006153263`,0.010182329`,0.005921813`,0.004864829`,0.005795113`,0.005777563`,0.008414063`,0.008819046`,0.010391063`,0.006230696`,0.010653579`,0.010922363`,0.009630379`,0.008819046`,0.008414063`,0.007320129`,0.011070913`,0.008709996`,0.008343546`,0.008343546`,0.008323396`,0.010107063`,0.009280979`,0.009867346`,0.009344446`,0.009098763`,0.009121163`,0.006477313`},{7/2430,0.010060392`,0.010137475`,0.010137475`,0.010095775`,0.010258375`,0.009390642`,0.009187008`,0.009336008`,0.008839075`,0.009464775`,0.009760142`,0.009577642`,0.009247558`,0.009137725`,0.008655142`,0.010235508`,0.010204508`,0.009792025`,0.009352275`,0.009731842`,0.009221642`,0.009446258`,0.009555125`,0.009616508`,0.010777325`,0.013148292`,0.014916175`,0.012970225`,0.012886025`,0.014595858`,0.012801242`,0.011546658`,0.015068292`,0.014465142`,0.009245808`,0.018538458`,0.017427425`,0.018851342`,0.017481808`,0.018434308`,0.017587592`,0.018680758`,0.018210925`,0.015375358`,0.015157442`,0.015066625`,0.015179658`,0.009344258`,0.009245808`,0.011224125`,0.013060625`,0.011145525`,0.010909875`,0.011174725`,0.016580708`,0.013916325`,0.009245808`,0.008867108`,0.008854758`,0.013006975`,0.008813875`,0.009472925`,0.015608442`,0.010495642`,0.010828125`,0.016193192`,0.014227092`,0.013301258`,0.012344058`,0.014795275`,0.019407308`,0.018501825`,0.016301692`,0.016116575`,0.014267608`,0.015309775`,0.014308092`,0.013206325`,0.019184358`,0.014068792`,0.013815425`,0.014923375`,0.014471058`,0.015257275`,0.012827925`,0.012731758`,0.012792642`,0.012792642`,0.014851625`,0.007503192`,0.006122042`,0.005086258`,0.009567225`,0.005836858`,0.003924158`,0.005981375`,0.005922292`,0.007833092`,0.008315492`,0.010224408`,0.005634292`,0.010477542`,0.010605375`,0.009382908`,0.008315492`,0.007833092`,0.006633592`,0.010640325`,0.008290942`,0.007369108`,0.007369108`,0.007471358`,0.009892692`,0.009048492`,0.009422675`,0.009064958`,0.009364158`,0.009302958`,0.006110708`},{7/2511,0.009712438`,0.009753271`,0.009753271`,0.009756304`,0.010153121`,0.010820188`,0.010164921`,0.010687054`,0.009807071`,0.010947088`,0.010211554`,0.010353088`,0.010486121`,0.010765771`,0.010159538`,0.010896038`,0.010958638`,0.010682038`,0.009931988`,0.010976538`,0.010585438`,0.010893654`,0.010913571`,0.011080088`,0.011731688`,0.014528621`,0.014599404`,0.015320604`,0.015100854`,0.016060738`,0.014161721`,0.011977788`,0.016507938`,0.016346238`,0.010075471`,0.018253521`,0.017608804`,0.018541654`,0.017613204`,0.017692754`,0.017688254`,0.017813504`,0.016978004`,0.012650021`,0.012498854`,0.012402604`,0.012543171`,0.010612638`,0.010075471`,0.011627188`,0.012114821`,0.011529904`,0.010648621`,0.011501938`,0.011982071`,0.011953288`,0.010075471`,0.009631271`,0.009559754`,0.012605921`,0.009550054`,0.009462188`,0.014456821`,0.011506288`,0.011568671`,0.013211221`,0.014009638`,0.012536771`,0.014188821`,0.014249454`,0.019491988`,0.019040688`,0.015802338`,0.017686504`,0.014637338`,0.016407154`,0.014708221`,0.013249321`,0.019308871`,0.014337921`,0.013859754`,0.015859204`,0.014802438`,0.016647954`,0.013025254`,0.012912054`,0.012980488`,0.012980488`,0.014892821`,0.007597854`,0.006907421`,0.004093438`,0.009008338`,0.005915204`,0.003752438`,0.005483671`,0.005398588`,0.008062854`,0.008483921`,0.010168721`,0.005620738`,0.010442738`,0.010536554`,0.009201588`,0.008483921`,0.008062854`,0.007146204`,0.010533688`,0.008389171`,0.007937338`,0.007937338`,0.007832438`,0.009777971`,0.008996304`,0.009467471`,0.009050188`,0.010376838`,0.010327954`,0.006325404`},{8/81,0.010468438`,0.010482021`,0.010482021`,0.010482338`,0.010692038`,0.011416354`,0.011593121`,0.011387138`,0.010138271`,0.011591638`,0.010939288`,0.011341688`,0.011143821`,0.011424621`,0.011049638`,0.012307304`,0.012196604`,0.013117288`,0.011210521`,0.013432171`,0.011988771`,0.012544838`,0.013268021`,0.012287571`,0.012234538`,0.015545554`,0.015359204`,0.016260088`,0.016225871`,0.017544604`,0.015240021`,0.013602054`,0.017432504`,0.017595921`,0.010991438`,0.017920121`,0.016995454`,0.018022288`,0.017008021`,0.018079788`,0.017317638`,0.016093388`,0.017549238`,0.012432288`,0.012402554`,0.012424638`,0.012460288`,0.011198838`,0.010991438`,0.012185254`,0.013078388`,0.012362354`,0.012260071`,0.012102438`,0.012091221`,0.011803188`,0.010991438`,0.010541221`,0.010522804`,0.014281238`,0.010501338`,0.010641321`,0.013921471`,0.013360504`,0.014422421`,0.014252504`,0.013566371`,0.014007521`,0.015446154`,0.014655721`,0.019513621`,0.017909821`,0.016925221`,0.018716654`,0.015156654`,0.017089671`,0.015225938`,0.013818488`,0.018502154`,0.014868571`,0.013648488`,0.016662471`,0.015298988`,0.016820771`,0.013153104`,0.012995904`,0.013091838`,0.013091838`,0.014554354`,0.009817804`,0.008701321`,0.005045038`,0.010281704`,0.005481854`,0.003807688`,0.004933321`,0.004831104`,0.008102638`,0.008556321`,0.010061088`,0.005459621`,0.010295221`,0.010432971`,0.009048521`,0.008556321`,0.008102638`,0.007211338`,0.010472854`,0.008492521`,0.007938371`,0.007938371`,0.007859354`,0.009658054`,0.009480138`,0.010117954`,0.009536271`,0.010691471`,0.010562638`,0.006330871`},{4/81,0.011308988`,0.011279521`,0.011279521`,0.011205204`,0.011687888`,0.011815904`,0.012736938`,0.011852688`,0.011542054`,0.011994321`,0.011696071`,0.012128004`,0.011385938`,0.013101171`,0.011437154`,0.014186821`,0.014123954`,0.014920138`,0.013091704`,0.015330771`,0.013670954`,0.013851604`,0.014745354`,0.014029938`,0.013814604`,0.017192571`,0.015558788`,0.014215754`,0.014178188`,0.018349188`,0.016351138`,0.015768254`,0.018157621`,0.017834354`,0.011592154`,0.017813754`,0.017066471`,0.018491888`,0.017063054`,0.017903204`,0.017071438`,0.017065504`,0.018076004`,0.013630538`,0.013809188`,0.013711338`,0.013626271`,0.011614754`,0.011592154`,0.013389038`,0.014219388`,0.013509771`,0.013230604`,0.013206121`,0.015591804`,0.013551138`,0.011592154`,0.011149204`,0.011184088`,0.013581471`,0.011140788`,0.011790021`,0.014735488`,0.015106721`,0.015989171`,0.016583754`,0.013577504`,0.015717388`,0.015023704`,0.016181954`,0.018623288`,0.017587854`,0.016152904`,0.018729654`,0.014770871`,0.016131254`,0.014816088`,0.013477554`,0.018112454`,0.014476404`,0.013205571`,0.015833954`,0.014904754`,0.015501038`,0.012558121`,0.012378271`,0.012492171`,0.012492171`,0.014179438`,0.008911854`,0.007950488`,0.005540938`,0.009957938`,0.005120221`,0.003446538`,0.005743804`,0.005569304`,0.007959171`,0.008474854`,0.010199938`,0.005070571`,0.010405121`,0.010693221`,0.009269888`,0.008474854`,0.007959171`,0.006909471`,0.010713538`,0.008469904`,0.007777421`,0.007777421`,0.007708971`,0.009850738`,0.009781821`,0.010129438`,0.009801721`,0.010230404`,0.010153371`,0.005760788`},{8/243,0.012996554`,0.012915888`,0.012915888`,0.012691004`,0.013590354`,0.013119921`,0.013334354`,0.013137988`,0.013269554`,0.013217321`,0.013639554`,0.013243588`,0.012822321`,0.014362771`,0.013790754`,0.016486821`,0.016463354`,0.015605704`,0.014834554`,0.016566704`,0.014251104`,0.016003921`,0.016230571`,0.014211071`,0.015295704`,0.015171538`,0.015044988`,0.015010104`,0.014964238`,0.017590021`,0.017550088`,0.016983354`,0.016092204`,0.016017804`,0.014144738`,0.017423371`,0.016747788`,0.018505304`,0.016698138`,0.017040921`,0.016670071`,0.017029338`,0.016662854`,0.015665071`,0.015519871`,0.015349604`,0.015451788`,0.013774904`,0.014144738`,0.014654721`,0.014500154`,0.014890654`,0.014412788`,0.014661204`,0.016403638`,0.014316571`,0.014144738`,0.013844288`,0.013913471`,0.014939138`,0.013860754`,0.014394938`,0.015714254`,0.015424704`,0.016136304`,0.017915121`,0.015069671`,0.017438838`,0.015971638`,0.018650154`,0.018618488`,0.017476354`,0.015486988`,0.018927038`,0.013676254`,0.014812521`,0.013646104`,0.012475138`,0.017870688`,0.013366554`,0.012257871`,0.014451121`,0.013860421`,0.014239871`,0.009438054`,0.009194188`,0.009356571`,0.009356571`,0.011125804`,0.010622271`,0.008863454`,0.005246838`,0.009322121`,0.003873188`,0.004083754`,0.004765654`,0.004660404`,0.008518871`,0.009004938`,0.010659604`,0.005230971`,0.010861971`,0.010903054`,0.009683771`,0.009004938`,0.008518871`,0.006915704`,0.010828938`,0.008964121`,0.008764271`,0.008764271`,0.008583854`,0.010276738`,0.009590371`,0.009841488`,0.009665471`,0.009521888`,0.009463371`,0.006779321`},{2/81,0.014125467`,0.014184833`,0.014184833`,0.0140835`,0.014670217`,0.0144825`,0.014005517`,0.014397083`,0.014207767`,0.01449635`,0.014084933`,0.013681867`,0.014896383`,0.015234867`,0.013899767`,0.01667905`,0.016597383`,0.016922117`,0.015182717`,0.017415517`,0.015277`,0.017198383`,0.017313417`,0.014740517`,0.015532817`,0.016712733`,0.014900583`,0.013471067`,0.013583133`,0.01836865`,0.016749583`,0.017786967`,0.017221983`,0.016807183`,0.015453983`,0.01762135`,0.01619745`,0.017687417`,0.016132417`,0.017911133`,0.0163578`,0.017239167`,0.017461783`,0.016049217`,0.016057833`,0.015933667`,0.015958783`,0.015448467`,0.015453983`,0.01603025`,0.016965667`,0.016346333`,0.016153067`,0.015976967`,0.0172037`,0.0159731`,0.015453983`,0.015096483`,0.01510185`,0.016934217`,0.015055783`,0.015912833`,0.01689645`,0.0173204`,0.018002567`,0.018387283`,0.0166029`,0.018294267`,0.016879367`,0.018799917`,0.019092433`,0.01800895`,0.014736817`,0.017643983`,0.013465683`,0.015891583`,0.01356845`,0.012098983`,0.01905565`,0.01317945`,0.01178365`,0.015471`,0.013615933`,0.015650467`,0.00783855`,0.0076156`,0.0077644`,0.0077644`,0.00998005`,0.011082017`,0.009965967`,0.005339717`,0.01012765`,0.00337775`,0.00427665`,0.004065467`,0.004011183`,0.0084707`,0.008970067`,0.0105831`,0.005057067`,0.010778233`,0.010930083`,0.009646167`,0.008970067`,0.0084707`,0.006999117`,0.01101605`,0.008940583`,0.00836575`,0.00836575`,0.008330333`,0.0102221`,0.010467033`,0.011125`,0.010468183`,0.0104412`,0.01026275`,0.006659417`},{8/405,0.014978167`,0.015044083`,0.015044083`,0.014986117`,0.015216533`,0.014634133`,0.0141035`,0.014466117`,0.013505767`,0.014550967`,0.013731633`,0.013324`,0.01509185`,0.015116833`,0.013779383`,0.016953883`,0.0168193`,0.017045467`,0.012213517`,0.01727955`,0.0142744`,0.016660933`,0.01690715`,0.0147322`,0.013891067`,0.017221117`,0.013402067`,0.014094867`,0.013956167`,0.018890667`,0.017121883`,0.0193249`,0.019608967`,0.0193491`,0.01463275`,0.017847667`,0.017160717`,0.017389233`,0.0172136`,0.017779633`,0.017772117`,0.017651483`,0.017704933`,0.015714633`,0.015566117`,0.0154316`,0.015541833`,0.014762683`,0.01463275`,0.01619955`,0.017021383`,0.016581167`,0.016430533`,0.016174683`,0.016981533`,0.015589917`,0.01463275`,0.01387735`,0.013875417`,0.016983`,0.013877783`,0.014991683`,0.017006983`,0.018237933`,0.018583667`,0.017859783`,0.01793955`,0.018826583`,0.01831625`,0.018687517`,0.01893815`,0.017978467`,0.014550317`,0.017638117`,0.014808217`,0.016585467`,0.01493445`,0.01358455`,0.018431083`,0.014586267`,0.012514583`,0.016215717`,0.01491385`,0.01649265`,0.007554167`,0.007533083`,0.0075386`,0.0075386`,0.0096273`,0.009251917`,0.008181917`,0.005896483`,0.0094605`,0.0036588`,0.004047833`,0.003640983`,0.00364815`,0.008326117`,0.0088259`,0.010632467`,0.005238433`,0.010875167`,0.011066783`,0.00976355`,0.0088259`,0.008326117`,0.007177633`,0.01118685`,0.008804133`,0.007948767`,0.007948767`,0.007994833`,0.010298567`,0.010178333`,0.01096235`,0.010156767`,0.0106679`,0.010520567`,0.006367217`},{4/243,0.012503746`,0.012618179`,0.012618179`,0.012603629`,0.012413279`,0.011414646`,0.011718446`,0.011229163`,0.011079379`,0.011446146`,0.012057063`,0.012782646`,0.011779379`,0.013051663`,0.011646613`,0.015565929`,0.015490529`,0.016954013`,0.012395646`,0.017345413`,0.012395896`,0.015982196`,0.016245529`,0.013994813`,0.013526929`,0.015448663`,0.015262729`,0.014417663`,0.014270763`,0.019452263`,0.017825413`,0.019007146`,0.016600146`,0.015997229`,0.012170163`,0.018306063`,0.018091779`,0.018387863`,0.018163129`,0.018235613`,0.018646129`,0.017152346`,0.018891346`,0.016790779`,0.016825913`,0.016848413`,0.016856679`,0.012162896`,0.012170163`,0.017587746`,0.017741629`,0.017840113`,0.017191346`,0.017630413`,0.017803429`,0.016375779`,0.012170163`,0.012096779`,0.012174096`,0.016130863`,0.012028063`,0.013538113`,0.018262663`,0.017972696`,0.018616396`,0.018534596`,0.018343213`,0.019577213`,0.018893763`,0.018701229`,0.019031863`,0.018322963`,0.015045946`,0.018641229`,0.015291796`,0.016475863`,0.015337546`,0.014112163`,0.018424979`,0.015035029`,0.012209813`,0.016130496`,0.015445463`,0.016274279`,0.009720029`,0.009662796`,0.009692296`,0.009692296`,0.012070846`,0.011169729`,0.011760863`,0.005462163`,0.008958629`,0.004901596`,0.004253513`,0.004209263`,0.004232413`,0.008449713`,0.008897279`,0.010724646`,0.005673579`,0.011109679`,0.011340729`,0.010060063`,0.008897279`,0.008449713`,0.007364546`,0.011445746`,0.008828229`,0.007967196`,0.007967196`,0.008034079`,0.010479079`,0.010865679`,0.011415529`,0.010952296`,0.011962863`,0.011851296`,0.007156929`},{8/567,0.011478129`,0.011508696`,0.011508696`,0.011419729`,0.011653479`,0.012048496`,0.011974496`,0.011875163`,0.010984529`,0.012073179`,0.010924029`,0.010881513`,0.012093229`,0.014325379`,0.012402713`,0.015253779`,0.015053463`,0.016140079`,0.013525313`,0.015583429`,0.013370729`,0.015296363`,0.015076113`,0.012373479`,0.013290279`,0.012519829`,0.011131013`,0.011911329`,0.011938896`,0.014154146`,0.015505879`,0.016296479`,0.012281396`,0.012180579`,0.013069829`,0.018640613`,0.018254013`,0.017981813`,0.018265929`,0.018919329`,0.018680146`,0.018247946`,0.019394013`,0.017047296`,0.017076429`,0.016996929`,0.016973229`,0.012654079`,0.013069829`,0.016736863`,0.016526596`,0.016739779`,0.015926779`,0.016772879`,0.017974163`,0.015713663`,0.013069829`,0.012886163`,0.012982863`,0.016018679`,0.012870896`,0.014677996`,0.018619979`,0.016115113`,0.016553979`,0.019039246`,0.016995263`,0.019262096`,0.017861996`,0.018680613`,0.019071146`,0.018472913`,0.016106413`,0.016915729`,0.015287629`,0.015389846`,0.015322379`,0.014821396`,0.018332529`,0.015244429`,0.012975979`,0.015103746`,0.015374563`,0.014545546`,0.010768679`,0.010882746`,0.010791463`,0.010791463`,0.012519679`,0.010828713`,0.009578063`,0.005660279`,0.009632563`,0.006355929`,0.004525896`,0.004825546`,0.004852346`,0.008477546`,0.008989646`,0.010702163`,0.005625079`,0.011084129`,0.011578996`,0.010168046`,0.008989646`,0.008477546`,0.007238129`,0.011735363`,0.008978896`,0.008004313`,0.008004313`,0.008138879`,0.010542263`,0.013241896`,0.013154779`,0.013324996`,0.013768879`,0.013681996`,0.007336963`},{1/81,0.012429467`,0.012447483`,0.012447483`,0.01232485`,0.013178467`,0.0141677`,0.0119449`,0.014090717`,0.012869`,0.014236717`,0.013168567`,0.012235483`,0.0136728`,0.014674033`,0.014121117`,0.01272065`,0.012612433`,0.013739017`,0.012077817`,0.013317667`,0.014099533`,0.013900367`,0.013636917`,0.011117417`,0.012294667`,0.0112704`,0.0077717`,0.011580817`,0.011324067`,0.012320633`,0.011444483`,0.013470383`,0.011295233`,0.011314417`,0.015814767`,0.018554383`,0.018453333`,0.018388717`,0.018450983`,0.018457083`,0.018679533`,0.018187633`,0.018989883`,0.016899683`,0.016866933`,0.016830033`,0.016851283`,0.015553067`,0.015814767`,0.01856145`,0.018012233`,0.018411567`,0.016902383`,0.01855355`,0.01839285`,0.015494383`,0.015814767`,0.015576117`,0.015592917`,0.018681983`,0.0155489`,0.017159533`,0.017391833`,0.013933567`,0.013633367`,0.016521883`,0.016247383`,0.015456317`,0.014515517`,0.01350685`,0.018626917`,0.018230417`,0.01036075`,0.011397817`,0.010936167`,0.01390715`,0.01115645`,0.010873567`,0.0178801`,0.01112505`,0.011288383`,0.013471383`,0.010957217`,0.014488183`,0.012163983`,0.012221033`,0.012169983`,0.012169983`,0.012844267`,0.008762567`,0.006854767`,0.005422867`,0.00923605`,0.00662485`,0.004587067`,0.005523467`,0.005501317`,0.00870485`,0.009182283`,0.010775967`,0.0058599`,0.01107065`,0.011579767`,0.010093817`,0.009182283`,0.00870485`,0.007371533`,0.011771983`,0.009138683`,0.00821655`,0.00821655`,0.008399683`,0.010552567`,0.014330367`,0.0143231`,0.0143954`,0.014722083`,0.014669483`,0.007827367`},{8/729,0.013053854`,0.013012604`,0.013012604`,0.012655154`,0.013463971`,0.015215438`,0.013870254`,0.015119204`,0.012968404`,0.015217638`,0.013463354`,0.013446571`,0.015492288`,0.013166971`,0.013623821`,0.013189038`,0.013123788`,0.013740488`,0.012012288`,0.013222304`,0.012988071`,0.013164454`,0.013234238`,0.011773588`,0.012728921`,0.012338254`,0.009664771`,0.011936771`,0.011941138`,0.013494638`,0.012086604`,0.013848171`,0.012430904`,0.012536304`,0.012449988`,0.018151171`,0.018792288`,0.018098804`,0.018828021`,0.018156421`,0.019161288`,0.017962288`,0.018761488`,0.014997888`,0.014812638`,0.014655104`,0.014741371`,0.012784404`,0.012449988`,0.017767388`,0.017190988`,0.017572088`,0.015745388`,0.017758004`,0.018095371`,0.015166238`,0.012449988`,0.011739504`,0.012824754`,0.018405004`,0.012479054`,0.016377571`,0.014138071`,0.012996238`,0.013353588`,0.013817704`,0.015607171`,0.013288871`,0.014197554`,0.012593554`,0.017843588`,0.017710738`,0.009966004`,0.010875404`,0.008710254`,0.010507588`,0.008664121`,0.008204438`,0.016001004`,0.008549004`,0.011061088`,0.010022254`,0.008735821`,0.011875904`,0.012241421`,0.012230221`,0.012224321`,0.012224321`,0.011551088`,0.009152788`,0.008652338`,0.006044054`,0.008497121`,0.008520571`,0.005066271`,0.005712671`,0.005701921`,0.009021071`,0.009382788`,0.010708588`,0.006282021`,0.010878154`,0.011192304`,0.009923854`,0.009382788`,0.009021071`,0.007951421`,0.011313838`,0.009224638`,0.008927504`,0.008927504`,0.008971204`,0.010431454`,0.010115471`,0.015446571`,0.010232471`,0.014526754`,0.014693338`,0.008106138`},{4/405,0.0148716`,0.01481175`,0.01481175`,0.014537317`,0.015064383`,0.014843`,0.014555367`,0.0147202`,0.013071283`,0.014821867`,0.013278767`,0.013571467`,0.014996317`,0.013050033`,0.0124633`,0.013657617`,0.0135312`,0.01472085`,0.0127839`,0.0144381`,0.013072167`,0.01361575`,0.01423315`,0.011226633`,0.012542633`,0.011081417`,0.0116933`,0.0102699`,0.010339717`,0.013610933`,0.013933667`,0.015227267`,0.010339583`,0.009424517`,0.01454775`,0.018768883`,0.0172672`,0.019537983`,0.017298283`,0.019062917`,0.018112933`,0.018435517`,0.0187341`,0.016674033`,0.016304283`,0.016220633`,0.01636125`,0.014381567`,0.01454775`,0.01685295`,0.016925133`,0.016662117`,0.015563067`,0.016808983`,0.017724783`,0.01595805`,0.01454775`,0.013428417`,0.01354175`,0.017383433`,0.013552383`,0.015931933`,0.015650117`,0.0139314`,0.01483505`,0.014120417`,0.014053083`,0.01346985`,0.01440835`,0.013130333`,0.017804667`,0.017524383`,0.010936433`,0.013250933`,0.0096808`,0.012480533`,0.0097164`,0.009013667`,0.017020967`,0.009540667`,0.011617233`,0.012040683`,0.00969455`,0.01313115`,0.011509633`,0.011692583`,0.011551383`,0.011551383`,0.012819633`,0.009301733`,0.0088762`,0.00624435`,0.008938467`,0.009918883`,0.006111517`,0.007088733`,0.0070449`,0.009169567`,0.00943365`,0.011209217`,0.007056733`,0.0115178`,0.011777167`,0.010543433`,0.00943365`,0.009169567`,0.008553733`,0.0119476`,0.009175233`,0.00914975`,0.00914975`,0.00918815`,0.010994617`,0.00855035`,0.01265365`,0.008593833`,0.014103167`,0.014411567`,0.006629517`},{8/891,0.014451996`,0.014519046`,0.014519046`,0.014438196`,0.014427479`,0.014580363`,0.014275679`,0.014484079`,0.013458463`,0.014581079`,0.014113829`,0.014259046`,0.015187213`,0.014477579`,0.013027713`,0.012226579`,0.012123563`,0.013288929`,0.010836663`,0.014403646`,0.013784663`,0.014458429`,0.014085479`,0.009444379`,0.011220079`,0.008840429`,0.010662946`,0.010789129`,0.010763379`,0.011415563`,0.013534929`,0.014042246`,0.010504746`,0.009938179`,0.016027396`,0.018039096`,0.016438329`,0.018796613`,0.016423746`,0.017475913`,0.016829979`,0.018430546`,0.017459746`,0.015792113`,0.015910513`,0.015791863`,0.015807913`,0.015676263`,0.016027396`,0.017286813`,0.017105013`,0.017417696`,0.016781846`,0.017356929`,0.017341863`,0.016371496`,0.016027396`,0.015181346`,0.015117629`,0.018001913`,0.015162196`,0.017287429`,0.016457946`,0.014623979`,0.015040129`,0.015323229`,0.015221596`,0.014482729`,0.015069813`,0.013931413`,0.017470779`,0.017801263`,0.013747946`,0.014479946`,0.011745879`,0.013590046`,0.011793829`,0.011033229`,0.017487013`,0.011607179`,0.013676413`,0.013194363`,0.011786279`,0.013955646`,0.011392313`,0.011505096`,0.011417829`,0.011417829`,0.012377629`,0.009974746`,0.009240146`,0.005639296`,0.009122013`,0.010782446`,0.004817713`,0.006702729`,0.006479063`,0.009374613`,0.009587163`,0.011129863`,0.007586163`,0.011473113`,0.011659346`,0.010715146`,0.009587163`,0.009374613`,0.009067796`,0.011796829`,0.009269246`,0.009730096`,0.009730096`,0.009443996`,0.011050479`,0.008585246`,0.013272346`,0.008662313`,0.014357546`,0.014514896`,0.006481646`},{2/243,0.014614963`,0.014637746`,0.014637746`,0.014436979`,0.015016629`,0.015081046`,0.012453179`,0.014956163`,0.012242113`,0.015049929`,0.012247713`,0.012266263`,0.014916979`,0.013132679`,0.011769379`,0.013623846`,0.013619479`,0.011762329`,0.011947346`,0.011565779`,0.011865146`,0.011702796`,0.011420513`,0.011515246`,0.013215979`,0.011769229`,0.011257046`,0.012299596`,0.012244929`,0.012460463`,0.012139913`,0.011769696`,0.012489246`,0.012358213`,0.014403629`,0.017965513`,0.016181096`,0.018008179`,0.016121713`,0.016997679`,0.016592646`,0.018341463`,0.017408513`,0.015362396`,0.015256863`,0.015335063`,0.015398613`,0.014195679`,0.014403629`,0.017211046`,0.016544596`,0.017209163`,0.015725129`,0.017183496`,0.016966296`,0.014428179`,0.014403629`,0.013596163`,0.013637279`,0.016990146`,0.013593129`,0.015866363`,0.016045879`,0.012309346`,0.012068846`,0.016037113`,0.015303063`,0.015776896`,0.014709279`,0.015993663`,0.018061896`,0.018304979`,0.014795446`,0.014442313`,0.013163096`,0.015407246`,0.013285313`,0.012298679`,0.017845846`,0.013029729`,0.014421546`,0.015048679`,0.013200713`,0.015511163`,0.010467679`,0.010918596`,0.010594646`,0.010594646`,0.012164396`,0.010541079`,0.010080746`,0.004936113`,0.010264746`,0.009946013`,0.005164246`,0.006287296`,0.006103013`,0.009410796`,0.009598079`,0.011311729`,0.008023229`,0.011755213`,0.011910463`,0.011224463`,0.009598079`,0.009410796`,0.009505813`,0.011971913`,0.009259796`,0.009934863`,0.009934863`,0.009511596`,0.011409196`,0.008792746`,0.013134396`,0.008848513`,0.013658829`,0.013571429`,0.005843896`},{8/1053,0.011608258`,0.011577375`,0.011577375`,0.011412058`,0.012282075`,0.012985175`,0.011101592`,0.012841192`,0.012731758`,0.013010992`,0.012037158`,0.011624992`,0.013121208`,0.012762208`,0.011812125`,0.015033425`,0.015012008`,0.013446492`,0.014638075`,0.012237608`,0.013573992`,0.012934975`,0.012922708`,0.012845908`,0.014756042`,0.013424808`,0.013238158`,0.014142875`,0.013916192`,0.014839758`,0.014112592`,0.013377458`,0.014674492`,0.014577675`,0.012476442`,0.017748408`,0.017462958`,0.017331092`,0.017431708`,0.017511625`,0.017540908`,0.017387058`,0.018149208`,0.014238008`,0.014137925`,0.013958392`,0.014038192`,0.012746675`,0.012476442`,0.016026492`,0.015747708`,0.015722175`,0.014277275`,0.015927825`,0.016757942`,0.014850508`,0.012476442`,0.012014558`,0.011891075`,0.015055275`,0.011901958`,0.012405092`,0.015381542`,0.012062492`,0.012002025`,0.015806258`,0.012794842`,0.014204042`,0.012679592`,0.015289408`,0.018559908`,0.017755525`,0.015529325`,0.015857858`,0.013628725`,0.015405775`,0.013744725`,0.013005625`,0.017626525`,0.013560825`,0.014642958`,0.015092008`,0.013683825`,0.015893425`,0.010313258`,0.010480958`,0.010351408`,0.010351408`,0.012203925`,0.009791008`,0.009635808`,0.004819392`,0.008285375`,0.008876392`,0.006341008`,0.007263925`,0.007121758`,0.008985492`,0.009265058`,0.011134908`,0.007966258`,0.011480008`,0.011608275`,0.010487858`,0.009265058`,0.008985492`,0.008852942`,0.011643558`,0.009015775`,0.009314258`,0.009314258`,0.008966958`,0.010924575`,0.008060175`,0.011968792`,0.008123125`,0.012539192`,0.012444858`,0.006163525`},{4/567,0.010514554`,0.010387771`,0.010387771`,0.010097038`,0.011441004`,0.012833654`,0.012284504`,0.012744538`,0.014117071`,0.012889704`,0.012905888`,0.012234438`,0.013672204`,0.014482621`,0.013288054`,0.014087804`,0.014140038`,0.013241904`,0.014260571`,0.013455504`,0.014948104`,0.014731571`,0.013855154`,0.015039621`,0.014655438`,0.016834504`,0.013407088`,0.014820171`,0.014904154`,0.017636221`,0.014819138`,0.014599371`,0.017052771`,0.016537204`,0.013245004`,0.016900604`,0.016533704`,0.016659988`,0.016458421`,0.017005104`,0.016758004`,0.018395921`,0.017850754`,0.015970388`,0.015851888`,0.015421021`,0.015563471`,0.013556371`,0.013245004`,0.014264221`,0.014160054`,0.014295388`,0.013745904`,0.014243638`,0.014946054`,0.016009588`,0.013245004`,0.012836121`,0.012702221`,0.015141104`,0.012709771`,0.012790171`,0.016701771`,0.012488121`,0.012771438`,0.016756404`,0.012935338`,0.014668504`,0.012747704`,0.015186121`,0.018833288`,0.017847588`,0.015595921`,0.017053138`,0.014685654`,0.016052954`,0.014833388`,0.014179688`,0.017979121`,0.014684638`,0.014557938`,0.015779121`,0.014712204`,0.016156154`,0.010683638`,0.011014954`,0.010771138`,0.010771138`,0.012324554`,0.008790488`,0.007975021`,0.005490121`,0.007934621`,0.009117371`,0.006997721`,0.007295238`,0.007139771`,0.008482754`,0.008868138`,0.011325338`,0.007745304`,0.011559421`,0.011832254`,0.010905854`,0.008868138`,0.008482754`,0.008031538`,0.012032854`,0.008726271`,0.008539538`,0.008539538`,0.008269604`,0.011263721`,0.007728171`,0.011641038`,0.007768138`,0.012039554`,0.011975604`,0.007500754`},{8/1215,0.01272055`,0.012666517`,0.012666517`,0.012432283`,0.013035`,0.0153776`,0.0135047`,0.01533665`,0.014412817`,0.015399`,0.0142379`,0.01425455`,0.01567715`,0.014761133`,0.013303567`,0.015122333`,0.015083733`,0.0159896`,0.01385215`,0.014946167`,0.0148523`,0.015114317`,0.014962983`,0.014403983`,0.01399335`,0.0157052`,0.013608533`,0.011994083`,0.012238967`,0.01762285`,0.017496633`,0.018472383`,0.016093967`,0.015238167`,0.014596983`,0.016253233`,0.016693233`,0.0160315`,0.016646583`,0.016049133`,0.01678635`,0.018282733`,0.01731435`,0.016242383`,0.016343767`,0.016350933`,0.016360283`,0.014651633`,0.014596983`,0.013698017`,0.014437983`,0.013800367`,0.0138159`,0.0137145`,0.014821533`,0.015194067`,0.014596983`,0.013962383`,0.013868917`,0.015324567`,0.01389705`,0.014398683`,0.017885867`,0.01492115`,0.01557945`,0.018278533`,0.015183083`,0.0183057`,0.016148283`,0.018158883`,0.0194971`,0.0189717`,0.015350417`,0.017093183`,0.014833917`,0.016116383`,0.014947233`,0.0142699`,0.0186411`,0.01478595`,0.0146938`,0.0158258`,0.01492955`,0.0162963`,0.009949633`,0.010125783`,0.009994417`,0.009994417`,0.011374733`,0.010921083`,0.009471433`,0.006009067`,0.007940717`,0.008971867`,0.005772367`,0.007262067`,0.00715905`,0.007977133`,0.008581367`,0.0112082`,0.007120483`,0.0114968`,0.01203335`,0.010775183`,0.008581367`,0.007977133`,0.007312067`,0.01224455`,0.008646967`,0.007516217`,0.007516217`,0.007387533`,0.011140017`,0.008000667`,0.011753583`,0.0080471`,0.011546583`,0.011477317`,0.008434583`},{1/162,0.014741592`,0.014786308`,0.014786308`,0.014635575`,0.015170958`,0.014923458`,0.013149642`,0.014820292`,0.011343342`,0.014906108`,0.011905625`,0.012576675`,0.015135592`,0.013261892`,0.012239475`,0.012222958`,0.012180525`,0.013771358`,0.010124825`,0.014809442`,0.012220592`,0.014362308`,0.014105392`,0.010209225`,0.010799825`,0.011332125`,0.013268892`,0.007819208`,0.007965492`,0.015583525`,0.017825075`,0.017268558`,0.012779092`,0.011223425`,0.014908175`,0.016638808`,0.016081158`,0.016296942`,0.016367642`,0.016674075`,0.016781258`,0.017562758`,0.017459025`,0.016885642`,0.016793408`,0.016835758`,0.016859508`,0.014679742`,0.014908175`,0.016089608`,0.016261158`,0.016103042`,0.015509292`,0.016043208`,0.016732125`,0.015273292`,0.014908175`,0.014216492`,0.014200492`,0.016599058`,0.014215358`,0.015009208`,0.017474058`,0.015841975`,0.016038725`,0.018761875`,0.017269825`,0.018785592`,0.018346725`,0.018486292`,0.020814258`,0.020117375`,0.017638475`,0.018222008`,0.015412258`,0.016134142`,0.015547008`,0.014776092`,0.019212608`,0.015356725`,0.014714942`,0.015986192`,0.015505508`,0.016132158`,0.009154375`,0.009302508`,0.009190375`,0.009190375`,0.010442025`,0.010038558`,0.009594525`,0.005593475`,0.008137892`,0.009023292`,0.004626975`,0.006349942`,0.006289425`,0.007992642`,0.008565425`,0.010822925`,0.007220308`,0.011061275`,0.011598192`,0.010342758`,0.008565425`,0.007992642`,0.007226992`,0.011848658`,0.008606525`,0.007118242`,0.007118242`,0.007207692`,0.010736225`,0.007917258`,0.012010825`,0.007980225`,0.011901608`,0.011801892`,0.008039592`},{8/1377,0.009008154`,0.009026754`,0.009026754`,0.008941654`,0.009233954`,0.008514221`,0.008057871`,0.008373204`,0.007108421`,0.008540588`,0.007666638`,0.008174538`,0.008919504`,0.008337371`,0.007711838`,0.008744354`,0.008724438`,0.009965171`,0.006838421`,0.010166171`,0.008093238`,0.009278588`,0.009640338`,0.007207654`,0.008478388`,0.009263738`,0.011345254`,0.007942771`,0.007922638`,0.012571671`,0.014459521`,0.012334038`,0.010020154`,0.008976071`,0.009312221`,0.017122638`,0.016291521`,0.017721988`,0.016325371`,0.016759921`,0.017133621`,0.019105521`,0.017279538`,0.017302904`,0.016767471`,0.016761088`,0.017005904`,0.008967938`,0.009312221`,0.014491954`,0.014781488`,0.014204438`,0.013137521`,0.014428171`,0.018442021`,0.014709154`,0.009312221`,0.008756671`,0.008791021`,0.014128754`,0.008767804`,0.010727971`,0.018458538`,0.011476954`,0.011880271`,0.019018838`,0.015397721`,0.017059621`,0.015820788`,0.017909421`,0.020061838`,0.020595904`,0.015763188`,0.016037654`,0.017205521`,0.016232321`,0.017506238`,0.017067638`,0.019069304`,0.017451104`,0.014771271`,0.016230654`,0.017195404`,0.016070371`,0.008917588`,0.009009204`,0.008936304`,0.008936304`,0.010049471`,0.009622738`,0.009658071`,0.004424054`,0.008628904`,0.008204171`,0.004353771`,0.004941504`,0.004880971`,0.008007671`,0.008536088`,0.011034171`,0.006093021`,0.011349321`,0.011635054`,0.010703304`,0.008536088`,0.008007671`,0.007158088`,0.011769554`,0.008538204`,0.007119104`,0.007119104`,0.007347021`,0.010984554`,0.007894421`,0.012179388`,0.007995521`,0.012201254`,0.012109288`,0.006363104`},{4/729,0.007963771`,0.007952204`,0.007952204`,0.007905088`,0.008081438`,0.007829221`,0.007543804`,0.007788888`,0.007467638`,0.007902254`,0.008054288`,0.007900204`,0.007578904`,0.007394788`,0.006706788`,0.008733254`,0.008651638`,0.008717821`,0.007177038`,0.008845904`,0.007629354`,0.008439338`,0.008547638`,0.007363338`,0.008653721`,0.008715338`,0.010168904`,0.008630721`,0.008671654`,0.010373454`,0.011015288`,0.010988704`,0.009528721`,0.008241404`,0.007538154`,0.016215438`,0.016719721`,0.016821704`,0.016836004`,0.016162388`,0.017542171`,0.017601221`,0.016612621`,0.014743804`,0.014434638`,0.014296904`,0.014602188`,0.007390304`,0.007538154`,0.012017004`,0.012962588`,0.011565438`,0.010987704`,0.011750954`,0.014844954`,0.013630021`,0.007538154`,0.007085504`,0.007074104`,0.010104754`,0.007060538`,0.007601771`,0.017171438`,0.009560304`,0.009836671`,0.018861104`,0.015016771`,0.015327021`,0.014645204`,0.014613838`,0.020673904`,0.020570188`,0.013095088`,0.012808271`,0.015558654`,0.016805304`,0.016103154`,0.015823188`,0.019370321`,0.016132204`,0.013036821`,0.016738021`,0.015501271`,0.016888704`,0.009513471`,0.009708471`,0.009563454`,0.009563454`,0.011172271`,0.009952388`,0.009484621`,0.005746538`,0.009267671`,0.008771204`,0.005224288`,0.004668738`,0.004581554`,0.008399204`,0.008870854`,0.011394988`,0.005733104`,0.011857888`,0.011869888`,0.011017221`,0.008870854`,0.008399204`,0.007572554`,0.011877888`,0.008807204`,0.007949204`,0.007949204`,0.007968854`,0.011305854`,0.007877754`,0.011556221`,0.007947738`,0.011513954`,0.011467671`,0.005307904`},{8/1539,0.007603946`,0.007556263`,0.007556263`,0.007475913`,0.008090596`,0.009140946`,0.009009013`,0.008957363`,0.008253046`,0.009210179`,0.008778896`,0.008761863`,0.009134029`,0.008384596`,0.008070179`,0.009522146`,0.009436279`,0.009916313`,0.007438646`,0.010542763`,0.009098779`,0.009493946`,0.009804463`,0.007965596`,0.009646996`,0.008973663`,0.010232513`,0.008796279`,0.008838746`,0.010965113`,0.010877546`,0.010657679`,0.009427679`,0.008290979`,0.009436146`,0.016077929`,0.016427296`,0.016156513`,0.016451796`,0.016192329`,0.017239579`,0.016150763`,0.016285779`,0.012739146`,0.012740929`,0.012738663`,0.012812213`,0.009230929`,0.009436146`,0.013130763`,0.011892996`,0.012843096`,0.011417963`,0.013113279`,0.012965146`,0.011799863`,0.009436146`,0.008718279`,0.008724879`,0.013851513`,0.008757946`,0.010405029`,0.014256179`,0.011739279`,0.012007063`,0.016919696`,0.013625246`,0.014881863`,0.013725596`,0.014206746`,0.019963696`,0.020431363`,0.011522429`,0.011445629`,0.014242529`,0.016144046`,0.014650113`,0.014309179`,0.018871596`,0.014629979`,0.012413246`,0.015898346`,0.014231346`,0.016469113`,0.010688746`,0.010946746`,0.010755113`,0.010755113`,0.012700746`,0.009157729`,0.008773096`,0.006195863`,0.009214779`,0.009579829`,0.005256329`,0.006830729`,0.006724263`,0.008262629`,0.008814263`,0.010959029`,0.005673013`,0.011438779`,0.011432613`,0.010255663`,0.008814263`,0.008262629`,0.007090596`,0.011419163`,0.008810563`,0.007811846`,0.007811846`,0.007792779`,0.010701129`,0.007522429`,0.011075329`,0.007535513`,0.010914413`,0.010905879`,0.006678946`},{2/405,0.007849108`,0.007815275`,0.007815275`,0.007731025`,0.008186758`,0.009662808`,0.009272725`,0.009381025`,0.009454825`,0.009701142`,0.009911942`,0.009036975`,0.009960075`,0.008289542`,0.008050375`,0.010058975`,0.009965525`,0.010043825`,0.007706392`,0.010345692`,0.009572675`,0.009417025`,0.009706142`,0.007702375`,0.010315208`,0.007939342`,0.010191692`,0.009702258`,0.009721525`,0.010679975`,0.011445408`,0.011724192`,0.009152992`,0.008181792`,0.010101258`,0.017101075`,0.017393442`,0.016825275`,0.017468158`,0.017443608`,0.018200625`,0.017556675`,0.017599742`,0.013381975`,0.013350908`,0.013390558`,0.013407475`,0.009820825`,0.010101258`,0.012518842`,0.011464825`,0.012310842`,0.010882858`,0.012612758`,0.012753992`,0.011817158`,0.010101258`,0.009429925`,0.009439875`,0.015065608`,0.009470675`,0.011385275`,0.013978142`,0.011192275`,0.012583958`,0.015277608`,0.013504408`,0.015154208`,0.012640408`,0.014172625`,0.017584875`,0.018827408`,0.010703625`,0.011307625`,0.012196342`,0.015046725`,0.012581792`,0.012152458`,0.017345758`,0.012518308`,0.011552092`,0.014674108`,0.012196608`,0.015674258`,0.010730608`,0.010938658`,0.010783408`,0.010783408`,0.011321375`,0.009183692`,0.008048358`,0.006895008`,0.008810608`,0.008252342`,0.004242042`,0.008015925`,0.008008058`,0.007940292`,0.008587175`,0.009996708`,0.005355225`,0.010424475`,0.011475825`,0.008886775`,0.008587175`,0.007940292`,0.006618242`,0.011535525`,0.008677975`,0.007641242`,0.007641242`,0.007525908`,0.009584692`,0.006676025`,0.009630442`,0.006704925`,0.010048392`,0.009973692`,0.007662592`},{8/1701,0.008086475`,0.008048058`,0.008048058`,0.008021375`,0.008076192`,0.008902542`,0.009980275`,0.008747342`,0.009626108`,0.008998842`,0.010116092`,0.009888742`,0.008316975`,0.008832875`,0.007962275`,0.011073325`,0.010976425`,0.010584675`,0.008903158`,0.010181492`,0.009293275`,0.010011025`,0.010404625`,0.008863375`,0.010718758`,0.008684342`,0.009829308`,0.010038608`,0.009975792`,0.010449542`,0.010603392`,0.010867758`,0.009475508`,0.008937908`,0.008433408`,0.016812658`,0.018270908`,0.016330692`,0.018266458`,0.017937625`,0.018303242`,0.016394175`,0.016814275`,0.012789208`,0.013017542`,0.012782892`,0.012675708`,0.008117642`,0.008433408`,0.010929058`,0.010778158`,0.010777942`,0.009844325`,0.010866308`,0.013023892`,0.011384408`,0.008433408`,0.007802025`,0.007815108`,0.012480125`,0.007823442`,0.008876058`,0.013774425`,0.010892392`,0.011315992`,0.013951608`,0.013128358`,0.014035242`,0.013086358`,0.014473858`,0.017612058`,0.018100575`,0.010351458`,0.010945858`,0.010882492`,0.013152758`,0.011095092`,0.010686058`,0.015783592`,0.011016458`,0.010770492`,0.012711908`,0.010931708`,0.014731792`,0.009017258`,0.009418692`,0.009131408`,0.009131408`,0.009251992`,0.009245092`,0.007651975`,0.004889742`,0.009632925`,0.008088892`,0.003424842`,0.007408058`,0.007310725`,0.007739192`,0.008462542`,0.009834258`,0.005420342`,0.010063142`,0.011580825`,0.008154342`,0.008462542`,0.007739192`,0.006322592`,0.011660875`,0.008629675`,0.007276008`,0.007276008`,0.007193825`,0.009190358`,0.006601575`,0.009305958`,0.006615258`,0.009934592`,0.009800225`,0.006506508`},{4/891,0.009104729`,0.009074446`,0.009074446`,0.009073463`,0.008773629`,0.009321329`,0.010701463`,0.009324146`,0.009971129`,0.009434313`,0.010946463`,0.010904129`,0.008562813`,0.009542746`,0.008571013`,0.011217813`,0.011239063`,0.011080546`,0.009329013`,0.010660113`,0.009694079`,0.010003296`,0.010526996`,0.010408046`,0.011538246`,0.009371596`,0.009985429`,0.011645996`,0.011472313`,0.010645779`,0.010001929`,0.011715763`,0.010352113`,0.009638846`,0.009612429`,0.016240663`,0.018534213`,0.016016746`,0.018497546`,0.016973463`,0.018549946`,0.015596496`,0.016516279`,0.012089679`,0.011955646`,0.011923346`,0.012033213`,0.009088563`,0.009612429`,0.012052313`,0.011642463`,0.011876863`,0.010615129`,0.012012063`,0.013156463`,0.011157229`,0.009612429`,0.008998979`,0.009004429`,0.013499979`,0.009036679`,0.010778079`,0.013686696`,0.011199063`,0.011819246`,0.015307629`,0.012016263`,0.013577096`,0.013537863`,0.013678796`,0.018027096`,0.017341163`,0.011509663`,0.011164563`,0.011001213`,0.013146313`,0.011224613`,0.010826696`,0.016740079`,0.011160796`,0.010055263`,0.012621613`,0.010998796`,0.014574613`,0.010073313`,0.010590779`,0.010212096`,0.010212096`,0.012002746`,0.009793363`,0.008951163`,0.004349579`,0.009449513`,0.008350913`,0.003724813`,0.007115413`,0.006895496`,0.007972379`,0.008582246`,0.010583063`,0.005234779`,0.010795079`,0.011702463`,0.009234996`,0.008582246`,0.007972379`,0.006501263`,0.011888663`,0.008659329`,0.007333679`,0.007333679`,0.007433313`,0.010052946`,0.006838046`,0.009551863`,0.006903663`,0.010187579`,0.010169763`,0.005683579`},{8/1863,0.009521467`,0.009468067`,0.009468067`,0.0093312`,0.010071983`,0.010553217`,0.01057235`,0.01063325`,0.009770333`,0.010628367`,0.011253767`,0.011245167`,0.009923183`,0.0092693`,0.0081464`,0.012364867`,0.012328017`,0.012043333`,0.010352483`,0.011891667`,0.009902217`,0.010287867`,0.010788983`,0.011080717`,0.0123601`,0.01061335`,0.011421667`,0.012964233`,0.01267435`,0.012169017`,0.012134817`,0.014110517`,0.013785717`,0.013342067`,0.009479633`,0.016591933`,0.018665083`,0.016375067`,0.01867505`,0.017998067`,0.0190073`,0.015230867`,0.018337133`,0.013652033`,0.01357915`,0.01355165`,0.0136209`,0.009250517`,0.009479633`,0.0114159`,0.01088165`,0.01130875`,0.01012465`,0.01149925`,0.0124538`,0.01189285`,0.009479633`,0.008879733`,0.0088866`,0.013513567`,0.008917533`,0.010350433`,0.014837133`,0.012717667`,0.013395417`,0.015392417`,0.012820867`,0.01440235`,0.0139927`,0.015576783`,0.017876067`,0.016741217`,0.0117376`,0.011796083`,0.011656233`,0.013170933`,0.011900167`,0.01141865`,0.0170682`,0.011817017`,0.01057865`,0.012834717`,0.01167345`,0.0136031`,0.011555533`,0.011751233`,0.011603583`,0.011603583`,0.012546233`,0.007908967`,0.007782117`,0.004133683`,0.007587467`,0.009177283`,0.00398625`,0.005999533`,0.0058773`,0.008350033`,0.00886155`,0.010201567`,0.004699883`,0.0106145`,0.011420767`,0.009077483`,0.00886155`,0.008350033`,0.006871683`,0.01154775`,0.008821683`,0.008053967`,0.008053967`,0.00803345`,0.009755867`,0.0071694`,0.0100768`,0.007238983`,0.010667317`,0.0106304`,0.00546495`},{1/243,0.009791279`,0.009780963`,0.009780963`,0.009705979`,0.009831846`,0.010118463`,0.010621846`,0.010178896`,0.010896129`,0.010300179`,0.010812596`,0.010934329`,0.009918679`,0.010953429`,0.010022746`,0.013472029`,0.013432446`,0.013613946`,0.011820413`,0.013475346`,0.012082213`,0.012371746`,0.013049179`,0.012367429`,0.012461946`,0.013502946`,0.011185429`,0.013857196`,0.013599513`,0.015181096`,0.013486479`,0.014851446`,0.013806279`,0.013678263`,0.009766879`,0.017331446`,0.017864713`,0.017850313`,0.017865146`,0.017948046`,0.018837629`,0.015248896`,0.018425729`,0.013330113`,0.013407846`,0.013562196`,0.013537729`,0.010163479`,0.009766879`,0.012048713`,0.012322096`,0.011967246`,0.011381846`,0.012028279`,0.013559546`,0.012794796`,0.009766879`,0.009556629`,0.009495946`,0.012749946`,0.009455446`,0.009936563`,0.014648629`,0.013951746`,0.014477063`,0.015364363`,0.014212696`,0.016018879`,0.015210646`,0.015374796`,0.017590813`,0.017043496`,0.013002163`,0.014362846`,0.013406179`,0.015601729`,0.013704546`,0.013041213`,0.018114213`,0.013572413`,0.010479613`,0.015322829`,0.013441296`,0.016146463`,0.011115679`,0.011420946`,0.011196863`,0.011196863`,0.012020996`,0.007908113`,0.007045563`,0.004388496`,0.007572929`,0.008835613`,0.004034496`,0.007333879`,0.007213496`,0.008735679`,0.009204529`,0.010055996`,0.005685613`,0.010445446`,0.011605146`,0.008975396`,0.009204529`,0.008735679`,0.007574929`,0.011725113`,0.009113063`,0.008709279`,0.008709279`,0.008508096`,0.009673446`,0.006282113`,0.010006329`,0.006295429`,0.010464779`,0.010468646`,0.006111563`},{8/2025,0.009967317`,0.009982717`,0.009982717`,0.009907133`,0.00987325`,0.01026305`,0.010401533`,0.01016905`,0.009712683`,0.010327417`,0.0103063`,0.010175533`,0.010443867`,0.010043283`,0.009275683`,0.014575333`,0.014577017`,0.014399833`,0.010822167`,0.013538117`,0.009845217`,0.011777117`,0.012645683`,0.01363685`,0.013467667`,0.013841367`,0.010290333`,0.013300883`,0.013221117`,0.01579195`,0.014829933`,0.015851667`,0.01578065`,0.0148508`,0.010408567`,0.0160212`,0.017011733`,0.01629275`,0.016894217`,0.017130717`,0.017173067`,0.0151123`,0.0179554`,0.01298475`,0.0129459`,0.013062217`,0.013104533`,0.010465283`,0.010408567`,0.012367717`,0.0115833`,0.01204725`,0.010641783`,0.012372183`,0.013993833`,0.011857633`,0.010408567`,0.010180233`,0.010133733`,0.013824917`,0.010112083`,0.01071705`,0.0141495`,0.0133741`,0.0140172`,0.0157106`,0.0150988`,0.0156976`,0.015040117`,0.0163818`,0.016662433`,0.017196833`,0.013755267`,0.01532965`,0.01424345`,0.015504167`,0.014597067`,0.014226867`,0.01746335`,0.014560833`,0.011530917`,0.015298533`,0.014211567`,0.016026017`,0.010140933`,0.010567367`,0.010261133`,0.010261133`,0.01049855`,0.00830065`,0.006928583`,0.0042356`,0.0074798`,0.009017433`,0.00407635`,0.00693095`,0.006774917`,0.008086183`,0.008739517`,0.009849667`,0.006420367`,0.009891317`,0.011476117`,0.008754683`,0.008739517`,0.008086183`,0.00707575`,0.01173355`,0.008840367`,0.007725367`,0.007725367`,0.007609967`,0.009556483`,0.006090533`,0.00885655`,0.00611595`,0.0088479`,0.008783483`,0.006190383`},{4/1053,0.007296263`,0.007303663`,0.007303663`,0.007292946`,0.007273263`,0.009993963`,0.008233246`,0.009981296`,0.009205779`,0.010086663`,0.009078579`,0.008737996`,0.010269313`,0.010825946`,0.010687379`,0.014970179`,0.014970846`,0.013935146`,0.011767079`,0.012053813`,0.010252463`,0.010598613`,0.011677963`,0.014820746`,0.014481013`,0.014687396`,0.011342179`,0.013672796`,0.013687313`,0.016203529`,0.015243179`,0.015556729`,0.015147746`,0.015010129`,0.010841029`,0.016224279`,0.016726813`,0.016946379`,0.016585513`,0.017483529`,0.016643846`,0.015550496`,0.017716079`,0.013239229`,0.013079529`,0.012950329`,0.013040546`,0.010950913`,0.010841029`,0.011907913`,0.012221996`,0.011686196`,0.010778779`,0.011810296`,0.014540429`,0.012445029`,0.010841029`,0.010749813`,0.010673613`,0.012908629`,0.010665479`,0.010567479`,0.013998746`,0.012345313`,0.013676646`,0.014177763`,0.012973079`,0.015959579`,0.014524029`,0.015849929`,0.016975029`,0.016639846`,0.014239696`,0.015996563`,0.014065196`,0.015317096`,0.014394629`,0.014209413`,0.016828646`,0.014416196`,0.011471663`,0.015178579`,0.014062729`,0.015942196`,0.010137079`,0.010695896`,0.010296979`,0.010296979`,0.010413429`,0.008229763`,0.008243896`,0.004092496`,0.008066113`,0.009458746`,0.004324646`,0.006483479`,0.006389129`,0.007173546`,0.008046396`,0.010656963`,0.006149479`,0.010438463`,0.011834729`,0.009378563`,0.008046396`,0.007173546`,0.005931229`,0.012019729`,0.008358513`,0.006368013`,0.006368013`,0.006336529`,0.010295163`,0.005809813`,0.008746379`,0.005803696`,0.008130129`,0.008047696`,0.005660713`},{8/2187,0.010081671`,0.010047138`,0.010047138`,0.009913521`,0.010396288`,0.011555504`,0.010406421`,0.011590471`,0.010335604`,0.011631971`,0.010501738`,0.010152021`,0.011704521`,0.011801638`,0.010673154`,0.015115604`,0.015031421`,0.014726638`,0.013257721`,0.013689321`,0.012415221`,0.012650738`,0.013497838`,0.014029138`,0.014237588`,0.012415021`,0.010176871`,0.012639271`,0.012772671`,0.013538721`,0.014512821`,0.016113271`,0.012052538`,0.012112671`,0.011292804`,0.016594671`,0.016214338`,0.016919204`,0.016201821`,0.017202638`,0.016730471`,0.016066471`,0.017273871`,0.013316154`,0.013105554`,0.013177538`,0.013335304`,0.011540904`,0.011292804`,0.011406388`,0.011028904`,0.011476571`,0.011035038`,0.011435188`,0.012278388`,0.011857554`,0.011292804`,0.011161638`,0.011021638`,0.012185238`,0.011031788`,0.010765204`,0.014562371`,0.013669854`,0.014717004`,0.014248871`,0.014044771`,0.016973071`,0.014984988`,0.015225838`,0.016283021`,0.016127371`,0.013987504`,0.015030204`,0.013864704`,0.014301304`,0.013998021`,0.013933088`,0.016788104`,0.014077154`,0.011828621`,0.014148238`,0.013931188`,0.014986971`,0.008419554`,0.008753704`,0.008512204`,0.008512204`,0.009030904`,0.010062971`,0.010066771`,0.004486438`,0.008499404`,0.009061438`,0.004481738`,0.006278104`,0.006200071`,0.007302538`,0.008168521`,0.010916454`,0.006356304`,0.010775221`,0.011809038`,0.009447204`,0.008168521`,0.007302538`,0.006243704`,0.011985704`,0.008470638`,0.006253854`,0.006253854`,0.006272288`,0.010409004`,0.005935088`,0.008236004`,0.005998054`,0.008385438`,0.008291321`,0.005174304`},{2/567,0.009361096`,0.009312346`,0.009312346`,0.009163863`,0.009783846`,0.012854696`,0.009923463`,0.012680713`,0.011748346`,0.012906263`,0.011732563`,0.010675229`,0.012971096`,0.014062363`,0.012202729`,0.014555513`,0.014509396`,0.015254846`,0.013858229`,0.015194763`,0.014700096`,0.015294979`,0.015371579`,0.013204963`,0.013636796`,0.012666413`,0.009229229`,0.011463163`,0.011572946`,0.012735596`,0.013837246`,0.015352846`,0.012020496`,0.012153746`,0.011778229`,0.016687079`,0.017276163`,0.016731813`,0.017375029`,0.015738779`,0.018168579`,0.016877196`,0.016401229`,0.012699496`,0.012511963`,0.012417196`,0.012505946`,0.012318829`,0.011778229`,0.012448363`,0.011359363`,0.012387363`,0.011334629`,0.012480479`,0.013310996`,0.011397379`,0.011778229`,0.011528596`,0.011430879`,0.013786213`,0.011418113`,0.011626013`,0.013763646`,0.014503979`,0.015200496`,0.015627946`,0.012825663`,0.015905079`,0.014726829`,0.016100829`,0.017555946`,0.017601129`,0.011530729`,0.013002946`,0.013985713`,0.015133129`,0.014161629`,0.013741896`,0.017314263`,0.014101263`,0.011889246`,0.014947746`,0.014050963`,0.015543196`,0.007871396`,0.008038446`,0.007912796`,0.007912796`,0.008728146`,0.009723646`,0.009098596`,0.004535696`,0.009384963`,0.007761529`,0.004547179`,0.006368429`,0.006140913`,0.007612379`,0.008454013`,0.010959813`,0.005919463`,0.010909796`,0.012049346`,0.009520246`,0.008454013`,0.007612379`,0.006243763`,0.012274613`,0.008731329`,0.006440746`,0.006440746`,0.006575963`,0.010466179`,0.005961546`,0.008038896`,0.006016329`,0.008173313`,0.008159863`,0.003875446`},{8/2349,0.009795688`,0.009730138`,0.009730138`,0.009651704`,0.009516571`,0.013508904`,0.011273521`,0.013279938`,0.012909671`,0.013528954`,0.012770171`,0.012570104`,0.013830388`,0.013535604`,0.012347021`,0.014158371`,0.014086454`,0.014864504`,0.013972354`,0.014652571`,0.014528588`,0.015190254`,0.014980971`,0.013100554`,0.013642554`,0.012752504`,0.010602904`,0.012191638`,0.012194454`,0.014296671`,0.014125138`,0.015456438`,0.012561588`,0.012761554`,0.012113388`,0.016448371`,0.018965788`,0.016511021`,0.019082821`,0.016410388`,0.019860971`,0.017524988`,0.017330571`,0.015328238`,0.015219038`,0.015128588`,0.015201838`,0.012632271`,0.012113388`,0.014132838`,0.013250971`,0.013996771`,0.012774221`,0.014172771`,0.015624988`,0.013974421`,0.012113388`,0.012088071`,0.012027788`,0.015406854`,0.011998054`,0.012974271`,0.016382971`,0.014489071`,0.015310721`,0.017386221`,0.013468521`,0.017048371`,0.015691938`,0.016338154`,0.018325321`,0.018399838`,0.012880688`,0.014200604`,0.014170221`,0.015554021`,0.014522288`,0.014130371`,0.017779638`,0.014486521`,0.011967904`,0.015320671`,0.014206938`,0.015575071`,0.008100638`,0.008311388`,0.008156421`,0.008156421`,0.009035554`,0.008829188`,0.007337804`,0.005175988`,0.009365154`,0.007594721`,0.004760188`,0.006973504`,0.006849388`,0.008260571`,0.008924754`,0.010600754`,0.005845138`,0.010654004`,0.012108171`,0.009175788`,0.008924754`,0.008260571`,0.006784971`,0.012259738`,0.009042138`,0.007689754`,0.007689754`,0.007786838`,0.010103521`,0.006202338`,0.009076738`,0.006226121`,0.008585904`,0.008518038`,0.004489554`},{4/1215,0.009729921`,0.009650671`,0.009650671`,0.009504988`,0.009897321`,0.013575504`,0.011950421`,0.013352771`,0.012591704`,0.013554688`,0.012608304`,0.012428754`,0.013914254`,0.013203154`,0.012681754`,0.014500804`,0.014413754`,0.015817704`,0.013323204`,0.014560654`,0.013811054`,0.014559671`,0.014759238`,0.013602071`,0.013570438`,0.014831621`,0.010172288`,0.012091138`,0.012019288`,0.016679421`,0.014977754`,0.016664421`,0.015830221`,0.016169754`,0.014375971`,0.018574454`,0.019643904`,0.017746454`,0.019735854`,0.018839038`,0.020154604`,0.018768354`,0.019125038`,0.015673788`,0.015474171`,0.015514704`,0.015637388`,0.014136121`,0.014375971`,0.015418354`,0.014680638`,0.015460671`,0.014639088`,0.015442121`,0.015713654`,0.014265421`,0.014375971`,0.014104771`,0.014177454`,0.017012721`,0.014122104`,0.014993738`,0.017051604`,0.014778621`,0.015599221`,0.017461238`,0.015033921`,0.017204654`,0.016193438`,0.017020238`,0.018269304`,0.018534754`,0.014385938`,0.015545821`,0.014912338`,0.015365104`,0.015122638`,0.014745938`,0.017562571`,0.015083871`,0.012765338`,0.015098388`,0.014909104`,0.015110338`,0.009701304`,0.010266438`,0.009858138`,0.009858138`,0.010748071`,0.007912604`,0.007188471`,0.005062954`,0.008223888`,0.007221788`,0.003951021`,0.006573688`,0.006423871`,0.008806521`,0.009352271`,0.010699838`,0.005637071`,0.010988754`,0.011824754`,0.009589788`,0.009352271`,0.008806521`,0.007601321`,0.012001604`,0.009342971`,0.008730254`,0.008730254`,0.008632938`,0.010280338`,0.006287654`,0.009937704`,0.006301871`,0.009384504`,0.009423371`,0.006136621`},{8/2511,0.010451004`,0.010376488`,0.010376488`,0.010250421`,0.010394588`,0.013590121`,0.012368554`,0.013375338`,0.013060321`,0.013555121`,0.012805621`,0.011933271`,0.013942188`,0.014018154`,0.012880588`,0.016908404`,0.016823204`,0.017007038`,0.014705904`,0.015923054`,0.014543988`,0.015558221`,0.016032438`,0.016574888`,0.015724921`,0.017236571`,0.011121604`,0.015970421`,0.016056604`,0.016636588`,0.016006821`,0.017546038`,0.016429121`,0.016817304`,0.014752571`,0.017757671`,0.018519204`,0.017305904`,0.018514138`,0.017883371`,0.018239838`,0.018004438`,0.017623988`,0.015913538`,0.015788604`,0.015778404`,0.015871821`,0.014540504`,0.014752571`,0.014998504`,0.014627588`,0.014938854`,0.014233038`,0.014966738`,0.015196704`,0.014406838`,0.014752571`,0.014670371`,0.014589054`,0.015590988`,0.014563554`,0.014378954`,0.017054621`,0.015406721`,0.016540888`,0.017340221`,0.015677804`,0.017935071`,0.016859238`,0.018475888`,0.018806054`,0.019060171`,0.015362804`,0.016666154`,0.015329254`,0.011722821`,0.015456138`,0.015327604`,0.018861104`,0.015483454`,0.013831121`,0.011890021`,0.015284271`,0.012135704`,0.013163354`,0.013500188`,0.013253421`,0.013253421`,0.013803804`,0.008062488`,0.006885388`,0.004663221`,0.007960338`,0.006513688`,0.004209988`,0.004442421`,0.004314904`,0.008474388`,0.009015038`,0.010636621`,0.005987788`,0.011109871`,0.011550454`,0.009681838`,0.009015038`,0.008474388`,0.007522604`,0.011606804`,0.009004038`,0.008262521`,0.008262521`,0.008178721`,0.010271871`,0.006440421`,0.009594971`,0.006482671`,0.010272588`,0.010237704`,0.005816071`},{1/9,0.011147858`,0.011093292`,0.011093292`,0.010941142`,0.011314858`,0.013056142`,0.011828625`,0.012877442`,0.013614558`,0.013048775`,0.013201808`,0.012278308`,0.013520975`,0.014885158`,0.013281642`,0.015941492`,0.015893275`,0.016090708`,0.015321492`,0.016055025`,0.015085025`,0.015756692`,0.015821458`,0.015273042`,0.015411342`,0.011738042`,0.007556125`,0.010274775`,0.010772442`,0.014130725`,0.015182608`,0.016836775`,0.009334808`,0.009159592`,0.014344958`,0.016890992`,0.016157758`,0.016481675`,0.016220125`,0.016411808`,0.016133525`,0.017703608`,0.017567242`,0.016143358`,0.015967925`,0.015846775`,0.015956542`,0.014245175`,0.014344958`,0.014877025`,0.014683208`,0.014816525`,0.014313908`,0.014816392`,0.015646525`,0.014751592`,0.014344958`,0.014313808`,0.014238242`,0.014722575`,0.014188458`,0.014087008`,0.017293625`,0.015940675`,0.016611342`,0.018510375`,0.015329658`,0.017275825`,0.016555575`,0.016933975`,0.019251958`,0.019840925`,0.015807158`,0.016563442`,0.015123492`,0.017113742`,0.015197542`,0.015599325`,0.019395325`,0.015380525`,0.013817642`,0.016790725`,0.014999775`,0.018815858`,0.012684758`,0.012877392`,0.012730425`,0.012730425`,0.013406942`,0.008509125`,0.008196975`,0.004346575`,0.007732492`,0.007925025`,0.004440025`,0.004661592`,0.004525192`,0.008674575`,0.009260458`,0.010731208`,0.005535442`,0.011078625`,0.011251208`,0.009585025`,0.009260458`,0.008674575`,0.006656242`,0.011201258`,0.009291158`,0.008636175`,0.008636175`,0.008608142`,0.010266558`,0.009594725`,0.010701508`,0.009587158`,0.008398258`,0.008502275`,0.007394092`},{1/18,0.010807958`,0.010780192`,0.010780192`,0.010691108`,0.010498025`,0.012914975`,0.012344392`,0.012891742`,0.014348308`,0.012920875`,0.013636092`,0.012894092`,0.013734258`,0.015390525`,0.014004875`,0.013724908`,0.013527758`,0.015434775`,0.013453925`,0.015873625`,0.015792708`,0.015735175`,0.015642092`,0.009367942`,0.011589308`,0.008999092`,0.007656325`,0.007655425`,0.007705925`,0.010573675`,0.013591925`,0.015098925`,0.008782292`,0.008890208`,0.014643192`,0.017221042`,0.017205042`,0.016645658`,0.017173342`,0.017007058`,0.017286925`,0.018099525`,0.017829158`,0.015228042`,0.015209608`,0.015200775`,0.015243592`,0.014526992`,0.014643192`,0.015673342`,0.015389875`,0.015768258`,0.015278575`,0.015639758`,0.015967708`,0.014821258`,0.014643192`,0.014751175`,0.014615192`,0.014574692`,0.014573492`,0.014205892`,0.016069725`,0.016230342`,0.016638558`,0.018039308`,0.015881675`,0.016600942`,0.016729458`,0.015961525`,0.019365075`,0.019226558`,0.014055275`,0.014454192`,0.014678275`,0.017942842`,0.014813142`,0.014966692`,0.019090692`,0.014906908`,0.013833092`,0.017510742`,0.014577775`,0.018133358`,0.010770725`,0.011007908`,0.010830692`,0.010830692`,0.012106542`,0.007368308`,0.006180008`,0.005365558`,0.007909375`,0.006486008`,0.004847358`,0.005166992`,0.005069342`,0.008718558`,0.009248575`,0.010825792`,0.005389642`,0.011120742`,0.011222808`,0.009639508`,0.009248575`,0.008718558`,0.007442458`,0.011185208`,0.009219842`,0.008471708`,0.008471708`,0.008424692`,0.010346908`,0.008367375`,0.009128358`,0.008354958`,0.008434808`,0.008280908`,0.005496792`},{1/27,0.010601775`,0.010619275`,0.010619275`,0.010526942`,0.010411008`,0.012376008`,0.011928275`,0.012274942`,0.014138658`,0.012384725`,0.014354642`,0.012996242`,0.012675375`,0.014835208`,0.013359092`,0.012508658`,0.012383625`,0.014637242`,0.012902958`,0.014772058`,0.014946092`,0.015193742`,0.014328075`,0.009570925`,0.010593108`,0.009548842`,0.011128842`,0.009429125`,0.009454658`,0.011704575`,0.012742292`,0.013668992`,0.010947492`,0.010795742`,0.014025925`,0.016995675`,0.017514125`,0.016839458`,0.017493342`,0.017470825`,0.017661208`,0.018596308`,0.018011158`,0.015172492`,0.015313408`,0.015297325`,0.015264058`,0.013420925`,0.014025925`,0.015147942`,0.015074958`,0.015265275`,0.015308708`,0.015006842`,0.015266842`,0.015269175`,0.014025925`,0.014181258`,0.014072642`,0.014324375`,0.014021225`,0.013646842`,0.016541242`,0.015449875`,0.015295492`,0.017593025`,0.016380092`,0.016309458`,0.015995292`,0.015972975`,0.018574592`,0.018514492`,0.014789858`,0.014724158`,0.016656592`,0.018286525`,0.016980175`,0.016820758`,0.019005408`,0.017031892`,0.014106792`,0.017947175`,0.016545692`,0.018226075`,0.010777758`,0.011055142`,0.010848208`,0.010848208`,0.012925175`,0.008189542`,0.008617575`,0.004168675`,0.007296825`,0.005251058`,0.004821675`,0.005430775`,0.005302542`,0.008418275`,0.008889075`,0.010847542`,0.004850958`,0.011203942`,0.011390192`,0.009663242`,0.008889075`,0.008418275`,0.007311542`,0.011375675`,0.008808425`,0.008084758`,0.008084758`,0.008055825`,0.010372075`,0.008164792`,0.008495558`,0.008208542`,0.008549858`,0.008483958`,0.005924592`},{1/36,0.010484042`,0.010440208`,0.010440208`,0.010288658`,0.010348758`,0.011758408`,0.011124792`,0.011690992`,0.013469475`,0.011800242`,0.012484692`,0.011345008`,0.011718275`,0.013678808`,0.012305825`,0.011119042`,0.011017475`,0.013333542`,0.011899242`,0.014435692`,0.013551142`,0.013682408`,0.013407692`,0.010286142`,0.010548108`,0.011289692`,0.010735742`,0.008292625`,0.008621492`,0.012963575`,0.011861308`,0.011939242`,0.012428408`,0.012636825`,0.012747925`,0.016939575`,0.017167192`,0.016783158`,0.017130092`,0.017082392`,0.017125692`,0.018196308`,0.017507275`,0.015995375`,0.015918992`,0.015778458`,0.015829592`,0.012123958`,0.012747925`,0.015200392`,0.015763425`,0.015145325`,0.015091825`,0.014933825`,0.016137025`,0.015839892`,0.012747925`,0.012790708`,0.012792875`,0.014575725`,0.012696775`,0.013191225`,0.016401692`,0.015099625`,0.015006008`,0.016805175`,0.015675625`,0.016166025`,0.015122192`,0.016214725`,0.018685108`,0.019289858`,0.015357642`,0.014402942`,0.016792725`,0.017263592`,0.016951608`,0.016886108`,0.018572058`,0.017023958`,0.014106042`,0.016859358`,0.016703108`,0.017304975`,0.010791125`,0.011008992`,0.010845808`,0.010845808`,0.011330392`,0.009525575`,0.008830675`,0.004365525`,0.009003608`,0.007768792`,0.004354025`,0.004983592`,0.004889142`,0.008510225`,0.008980608`,0.010603658`,0.005701375`,0.011126975`,0.011371525`,0.010029242`,0.008980608`,0.008510225`,0.007642758`,0.011295992`,0.008893025`,0.008307092`,0.008307092`,0.008184208`,0.010445758`,0.009275008`,0.008912975`,0.009307608`,0.009430625`,0.009344692`,0.005418158`},{1/45,0.008694288`,0.008680538`,0.008680538`,0.008655554`,0.008258021`,0.010923604`,0.010782521`,0.010721988`,0.012160721`,0.010928754`,0.011528571`,0.010991571`,0.011422688`,0.012564788`,0.012463154`,0.011105938`,0.011033738`,0.011496288`,0.011032104`,0.013424904`,0.013157488`,0.012249888`,0.012486921`,0.010243671`,0.010705071`,0.010970104`,0.012377138`,0.008188871`,0.008201021`,0.013213804`,0.012553638`,0.012483454`,0.013775188`,0.012876221`,0.012926354`,0.016535421`,0.016736871`,0.016490904`,0.016659354`,0.017269271`,0.016892088`,0.018569121`,0.017897604`,0.015856954`,0.015758421`,0.015582321`,0.015644304`,0.012519804`,0.012926354`,0.013861471`,0.014628004`,0.013867838`,0.013708338`,0.013891904`,0.016247221`,0.015306604`,0.012926354`,0.013039071`,0.013007338`,0.014276521`,0.012917671`,0.013161138`,0.015649154`,0.014164788`,0.013298854`,0.015150504`,0.015116404`,0.012789004`,0.013054688`,0.013260771`,0.017841604`,0.018320438`,0.015096654`,0.014216338`,0.016237321`,0.016282954`,0.016461254`,0.016419254`,0.018645521`,0.016540721`,0.013610121`,0.016070321`,0.016143738`,0.016131304`,0.010286821`,0.010913154`,0.010459104`,0.010459104`,0.011238738`,0.009498838`,0.008805688`,0.004796338`,0.009853021`,0.010501154`,0.003497888`,0.007179171`,0.007064138`,0.008344388`,0.008880388`,0.010963538`,0.005665454`,0.011462054`,0.011731038`,0.010678204`,0.008880388`,0.008344388`,0.007227454`,0.011723854`,0.008861738`,0.007961038`,0.007961038`,0.007915904`,0.010965171`,0.009242454`,0.008898821`,0.009262988`,0.009065454`,0.009015754`,0.006459171`},{1/54,0.008808275`,0.008809725`,0.008809725`,0.008826808`,0.008134008`,0.010963492`,0.011421592`,0.010884742`,0.012531025`,0.010975775`,0.011958325`,0.011523775`,0.011324775`,0.012254825`,0.011784992`,0.011262858`,0.011120708`,0.012119375`,0.011226208`,0.012789958`,0.011871008`,0.012449608`,0.012070542`,0.009579408`,0.010716242`,0.011722925`,0.013452725`,0.010377708`,0.010154392`,0.014153542`,0.013311858`,0.012028142`,0.014487408`,0.014182575`,0.012964642`,0.016739475`,0.016700908`,0.016873625`,0.016587792`,0.018058958`,0.016537425`,0.017521175`,0.018274175`,0.015709608`,0.015346758`,0.015183925`,0.015402392`,0.012668408`,0.012964642`,0.013628908`,0.013614975`,0.013639642`,0.013293592`,0.013633108`,0.015140842`,0.013997275`,0.012964642`,0.013056792`,0.012992458`,0.012701392`,0.012912475`,0.012731342`,0.016754775`,0.013644825`,0.014248425`,0.013448075`,0.014901642`,0.012860425`,0.015198642`,0.013181592`,0.015879792`,0.017434058`,0.014941092`,0.014421575`,0.015237392`,0.016898558`,0.015543108`,0.016028692`,0.017819375`,0.015790125`,0.013972708`,0.016500992`,0.015048175`,0.017162542`,0.011343108`,0.011762708`,0.011455392`,0.011455392`,0.012587475`,0.009202958`,0.009406275`,0.005227842`,0.009204725`,0.010620525`,0.003733592`,0.008351942`,0.008234992`,0.008434842`,0.008996642`,0.011041075`,0.006449425`,0.011510042`,0.011700758`,0.010538425`,0.008996642`,0.008434842`,0.007090092`,0.011759508`,0.009002558`,0.008415142`,0.008415142`,0.008269208`,0.010920142`,0.008639292`,0.008526175`,0.008684258`,0.009156275`,0.009096325`,0.006352308`},{1/63,0.009715183`,0.009598317`,0.009598317`,0.009452783`,0.009612867`,0.01183375`,0.0113705`,0.011618067`,0.01207215`,0.01175495`,0.012540133`,0.011991017`,0.0122656`,0.012699367`,0.011927167`,0.011822183`,0.01176635`,0.0114207`,0.010775483`,0.011486733`,0.011023817`,0.011598383`,0.011258317`,0.01021955`,0.011190717`,0.012435133`,0.011178283`,0.011464317`,0.011345183`,0.01499735`,0.014035433`,0.01235075`,0.012416417`,0.012511983`,0.013328283`,0.017338733`,0.017607567`,0.017212617`,0.017513883`,0.017478833`,0.017135083`,0.01759875`,0.017879533`,0.015357467`,0.014631633`,0.014622417`,0.0150494`,0.0129463`,0.013328283`,0.014614167`,0.014109817`,0.014671333`,0.0139984`,0.014566717`,0.015704917`,0.013923217`,0.013328283`,0.013252867`,0.01317845`,0.014421333`,0.01311875`,0.013509533`,0.017295933`,0.01236795`,0.01285955`,0.014401217`,0.013962267`,0.0126144`,0.015847217`,0.012607517`,0.01689385`,0.018098983`,0.014566483`,0.01464945`,0.015192933`,0.017239333`,0.015364917`,0.016031267`,0.0179203`,0.0156626`,0.014210267`,0.0170401`,0.014988467`,0.016775567`,0.010520083`,0.010899267`,0.010627583`,0.010627583`,0.011785733`,0.009158`,0.00906805`,0.00591245`,0.0086997`,0.008643467`,0.004507917`,0.0083534`,0.008267017`,0.008554917`,0.009124967`,0.011108783`,0.006529383`,0.011636633`,0.011993233`,0.01079095`,0.009124967`,0.008554917`,0.007242733`,0.012038983`,0.009128183`,0.008191917`,0.008191917`,0.008159783`,0.011088517`,0.0095782`,0.00911205`,0.009591533`,0.0099172`,0.009948333`,0.005932783`},{1/72,0.011192683`,0.011163017`,0.011163017`,0.0110411`,0.01120545`,0.012675233`,0.0115334`,0.012617017`,0.0111773`,0.01272195`,0.011970583`,0.011723017`,0.013029217`,0.012178567`,0.0118375`,0.009934133`,0.009843067`,0.011482483`,0.009837933`,0.011909183`,0.01105195`,0.011958583`,0.01139545`,0.008853483`,0.0097206`,0.008050833`,0.007363617`,0.00805525`,0.00807555`,0.009703767`,0.010660333`,0.011663083`,0.008663967`,0.008616017`,0.013560483`,0.0177421`,0.017892717`,0.017788717`,0.017862067`,0.0177188`,0.017896`,0.018184117`,0.017447283`,0.015712367`,0.0156821`,0.015610517`,0.015624217`,0.013604317`,0.013560483`,0.015316833`,0.015172467`,0.015326`,0.0141921`,0.015305983`,0.016612967`,0.015363683`,0.013560483`,0.013297033`,0.013217167`,0.0153486`,0.013183217`,0.013996283`,0.01533485`,0.012720817`,0.012863467`,0.013105933`,0.015215767`,0.013004383`,0.014161217`,0.0127123`,0.014372483`,0.0172121`,0.009787983`,0.0106869`,0.013569833`,0.015629567`,0.01386375`,0.013959383`,0.018182367`,0.013962367`,0.010838217`,0.015367383`,0.013476917`,0.01607645`,0.009808217`,0.010002617`,0.00985605`,0.00985605`,0.01175785`,0.008302333`,0.007608583`,0.005977033`,0.009587367`,0.008301583`,0.005417583`,0.009638217`,0.0093492`,0.008613483`,0.00915825`,0.0110655`,0.006901233`,0.01158075`,0.012111917`,0.0110371`,0.00915825`,0.008613483`,0.0075374`,0.012222983`,0.009134083`,0.008327883`,0.008327883`,0.008259633`,0.011212467`,0.009966883`,0.01011505`,0.01002525`,0.010360133`,0.0103196`,0.006606867`},{1/81,0.010410329`,0.010492796`,0.010492796`,0.010480129`,0.010254413`,0.010317613`,0.009724596`,0.010238429`,0.007287713`,0.010327396`,0.008115646`,0.008445013`,0.009993479`,0.008788713`,0.008107863`,0.008855579`,0.008832079`,0.008863013`,0.007609329`,0.008458579`,0.008338446`,0.008326479`,0.008350646`,0.008700379`,0.009035279`,0.008999479`,0.007671629`,0.009584613`,0.009535929`,0.010715796`,0.009385163`,0.009503813`,0.009777996`,0.009857079`,0.009218696`,0.018252646`,0.017857446`,0.018039079`,0.017816079`,0.018343096`,0.017874896`,0.017108896`,0.017557796`,0.011633429`,0.011379913`,0.011375046`,0.011511846`,0.009234913`,0.009218696`,0.010890813`,0.010270596`,0.010675563`,0.009380813`,0.010911163`,0.012688396`,0.010113363`,0.009218696`,0.008916896`,0.008906713`,0.012630246`,0.008887379`,0.009783846`,0.011186813`,0.008819779`,0.008877463`,0.010459896`,0.010945379`,0.009073979`,0.009352029`,0.009130696`,0.014186879`,0.016045063`,0.008415179`,0.009147079`,0.009126829`,0.011263796`,0.009338096`,0.009481779`,0.015881496`,0.009440746`,0.009538346`,0.010845396`,0.009106029`,0.012292863`,0.010772246`,0.011095379`,0.010858829`,0.010858829`,0.012620313`,0.008168396`,0.007343713`,0.006360529`,0.009146663`,0.008753479`,0.005925463`,0.008916079`,0.008712529`,0.008211263`,0.008836863`,0.010672246`,0.006175546`,0.011259296`,0.011991563`,0.010029463`,0.008836863`,0.008211263`,0.006916096`,0.012112013`,0.008913696`,0.007550963`,0.007550963`,0.007619146`,0.010487113`,0.009084963`,0.009353929`,0.009134046`,0.010413146`,0.010365229`,0.006060979`},{1/90,0.006500313`,0.006508963`,0.006508963`,0.006483463`,0.006636163`,0.008009063`,0.007152279`,0.007999763`,0.008603396`,0.008095779`,0.008122063`,0.007498246`,0.007699729`,0.007568163`,0.006980296`,0.011817229`,0.011871963`,0.009722113`,0.011811263`,0.008491046`,0.008909146`,0.008456163`,0.008753246`,0.012424846`,0.012463279`,0.010834246`,0.009283279`,0.011541479`,0.011618079`,0.011558846`,0.010053329`,0.010597596`,0.010621446`,0.010752513`,0.007417879`,0.017232229`,0.017984729`,0.016958063`,0.017935613`,0.017417663`,0.017754896`,0.015548729`,0.017268146`,0.009816563`,0.009576096`,0.009497896`,0.009593929`,0.007529929`,0.007417879`,0.008979913`,0.008803629`,0.008879879`,0.008230113`,0.008960129`,0.010344029`,0.008847196`,0.007417879`,0.007043229`,0.007025096`,0.010301563`,0.007012179`,0.007676596`,0.009210963`,0.008918563`,0.009227579`,0.008590179`,0.009669863`,0.009474296`,0.009409096`,0.009686946`,0.010752063`,0.014413079`,0.009223096`,0.009697546`,0.009585596`,0.011134396`,0.009726879`,0.009806363`,0.013167479`,0.009806646`,0.011047246`,0.010777229`,0.009537146`,0.012149779`,0.009111763`,0.009464113`,0.009205679`,0.009205679`,0.010066996`,0.007740129`,0.006622129`,0.005418329`,0.008537379`,0.008878113`,0.005376879`,0.008363763`,0.008283246`,0.008747446`,0.009238046`,0.010796346`,0.006578129`,0.011308363`,0.011850763`,0.010231896`,0.009238046`,0.008747446`,0.007770646`,0.012046229`,0.009175146`,0.008324213`,0.008324213`,0.008311979`,0.010639429`,0.009411113`,0.009768913`,0.009452829`,0.009646363`,0.009494063`,0.005211163`},{1/99,0.009597313`,0.009635629`,0.009635629`,0.009539946`,0.009989246`,0.010536396`,0.009023929`,0.010573046`,0.011358029`,0.010668213`,0.010540996`,0.010067029`,0.010279263`,0.011391479`,0.011169463`,0.013310713`,0.013310813`,0.012150679`,0.012989196`,0.010581379`,0.013044996`,0.011650563`,0.011436096`,0.013131129`,0.013352196`,0.011663646`,0.011166746`,0.011473746`,0.011671446`,0.012821863`,0.010778396`,0.011904746`,0.012423029`,0.012227529`,0.009625063`,0.016234946`,0.017742896`,0.015850313`,0.017716229`,0.017171213`,0.017822579`,0.015301996`,0.017488279`,0.011738979`,0.011519729`,0.011373079`,0.011474179`,0.010150213`,0.009625063`,0.010008263`,0.010117296`,0.010019596`,0.009683329`,0.010003563`,0.011514029`,0.010315996`,0.009625063`,0.009394929`,0.009320063`,0.011663546`,0.009282579`,0.008880446`,0.010674629`,0.010670196`,0.010900296`,0.010554279`,0.010535529`,0.010214113`,0.010234063`,0.010293496`,0.014336929`,0.017014413`,0.011382363`,0.011258313`,0.011355529`,0.012775263`,0.011533729`,0.012069529`,0.014301463`,0.011774113`,0.012929563`,0.012540246`,0.011201729`,0.013435479`,0.008781363`,0.008955946`,0.008821646`,0.008821646`,0.010449013`,0.006951079`,0.006490763`,0.004531196`,0.006827779`,0.008584096`,0.004908246`,0.008169846`,0.008056413`,0.008545363`,0.009077013`,0.010462046`,0.006449246`,0.010795579`,0.011059079`,0.009536363`,0.009077013`,0.008545363`,0.007593679`,0.011176746`,0.009044563`,0.007924379`,0.007924379`,0.007983646`,0.010113779`,0.009230913`,0.009440696`,0.009283596`,0.009444963`,0.009328646`,0.005417946`},{1/108,0.011540042`,0.011507892`,0.011507892`,0.011339125`,0.011780192`,0.013192258`,0.010407158`,0.013241158`,0.012181008`,0.013240658`,0.011163908`,0.010735658`,0.012961275`,0.012762375`,0.012546892`,0.013410992`,0.013403642`,0.012491525`,0.012419492`,0.011765942`,0.012970692`,0.012253458`,0.012086692`,0.012243008`,0.012505442`,0.010734242`,0.010281525`,0.008505958`,0.008632375`,0.014459958`,0.013599292`,0.013178008`,0.009068742`,0.008713308`,0.011353725`,0.014876325`,0.014687208`,0.014975042`,0.014949342`,0.015547575`,0.016493825`,0.015379875`,0.016504458`,0.011925675`,0.011950458`,0.011953158`,0.011954908`,0.012062208`,0.011353725`,0.011458758`,0.010971575`,0.011477875`,0.010843992`,0.011488642`,0.011496192`,0.010592058`,0.011353725`,0.011310608`,0.011187942`,0.012750042`,0.011157025`,0.010405942`,0.013074908`,0.011925708`,0.012219425`,0.014985425`,0.012513208`,0.011326392`,0.012139908`,0.011878658`,0.018432858`,0.018981608`,0.014691992`,0.015197842`,0.013326008`,0.013895858`,0.013341808`,0.013837892`,0.016717808`,0.013561042`,0.013217708`,0.013647408`,0.013153058`,0.014142175`,0.008415075`,0.008632975`,0.008468892`,0.008468892`,0.009656642`,0.007291675`,0.006410642`,0.004525108`,0.006981758`,0.007804925`,0.004881225`,0.007633642`,0.007558392`,0.008693808`,0.009237375`,0.010288908`,0.006422392`,0.010626358`,0.011056242`,0.009110392`,0.009237375`,0.008693808`,0.007507392`,0.011142758`,0.009206675`,0.008266942`,0.008266942`,0.008267542`,0.009822142`,0.008573875`,0.008813058`,0.008623975`,0.009228325`,0.009154842`,0.004891408`},{1/117,0.009840846`,0.009830513`,0.009830513`,0.009725279`,0.009820579`,0.010854846`,0.009509029`,0.010742446`,0.009964779`,0.010945513`,0.009639163`,0.009580179`,0.011577263`,0.013600813`,0.011790696`,0.014064046`,0.013946196`,0.013867879`,0.010810896`,0.012293296`,0.013190496`,0.012630379`,0.012797913`,0.011057046`,0.011072829`,0.009069346`,0.010862779`,0.009547629`,0.009597163`,0.013275979`,0.014988179`,0.015378296`,0.010056079`,0.010143746`,0.011798196`,0.014375046`,0.017210063`,0.014633646`,0.017103096`,0.014998213`,0.016655863`,0.016917763`,0.015691713`,0.011495013`,0.011480429`,0.011487563`,0.011525396`,0.012007196`,0.011798196`,0.011936629`,0.011151179`,0.011962013`,0.011116363`,0.011993496`,0.012196579`,0.010786779`,0.011798196`,0.011822513`,0.011743946`,0.014097779`,0.011706746`,0.011420146`,0.013331196`,0.012697513`,0.013358429`,0.016835729`,0.013055879`,0.013923796`,0.013031663`,0.014681163`,0.018667529`,0.018361163`,0.014904079`,0.016301646`,0.013878763`,0.015356746`,0.013943413`,0.014284563`,0.017970646`,0.014097979`,0.012618429`,0.015065613`,0.013719796`,0.015480596`,0.008026046`,0.008202929`,0.008069829`,0.008069829`,0.009420396`,0.007079246`,0.006004396`,0.004257913`,0.006346613`,0.007508096`,0.005120196`,0.007150363`,0.007009646`,0.008680846`,0.009230596`,0.010247129`,0.006827546`,0.010768763`,0.011374496`,0.009403113`,0.009230596`,0.008680846`,0.007879613`,0.011432879`,0.009213196`,0.008249063`,0.008249063`,0.008149913`,0.009985296`,0.008544146`,0.008509246`,0.008597013`,0.008518446`,0.008399713`,0.005340063`},{1/126,0.010883896`,0.010808729`,0.010808729`,0.010586679`,0.011409663`,0.012852529`,0.010783679`,0.012921346`,0.012683479`,0.012969363`,0.012123613`,0.011727646`,0.012999563`,0.013461979`,0.012955213`,0.015028146`,0.014897946`,0.015171163`,0.011870679`,0.014098929`,0.014702663`,0.013948346`,0.014584396`,0.010943696`,0.011707696`,0.010267563`,0.010091779`,0.007790346`,0.008012129`,0.014486846`,0.013901463`,0.015488863`,0.010067263`,0.009771979`,0.011703463`,0.015860646`,0.017647446`,0.016153763`,0.017640946`,0.016587379`,0.017653829`,0.016995029`,0.017155929`,0.012720979`,0.012653313`,0.012686146`,0.012728879`,0.012375596`,0.011703463`,0.013503313`,0.012608546`,0.013297463`,0.012174246`,0.013553079`,0.014097379`,0.012007163`,0.011703463`,0.011786779`,0.011666613`,0.014617013`,0.011627129`,0.011184146`,0.014895163`,0.014042229`,0.015341279`,0.016801963`,0.013453446`,0.016712646`,0.015097696`,0.016945629`,0.018301429`,0.017519013`,0.014611446`,0.015383213`,0.016208879`,0.016517563`,0.016224129`,0.016193029`,0.018212496`,0.016269629`,0.012740463`,0.016249579`,0.016179746`,0.016560996`,0.006704663`,0.006761629`,0.006714113`,0.006714113`,0.007949096`,0.006202046`,0.005153746`,0.004340229`,0.006555829`,0.007448463`,0.005672563`,0.005966129`,0.005804679`,0.008239146`,0.008856596`,0.010373596`,0.006056046`,0.010850079`,0.011449379`,0.009490346`,0.008856596`,0.008239146`,0.007530679`,0.011522829`,0.008914746`,0.007594146`,0.007594146`,0.007566346`,0.010075063`,0.007214896`,0.007266096`,0.007269779`,0.008539479`,0.008497196`,0.004518313`},{1/135,0.014068708`,0.014041058`,0.014041058`,0.013681425`,0.014467925`,0.014358208`,0.012355858`,0.014442792`,0.008886425`,0.014407775`,0.010505358`,0.011755742`,0.014364792`,0.012353342`,0.011920125`,0.009110192`,0.009048158`,0.011543175`,0.007192308`,0.013015942`,0.010616775`,0.012754025`,0.012347875`,0.007581225`,0.008530958`,0.007038175`,0.006780625`,0.006969592`,0.006999058`,0.010583875`,0.013359192`,0.013774808`,0.007085092`,0.006914575`,0.013311725`,0.017422608`,0.018196158`,0.017235158`,0.018284892`,0.017671192`,0.018724958`,0.016761808`,0.017659808`,0.014854275`,0.014691525`,0.014581442`,0.014666942`,0.013649692`,0.013311725`,0.015215825`,0.015208958`,0.015271808`,0.014808375`,0.015251392`,0.015492642`,0.013970658`,0.013311725`,0.013212942`,0.013109308`,0.016047775`,0.013048458`,0.013778125`,0.015600792`,0.013692942`,0.014163375`,0.016258942`,0.015356542`,0.015334275`,0.014902125`,0.015538492`,0.017463108`,0.017428908`,0.012450975`,0.013447642`,0.015313625`,0.016343258`,0.015387175`,0.015185058`,0.017397075`,0.015381708`,0.011155175`,0.016107008`,0.015293725`,0.016589758`,0.006460642`,0.006462158`,0.006455092`,0.006455092`,0.007576125`,0.007408542`,0.007425125`,0.003438108`,0.006709575`,0.007099942`,0.005357825`,0.004919142`,0.004757958`,0.008168208`,0.008873542`,0.010790475`,0.005880675`,0.011208025`,0.011676908`,0.009885108`,0.008873542`,0.008168208`,0.007263025`,0.011687858`,0.009002208`,0.007422825`,0.007422825`,0.007309108`,0.010476908`,0.008946592`,0.008713592`,0.008994475`,0.009449125`,0.009396458`,0.004938608`},{1/144,0.011875654`,0.011861254`,0.011861254`,0.011663888`,0.012714921`,0.012365554`,0.009477254`,0.012217171`,0.007595038`,0.012324854`,0.007742554`,0.007652354`,0.012582438`,0.009395438`,0.008904254`,0.007784071`,0.007712771`,0.007882721`,0.007379888`,0.009014721`,0.008636221`,0.008776938`,0.008669821`,0.006462588`,0.007339471`,0.005555204`,0.006352338`,0.005589371`,0.005659871`,0.007437554`,0.008109421`,0.008345388`,0.006182254`,0.005952621`,0.012506038`,0.017445171`,0.018534688`,0.017919938`,0.018580704`,0.018101388`,0.018673604`,0.016780571`,0.017461038`,0.013544304`,0.013336004`,0.013223104`,0.013358521`,0.012156471`,0.012506038`,0.015158221`,0.014208588`,0.015207871`,0.013887954`,0.015227554`,0.014677488`,0.012889671`,0.012506038`,0.012148904`,0.012220438`,0.016158271`,0.012161438`,0.013291121`,0.013338621`,0.009783538`,0.009696004`,0.013997054`,0.012678621`,0.012027938`,0.011769471`,0.012223738`,0.016490671`,0.016818138`,0.008749338`,0.008711721`,0.013336788`,0.015084371`,0.013552004`,0.013699104`,0.016959904`,0.013664738`,0.009117271`,0.014865221`,0.013265938`,0.015305538`,0.007342554`,0.007541554`,0.007392188`,0.007392188`,0.009254321`,0.008503704`,0.007955888`,0.004013438`,0.007501321`,0.006912754`,0.005153121`,0.005158071`,0.005029671`,0.008551654`,0.009129604`,0.011023054`,0.007253254`,0.011457088`,0.011979988`,0.010291321`,0.009129604`,0.008551654`,0.008100904`,0.011996421`,0.009144904`,0.008102171`,0.008102171`,0.007894638`,0.010790354`,0.009695254`,0.009597888`,0.009753954`,0.010323554`,0.010270038`,0.005546354`},{1/153,0.008977308`,0.009015075`,0.009015075`,0.008936608`,0.009410192`,0.010420475`,0.008267475`,0.010289792`,0.008119092`,0.010396475`,0.008326608`,0.007670792`,0.010460275`,0.008539158`,0.008632358`,0.006923608`,0.006827842`,0.006515892`,0.006804408`,0.006602675`,0.007890292`,0.007415675`,0.006847175`,0.005544025`,0.006860008`,0.004617058`,0.004489742`,0.005212775`,0.005214975`,0.005863625`,0.006004008`,0.006829292`,0.004920592`,0.004933308`,0.010556375`,0.016761742`,0.018476875`,0.016951608`,0.018432042`,0.017372542`,0.018570708`,0.015418792`,0.017255958`,0.009172242`,0.009076525`,0.009149592`,0.009182558`,0.010237075`,0.010556375`,0.012894208`,0.011945275`,0.012687458`,0.011437508`,0.012853592`,0.012865525`,0.009248092`,0.010556375`,0.010159508`,0.010205292`,0.013412608`,0.010179142`,0.011470392`,0.008774142`,0.006647942`,0.006483892`,0.009497608`,0.009383475`,0.007478875`,0.007380008`,0.006787625`,0.012157725`,0.013741258`,0.005169425`,0.005492308`,0.006821742`,0.008771992`,0.006922608`,0.007182808`,0.011404758`,0.007036242`,0.007433442`,0.008436175`,0.006758592`,0.010047158`,0.007595725`,0.008017925`,0.007715208`,0.007715208`,0.008677442`,0.007374442`,0.006610542`,0.004576008`,0.007716042`,0.006878408`,0.005412208`,0.005498075`,0.005322308`,0.008484692`,0.009087508`,0.011069975`,0.007214608`,0.011583358`,0.012195192`,0.010469592`,0.009087508`,0.008484692`,0.007712092`,0.012272875`,0.009118142`,0.007738258`,0.007738258`,0.007798942`,0.010899992`,0.010286892`,0.009787742`,0.010347025`,0.010451625`,0.010396725`,0.005911808`},{1/162,0.008573621`,0.008601054`,0.008601054`,0.008560388`,0.009114521`,0.010616804`,0.008823004`,0.010556288`,0.007199804`,0.010626104`,0.007790404`,0.008038921`,0.010510254`,0.006758504`,0.007107338`,0.006781188`,0.006680954`,0.006906754`,0.005959504`,0.006521288`,0.006838938`,0.006835071`,0.006685321`,0.006143488`,0.006494221`,0.004773488`,0.005416454`,0.005710521`,0.005907121`,0.005944154`,0.005447588`,0.006513688`,0.004847804`,0.004900704`,0.010174804`,0.012817688`,0.017369088`,0.012741588`,0.017282654`,0.015961238`,0.017337071`,0.008459288`,0.015893854`,0.006495121`,0.006538804`,0.006578521`,0.006558054`,0.010205454`,0.010174804`,0.011288354`,0.009261171`,0.011088588`,0.009002121`,0.011358371`,0.010648404`,0.007051838`,0.010174804`,0.009630438`,0.009592071`,0.012416404`,0.009656788`,0.009775038`,0.006569821`,0.006603654`,0.006670621`,0.006618204`,0.006898871`,0.006226271`,0.006939204`,0.006008538`,0.008507438`,0.008963238`,0.005085404`,0.005615738`,0.005750238`,0.006151488`,0.005801838`,0.005962254`,0.007287471`,0.005877638`,0.006714554`,0.006043121`,0.005707088`,0.006103921`,0.007431271`,0.007734904`,0.007517271`,0.007517271`,0.008443604`,0.005365221`,0.004264004`,0.004665404`,0.007677771`,0.007098538`,0.005303904`,0.005633488`,0.005516388`,0.009050571`,0.009636238`,0.011424438`,0.006629371`,0.011754271`,0.012124521`,0.010749071`,0.009636238`,0.009050571`,0.007634238`,0.012240454`,0.009639704`,0.008948754`,0.008948754`,0.008796604`,0.011227554`,0.010798904`,0.010766604`,0.010866688`,0.010692521`,0.010676771`,0.006789804`},{1/171,0.0096675`,0.009779717`,0.009779717`,0.0097794`,0.009836033`,0.00965755`,0.008936617`,0.009666717`,0.0071608`,0.009704033`,0.007508883`,0.007885833`,0.009251167`,0.006933867`,0.00686795`,0.007697517`,0.0076809`,0.007207333`,0.0078961`,0.007065167`,0.007600667`,0.007386517`,0.00718445`,0.006825967`,0.0075241`,0.005635267`,0.006794933`,0.00599695`,0.006070717`,0.006988283`,0.005963033`,0.007022683`,0.006611567`,0.0065644`,0.008039783`,0.007639567`,0.017209283`,0.008040817`,0.017306433`,0.009903833`,0.017191667`,0.006766783`,0.010405283`,0.006264783`,0.00631585`,0.006355517`,0.006333267`,0.008329783`,0.008039783`,0.006939083`,0.005995717`,0.006854967`,0.00601805`,0.00698475`,0.006542617`,0.005531017`,0.008039783`,0.007524767`,0.007475317`,0.009510467`,0.007509183`,0.007805967`,0.006776317`,0.006965767`,0.007279417`,0.00615985`,0.006864333`,0.0060111`,0.007223617`,0.006315183`,0.006958783`,0.008338583`,0.00607545`,0.006400617`,0.00612545`,0.006605517`,0.006144917`,0.006183183`,0.0082533`,0.006177983`,0.0071943`,0.006499167`,0.006094433`,0.006666767`,0.008707067`,0.009004383`,0.008787817`,0.008787817`,0.0094863`,0.003988917`,0.0032293`,0.005325817`,0.006804183`,0.007258233`,0.004928483`,0.005264233`,0.005205233`,0.00942465`,0.009884883`,0.011290983`,0.007026817`,0.011553283`,0.012135517`,0.010538717`,0.009884883`,0.00942465`,0.0082848`,0.012327917`,0.00977475`,0.009573233`,0.009573233`,0.009323217`,0.01108765`,0.0092595`,0.009006317`,0.009269817`,0.00928475`,0.009321167`,0.0065643`},{1/180,0.007243808`,0.007301642`,0.007301642`,0.007245025`,0.008077208`,0.008038558`,0.007158575`,0.008123825`,0.006987442`,0.008157325`,0.007098358`,0.007130875`,0.007784908`,0.008160858`,0.007505342`,0.008378225`,0.008321642`,0.008730342`,0.006353125`,0.007690275`,0.008516858`,0.008361208`,0.008370275`,0.006648658`,0.007692425`,0.007029775`,0.007247075`,0.005353025`,0.005376075`,0.008813808`,0.007270325`,0.008386825`,0.008248075`,0.008211325`,0.007309875`,0.008742058`,0.017400775`,0.008725875`,0.017520675`,0.010539725`,0.017434142`,0.007671675`,0.010959525`,0.006867575`,0.007009142`,0.006951575`,0.006897375`,0.007659658`,0.007309875`,0.006845108`,0.006679358`,0.006934808`,0.006738958`,0.006840758`,0.006716525`,0.006520242`,0.007309875`,0.006931558`,0.006891225`,0.007974125`,0.006850175`,0.006718042`,0.006844275`,0.007741508`,0.007892825`,0.007242342`,0.007718692`,0.006892458`,0.007516875`,0.007465858`,0.008848275`,0.009863308`,0.007551508`,0.008120808`,0.007494792`,0.008372075`,0.007525142`,0.007715325`,0.011850858`,0.007619492`,0.008294025`,0.008217758`,0.007435492`,0.008630308`,0.008447408`,0.008728358`,0.008519325`,0.008519325`,0.009346875`,0.004366742`,0.003858542`,0.004049775`,0.005709142`,0.008088158`,0.004983642`,0.005499092`,0.005359092`,0.008039225`,0.008751658`,0.011666492`,0.007611758`,0.012012575`,0.012221858`,0.011174375`,0.008751658`,0.008039225`,0.007519592`,0.012321775`,0.008896942`,0.007647092`,0.007647092`,0.007497975`,0.011578975`,0.008003742`,0.008042192`,0.007991658`,0.007513642`,0.007449442`,0.004762792`},{1/189,0.006247363`,0.006308329`,0.006308329`,0.006285063`,0.007069363`,0.007492446`,0.006371396`,0.007330246`,0.006121946`,0.007481813`,0.006018346`,0.006087779`,0.008327496`,0.008657629`,0.007458729`,0.009102829`,0.009072846`,0.009397846`,0.006340896`,0.008421996`,0.007986646`,0.009438296`,0.009243063`,0.007896029`,0.008152279`,0.008360529`,0.006945763`,0.006410113`,0.006466029`,0.010249996`,0.009202363`,0.009573629`,0.008313463`,0.008486279`,0.009487163`,0.012801246`,0.016700463`,0.012596463`,0.016537579`,0.015616096`,0.016456429`,0.009980796`,0.014595179`,0.007352129`,0.007400546`,0.007380579`,0.007362813`,0.009275563`,0.009487163`,0.007964746`,0.007401279`,0.008073196`,0.007686446`,0.008010429`,0.007629913`,0.006892946`,0.009487163`,0.009132063`,0.009029479`,0.009746279`,0.009039429`,0.008232829`,0.007593729`,0.008281746`,0.008539279`,0.009473896`,0.008037896`,0.007913496`,0.008075079`,0.009132413`,0.013406096`,0.013896029`,0.009484063`,0.010254046`,0.009856013`,0.011984096`,0.009954646`,0.009965429`,0.014744996`,0.009999079`,0.008350546`,0.011705079`,0.009767479`,0.012306179`,0.008488929`,0.008705763`,0.008543146`,0.008543146`,0.009526513`,0.005918163`,0.005679146`,0.004111363`,0.005035546`,0.006768363`,0.004172813`,0.005742629`,0.005552329`,0.007036196`,0.008025829`,0.011043929`,0.005750946`,0.011363163`,0.011684279`,0.010212863`,0.008025829`,0.007036196`,0.005736479`,0.011829229`,0.008443963`,0.006442679`,0.006442679`,0.006398896`,0.010768563`,0.007432113`,0.007513013`,0.007458296`,0.007060113`,0.007115996`,0.005243579`},{1/198,0.009501871`,0.009546688`,0.009546688`,0.009369721`,0.010217754`,0.010754871`,0.008750371`,0.010879754`,0.007250988`,0.010892221`,0.007472121`,0.007532721`,0.010331754`,0.009742571`,0.009183804`,0.007385854`,0.007362488`,0.009274521`,0.005709321`,0.009012571`,0.009129788`,0.009124804`,0.009060654`,0.005900371`,0.006550988`,0.006722054`,0.007799754`,0.006001021`,0.006182621`,0.010433688`,0.011810204`,0.010655204`,0.007656488`,0.007259171`,0.010038371`,0.015734471`,0.016353254`,0.015571388`,0.016189621`,0.016128621`,0.016091088`,0.012252471`,0.016438854`,0.008309804`,0.008439654`,0.008449821`,0.008392421`,0.010400404`,0.010038371`,0.009011254`,0.008100538`,0.009078404`,0.008605938`,0.009103421`,0.008485704`,0.007763938`,0.010038371`,0.009816621`,0.009681588`,0.012032521`,0.009688154`,0.008877721`,0.008402671`,0.009627238`,0.009819771`,0.010638638`,0.009701138`,0.010511688`,0.010228721`,0.011712838`,0.012951054`,0.013315954`,0.010644321`,0.011909054`,0.011207204`,0.012808571`,0.011280171`,0.011359438`,0.015516271`,0.011347188`,0.008528904`,0.012586521`,0.011101354`,0.013451538`,0.009778438`,0.010092938`,0.009855171`,0.009855171`,0.011201121`,0.006703604`,0.005972338`,0.003705438`,0.005686754`,0.006304238`,0.002566538`,0.005218938`,0.005044021`,0.006350454`,0.007545688`,0.010604271`,0.004261554`,0.010807254`,0.011240471`,0.009485838`,0.007545688`,0.006350454`,0.003806654`,0.011283404`,0.008171288`,0.005327538`,0.005327538`,0.005525021`,0.010198738`,0.006725054`,0.007034804`,0.006734488`,0.006706854`,0.006743704`,0.004346621`},{1/207,0.009999633`,0.010103483`,0.010103483`,0.010040733`,0.010122417`,0.007948667`,0.0072212`,0.008058117`,0.005459783`,0.007971817`,0.006273183`,0.006687167`,0.007691517`,0.0059844`,0.005739017`,0.005603017`,0.00561085`,0.005519267`,0.004869683`,0.00570395`,0.006136333`,0.005648`,0.00550335`,0.00522235`,0.005666967`,0.00612945`,0.009540867`,0.0060225`,0.00608145`,0.010609767`,0.01148655`,0.00716225`,0.008839533`,0.00811675`,0.00723975`,0.014263533`,0.016354017`,0.014076617`,0.016272883`,0.01448315`,0.016172133`,0.012951583`,0.015736383`,0.010126067`,0.0101962`,0.010219867`,0.010212717`,0.007218833`,0.00723975`,0.00781925`,0.008407317`,0.00792025`,0.00801265`,0.00775415`,0.0088523`,0.008559167`,0.00723975`,0.006893417`,0.006905833`,0.009263217`,0.006892133`,0.0071251`,0.011307317`,0.006639217`,0.006905783`,0.011267983`,0.0109087`,0.011658083`,0.009701783`,0.012426033`,0.0125333`,0.012989633`,0.010786883`,0.0114989`,0.011448733`,0.0138462`,0.011579`,0.011779`,0.01621595`,0.0116923`,0.0118968`,0.01356035`,0.0113108`,0.013901783`,0.010702667`,0.010890767`,0.010748617`,0.010748617`,0.010960233`,0.00640795`,0.0055926`,0.0035083`,0.008349983`,0.005894483`,0.00240855`,0.004684917`,0.004528717`,0.006355317`,0.007487017`,0.010104833`,0.00331675`,0.010317467`,0.011362417`,0.008644833`,0.007487017`,0.006355317`,0.003795`,0.011594283`,0.008055033`,0.0054473`,0.0054473`,0.005596383`,0.00951645`,0.0063046`,0.006710883`,0.006362233`,0.006367833`,0.006331`,0.0039918`},{1/216,0.007205663`,0.007347246`,0.007347246`,0.007449579`,0.007084779`,0.006142946`,0.006656629`,0.006259013`,0.005512846`,0.006248946`,0.006160813`,0.006335896`,0.005754113`,0.006009229`,0.005142879`,0.006903513`,0.006921729`,0.005855696`,0.006128479`,0.005292129`,0.005800379`,0.005476896`,0.005518563`,0.007146446`,0.007559246`,0.009338663`,0.011121763`,0.007619363`,0.007637896`,0.012822929`,0.011060663`,0.007619296`,0.013194196`,0.012660879`,0.005245996`,0.014706929`,0.015651946`,0.015240379`,0.015630579`,0.014539329`,0.015751579`,0.013323163`,0.015416596`,0.008064596`,0.007874346`,0.007833696`,0.007913896`,0.005334346`,0.005245996`,0.005158029`,0.006000979`,0.005225029`,0.005097946`,0.005095579`,0.007696829`,0.006479996`,0.005245996`,0.005095329`,0.005036013`,0.006286346`,0.005023796`,0.004581846`,0.008245829`,0.005621996`,0.005892413`,0.011414113`,0.006824979`,0.008480013`,0.006667263`,0.011209479`,0.013575546`,0.014561929`,0.011351996`,0.012270263`,0.011927646`,0.014727796`,0.012091063`,0.012248463`,0.015757629`,0.012182513`,0.012857246`,0.014505046`,0.011787463`,0.014734029`,0.009477979`,0.009790496`,0.009555996`,0.009555996`,0.010271363`,0.008275163`,0.007876296`,0.003572496`,0.008601696`,0.008531696`,0.003359446`,0.006172529`,0.006009863`,0.006828329`,0.007772863`,0.010056379`,0.003733063`,0.010478479`,0.010843729`,0.009071779`,0.007772863`,0.006828329`,0.004918729`,0.010798763`,0.008156829`,0.006190463`,0.006190463`,0.006203463`,0.009676379`,0.006553763`,0.006677346`,0.006624713`,0.006232029`,0.006190763`,0.003840779`},{1/225,0.007203633`,0.007310133`,0.007310133`,0.007353667`,0.007279917`,0.006996217`,0.007275817`,0.00707745`,0.0065027`,0.0070966`,0.006880883`,0.006866233`,0.006428917`,0.006085833`,0.005878767`,0.009110233`,0.009099483`,0.007748483`,0.0087472`,0.0068744`,0.007080567`,0.006783017`,0.007045583`,0.009810467`,0.0093395`,0.0130143`,0.011788167`,0.010630467`,0.01056075`,0.0136763`,0.010696967`,0.009697067`,0.01401055`,0.01346775`,0.005754933`,0.012935183`,0.016687983`,0.0134843`,0.0167109`,0.013837733`,0.01662185`,0.014036683`,0.014598467`,0.008637233`,0.008450333`,0.00855295`,0.008640483`,0.005887467`,0.005754933`,0.005527`,0.0061156`,0.005628933`,0.005644383`,0.005468183`,0.006414367`,0.00665675`,0.005754933`,0.005522283`,0.005485033`,0.007234467`,0.0054649`,0.005160967`,0.010478283`,0.0073946`,0.008057917`,0.0118168`,0.008041483`,0.0089761`,0.009179617`,0.010763117`,0.0148583`,0.01647585`,0.01231235`,0.012650983`,0.012251283`,0.014346517`,0.012412283`,0.012577867`,0.016439567`,0.012509667`,0.013261617`,0.014146467`,0.012084633`,0.014377533`,0.008624517`,0.00889455`,0.008693133`,0.008693133`,0.007995567`,0.007274033`,0.006885583`,0.005033917`,0.007180667`,0.006090217`,0.006286017`,0.006050467`,0.0059398`,0.008258067`,0.0088486`,0.010147783`,0.00513495`,0.010564283`,0.010874917`,0.009302117`,0.0088486`,0.008258067`,0.008016167`,0.010834783`,0.00888655`,0.009186467`,0.009186467`,0.008781567`,0.009852533`,0.006502117`,0.007034`,0.006538367`,0.00651695`,0.006495117`,0.004086017`},{1/234,0.006794563`,0.006866213`,0.006866213`,0.006884679`,0.007237329`,0.008030129`,0.007323496`,0.008067179`,0.009201579`,0.008130446`,0.009078013`,0.008439796`,0.007524713`,0.009546913`,0.008102863`,0.012397196`,0.012369913`,0.011600196`,0.011236013`,0.010325579`,0.009828963`,0.010269896`,0.010469513`,0.012001829`,0.011138963`,0.012780363`,0.008325679`,0.010316846`,0.010338446`,0.013458313`,0.012773013`,0.012930029`,0.012300063`,0.012304396`,0.007893096`,0.013579646`,0.016660813`,0.014083129`,0.016692046`,0.015002746`,0.016713879`,0.011669946`,0.015455829`,0.008793246`,0.008737779`,0.008905646`,0.008961696`,0.007908346`,0.007893096`,0.006844863`,0.007280963`,0.007018213`,0.007205346`,0.006785113`,0.007803729`,0.007397646`,0.007893096`,0.007532846`,0.007480429`,0.007965779`,0.007459829`,0.006836763`,0.011678013`,0.010955496`,0.011482196`,0.014145029`,0.010125213`,0.011854029`,0.011966013`,0.012898079`,0.016181279`,0.015947913`,0.012657529`,0.013102163`,0.014295879`,0.015728713`,0.014469663`,0.014386263`,0.017523413`,0.014510313`,0.011462663`,0.015419163`,0.014189546`,0.015067279`,0.006405546`,0.006481363`,0.006420546`,0.006420546`,0.006760846`,0.004703229`,0.004146863`,0.003979496`,0.004886329`,0.005453946`,0.005599146`,0.004180729`,0.004093429`,0.008720529`,0.009282663`,0.010459096`,0.007675496`,0.010845429`,0.011178796`,0.009653463`,0.009282663`,0.008720529`,0.008864963`,0.011173563`,0.009276329`,0.008805329`,0.008805329`,0.008430029`,0.010206163`,0.007325963`,0.007538963`,0.007294463`,0.006203979`,0.006226579`,0.004336429`},{1/243,0.009678858`,0.009762992`,0.009762992`,0.009751958`,0.010188358`,0.010255958`,0.010534508`,0.010377558`,0.010818808`,0.010376492`,0.010948025`,0.011122975`,0.010140858`,0.011968008`,0.010641325`,0.009225925`,0.009120825`,0.011423075`,0.009714958`,0.011520458`,0.011866175`,0.011798592`,0.011556675`,0.006974492`,0.007945758`,0.005440725`,0.005534375`,0.004815525`,0.004997158`,0.007362208`,0.010994475`,0.010525875`,0.006002625`,0.005545542`,0.009776608`,0.015049758`,0.018455742`,0.015264708`,0.018603775`,0.014944675`,0.019324008`,0.014483508`,0.015359925`,0.009348858`,0.009434775`,0.009476642`,0.009442908`,0.009941608`,0.009776608`,0.008762108`,0.008818092`,0.008906592`,0.008795475`,0.008740608`,0.009876058`,0.008754808`,0.009776608`,0.009549175`,0.009403125`,0.010173075`,0.009417842`,0.008321608`,0.010960808`,0.011888708`,0.012522725`,0.014137608`,0.010809908`,0.012218808`,0.012819208`,0.013498792`,0.015950208`,0.016273675`,0.012221142`,0.012429692`,0.013897425`,0.015130392`,0.014032975`,0.014139108`,0.016529275`,0.014127342`,0.009720958`,0.014957675`,0.013779525`,0.015132258`,0.005688375`,0.005838008`,0.005727408`,0.005727408`,0.005933658`,0.003857292`,0.003609592`,0.006810875`,0.004668075`,0.004997808`,0.006644108`,0.003874742`,0.003817292`,0.009890542`,0.010311942`,0.010202508`,0.007547792`,0.010509358`,0.010982442`,0.009309308`,0.010311942`,0.009890542`,0.009735975`,0.010948075`,0.010146358`,0.010313975`,0.010313975`,0.009923258`,0.009900325`,0.009316492`,0.009155075`,0.009332542`,0.007913592`,0.007882025`,0.006455525`},{1/252,0.008985113`,0.009043813`,0.009043813`,0.008978513`,0.009384529`,0.008894096`,0.009009896`,0.008944813`,0.006068313`,0.008980279`,0.006690829`,0.007478529`,0.008737746`,0.006597513`,0.006596263`,0.005151546`,0.005094846`,0.005793913`,0.005377363`,0.005821029`,0.006472663`,0.006054113`,0.005847046`,0.004535513`,0.004974146`,0.004881846`,0.008390463`,0.004175429`,0.004197113`,0.007133313`,0.007884596`,0.006569996`,0.006609529`,0.005489179`,0.008449496`,0.013879529`,0.017352379`,0.014241629`,0.017300146`,0.014827196`,0.018271329`,0.013305396`,0.014991463`,0.010631163`,0.010655946`,0.010678429`,0.010678796`,0.008309713`,0.008449496`,0.008678913`,0.008660996`,0.008714629`,0.008465396`,0.008638946`,0.009632629`,0.009037746`,0.008449496`,0.008304379`,0.008194279`,0.010386546`,0.008221913`,0.008040296`,0.011750963`,0.006470529`,0.006410579`,0.013129279`,0.010287546`,0.010389029`,0.008952629`,0.013022096`,0.015754713`,0.015779446`,0.012951896`,0.012297979`,0.012054346`,0.013381529`,0.012037746`,0.012248629`,0.015906113`,0.012156846`,0.011121396`,0.013147696`,0.012031379`,0.013695246`,0.006032146`,0.006303146`,0.006103429`,0.006103429`,0.006677713`,0.004881596`,0.004158779`,0.007510896`,0.005311696`,0.005226163`,0.005842879`,0.004269029`,0.004212663`,0.009183913`,0.009636679`,0.010548063`,0.008509229`,0.010881763`,0.011193729`,0.009708413`,0.009636679`,0.009183913`,0.009498746`,0.011079913`,0.009515629`,0.009731213`,0.009731213`,0.009256996`,0.010271213`,0.007892279`,0.008008196`,0.007946879`,0.007837629`,0.007884129`,0.007046496`},{1/261,0.004443804`,0.004498538`,0.004498538`,0.004510271`,0.004583304`,0.004838638`,0.004629871`,0.004823671`,0.004812571`,0.004900904`,0.004905038`,0.004909388`,0.004948504`,0.005695471`,0.004995354`,0.006882254`,0.006900554`,0.006781804`,0.005605104`,0.005634538`,0.005742804`,0.005594838`,0.005753888`,0.006825754`,0.006983738`,0.009290538`,0.009379104`,0.006600421`,0.006633738`,0.012163704`,0.011146888`,0.008534521`,0.011144421`,0.010758404`,0.005233588`,0.014100254`,0.017957788`,0.014489104`,0.018144638`,0.014976471`,0.018628538`,0.012439271`,0.015520571`,0.006828421`,0.006711721`,0.006802121`,0.006850521`,0.005150521`,0.005233588`,0.005457621`,0.005940188`,0.005562554`,0.005493821`,0.005387438`,0.007423338`,0.005889188`,0.005233588`,0.005161771`,0.005120638`,0.007163621`,0.005095504`,0.005054138`,0.006985021`,0.005908088`,0.006176221`,0.011972338`,0.006542738`,0.007731821`,0.006667588`,0.011368321`,0.015588571`,0.014970504`,0.010593154`,0.012378554`,0.011456404`,0.012319721`,0.011480421`,0.011444538`,0.015588821`,0.011526488`,0.009515438`,0.012080738`,0.011483871`,0.012956238`,0.006420521`,0.006717454`,0.006500321`,0.006500321`,0.006993221`,0.005384671`,0.004196971`,0.005490538`,0.006954721`,0.005253871`,0.005067488`,0.004497121`,0.004448454`,0.007221938`,0.008007188`,0.011201821`,0.008860571`,0.011457304`,0.011482838`,0.010804371`,0.008007188`,0.007221938`,0.006922904`,0.011392021`,0.008244871`,0.007170838`,0.007170838`,0.006897438`,0.011133871`,0.006900321`,0.007297121`,0.006957838`,0.007077104`,0.007052438`,0.005410804`},{1/270,0.003973833`,0.00400675`,0.00400675`,0.004000217`,0.004181683`,0.004919717`,0.00427435`,0.004831133`,0.0048344`,0.0049761`,0.004696483`,0.004909217`,0.00538265`,0.006517783`,0.005830333`,0.01018445`,0.01013935`,0.009656667`,0.00685065`,0.00826105`,0.0070398`,0.008161967`,0.008559417`,0.009172183`,0.008183283`,0.011458333`,0.008103333`,0.0080505`,0.0080347`,0.012135583`,0.012189017`,0.011960033`,0.010943683`,0.010851833`,0.006516117`,0.01409335`,0.015716917`,0.01516225`,0.015659`,0.015143567`,0.016579317`,0.013479817`,0.01615095`,0.00841695`,0.008540633`,0.00835545`,0.008305283`,0.006121633`,0.006516117`,0.008039633`,0.008754383`,0.008141267`,0.00811475`,0.007954183`,0.010737867`,0.008678183`,0.006516117`,0.006255317`,0.00627485`,0.008106217`,0.006233317`,0.006690067`,0.007884833`,0.008520433`,0.0090626`,0.011201417`,0.00827345`,0.009622483`,0.008551383`,0.01219655`,0.014767417`,0.015795917`,0.010484283`,0.0114906`,0.010912683`,0.013296033`,0.010961033`,0.0109247`,0.016238717`,0.010993817`,0.011117717`,0.013017717`,0.010917`,0.0144601`,0.006229467`,0.006534667`,0.006309483`,0.006309483`,0.007759383`,0.00552395`,0.00485115`,0.003659683`,0.00622225`,0.00475615`,0.0036383`,0.005604167`,0.005535933`,0.006427267`,0.00752775`,0.010385467`,0.00569785`,0.010495117`,0.010751`,0.009580967`,0.00752775`,0.006427267`,0.0053669`,0.011011167`,0.008063633`,0.005849333`,0.005849333`,0.005772033`,0.010184433`,0.007193367`,0.00696395`,0.007252817`,0.0075448`,0.00757555`,0.00497155`},{10/81,0.004297192`,0.004353775`,0.004353775`,0.004358908`,0.004727025`,0.006539392`,0.004475375`,0.006203158`,0.005549492`,0.006480758`,0.005423125`,0.004905575`,0.008052192`,0.009929175`,0.008310292`,0.009747675`,0.009627408`,0.010232608`,0.007882842`,0.009831108`,0.010155258`,0.010226758`,0.010145108`,0.007399525`,0.007355892`,0.006752325`,0.005571692`,0.005765575`,0.006002942`,0.008710892`,0.009599858`,0.010058425`,0.006347708`,0.006276658`,0.009163142`,0.013350558`,0.016138658`,0.014055625`,0.016101592`,0.014789325`,0.016711258`,0.014169525`,0.015604775`,0.009755625`,0.009782492`,0.009705158`,0.009697258`,0.009123342`,0.009163142`,0.011570575`,0.011300525`,0.011578858`,0.010871125`,0.011538175`,0.012348175`,0.010030675`,0.009163142`,0.009115842`,0.008986742`,0.011378008`,0.008991175`,0.008780858`,0.010640358`,0.010477858`,0.010556542`,0.013234525`,0.010627625`,0.010892608`,0.011244392`,0.012437692`,0.017059225`,0.016699708`,0.009169625`,0.009364742`,0.011549992`,0.015528408`,0.011799808`,0.011976558`,0.016688658`,0.011900525`,0.011405358`,0.015265158`,0.011393175`,0.015865008`,0.008725192`,0.009067708`,0.008815892`,0.008815892`,0.010087158`,0.006026458`,0.005455042`,0.003605492`,0.007673208`,0.007620075`,0.003344208`,0.003539775`,0.003479175`,0.006517358`,0.007787158`,0.010796542`,0.005140258`,0.010842475`,0.010615342`,0.010013408`,0.007787158`,0.006517358`,0.004965125`,0.010531842`,0.008463308`,0.005032275`,0.005032275`,0.005187225`,0.010615225`,0.007649208`,0.008129542`,0.007684208`,0.008839708`,0.008947842`,0.005096075`},{5/81,0.007379033`,0.007428517`,0.007428517`,0.007332383`,0.008299383`,0.008868233`,0.00635875`,0.00859205`,0.005826433`,0.0088185`,0.006041783`,0.0060124`,0.0094146`,0.006390733`,0.006515817`,0.00466395`,0.004593517`,0.005186833`,0.004989367`,0.005117183`,0.0062452`,0.005383867`,0.005212517`,0.00393515`,0.00456525`,0.0037044`,0.0055637`,0.003632967`,0.00362325`,0.00499925`,0.0048804`,0.00503105`,0.004610933`,0.004155267`,0.007746283`,0.0140119`,0.016795083`,0.01394275`,0.01682575`,0.015652683`,0.017179167`,0.014381467`,0.016698317`,0.0082137`,0.008249567`,0.008267083`,0.00826515`,0.008236817`,0.007746283`,0.008925333`,0.007776017`,0.00889735`,0.008078817`,0.008974733`,0.008200883`,0.007532183`,0.007746283`,0.007497717`,0.007473033`,0.011057133`,0.007489067`,0.008465567`,0.0084912`,0.005737767`,0.005609367`,0.010426817`,0.008463033`,0.005971717`,0.007180483`,0.00769075`,0.016386417`,0.017140467`,0.005256883`,0.005235633`,0.009182367`,0.0148135`,0.009494533`,0.010147283`,0.016300733`,0.009769067`,0.009725083`,0.01461375`,0.009069083`,0.01505375`,0.011521367`,0.011510983`,0.011507883`,0.011507883`,0.011600083`,0.006482983`,0.005540133`,0.0040569`,0.00942565`,0.008235583`,0.00463595`,0.0059432`,0.005851283`,0.0084816`,0.009098317`,0.010641183`,0.006544917`,0.01069405`,0.01066825`,0.009860283`,0.009098317`,0.0084816`,0.006842117`,0.0105403`,0.009139467`,0.008465683`,0.008465683`,0.0083271`,0.0104406`,0.007732733`,0.008693467`,0.007753`,0.0072715`,0.007327817`,0.00602295`},{10/243,0.006554992`,0.006633092`,0.006633092`,0.006649708`,0.006408992`,0.005410008`,0.005829908`,0.005486158`,0.005225625`,0.005503942`,0.005516275`,0.005529492`,0.005085142`,0.005525158`,0.005020975`,0.004596708`,0.004549425`,0.004589025`,0.004395142`,0.004710625`,0.005655575`,0.004779042`,0.004767825`,0.004020225`,0.004684158`,0.004478758`,0.008001442`,0.004642558`,0.004655325`,0.005559042`,0.004574908`,0.004439358`,0.006576892`,0.005968242`,0.004789008`,0.010913425`,0.016938875`,0.011032308`,0.017028342`,0.014045175`,0.017351075`,0.006916458`,0.015372975`,0.004762625`,0.004784608`,0.004844542`,0.004831092`,0.004990025`,0.004789008`,0.003955992`,0.003962242`,0.004123575`,0.004059625`,0.003959608`,0.004020992`,0.004047525`,0.004789008`,0.004732692`,0.004665908`,0.005454242`,0.004656742`,0.004272292`,0.004983742`,0.004958075`,0.004921958`,0.005208408`,0.005145042`,0.004033842`,0.004902942`,0.004980675`,0.010257442`,0.012233692`,0.008353892`,0.005731158`,0.009541592`,0.015524508`,0.009928125`,0.010931358`,0.017373108`,0.010315492`,0.012053525`,0.015301575`,0.009279775`,0.015685008`,0.008477658`,0.008197708`,0.008385858`,0.008385858`,0.009182792`,0.007157608`,0.006666408`,0.006212508`,0.008322375`,0.007234708`,0.005807258`,0.007183192`,0.007013875`,0.008564908`,0.009034225`,0.010655642`,0.007852108`,0.010886525`,0.010710575`,0.010291792`,0.009034225`,0.008564908`,0.008889092`,0.010585258`,0.008934075`,0.008922108`,0.008922108`,0.008474558`,0.010633992`,0.006062692`,0.006395775`,0.006098058`,0.006081408`,0.006091525`,0.003846925`},{5/162,0.005414829`,0.005472263`,0.005472263`,0.005475829`,0.005531013`,0.005466996`,0.005481113`,0.005494463`,0.005572896`,0.005555513`,0.005650479`,0.005902263`,0.005437663`,0.005294296`,0.005004229`,0.006417163`,0.006419646`,0.005478029`,0.005737546`,0.004860996`,0.005346563`,0.004957496`,0.004906163`,0.006486279`,0.006687779`,0.007882113`,0.006813529`,0.006285746`,0.006181213`,0.009448829`,0.008827963`,0.007194313`,0.009454746`,0.009030063`,0.005257396`,0.013107229`,0.018273396`,0.012144979`,0.018309413`,0.016415113`,0.018377579`,0.008821796`,0.015431963`,0.004980879`,0.005041063`,0.005137363`,0.005107929`,0.005411529`,0.005257396`,0.004631863`,0.004481713`,0.004802396`,0.004810379`,0.004607229`,0.004332096`,0.004372596`,0.005257396`,0.005208696`,0.005124296`,0.005831596`,0.005130346`,0.004739779`,0.005726129`,0.005469046`,0.005698963`,0.008677613`,0.006227296`,0.006430279`,0.006060079`,0.008819096`,0.014160713`,0.014602046`,0.013531796`,0.010067663`,0.014387029`,0.016132396`,0.014595196`,0.014539146`,0.018350229`,0.014636529`,0.011303446`,0.015907629`,0.014283396`,0.015767129`,0.006813796`,0.006960979`,0.006852746`,0.006852746`,0.006583763`,0.005221446`,0.005164179`,0.003333679`,0.005900029`,0.007743829`,0.004477029`,0.007354679`,0.007259929`,0.006904729`,0.007745863`,0.010068829`,0.006597246`,0.010393929`,0.010747079`,0.009730279`,0.007745863`,0.006904729`,0.006196879`,0.010802746`,0.008019746`,0.006537279`,0.006537279`,0.006298696`,0.010066863`,0.006118829`,0.006269946`,0.006110246`,0.005983879`,0.005981829`,0.003934463`},{2/81,0.005880908`,0.005951108`,0.005951108`,0.005918408`,0.006632792`,0.007426892`,0.006197475`,0.007436492`,0.007928275`,0.007506308`,0.007394092`,0.006994508`,0.007671575`,0.008052625`,0.007473942`,0.009711075`,0.009682308`,0.010301158`,0.008454525`,0.009030225`,0.008614825`,0.008584708`,0.009108292`,0.008459758`,0.008146775`,0.010205658`,0.007384742`,0.007331758`,0.007297242`,0.014133308`,0.014190725`,0.013174658`,0.010290492`,0.010214008`,0.007514908`,0.015356375`,0.016945042`,0.015305375`,0.017001975`,0.015795042`,0.017085525`,0.012127508`,0.016528925`,0.006576158`,0.006658225`,0.006794142`,0.006774075`,0.007677042`,0.007514908`,0.006826458`,0.006380792`,0.006993142`,0.006778492`,0.006826125`,0.006880558`,0.006103125`,0.007514908`,0.007332425`,0.007240308`,0.007575525`,0.007244742`,0.006628475`,0.008902875`,0.009712642`,0.010411758`,0.013644358`,0.008973658`,0.012428542`,0.010374342`,0.015374975`,0.015982892`,0.015678208`,0.013720058`,0.013999158`,0.014537308`,0.015464658`,0.014681158`,0.014512125`,0.016905525`,0.014683175`,0.011641858`,0.015259042`,0.014467275`,0.015215142`,0.007382608`,0.007679475`,0.007465308`,0.007465308`,0.007340292`,0.005196108`,0.006108275`,0.002740125`,0.005388508`,0.006838758`,0.003603175`,0.006670525`,0.006509425`,0.007137575`,0.007930425`,0.009204325`,0.005531092`,0.009511225`,0.010062625`,0.008151375`,0.007930425`,0.007137575`,0.006336792`,0.010068575`,0.008156342`,0.006668492`,0.006668492`,0.006463875`,0.008856392`,0.006576708`,0.006811308`,0.006584425`,0.006684075`,0.006727242`,0.004029975`},{5/243,0.006493142`,0.006490792`,0.006490792`,0.006344858`,0.007586542`,0.009969408`,0.007356925`,0.009858775`,0.008996342`,0.009979742`,0.008704142`,0.008109225`,0.010281442`,0.010278708`,0.009895975`,0.009193358`,0.009078542`,0.012058792`,0.008513475`,0.011687675`,0.010330642`,0.011287258`,0.011422175`,0.007753192`,0.007648625`,0.007154658`,0.005986658`,0.005996492`,0.006087825`,0.008290642`,0.010052192`,0.010974042`,0.006396892`,0.006485075`,0.010176342`,0.013447825`,0.017952575`,0.013463642`,0.018152625`,0.013705108`,0.018230075`,0.013624492`,0.014515858`,0.009874592`,0.010213175`,0.010246208`,0.010112575`,0.010140858`,0.010176342`,0.009337225`,0.008932475`,0.009737058`,0.009768558`,0.009338325`,0.008509425`,0.009445308`,0.010176342`,0.010150025`,0.010117708`,0.010145525`,0.010071225`,0.010052492`,0.011702458`,0.012369642`,0.012536275`,0.014110342`,0.011876008`,0.012444575`,0.013054008`,0.014747808`,0.016399925`,0.016133608`,0.011258692`,0.010317425`,0.014832175`,0.014912958`,0.014996825`,0.014485092`,0.014259775`,0.014895058`,0.011659075`,0.014926175`,0.014824908`,0.014787108`,0.006921692`,0.007007708`,0.006945442`,0.006945442`,0.007426608`,0.005987608`,0.005808108`,0.003582025`,0.005693708`,0.007366408`,0.003865425`,0.005534542`,0.005421742`,0.007664325`,0.008486692`,0.009261708`,0.005482242`,0.009369342`,0.010230758`,0.008025025`,0.008486692`,0.007664325`,0.006643558`,0.010335692`,0.008746542`,0.007161808`,0.007161808`,0.007106875`,0.008836375`,0.009687892`,0.009553775`,0.009698125`,0.009427992`,0.009391542`,0.006364975`},{10/567,0.007193071`,0.007244421`,0.007244421`,0.007155988`,0.007695854`,0.007498604`,0.006769721`,0.007501004`,0.005633604`,0.007545604`,0.006259821`,0.006308604`,0.007359071`,0.006233821`,0.006046988`,0.005147704`,0.005102404`,0.005721804`,0.005618904`,0.005867504`,0.006351888`,0.005974021`,0.005821471`,0.004569254`,0.005145638`,0.004034671`,0.004443571`,0.004304054`,0.004330354`,0.004894388`,0.005099421`,0.005366288`,0.004739571`,0.004507421`,0.007022521`,0.013833171`,0.017328421`,0.013899071`,0.017429488`,0.014208404`,0.017358504`,0.013802054`,0.015201371`,0.009383738`,0.009078104`,0.009167354`,0.009275121`,0.006904421`,0.007022521`,0.008161821`,0.007957971`,0.008205288`,0.007428754`,0.008087754`,0.008802904`,0.007495471`,0.007022521`,0.006641788`,0.006630454`,0.009264738`,0.006654488`,0.007660538`,0.009658021`,0.006043204`,0.005980921`,0.011608338`,0.007934004`,0.005658421`,0.006757904`,0.007164854`,0.016621271`,0.017027921`,0.006988471`,0.006135621`,0.010215154`,0.014963804`,0.010622438`,0.010723604`,0.015666738`,0.010727538`,0.008297204`,0.014764488`,0.010146888`,0.014272238`,0.006962004`,0.007017171`,0.006972288`,0.006972288`,0.007975121`,0.005386804`,0.005002088`,0.005728788`,0.008237254`,0.005788221`,0.004738154`,0.006970688`,0.006935554`,0.009048054`,0.009528921`,0.009974721`,0.005771088`,0.010217571`,0.010668488`,0.008943171`,0.009528921`,0.009048054`,0.008896621`,0.010730721`,0.009446654`,0.009568438`,0.009568438`,0.009241121`,0.009620704`,0.007566954`,0.007858804`,0.007623838`,0.007426238`,0.007495938`,0.007563588`},{5/324,0.0053452`,0.005407683`,0.005407683`,0.00542265`,0.005568417`,0.005546333`,0.00555565`,0.005577383`,0.005378817`,0.005618233`,0.005729833`,0.005776533`,0.0053468`,0.005909367`,0.005388483`,0.004980817`,0.0049441`,0.004913283`,0.004609883`,0.005180833`,0.0057413`,0.0052788`,0.005063783`,0.004211833`,0.005061417`,0.00426115`,0.006491917`,0.00442505`,0.004363733`,0.004750867`,0.004685617`,0.004974917`,0.004892517`,0.004570483`,0.00507365`,0.013852183`,0.01762145`,0.013737917`,0.017717467`,0.015062067`,0.017932083`,0.0103053`,0.0162822`,0.006713967`,0.006485617`,0.00662495`,0.00673875`,0.005232817`,0.00507365`,0.004423617`,0.0048019`,0.004615417`,0.004728767`,0.004388517`,0.004998983`,0.00477485`,0.00507365`,0.005060033`,0.004986267`,0.005716883`,0.004974933`,0.00458025`,0.007483467`,0.0051784`,0.0051123`,0.008479317`,0.006121833`,0.004925583`,0.005876433`,0.007128333`,0.013818117`,0.014903083`,0.007258633`,0.006359317`,0.0081566`,0.0104217`,0.00831475`,0.008183467`,0.013026967`,0.008310717`,0.008296733`,0.010122633`,0.0081222`,0.011287667`,0.008383917`,0.008433533`,0.008386783`,0.008386783`,0.010436367`,0.005700567`,0.004894683`,0.004885533`,0.007746917`,0.005089767`,0.00430465`,0.0070227`,0.007021817`,0.00738155`,0.008128133`,0.010364317`,0.007043217`,0.010694233`,0.010839383`,0.009959883`,0.008128133`,0.00738155`,0.006978717`,0.0107373`,0.0083075`,0.007296933`,0.007296933`,0.0069717`,0.01031425`,0.007128733`,0.007099`,0.007148983`,0.006723867`,0.006791517`,0.005335433`},{10/729,0.004962817`,0.005020467`,0.005020467`,0.00503005`,0.005132683`,0.005203517`,0.005159367`,0.005201533`,0.004979217`,0.00527735`,0.0052896`,0.005591383`,0.0050135`,0.00536235`,0.004830083`,0.005333583`,0.0053292`,0.0049452`,0.004890933`,0.004684367`,0.005571317`,0.00499555`,0.004806667`,0.004926533`,0.005607717`,0.005606317`,0.007716833`,0.005273317`,0.005292767`,0.006453233`,0.006400383`,0.00586335`,0.006447867`,0.005788317`,0.00480495`,0.0141569`,0.017662583`,0.013963983`,0.017791617`,0.015060233`,0.018036283`,0.012377917`,0.015603067`,0.008045633`,0.00777885`,0.007752583`,0.00787865`,0.004799433`,0.00480495`,0.004502367`,0.004887567`,0.0046769`,0.004824467`,0.00448015`,0.005450633`,0.005540733`,0.00480495`,0.004786483`,0.004741333`,0.005869283`,0.004724483`,0.0048217`,0.009471117`,0.005162533`,0.005370467`,0.0110818`,0.006239067`,0.008131533`,0.006929733`,0.008945167`,0.014288267`,0.015656967`,0.009345283`,0.007887583`,0.009761517`,0.013347633`,0.009934883`,0.0104192`,0.01560635`,0.010119817`,0.009720917`,0.013077433`,0.009671183`,0.013593917`,0.007176767`,0.007277133`,0.007194167`,0.007194167`,0.009028233`,0.005085133`,0.005249083`,0.005082033`,0.005677867`,0.00454265`,0.005106867`,0.0044697`,0.00442365`,0.0075386`,0.00829375`,0.010183267`,0.005239217`,0.010395517`,0.010397317`,0.009463717`,0.00829375`,0.0075386`,0.006695033`,0.010273167`,0.008476167`,0.007284917`,0.007284917`,0.007104817`,0.009960467`,0.007242833`,0.007080317`,0.0072496`,0.006456817`,0.006500233`,0.00546875`},{1/81,0.004950171`,0.005009821`,0.005009821`,0.004999504`,0.005072954`,0.005029521`,0.004936154`,0.005007638`,0.004715704`,0.005062604`,0.005000421`,0.004946338`,0.004896654`,0.005256871`,0.004840354`,0.006660504`,0.006696538`,0.006061154`,0.006152254`,0.005954138`,0.005621638`,0.005428354`,0.005559071`,0.006739121`,0.007155321`,0.007188304`,0.007159854`,0.006695054`,0.006791754`,0.008261171`,0.009292288`,0.008482388`,0.007255754`,0.007069888`,0.004780688`,0.015367604`,0.018550721`,0.015228354`,0.018633888`,0.016435971`,0.018830054`,0.014736488`,0.017005671`,0.008984821`,0.009225738`,0.009172604`,0.009042338`,0.004879721`,0.004780688`,0.005383804`,0.007681921`,0.005528288`,0.005769188`,0.005312654`,0.009371738`,0.008982771`,0.004780688`,0.004648571`,0.004658788`,0.006122288`,0.004640338`,0.004967304`,0.009897904`,0.007543304`,0.008170804`,0.014812738`,0.009779171`,0.011213704`,0.010552088`,0.011083221`,0.016983154`,0.017089871`,0.010517221`,0.010442688`,0.011780921`,0.016750488`,0.012036771`,0.012324371`,0.018944621`,0.012167788`,0.009378804`,0.016290321`,0.011622088`,0.016501138`,0.008096004`,0.008281254`,0.008143354`,0.008143354`,0.009328304`,0.005011838`,0.004366221`,0.006739021`,0.004998171`,0.005712071`,0.006105988`,0.005840754`,0.005789321`,0.008715421`,0.009282121`,0.010092054`,0.006122938`,0.010304254`,0.010403421`,0.009384871`,0.009282121`,0.008715421`,0.008617138`,0.010237088`,0.009271704`,0.008881271`,0.008881271`,0.008579454`,0.009881354`,0.007169004`,0.007407104`,0.007116671`,0.005717938`,0.005746638`,0.004476121`},{10/891,0.004652004`,0.004716071`,0.004716071`,0.004713854`,0.004782088`,0.004921504`,0.004406354`,0.004827004`,0.005235604`,0.004924371`,0.004933938`,0.004705104`,0.005188504`,0.005919821`,0.005485704`,0.006712371`,0.006689454`,0.007058754`,0.005394738`,0.007449788`,0.006050054`,0.006451754`,0.006561738`,0.006118204`,0.006626371`,0.006188521`,0.008224438`,0.005496821`,0.005556171`,0.007563254`,0.007895838`,0.008353171`,0.007366538`,0.007159104`,0.006056288`,0.014140238`,0.018485521`,0.014467021`,0.018584138`,0.015983321`,0.018709138`,0.014259771`,0.016565021`,0.009552638`,0.009490788`,0.009526438`,0.009577871`,0.005599554`,0.006056288`,0.007122638`,0.007635054`,0.007308788`,0.007229688`,0.007110171`,0.008626604`,0.008337004`,0.006056288`,0.006036171`,0.006036804`,0.008283454`,0.006006521`,0.006818471`,0.010782038`,0.008651654`,0.009324421`,0.012873821`,0.011305804`,0.010170454`,0.011521654`,0.010670954`,0.017049604`,0.017654888`,0.010150454`,0.009132238`,0.012679738`,0.017367321`,0.013011104`,0.013276254`,0.018153104`,0.013158138`,0.012762988`,0.016982088`,0.012532321`,0.017389938`,0.008351188`,0.008547071`,0.008394054`,0.008394054`,0.009606154`,0.005329788`,0.004823171`,0.006391971`,0.006900838`,0.005794221`,0.004406838`,0.006671371`,0.006655154`,0.007341471`,0.007933204`,0.009670854`,0.007083471`,0.009968188`,0.010011654`,0.009497204`,0.007933204`,0.007341471`,0.007542154`,0.009903354`,0.008002988`,0.007599754`,0.007599754`,0.007269154`,0.009723021`,0.005610504`,0.005850204`,0.005612354`,0.005402204`,0.005457904`,0.004504188`},{5/486,0.0045634`,0.004624367`,0.004624367`,0.00461295`,0.004633333`,0.00535415`,0.0045532`,0.00523015`,0.004521483`,0.005368867`,0.004787633`,0.004663283`,0.0054035`,0.0059258`,0.0055512`,0.00608725`,0.0061001`,0.006142217`,0.0051608`,0.006309183`,0.00616845`,0.005946717`,0.005773867`,0.005865883`,0.006302083`,0.0073308`,0.010395983`,0.006252917`,0.006184583`,0.0093124`,0.01012835`,0.008788667`,0.009441633`,0.008859`,0.005809967`,0.012501183`,0.018234833`,0.0128516`,0.018344283`,0.013963483`,0.017996917`,0.0112611`,0.01460665`,0.0086422`,0.008589733`,0.008710233`,0.008764833`,0.00549475`,0.005809967`,0.006285683`,0.006653583`,0.006468183`,0.006392583`,0.006279333`,0.007393917`,0.00731995`,0.005809967`,0.005732833`,0.005721533`,0.007902467`,0.005698467`,0.006305017`,0.0101966`,0.00736235`,0.0079354`,0.012523083`,0.0102567`,0.009449567`,0.0108749`,0.0111474`,0.017532117`,0.0179519`,0.012170817`,0.010522933`,0.01547145`,0.01779995`,0.01570315`,0.01582725`,0.018427667`,0.0158124`,0.013418617`,0.01739215`,0.015366867`,0.017825067`,0.00737165`,0.006990833`,0.007244283`,0.007244283`,0.009440717`,0.004853533`,0.004058617`,0.005005917`,0.0062503`,0.004611117`,0.003317917`,0.005077317`,0.005075083`,0.006611033`,0.007353417`,0.008486867`,0.004778683`,0.008825567`,0.0087562`,0.007988033`,0.007353417`,0.006611033`,0.005101717`,0.008561367`,0.007564067`,0.006449367`,0.006449367`,0.0062565`,0.00837425`,0.005879333`,0.00588325`,0.005861667`,0.00577935`,0.005884633`,0.00426225`},{10/1053,0.004117779`,0.004153546`,0.004153546`,0.004124896`,0.004458379`,0.004942579`,0.003923913`,0.004839663`,0.004410913`,0.004963196`,0.004475463`,0.004217129`,0.004896513`,0.005111379`,0.004878813`,0.006620479`,0.006653113`,0.006663346`,0.005780546`,0.006693296`,0.005688596`,0.006081579`,0.006057313`,0.006888813`,0.006835263`,0.009726846`,0.012259846`,0.008253096`,0.008138313`,0.011164529`,0.011591729`,0.010535013`,0.010831246`,0.010798479`,0.005004546`,0.010675396`,0.015192979`,0.011498246`,0.015249396`,0.011940579`,0.015147746`,0.008556613`,0.012654879`,0.006510613`,0.006449596`,0.006556396`,0.006640246`,0.004868413`,0.005004546`,0.005527129`,0.005400913`,0.005691896`,0.005425763`,0.005565046`,0.005548263`,0.005536829`,0.005004546`,0.004870829`,0.004859429`,0.007889113`,0.004844329`,0.005355263`,0.008051863`,0.007597096`,0.007977946`,0.012373413`,0.008887363`,0.010502746`,0.009566779`,0.013476463`,0.016469663`,0.016189163`,0.013903013`,0.012891513`,0.014097063`,0.016347563`,0.014091029`,0.014832596`,0.017540979`,0.014403363`,0.013620329`,0.016084263`,0.014029096`,0.016407563`,0.006402379`,0.005996529`,0.006268596`,0.006268596`,0.008608879`,0.005115796`,0.005688829`,0.004930679`,0.006363779`,0.003673813`,0.003676813`,0.004953396`,0.004933696`,0.006180946`,0.007047263`,0.007666396`,0.003812896`,0.007915546`,0.007986379`,0.007066146`,0.007047263`,0.006180946`,0.004672863`,0.007932163`,0.007380163`,0.006011879`,0.006011879`,0.005862146`,0.007477863`,0.005080013`,0.005157296`,0.005074513`,0.005287063`,0.005331263`,0.003827629`},{5/567,0.004397996`,0.004450463`,0.004450463`,0.004448629`,0.004545729`,0.005121379`,0.004019346`,0.005054296`,0.004839813`,0.005182279`,0.005024046`,0.004729413`,0.004751529`,0.004651379`,0.004221679`,0.008479296`,0.008523446`,0.007014596`,0.006659179`,0.005708163`,0.005088929`,0.005127463`,0.005520679`,0.009576129`,0.007982196`,0.011019863`,0.009666446`,0.009334446`,0.009709413`,0.013572679`,0.012722879`,0.009648413`,0.009946279`,0.009703413`,0.004728763`,0.010895429`,0.013650096`,0.012204213`,0.013676663`,0.011394829`,0.013564029`,0.008404129`,0.011701246`,0.005733263`,0.005614913`,0.005643263`,0.005731679`,0.004729096`,0.004728763`,0.005739679`,0.005272546`,0.005840296`,0.005463929`,0.005797596`,0.005618363`,0.005058913`,0.004728763`,0.004481963`,0.004490479`,0.008472646`,0.004501779`,0.005198863`,0.006853829`,0.005999663`,0.007227479`,0.008983363`,0.006161796`,0.008530696`,0.007416813`,0.013102429`,0.014954463`,0.014108079`,0.013175896`,0.012249563`,0.012391363`,0.017490313`,0.012753963`,0.014216129`,0.016966179`,0.013279446`,0.011534979`,0.017236429`,0.012132846`,0.017423396`,0.005414963`,0.005237963`,0.005354129`,0.005354129`,0.007369196`,0.005306479`,0.006151546`,0.004574079`,0.005784946`,0.003468963`,0.003696179`,0.004671613`,0.004622063`,0.005945963`,0.006955779`,0.007617496`,0.003989946`,0.007735429`,0.007572163`,0.006844463`,0.006955779`,0.005945963`,0.004922829`,0.007233679`,0.007412946`,0.005377629`,0.005377629`,0.005322296`,0.007350496`,0.005206163`,0.005198913`,0.005243963`,0.005770029`,0.005774479`,0.004218329`},{2/243,0.005437267`,0.005478933`,0.005478933`,0.00542265`,0.0057946`,0.005887867`,0.00464825`,0.005894367`,0.00575785`,0.005981033`,0.005581217`,0.0052846`,0.005150333`,0.0054518`,0.004975367`,0.008764267`,0.00875655`,0.008391117`,0.008306467`,0.0075979`,0.006477817`,0.0067986`,0.0076039`,0.0084028`,0.0081344`,0.00819795`,0.006515717`,0.005947017`,0.0061473`,0.010825067`,0.012478517`,0.009725567`,0.00668145`,0.006775417`,0.00529025`,0.01127005`,0.013791917`,0.01200775`,0.013889417`,0.012512767`,0.014040667`,0.009618933`,0.012628717`,0.007328283`,0.0072066`,0.0073618`,0.00745035`,0.005321`,0.00529025`,0.005857117`,0.005966583`,0.006030033`,0.0060138`,0.00585775`,0.0061487`,0.006228267`,0.00529025`,0.005155333`,0.0051725`,0.0083881`,0.005153667`,0.005317733`,0.009416467`,0.008036883`,0.008628467`,0.011787933`,0.0080623`,0.0104419`,0.009567733`,0.012150483`,0.01478065`,0.015205767`,0.014626667`,0.014434283`,0.016887033`,0.017535333`,0.017106617`,0.017086767`,0.017432433`,0.0171741`,0.013341467`,0.017284433`,0.01670155`,0.017571`,0.005869033`,0.005803467`,0.005844783`,0.005844783`,0.007008167`,0.006320417`,0.0064905`,0.00426685`,0.005463233`,0.0036526`,0.0036058`,0.0046585`,0.004554883`,0.005754117`,0.00675595`,0.007895167`,0.0039485`,0.00831`,0.0084932`,0.007105683`,0.00675595`,0.005754117`,0.00478925`,0.008135167`,0.007213967`,0.005205233`,0.005205233`,0.005119517`,0.00763565`,0.0058022`,0.005478283`,0.005838617`,0.006229983`,0.006223117`,0.004658567`},{5/648,0.0058272`,0.005854167`,0.005854167`,0.005783617`,0.005978317`,0.0066791`,0.005697867`,0.006668783`,0.006958233`,0.006790017`,0.0071273`,0.007051367`,0.006120533`,0.0072881`,0.00652945`,0.006287583`,0.006221233`,0.0073664`,0.006154317`,0.008124867`,0.00728625`,0.007736217`,0.007727817`,0.005314417`,0.005752183`,0.005580433`,0.00739035`,0.0050884`,0.005065767`,0.00903645`,0.01137045`,0.010719033`,0.00625995`,0.0059011`,0.005878933`,0.008799717`,0.01290545`,0.00938925`,0.012989417`,0.010463117`,0.013266833`,0.008659817`,0.0112933`,0.009479267`,0.009474583`,0.00951225`,0.0095163`,0.006057933`,0.005878933`,0.00579005`,0.007344367`,0.006084967`,0.0069598`,0.005772967`,0.007054617`,0.008064117`,0.005878933`,0.005834033`,0.005812967`,0.00773905`,0.00578005`,0.005871633`,0.0105731`,0.008822883`,0.008973167`,0.012941217`,0.01054525`,0.012786067`,0.010989733`,0.0129777`,0.015190683`,0.014689167`,0.012616983`,0.0122627`,0.01584575`,0.016425867`,0.015974017`,0.01591715`,0.0170937`,0.01601945`,0.01323205`,0.0161194`,0.015815133`,0.01675745`,0.00489885`,0.0047765`,0.0048588`,0.0048588`,0.005849467`,0.0058741`,0.006090117`,0.004432167`,0.0052046`,0.004111`,0.003432733`,0.006499883`,0.00641085`,0.005583583`,0.00681325`,0.008096167`,0.0034014`,0.00803645`,0.008279667`,0.006718283`,0.00681325`,0.005583583`,0.004627233`,0.00794695`,0.007486067`,0.004696817`,0.004696817`,0.00458055`,0.007579983`,0.006372283`,0.005915033`,0.006405583`,0.00664905`,0.006628567`,0.004984067`},{10/1377,0.005427504`,0.005480838`,0.005480838`,0.005464571`,0.005519038`,0.005109621`,0.004794704`,0.005141904`,0.004532454`,0.005202138`,0.004626388`,0.004966571`,0.004738321`,0.004637221`,0.004311771`,0.007419004`,0.007439921`,0.007074521`,0.005836604`,0.006339238`,0.004680588`,0.004945738`,0.005502421`,0.007313121`,0.006842071`,0.008795671`,0.008318654`,0.007130021`,0.007096021`,0.011215171`,0.012642504`,0.011462804`,0.008728854`,0.008642021`,0.004475754`,0.010094371`,0.013441538`,0.010956254`,0.013575071`,0.010984821`,0.014337621`,0.011035554`,0.011297854`,0.009103288`,0.008948204`,0.008987621`,0.009053771`,0.004499288`,0.004475754`,0.005521804`,0.006665588`,0.005650271`,0.005643421`,0.005456288`,0.007954254`,0.007659738`,0.004475754`,0.004365588`,0.004353704`,0.006398721`,0.004333088`,0.004669804`,0.010530571`,0.007415888`,0.008446488`,0.013550721`,0.009040321`,0.014057704`,0.011333254`,0.013979121`,0.015834404`,0.015289371`,0.013672054`,0.013769921`,0.016036904`,0.016783454`,0.016174554`,0.016189771`,0.017423038`,0.016260788`,0.010508604`,0.016538821`,0.015979721`,0.016493021`,0.003543604`,0.003555904`,0.003544054`,0.003544054`,0.003761171`,0.003332154`,0.003467821`,0.004960971`,0.003305921`,0.004318721`,0.004048838`,0.005598338`,0.005532854`,0.006313888`,0.007297471`,0.007224121`,0.003927571`,0.007033888`,0.008013588`,0.005234804`,0.007297471`,0.006313888`,0.005503671`,0.008152921`,0.007730521`,0.005468238`,0.005468238`,0.005317804`,0.006495154`,0.007297371`,0.007633571`,0.007349021`,0.006982304`,0.006912838`,0.005039554`},{5/729,0.005178192`,0.005213275`,0.005213275`,0.005157475`,0.005613375`,0.006366808`,0.004403725`,0.006458158`,0.006178825`,0.006494075`,0.006032292`,0.005336325`,0.005965708`,0.006555858`,0.005801708`,0.007017558`,0.006966208`,0.007718575`,0.007353325`,0.008110808`,0.006997542`,0.007456108`,0.007702575`,0.005943825`,0.006418775`,0.004296808`,0.003357108`,0.004505075`,0.004647708`,0.004880975`,0.006450942`,0.007120742`,0.003834342`,0.003987492`,0.006870225`,0.013113608`,0.015313325`,0.013556642`,0.015412358`,0.014093025`,0.015518325`,0.013538925`,0.014149875`,0.010815908`,0.010679358`,0.010476842`,0.010530558`,0.006725075`,0.006870225`,0.007797675`,0.009518375`,0.008057342`,0.008709542`,0.007729425`,0.010517708`,0.010172875`,0.006870225`,0.006637542`,0.006628292`,0.008161292`,0.006601758`,0.006937175`,0.011021625`,0.008778608`,0.008412358`,0.011233642`,0.010278925`,0.010129392`,0.009896642`,0.009095842`,0.013513108`,0.015007192`,0.005667108`,0.005690692`,0.008660358`,0.010997475`,0.008866025`,0.008716142`,0.013081325`,0.008839325`,0.005495208`,0.010505042`,0.008721708`,0.011540025`,0.003510675`,0.003577858`,0.003527642`,0.003527642`,0.003472208`,0.003965892`,0.004039942`,0.004802692`,0.003361925`,0.004955925`,0.004620208`,0.005518158`,0.005467725`,0.006558242`,0.007468192`,0.007787858`,0.004465192`,0.007309992`,0.007859992`,0.005292158`,0.007468192`,0.006558242`,0.006326425`,0.007992892`,0.007834525`,0.005719925`,0.005719925`,0.005590908`,0.006867092`,0.007920542`,0.007828758`,0.007940675`,0.007335958`,0.007252308`,0.004649292`},{10/1539,0.007301621`,0.007374054`,0.007374054`,0.007342971`,0.007386888`,0.006242171`,0.005137171`,0.006325354`,0.004231488`,0.006317388`,0.004635204`,0.005018071`,0.005837021`,0.004365638`,0.004385321`,0.003441871`,0.003437621`,0.003608804`,0.003812488`,0.003717504`,0.004515221`,0.003940088`,0.003750571`,0.003276988`,0.003389604`,0.003370754`,0.003550421`,0.003574754`,0.003544154`,0.004281238`,0.004071671`,0.003990738`,0.003816321`,0.003732821`,0.005155171`,0.009446204`,0.015498721`,0.009213071`,0.015596604`,0.011516204`,0.015982804`,0.007131104`,0.012624321`,0.004331904`,0.004336771`,0.004401754`,0.004393171`,0.005175854`,0.005155171`,0.005436604`,0.004993838`,0.005442821`,0.004882571`,0.005447571`,0.005353221`,0.004208338`,0.005155171`,0.004801904`,0.004788288`,0.007294588`,0.004799288`,0.005319454`,0.004214788`,0.004008304`,0.003931121`,0.004416638`,0.004588804`,0.004655838`,0.004343471`,0.004440554`,0.005476271`,0.006685621`,0.005349171`,0.005024504`,0.005703788`,0.005906471`,0.005743138`,0.005823704`,0.006390621`,0.005789821`,0.005596804`,0.005805588`,0.005693854`,0.005708004`,0.003993021`,0.004049988`,0.004004938`,0.004004938`,0.004403788`,0.002854371`,0.002789321`,0.004579938`,0.003639971`,0.004578771`,0.004551121`,0.005479054`,0.005428304`,0.006838588`,0.007709838`,0.007475071`,0.004575754`,0.007354021`,0.008019588`,0.005210838`,0.007709838`,0.006838588`,0.006610621`,0.008132721`,0.008026471`,0.005601338`,0.005601338`,0.005654404`,0.006632038`,0.007361754`,0.007644938`,0.007376988`,0.007159704`,0.007096504`,0.005428588`},{1/162,0.003789379`,0.003845863`,0.003845863`,0.003878679`,0.003868679`,0.003902846`,0.003805813`,0.003944463`,0.004371913`,0.003969846`,0.004288846`,0.004198246`,0.003757996`,0.003798429`,0.003519546`,0.005262529`,0.005307413`,0.004408779`,0.005358596`,0.003676696`,0.004135479`,0.003822563`,0.003848696`,0.005197429`,0.005487779`,0.005635646`,0.004760496`,0.005048196`,0.004984729`,0.006919096`,0.005602846`,0.005339779`,0.005942063`,0.005878579`,0.003474246`,0.007093263`,0.015783879`,0.008077563`,0.015944513`,0.009419096`,0.016155279`,0.004991279`,0.009125446`,0.003671213`,0.003645779`,0.003689079`,0.003696296`,0.003526296`,0.003474246`,0.002790663`,0.002967479`,0.002943763`,0.003004146`,0.002787129`,0.003052746`,0.003030779`,0.003474246`,0.003255146`,0.003222346`,0.003783196`,0.003221446`,0.003072596`,0.003969313`,0.003947063`,0.004164079`,0.004134663`,0.003831996`,0.005033946`,0.004187446`,0.005401929`,0.005241529`,0.006841296`,0.007203563`,0.006681663`,0.006768279`,0.007312246`,0.006795179`,0.007018563`,0.008232463`,0.006900463`,0.006706529`,0.007181763`,0.006718429`,0.007280646`,0.005068163`,0.005210329`,0.005105629`,0.005105629`,0.006041529`,0.001962579`,0.001928163`,0.004520613`,0.004452096`,0.004375413`,0.004622129`,0.005346829`,0.005360913`,0.007173296`,0.007921946`,0.008602163`,0.004808129`,0.008239363`,0.009288996`,0.006201779`,0.007921946`,0.007173296`,0.006772679`,0.009606596`,0.008117979`,0.005789163`,0.005789163`,0.005972463`,0.007695879`,0.006516646`,0.006765563`,0.006541613`,0.006390263`,0.006371346`,0.004321096`},{10/1701,0.005153708`,0.005205375`,0.005205375`,0.005167592`,0.005766792`,0.005440225`,0.004468708`,0.005575008`,0.006188042`,0.005602742`,0.005930325`,0.005387775`,0.004920975`,0.004556225`,0.004087725`,0.006476325`,0.006447142`,0.005639625`,0.005346758`,0.004724875`,0.005591775`,0.004695558`,0.004957992`,0.005365458`,0.005515408`,0.004460142`,0.004438258`,0.003587675`,0.003573675`,0.006768992`,0.006910992`,0.006904275`,0.004570758`,0.004426275`,0.004342992`,0.011616442`,0.015835758`,0.012299875`,0.015930492`,0.012536592`,0.015812442`,0.009527075`,0.012737958`,0.005700992`,0.005516275`,0.005473308`,0.005553675`,0.004383225`,0.004342992`,0.003583892`,0.003800258`,0.003755042`,0.003813408`,0.003606458`,0.004581975`,0.004240058`,0.004342992`,0.003801258`,0.003734908`,0.004994942`,0.003770992`,0.003352692`,0.005380642`,0.004918525`,0.005210975`,0.006420242`,0.004827958`,0.006658492`,0.005528342`,0.007278342`,0.008605725`,0.010937175`,0.008821725`,0.007954358`,0.011020125`,0.011950292`,0.011208308`,0.011199175`,0.012946075`,0.011248125`,0.007402042`,0.011709892`,0.010942408`,0.011895175`,0.006006108`,0.006264292`,0.006075608`,0.006075608`,0.007165858`,0.003171742`,0.003438008`,0.003105808`,0.004496925`,0.003509675`,0.004450275`,0.005196308`,0.005159908`,0.007259558`,0.007953292`,0.008119758`,0.005012492`,0.008037975`,0.008909408`,0.006192625`,0.007953292`,0.007259558`,0.007086525`,0.009543042`,0.008102808`,0.005946958`,0.005946958`,0.006049358`,0.007358158`,0.005004292`,0.005289142`,0.004980725`,0.004542375`,0.004692475`,0.002788892`},{5/891,0.006595621`,0.006607921`,0.006607921`,0.006481971`,0.007244304`,0.007137254`,0.005662104`,0.007268721`,0.005627238`,0.007289138`,0.005837021`,0.005877804`,0.006448421`,0.005411704`,0.005046588`,0.004881104`,0.004835788`,0.006056121`,0.004461054`,0.006539538`,0.006476838`,0.005970854`,0.006261321`,0.003849588`,0.004354888`,0.003082071`,0.003245688`,0.002905421`,0.002949571`,0.004254054`,0.006784671`,0.006572854`,0.002989138`,0.002871838`,0.005744438`,0.012434121`,0.016354704`,0.013008788`,0.016427771`,0.013824904`,0.016787238`,0.011268554`,0.014257254`,0.008627838`,0.008516121`,0.008643971`,0.008699354`,0.005905638`,0.005744438`,0.006422338`,0.005708704`,0.006404688`,0.005667254`,0.006510888`,0.006846221`,0.006259788`,0.005744438`,0.005192154`,0.005115338`,0.008413554`,0.005175288`,0.005105038`,0.009688238`,0.007141554`,0.006942921`,0.009971888`,0.008032738`,0.009160654`,0.007918004`,0.010613988`,0.012945438`,0.013942521`,0.006373821`,0.006505221`,0.010236071`,0.012792038`,0.010735054`,0.010623304`,0.014853454`,0.010788704`,0.006187704`,0.012315954`,0.010222521`,0.013496471`,0.006523588`,0.006761004`,0.006590888`,0.006590888`,0.006741721`,0.003699471`,0.003809538`,0.002847338`,0.005738871`,0.003350204`,0.004029021`,0.004189788`,0.004103504`,0.006980938`,0.007614754`,0.008279588`,0.005223221`,0.008323954`,0.009291588`,0.006740471`,0.007614754`,0.006980938`,0.007164321`,0.009392288`,0.007728704`,0.005808788`,0.005808788`,0.005764254`,0.007672788`,0.004199238`,0.004457121`,0.004157204`,0.004506838`,0.004680421`,0.002650771`},{10/1863,0.009642925`,0.009658025`,0.009658025`,0.009480442`,0.009945558`,0.010011025`,0.008043058`,0.010090708`,0.005453342`,0.010045342`,0.005862192`,0.006064908`,0.009726975`,0.006452508`,0.006347442`,0.002923225`,0.002881708`,0.003922692`,0.003566642`,0.005122825`,0.005668808`,0.005453775`,0.004738992`,0.002494142`,0.003001558`,0.001823258`,0.002624492`,0.002278842`,0.002296475`,0.002634142`,0.003386892`,0.003370325`,0.002085392`,0.001932175`,0.009203292`,0.014477942`,0.016342408`,0.013802742`,0.016449875`,0.014965008`,0.016532358`,0.013255208`,0.015329575`,0.010000658`,0.009980592`,0.009732308`,0.009734792`,0.009126742`,0.009203292`,0.009860708`,0.010463808`,0.010090425`,0.009976842`,0.009864675`,0.010913858`,0.010310025`,0.009203292`,0.008696675`,0.008693458`,0.011205825`,0.008733558`,0.009790992`,0.009150092`,0.005728675`,0.005058408`,0.008538575`,0.009166258`,0.005264908`,0.006571008`,0.005369725`,0.011479792`,0.013178258`,0.003837792`,0.003709342`,0.005261575`,0.006445358`,0.005376575`,0.005425925`,0.009135158`,0.005414192`,0.004427775`,0.006235225`,0.005261192`,0.006932475`,0.005206192`,0.005290258`,0.005231592`,0.005231592`,0.005917692`,0.003400908`,0.003129808`,0.002818725`,0.005143708`,0.002972842`,0.004069642`,0.004005058`,0.003967258`,0.006389425`,0.007164725`,0.007505992`,0.005467675`,0.007426775`,0.008779825`,0.005650225`,0.007164725`,0.006389425`,0.006866208`,0.009050858`,0.007427942`,0.005209508`,0.005209508`,0.005138475`,0.006787342`,0.004775125`,0.005442925`,0.004766075`,0.004993825`,0.005104658`,0.003028342`},{5/972,0.006487742`,0.006543042`,0.006543042`,0.006497242`,0.006677958`,0.005464275`,0.004717925`,0.005521392`,0.003221342`,0.005501742`,0.003624892`,0.004072358`,0.005046675`,0.003415708`,0.003311342`,0.002274558`,0.002262908`,0.002366642`,0.002879708`,0.002513392`,0.003366325`,0.002687808`,0.002463708`,0.002009308`,0.002321908`,0.002282575`,0.003540008`,0.002381725`,0.002355675`,0.002743475`,0.002623892`,0.002723342`,0.002988842`,0.002827392`,0.004353775`,0.013962708`,0.016805975`,0.013916392`,0.016790242`,0.015577258`,0.016715058`,0.009376875`,0.015600692`,0.005029125`,0.004983858`,0.004882258`,0.004882558`,0.004254725`,0.004353775`,0.006225908`,0.005622258`,0.006150258`,0.005109142`,0.006258742`,0.007158292`,0.005069858`,0.004353775`,0.004109225`,0.004154858`,0.006927192`,0.004142208`,0.005274808`,0.003779892`,0.002704892`,0.002549392`,0.003418275`,0.003888008`,0.002979442`,0.003001058`,0.003187525`,0.004919558`,0.006974392`,0.004051475`,0.003499758`,0.004554375`,0.004976225`,0.004587208`,0.004605075`,0.006126875`,0.004614875`,0.004463175`,0.004826592`,0.004536408`,0.005318525`,0.004538942`,0.004596642`,0.004554242`,0.004554242`,0.004942042`,0.003265975`,0.003523558`,0.003469158`,0.004658575`,0.002545908`,0.003927975`,0.003985275`,0.004024908`,0.006808292`,0.007675925`,0.008087192`,0.005719692`,0.007889075`,0.009076758`,0.006056992`,0.007675925`,0.006808292`,0.006744342`,0.009245375`,0.007988758`,0.005870058`,0.005870058`,0.005717092`,0.007307542`,0.005652942`,0.005523525`,0.005675925`,0.005636692`,0.005672308`,0.003804592`},{2/405,0.003934779`,0.003977879`,0.003977879`,0.003962179`,0.004318346`,0.005260796`,0.003698396`,0.005142929`,0.003407079`,0.005266779`,0.003650896`,0.003688629`,0.005047113`,0.003627463`,0.003677163`,0.003398763`,0.003436879`,0.003659696`,0.003328729`,0.003690363`,0.003470346`,0.003560679`,0.003416263`,0.003463963`,0.003853763`,0.003933746`,0.004673613`,0.003419196`,0.003436646`,0.004574229`,0.003733213`,0.003319096`,0.004230763`,0.004022663`,0.004680746`,0.015600329`,0.017838429`,0.015979079`,0.017922629`,0.016399929`,0.018140263`,0.012064829`,0.016740279`,0.006322779`,0.006136913`,0.006035829`,0.006118879`,0.004668663`,0.004680746`,0.006088146`,0.005755579`,0.005943579`,0.005189696`,0.006170413`,0.006656946`,0.005954379`,0.004680746`,0.003962313`,0.003977246`,0.009790696`,0.003979279`,0.005708129`,0.007550646`,0.004157029`,0.004245296`,0.007674546`,0.005493929`,0.004596879`,0.004957429`,0.003895946`,0.009733313`,0.011481146`,0.005482779`,0.004897829`,0.007296413`,0.008705496`,0.007444229`,0.007243546`,0.012099663`,0.007423779`,0.006086379`,0.008532779`,0.007272296`,0.008617796`,0.003927846`,0.003904563`,0.003920029`,0.003920029`,0.004572479`,0.004066579`,0.004178029`,0.004436746`,0.002788346`,0.003107479`,0.003966696`,0.004059329`,0.004060929`,0.007264663`,0.007976079`,0.009047696`,0.005483896`,0.009318796`,0.009522779`,0.008029063`,0.007976079`,0.007264663`,0.006878396`,0.009436246`,0.008142496`,0.006156463`,0.006156463`,0.006187196`,0.008644113`,0.006579946`,0.006497163`,0.006613696`,0.006322546`,0.006262863`,0.005161629`},{5/1053,0.006999917`,0.007009567`,0.007009567`,0.006844583`,0.007882483`,0.008749067`,0.005909017`,0.00865675`,0.005827067`,0.0086844`,0.006103833`,0.0060357`,0.0084679`,0.006951717`,0.00659505`,0.0052265`,0.005181733`,0.00683925`,0.004508483`,0.0073932`,0.006792617`,0.007309417`,0.0071448`,0.003782483`,0.004757317`,0.00329985`,0.004126117`,0.003098317`,0.0030771`,0.004692317`,0.005031917`,0.0055978`,0.00388325`,0.003689433`,0.009301533`,0.016469217`,0.018657583`,0.016871833`,0.018698117`,0.016830267`,0.018701467`,0.015522417`,0.017451233`,0.00959565`,0.009467717`,0.009351017`,0.009389267`,0.008493033`,0.009301533`,0.009698917`,0.009189083`,0.009526783`,0.008753433`,0.00993965`,0.010823483`,0.0089244`,0.009301533`,0.008856117`,0.008902417`,0.012974033`,0.008909217`,0.010471133`,0.010056933`,0.007443783`,0.007608767`,0.0107447`,0.00872665`,0.007737467`,0.008035267`,0.006071217`,0.012034467`,0.01286115`,0.004976933`,0.0054356`,0.00594525`,0.0063163`,0.0059839`,0.00575465`,0.0089306`,0.005932917`,0.004319083`,0.006152767`,0.005979117`,0.006379267`,0.00367155`,0.003732983`,0.003686467`,0.003686467`,0.004599467`,0.002687367`,0.0027479`,0.00502365`,0.002831383`,0.0035466`,0.004813583`,0.0043562`,0.0043191`,0.007620967`,0.008248233`,0.00898085`,0.0054764`,0.009296217`,0.009345483`,0.00804435`,0.008248233`,0.007620967`,0.007157083`,0.00922535`,0.0083214`,0.0073857`,0.0073857`,0.007227067`,0.00861095`,0.008448617`,0.009042417`,0.008447183`,0.007738767`,0.007745967`,0.00621385`},{10/2187,0.009979817`,0.0099507`,0.0099507`,0.009696167`,0.0108608`,0.011099367`,0.00860925`,0.011095417`,0.008235917`,0.010990833`,0.00876525`,0.009778233`,0.011616833`,0.009825783`,0.010639567`,0.005568883`,0.005509267`,0.007155333`,0.00583625`,0.00852315`,0.009469183`,0.009513133`,0.008433133`,0.004075933`,0.004652617`,0.0043094`,0.00500305`,0.00408105`,0.004042317`,0.005032333`,0.004706217`,0.00540875`,0.005177533`,0.005152933`,0.012007083`,0.015682467`,0.017371467`,0.01577655`,0.01741995`,0.016971283`,0.017805233`,0.012304883`,0.016958967`,0.009741283`,0.009743717`,0.009612283`,0.009605667`,0.011976233`,0.012007083`,0.0131663`,0.01115665`,0.013071417`,0.011780583`,0.01313925`,0.012724367`,0.009431667`,0.012007083`,0.01201155`,0.012070333`,0.0140081`,0.011988767`,0.012902467`,0.008472733`,0.008348667`,0.007932183`,0.006939283`,0.00916555`,0.006658117`,0.00786515`,0.006057`,0.006906633`,0.00767475`,0.00544575`,0.005083083`,0.005599783`,0.005365383`,0.005598833`,0.005592667`,0.006153717`,0.005615483`,0.0056771`,0.005313017`,0.005592483`,0.005488167`,0.004920717`,0.00507655`,0.00496385`,0.00496385`,0.005598317`,0.003001767`,0.003362133`,0.005036733`,0.002797617`,0.0041789`,0.0045253`,0.00401825`,0.003997317`,0.008120717`,0.008749117`,0.008866233`,0.005595567`,0.00921355`,0.009290483`,0.008353017`,0.008749117`,0.008120717`,0.007984033`,0.009130983`,0.008825633`,0.008681767`,0.008681767`,0.008306767`,0.008728917`,0.008496033`,0.0084738`,0.008469933`,0.008315817`,0.008353933`,0.00730365`},{5/1134,0.010047925`,0.010066042`,0.010066042`,0.009887208`,0.010127442`,0.009274275`,0.009415875`,0.009437242`,0.006771392`,0.009344708`,0.007121608`,0.007965008`,0.009355158`,0.007596258`,0.007953275`,0.005053808`,0.005049358`,0.005076475`,0.004870958`,0.005781858`,0.006866192`,0.006445842`,0.005805025`,0.004858742`,0.005087008`,0.005587508`,0.006439092`,0.004943725`,0.004923275`,0.005846608`,0.005154925`,0.005377692`,0.005991975`,0.005936225`,0.008674042`,0.010957908`,0.017193758`,0.011317142`,0.017217725`,0.015222558`,0.017339442`,0.007900492`,0.014562042`,0.007209825`,0.007308942`,0.007330942`,0.007260958`,0.008878875`,0.008674042`,0.007967342`,0.007069175`,0.007938608`,0.007111575`,0.008052642`,0.007290458`,0.006907642`,0.008674042`,0.008365525`,0.008315258`,0.010044892`,0.008321892`,0.008616725`,0.006933992`,0.005997758`,0.005624725`,0.006395492`,0.007975158`,0.005769758`,0.006581142`,0.005770775`,0.006975175`,0.008041342`,0.006997958`,0.006069942`,0.006829275`,0.007395708`,0.006877808`,0.007074092`,0.008297142`,0.006964458`,0.007115042`,0.007305325`,0.006749975`,0.007932542`,0.005673558`,0.005887325`,0.005731492`,0.005731492`,0.005901808`,0.002970542`,0.003022792`,0.005084225`,0.003494608`,0.005566775`,0.005085642`,0.004354358`,0.004270592`,0.007594258`,0.008139892`,0.009717808`,0.008548042`,0.009999842`,0.009921092`,0.009518875`,0.008139892`,0.007594258`,0.008485025`,0.009992325`,0.008151208`,0.008014625`,0.008014625`,0.007624758`,0.009771392`,0.007410092`,0.007596775`,0.007428625`,0.007357042`,0.007383208`,0.006911275`},{10/2349,0.005191567`,0.005263833`,0.005263833`,0.005232333`,0.0055055`,0.00613995`,0.004491133`,0.005987467`,0.004522967`,0.00614145`,0.004592133`,0.00454895`,0.006291317`,0.005574283`,0.005001133`,0.00607015`,0.006074067`,0.005992967`,0.0054898`,0.005838183`,0.005487717`,0.005913417`,0.006014233`,0.005581867`,0.005931067`,0.005780183`,0.007139683`,0.005610567`,0.005664317`,0.006804967`,0.006596267`,0.006309233`,0.006485117`,0.0063396`,0.006409617`,0.012759583`,0.0156147`,0.013211233`,0.01559555`,0.015764517`,0.0155261`,0.00867475`,0.0156502`,0.00752715`,0.007694033`,0.00761305`,0.0075372`,0.00618735`,0.006409617`,0.008322667`,0.007929033`,0.008339067`,0.007731183`,0.0083502`,0.00787805`,0.0079014`,0.006409617`,0.006010767`,0.006059917`,0.008920983`,0.006050383`,0.007318733`,0.007946017`,0.0062959`,0.006286717`,0.007156883`,0.007886517`,0.006850417`,0.007132333`,0.006965117`,0.007996867`,0.009312217`,0.008977417`,0.007762067`,0.008603967`,0.009117667`,0.008694783`,0.008675533`,0.011085967`,0.008709867`,0.00877945`,0.008977417`,0.008497167`,0.00946165`,0.005823267`,0.005828767`,0.005818`,0.005818`,0.007040267`,0.004184667`,0.003958283`,0.004336033`,0.00467925`,0.004959267`,0.0036874`,0.006016633`,0.005982283`,0.006779`,0.007313417`,0.008871183`,0.006226067`,0.009376283`,0.009844433`,0.008224217`,0.007313417`,0.006779`,0.00680175`,0.009825983`,0.00737305`,0.00727635`,0.00727635`,0.007028183`,0.008697`,0.006104383`,0.006100933`,0.0061371`,0.005988983`,0.006005217`,0.00530495`},{1/243,0.004631013`,0.004669946`,0.004669946`,0.004622513`,0.005015446`,0.005711329`,0.003769129`,0.005544779`,0.004983763`,0.005688929`,0.004913696`,0.004770346`,0.005942896`,0.005628363`,0.005438779`,0.007028613`,0.007015646`,0.007377763`,0.006516896`,0.006868279`,0.005999296`,0.006704996`,0.006951996`,0.006593963`,0.006565246`,0.007457079`,0.008015829`,0.006353013`,0.006435679`,0.008369763`,0.007789246`,0.007899896`,0.008651196`,0.008602913`,0.006592329`,0.013630496`,0.015368529`,0.014121346`,0.015376596`,0.014012113`,0.015354479`,0.010804129`,0.015064363`,0.007648713`,0.007656696`,0.007630846`,0.007639363`,0.006237513`,0.006592329`,0.008241163`,0.007786213`,0.008170913`,0.007617179`,0.008215263`,0.008247146`,0.007548813`,0.006592329`,0.006480613`,0.006490996`,0.009024163`,0.006457379`,0.007147113`,0.008633629`,0.007409946`,0.007750313`,0.008686129`,0.007929679`,0.008271846`,0.008343229`,0.008102913`,0.009785079`,0.011554579`,0.009973546`,0.009075029`,0.010855629`,0.012667496`,0.011046046`,0.010848329`,0.014054079`,0.011036013`,0.009335596`,0.012413429`,0.010734296`,0.012692729`,0.003433879`,0.003417796`,0.003426546`,0.003426546`,0.004280229`,0.003091896`,0.002946513`,0.003676063`,0.003427146`,0.002858263`,0.003315296`,0.004152279`,0.004158963`,0.005897746`,0.006498229`,0.006621963`,0.005410563`,0.007056363`,0.008115396`,0.005546863`,0.006498229`,0.005897746`,0.005521846`,0.008011196`,0.006638863`,0.005915379`,0.005915379`,0.005732913`,0.006259013`,0.006099763`,0.006187046`,0.006110479`,0.005914246`,0.005955313`,0.004554146`},{10/2511,0.004633946`,0.004672946`,0.004672946`,0.004638713`,0.005183663`,0.006164746`,0.003796563`,0.005996313`,0.005090329`,0.006170479`,0.004939196`,0.004580263`,0.005878796`,0.005621446`,0.004950063`,0.008587329`,0.008583313`,0.008274396`,0.008037946`,0.007549163`,0.006304029`,0.006910679`,0.007514663`,0.008325363`,0.008058596`,0.008743496`,0.004380529`,0.006305879`,0.006602029`,0.008844563`,0.010011463`,0.009341979`,0.006540313`,0.006636629`,0.006100329`,0.012807946`,0.014819113`,0.013532213`,0.014903079`,0.013588413`,0.015068029`,0.010747979`,0.013776946`,0.007510296`,0.007556196`,0.007506129`,0.007487029`,0.005936063`,0.006100329`,0.007153829`,0.007042279`,0.007080579`,0.006612279`,0.007152313`,0.007729713`,0.007270479`,0.006100329`,0.005883596`,0.005868213`,0.008436846`,0.005848113`,0.006423346`,0.008805096`,0.007616096`,0.008190563`,0.010977029`,0.007554979`,0.010276946`,0.008577513`,0.010456679`,0.013089179`,0.014550579`,0.010120613`,0.009628213`,0.011725563`,0.012073046`,0.012125396`,0.012254213`,0.015279629`,0.012223513`,0.005823413`,0.012109046`,0.011671646`,0.011316596`,0.002243813`,0.002216296`,0.002236046`,0.002236046`,0.002867363`,0.003806263`,0.003830246`,0.004030863`,0.002497729`,0.002493846`,0.003430829`,0.003666329`,0.003647979`,0.006023896`,0.007016363`,0.006082563`,0.005159413`,0.005668579`,0.005225263`,0.003525696`,0.007016363`,0.006023896`,0.005791246`,0.003916063`,0.007462913`,0.005367596`,0.005367596`,0.005220863`,0.005089796`,0.007873696`,0.008115079`,0.007898146`,0.008297763`,0.008274596`,0.005647146`},{11/81,0.005049275`,0.005074208`,0.005074208`,0.005013208`,0.005457775`,0.006525025`,0.004775625`,0.006445308`,0.005660708`,0.006564142`,0.005642108`,0.005541325`,0.006461008`,0.005957458`,0.005780308`,0.007636875`,0.007905475`,0.009348792`,0.008640725`,0.009101992`,0.006654142`,0.007349725`,0.007174775`,0.007204892`,0.008156175`,0.007357092`,0.004305942`,0.003846275`,0.003878158`,0.009835792`,0.010943158`,0.011035525`,0.005989308`,0.005974875`,0.006764992`,0.012609258`,0.015130725`,0.013263958`,0.015228025`,0.013249858`,0.015534908`,0.010433958`,0.013299692`,0.007946642`,0.007878692`,0.007879375`,0.007958192`,0.006707758`,0.006764992`,0.007881808`,0.007308675`,0.007877208`,0.007364625`,0.007885308`,0.007972258`,0.007278458`,0.006764992`,0.006640258`,0.006621708`,0.009415708`,0.006595225`,0.007010275`,0.009275842`,0.009246158`,0.010042708`,0.011158608`,0.008227708`,0.011135458`,0.009755692`,0.011910042`,0.013721292`,0.014185308`,0.005878075`,0.008032392`,0.007973825`,0.008559808`,0.008112708`,0.007755158`,0.012494942`,0.008043858`,0.004383392`,0.008456058`,0.007925175`,0.008462092`,0.001970625`,0.001960942`,0.001967125`,0.001967125`,0.002456892`,0.003419342`,0.003467975`,0.005139158`,0.002425158`,0.002985642`,0.004089225`,0.004132158`,0.004101625`,0.006125842`,0.006929492`,0.005469792`,0.005576208`,0.005214425`,0.005074142`,0.003514325`,0.006929492`,0.006125842`,0.006530392`,0.003473642`,0.007210508`,0.004521375`,0.004521375`,0.004611225`,0.004728908`,0.007662192`,0.007549758`,0.007673208`,0.008642792`,0.008679358`,0.006153058`},{11/162,0.005792238`,0.005832454`,0.005832454`,0.005784254`,0.006273171`,0.007187771`,0.005527904`,0.007094421`,0.006282454`,0.007217421`,0.006050804`,0.005991938`,0.007646871`,0.007291071`,0.007036788`,0.006743338`,0.007015088`,0.010366421`,0.006324488`,0.009368904`,0.008125271`,0.009102438`,0.007523888`,0.006586954`,0.006271521`,0.005508021`,0.006221571`,0.003882054`,0.003857121`,0.008132938`,0.006994004`,0.011114038`,0.007674021`,0.007518338`,0.007807138`,0.011894121`,0.013561121`,0.012799488`,0.013620638`,0.012173254`,0.013831304`,0.011319188`,0.012417721`,0.009452254`,0.009445138`,0.009300804`,0.009309321`,0.007767371`,0.007807138`,0.009166688`,0.009025338`,0.009061521`,0.008354821`,0.009139588`,0.010191088`,0.009323454`,0.007807138`,0.007510838`,0.007493288`,0.009536554`,0.007482421`,0.008319421`,0.009801238`,0.008710704`,0.009358271`,0.011581304`,0.008337371`,0.011224938`,0.009521938`,0.008829338`,0.012982004`,0.014144671`,0.006167038`,0.006799788`,0.006288971`,0.005686671`,0.006191688`,0.006020471`,0.007492638`,0.006162938`,0.004444088`,0.005576004`,0.006330604`,0.005516754`,0.002398571`,0.002405904`,0.002398538`,0.002398538`,0.002585988`,0.004570538`,0.004616754`,0.005093338`,0.003254038`,0.003835004`,0.004419304`,0.005149204`,0.005096204`,0.006394671`,0.006930788`,0.006966388`,0.005876004`,0.006541871`,0.006471104`,0.004280121`,0.006930788`,0.006394671`,0.007090188`,0.006113321`,0.007008021`,0.005029904`,0.005029904`,0.005109788`,0.005947871`,0.007225788`,0.007452821`,0.007247154`,0.006649138`,0.006710871`,0.005895754`},{11/243,0.004182113`,0.004233746`,0.004233746`,0.004223846`,0.004477113`,0.004927963`,0.004158546`,0.004815929`,0.004354579`,0.004974929`,0.004274129`,0.004238029`,0.005306929`,0.006778363`,0.005109963`,0.006255696`,0.006406229`,0.010011413`,0.005494179`,0.009431096`,0.005891396`,0.009212496`,0.007659013`,0.006033179`,0.005553363`,0.005255113`,0.006010663`,0.005188096`,0.005177113`,0.007028113`,0.006739096`,0.010791013`,0.007385096`,0.007486013`,0.006671396`,0.011713563`,0.015628313`,0.012039229`,0.015729129`,0.013097346`,0.016051646`,0.011084496`,0.013700079`,0.009336329`,0.009242179`,0.009170296`,0.009209246`,0.006154779`,0.006671396`,0.008346213`,0.008481296`,0.008286446`,0.007948213`,0.008294379`,0.009814929`,0.008714746`,0.006671396`,0.006593596`,0.006645763`,0.008491296`,0.006583679`,0.007433679`,0.009692463`,0.008918296`,0.009253979`,0.011950863`,0.008933529`,0.010587129`,0.009481829`,0.008594813`,0.012880363`,0.013470046`,0.006426963`,0.007133196`,0.007728063`,0.006687913`,0.007714413`,0.007578763`,0.008305829`,0.007713463`,0.006263046`,0.006572579`,0.007710296`,0.005848813`,0.002855596`,0.002879829`,0.002860846`,0.002860846`,0.003046346`,0.005103663`,0.004960196`,0.004876496`,0.003090113`,0.003836713`,0.004255863`,0.004888713`,0.004908729`,0.006852996`,0.007719029`,0.007539129`,0.005882396`,0.006870763`,0.008096096`,0.004560813`,0.007719029`,0.006852996`,0.006843013`,0.008538996`,0.008021929`,0.005771063`,0.005771063`,0.005846829`,0.006389629`,0.007123729`,0.007586646`,0.007159679`,0.007051013`,0.007042813`,0.005372596`},{11/324,0.00325375`,0.00334025`,0.00334025`,0.003380633`,0.003827667`,0.004371733`,0.0035842`,0.004315217`,0.0043598`,0.0044616`,0.004246917`,0.0040532`,0.0044399`,0.0047508`,0.003919267`,0.008329883`,0.0082972`,0.009409533`,0.006814567`,0.009118367`,0.00506145`,0.007515783`,0.0085611`,0.008446833`,0.006948833`,0.007168833`,0.00566855`,0.007730767`,0.007705967`,0.007300367`,0.00695455`,0.0098217`,0.0071764`,0.007173367`,0.005614883`,0.012679967`,0.01494865`,0.01351305`,0.015008617`,0.014571183`,0.01530725`,0.012223333`,0.01432405`,0.00987535`,0.0097643`,0.009761783`,0.009809767`,0.005115683`,0.005614883`,0.008871233`,0.00906335`,0.008923667`,0.008709733`,0.008854967`,0.010184367`,0.009199933`,0.005614883`,0.00542215`,0.005522783`,0.007472583`,0.00546655`,0.007222767`,0.0102082`,0.008940633`,0.009230667`,0.01229995`,0.008974033`,0.0100615`,0.0096931`,0.008715117`,0.013424017`,0.014154967`,0.006450767`,0.006791633`,0.007538733`,0.007837133`,0.007644717`,0.007467367`,0.009649267`,0.007627717`,0.00610015`,0.0076731`,0.007525433`,0.0073144`,0.003178`,0.003190767`,0.003178467`,0.003178467`,0.003468767`,0.004071233`,0.0041332`,0.004750567`,0.002739733`,0.00383245`,0.004309467`,0.005056633`,0.005066217`,0.00772315`,0.0083414`,0.008566433`,0.00629825`,0.008519267`,0.009537817`,0.006748717`,0.0083414`,0.00772315`,0.007205917`,0.009536433`,0.008405417`,0.00731745`,0.00731745`,0.007257533`,0.007833333`,0.005231783`,0.005733683`,0.005237617`,0.005101233`,0.005032917`,0.0045613`},{11/405,0.004470921`,0.004516704`,0.004516704`,0.004463421`,0.005137371`,0.005417854`,0.004500721`,0.005410688`,0.005376988`,0.005517154`,0.005122321`,0.004963354`,0.004931754`,0.005723588`,0.004423771`,0.008356071`,0.008287988`,0.008777271`,0.008245288`,0.009006988`,0.007396238`,0.008573788`,0.008860788`,0.007670538`,0.007710238`,0.006493204`,0.005452488`,0.006731388`,0.006867288`,0.007024354`,0.006777038`,0.007297754`,0.006029571`,0.006137938`,0.006308721`,0.014391354`,0.016793221`,0.014383104`,0.016868554`,0.015123871`,0.017211004`,0.012953754`,0.015060788`,0.010628154`,0.010488788`,0.010486654`,0.010563971`,0.005477488`,0.006308721`,0.009981738`,0.010262221`,0.009893921`,0.009628904`,0.009895288`,0.011260004`,0.010244871`,0.006308721`,0.006073788`,0.006194938`,0.009068838`,0.006157688`,0.008001621`,0.011392854`,0.009254338`,0.009359888`,0.011267154`,0.009766371`,0.008233588`,0.009595838`,0.007778704`,0.012980854`,0.013939554`,0.007105571`,0.007369004`,0.008567754`,0.009205321`,0.008634838`,0.008456221`,0.011406371`,0.008614538`,0.005914504`,0.008948804`,0.008532171`,0.009683521`,0.003561154`,0.003589038`,0.003564571`,0.003564571`,0.004687571`,0.003442688`,0.003679304`,0.004913438`,0.003047188`,0.003720771`,0.004512104`,0.004489404`,0.004431154`,0.008030821`,0.008612488`,0.008726238`,0.006021671`,0.008995588`,0.009420004`,0.007715238`,0.008612488`,0.008030821`,0.008059538`,0.009507904`,0.008635421`,0.007874504`,0.007874504`,0.007638054`,0.008343054`,0.004514571`,0.004648371`,0.004517838`,0.004936238`,0.004964921`,0.003416121`},{11/486,0.007628563`,0.007646529`,0.007646529`,0.007470879`,0.007985663`,0.007964463`,0.006384613`,0.008019679`,0.006552163`,0.008018529`,0.006998379`,0.006855046`,0.007722913`,0.006386613`,0.006288096`,0.004682246`,0.004642996`,0.005383996`,0.005172029`,0.005686313`,0.006237779`,0.005819846`,0.005626263`,0.003912296`,0.004415096`,0.003468329`,0.004135813`,0.003270963`,0.003284646`,0.004177213`,0.005007696`,0.005538346`,0.003204229`,0.003101913`,0.007603563`,0.011917529`,0.015284763`,0.011872596`,0.015395196`,0.012992813`,0.015451679`,0.010204246`,0.013477196`,0.007878079`,0.007878896`,0.007885346`,0.007863313`,0.007476296`,0.007603563`,0.008591196`,0.007780996`,0.008408463`,0.007428063`,0.008617096`,0.008688196`,0.007184729`,0.007603563`,0.007463263`,0.007424063`,0.009628913`,0.007432563`,0.008105429`,0.007931713`,0.005949263`,0.006000063`,0.008108029`,0.006942113`,0.006550229`,0.006384946`,0.006830929`,0.010095146`,0.012144763`,0.006103413`,0.005710663`,0.007920096`,0.008984663`,0.008057196`,0.007966229`,0.010224279`,0.008071196`,0.007031879`,0.008779963`,0.007880596`,0.009865963`,0.005098063`,0.005165446`,0.005109229`,0.005109229`,0.006620096`,0.003977679`,0.003996029`,0.005239529`,0.003414229`,0.004844263`,0.005054529`,0.004634429`,0.004575163`,0.008369229`,0.008877529`,0.009225246`,0.007696846`,0.009237246`,0.009102346`,0.008464379`,0.008877529`,0.008369229`,0.008793296`,0.008928429`,0.008828413`,0.008614763`,0.008614763`,0.008136079`,0.008994879`,0.004620563`,0.005678546`,0.004639929`,0.004708446`,0.004783863`,0.003473196`},{11/567,0.004746329`,0.004826779`,0.004826779`,0.004841413`,0.004865479`,0.004015246`,0.004156513`,0.004076546`,0.003323763`,0.004078529`,0.003759146`,0.003926179`,0.003661596`,0.003963263`,0.003536313`,0.003932779`,0.003920696`,0.003779046`,0.003691196`,0.003700479`,0.003912229`,0.003618546`,0.003700896`,0.003564096`,0.003942513`,0.003849696`,0.005680163`,0.003732313`,0.003678579`,0.004102663`,0.003725679`,0.004664229`,0.004334129`,0.004140646`,0.003708613`,0.006435729`,0.011113596`,0.006665663`,0.011261629`,0.007664263`,0.011365229`,0.005173946`,0.008653663`,0.004176613`,0.004137029`,0.004209696`,0.004221513`,0.003721029`,0.003708613`,0.003805929`,0.003526229`,0.003756763`,0.003428713`,0.003791229`,0.003994746`,0.003413846`,0.003708613`,0.003579629`,0.003544063`,0.004440129`,0.003531546`,0.003483513`,0.004380379`,0.003809113`,0.003897413`,0.004646979`,0.004126729`,0.004530829`,0.004334379`,0.004507696`,0.006355563`,0.007131396`,0.005324213`,0.004683396`,0.006409546`,0.007844679`,0.006525329`,0.006163096`,0.009046863`,0.006440579`,0.007911879`,0.007661679`,0.006381779`,0.008712346`,0.006082296`,0.006091879`,0.006075996`,0.006075996`,0.006661646`,0.004143313`,0.003726363`,0.005220596`,0.005010763`,0.005083929`,0.004858696`,0.006592029`,0.006579929`,0.007230796`,0.007934729`,0.008910646`,0.007537179`,0.009064179`,0.009302946`,0.008268546`,0.007934729`,0.007230796`,0.007366629`,0.009232679`,0.008089163`,0.007076179`,0.007076179`,0.006692579`,0.008776679`,0.006436863`,0.007289846`,0.006478513`,0.006025329`,0.005897246`,0.003924863`},{11/648,0.003366513`,0.003434879`,0.003434879`,0.003476263`,0.003443346`,0.003615196`,0.003255963`,0.003590563`,0.004299113`,0.003673879`,0.004209329`,0.003783329`,0.003600563`,0.003758946`,0.003776663`,0.004706646`,0.004699096`,0.004581579`,0.004643379`,0.003996813`,0.004413863`,0.004044446`,0.004186596`,0.004181346`,0.004644013`,0.004140913`,0.005984913`,0.003633963`,0.003609513`,0.006190446`,0.005605713`,0.005506696`,0.004794063`,0.004493046`,0.003489446`,0.006501479`,0.011420613`,0.007215579`,0.011616279`,0.007764163`,0.011956463`,0.005220596`,0.007859813`,0.004146529`,0.004046963`,0.004112746`,0.004157829`,0.003717513`,0.003489446`,0.003112496`,0.003058146`,0.003084163`,0.002855496`,0.003086879`,0.003428396`,0.003208146`,0.003489446`,0.003317713`,0.003252429`,0.003941379`,0.003244713`,0.002830129`,0.004818363`,0.004223129`,0.004428129`,0.004814046`,0.004160796`,0.005236163`,0.004741563`,0.005788113`,0.006416179`,0.007581679`,0.007991196`,0.006953779`,0.008694463`,0.011272163`,0.008933379`,0.008894863`,0.011385363`,0.008955879`,0.007410646`,0.011070663`,0.008572763`,0.012125713`,0.004701813`,0.004697829`,0.004695979`,0.004695979`,0.005129679`,0.004007013`,0.003986529`,0.004468579`,0.004569796`,0.005262113`,0.004469546`,0.006161996`,0.006146413`,0.007244763`,0.007934446`,0.008354596`,0.007032313`,0.008342496`,0.008861096`,0.007387563`,0.007934446`,0.007244763`,0.007325796`,0.008901079`,0.008071763`,0.007132546`,0.007132546`,0.006781863`,0.008033746`,0.006673129`,0.007174013`,0.006710579`,0.006817196`,0.006800996`,0.004502329`},{11/729,0.004004675`,0.004072075`,0.004072075`,0.004074258`,0.004444642`,0.004726592`,0.003849692`,0.004756958`,0.004431642`,0.004832442`,0.004347525`,0.004196258`,0.004513642`,0.004595675`,0.004286508`,0.003691958`,0.003633108`,0.005236742`,0.003186842`,0.005595258`,0.004791575`,0.005175542`,0.005305692`,0.002329125`,0.003021542`,0.002027258`,0.002263125`,0.001858808`,0.001862208`,0.003250025`,0.005758292`,0.005958642`,0.002037275`,0.001916208`,0.004211642`,0.009844692`,0.014924525`,0.010596692`,0.014933008`,0.012165592`,0.015051175`,0.008199675`,0.011464458`,0.005132058`,0.005008392`,0.005005825`,0.005056642`,0.004542558`,0.004211642`,0.004320325`,0.004408425`,0.004303675`,0.004131508`,0.004282575`,0.005336908`,0.004483592`,0.004211642`,0.003937642`,0.003916108`,0.004470258`,0.003895992`,0.003518558`,0.006209975`,0.005672042`,0.005996742`,0.007380658`,0.005171825`,0.006891425`,0.005858158`,0.007911058`,0.010736475`,0.012009042`,0.004718425`,0.005396075`,0.006931925`,0.007856275`,0.007069975`,0.006683242`,0.010811508`,0.006990775`,0.003495225`,0.007561575`,0.006972792`,0.007355858`,0.004596275`,0.004659325`,0.004613525`,0.004613525`,0.004408275`,0.003081925`,0.003354425`,0.004436992`,0.003609008`,0.004859875`,0.004222375`,0.005203575`,0.005142175`,0.007710092`,0.008354192`,0.008124658`,0.007045342`,0.008041425`,0.008967325`,0.006703692`,0.008354192`,0.007710092`,0.007618375`,0.008975708`,0.008440275`,0.007599558`,0.007599558`,0.007331658`,0.007617458`,0.006683992`,0.007102642`,0.006717758`,0.006217792`,0.006190442`,0.004775592`},{11/810,0.003441488`,0.003497471`,0.003497471`,0.003444754`,0.003860121`,0.004202104`,0.002425154`,0.003982904`,0.002629988`,0.004161721`,0.002642471`,0.002410771`,0.004435504`,0.003632638`,0.003280038`,0.003015554`,0.003017021`,0.002963354`,0.002908821`,0.003859304`,0.003098138`,0.003511088`,0.003367604`,0.002526871`,0.003049154`,0.002479254`,0.003112954`,0.002337321`,0.002311321`,0.003213904`,0.004563754`,0.003639054`,0.002692938`,0.002616621`,0.004902821`,0.012515621`,0.015766171`,0.013046838`,0.015825671`,0.014026538`,0.015664921`,0.010479971`,0.013895888`,0.007218871`,0.007003788`,0.006911254`,0.007002671`,0.004519938`,0.004902821`,0.006924004`,0.006232854`,0.006778438`,0.005980054`,0.006911921`,0.007361488`,0.006140188`,0.004902821`,0.004640371`,0.004696904`,0.007833371`,0.004662021`,0.005427638`,0.007491554`,0.004801838`,0.004489738`,0.007604921`,0.005751588`,0.005673154`,0.005619804`,0.006148138`,0.009137121`,0.010594938`,0.003717554`,0.004124454`,0.005421888`,0.005719171`,0.005484954`,0.005287004`,0.007105321`,0.005452688`,0.003155804`,0.005544704`,0.005447538`,0.005460404`,0.003521471`,0.003580071`,0.003536704`,0.003536704`,0.003691738`,0.002923988`,0.002832138`,0.004321938`,0.003239154`,0.004732388`,0.003785471`,0.004770554`,0.004726638`,0.008096271`,0.008790221`,0.008092954`,0.006929854`,0.008061088`,0.008887888`,0.006339804`,0.008790221`,0.008096271`,0.008076521`,0.008767554`,0.008923754`,0.008215104`,0.008215104`,0.007929571`,0.007420204`,0.006569121`,0.006533804`,0.006558988`,0.005889921`,0.005925904`,0.004592871`},{1/81,0.00490295`,0.004940767`,0.004940767`,0.004872517`,0.00537705`,0.005527533`,0.003639433`,0.005502083`,0.004028933`,0.00555745`,0.00395835`,0.0039169`,0.00482225`,0.003753533`,0.003838633`,0.003603517`,0.003574917`,0.003564233`,0.003621133`,0.0038091`,0.003818583`,0.00381255`,0.003731967`,0.003021067`,0.003473533`,0.00344255`,0.00411715`,0.0031939`,0.003139983`,0.004079567`,0.004311667`,0.0041471`,0.003946283`,0.0038824`,0.004658567`,0.011866733`,0.014421667`,0.012187683`,0.0144382`,0.0131538`,0.014517983`,0.00915385`,0.012392283`,0.005762333`,0.0056461`,0.005558467`,0.0056032`,0.004652867`,0.004658567`,0.006362117`,0.005687717`,0.0061451`,0.005368217`,0.00638265`,0.006964917`,0.005493433`,0.004658567`,0.004355233`,0.00439585`,0.007824383`,0.004385117`,0.0051606`,0.005794817`,0.004076683`,0.00401805`,0.00546755`,0.005259067`,0.004681417`,0.0048747`,0.005271383`,0.0065307`,0.007609283`,0.0041193`,0.00447025`,0.005404817`,0.00605125`,0.005463883`,0.005187683`,0.007582417`,0.0054124`,0.003566733`,0.0058678`,0.005431967`,0.0058722`,0.003230917`,0.003271183`,0.003239233`,0.003239233`,0.003554167`,0.00245435`,0.0025781`,0.004354433`,0.0035482`,0.004401017`,0.004542983`,0.00469855`,0.00468465`,0.008494867`,0.00918205`,0.008554817`,0.007145367`,0.008855083`,0.009372117`,0.007426367`,0.00918205`,0.008494867`,0.0085114`,0.009283233`,0.009289567`,0.00877635`,0.00877635`,0.008423233`,0.008148967`,0.007045983`,0.008260933`,0.00705725`,0.007796533`,0.007785067`,0.00510115`},{11/972,0.003242296`,0.003283029`,0.003283029`,0.003262829`,0.003461779`,0.003402079`,0.002952629`,0.003336829`,0.002992829`,0.003432946`,0.003070079`,0.003051796`,0.003328129`,0.003294063`,0.003074913`,0.003762529`,0.003752079`,0.003794396`,0.003316246`,0.003653746`,0.003473096`,0.003519229`,0.003628563`,0.003392363`,0.003763413`,0.003794513`,0.004693896`,0.003434796`,0.003370779`,0.004696729`,0.004668046`,0.004455029`,0.004441713`,0.004374929`,0.003502546`,0.008369829`,0.013303729`,0.009188979`,0.013412813`,0.010067179`,0.013522463`,0.006298529`,0.009974563`,0.004539979`,0.004507846`,0.004581129`,0.004591813`,0.003408963`,0.003502546`,0.004352646`,0.003976079`,0.004280663`,0.003863296`,0.004367829`,0.004269129`,0.004018329`,0.003502546`,0.003251396`,0.003278296`,0.006081179`,0.003257629`,0.003800863`,0.004998679`,0.003799446`,0.004013496`,0.004632163`,0.004495046`,0.004672546`,0.004549863`,0.005192563`,0.005372779`,0.006263913`,0.005029063`,0.005037596`,0.005771579`,0.006902313`,0.005857446`,0.005786413`,0.007833863`,0.005862029`,0.003783029`,0.006719996`,0.005734446`,0.007032129`,0.003403013`,0.003425246`,0.003405546`,0.003405546`,0.003862379`,0.002741679`,0.002436979`,0.006034413`,0.003407546`,0.004166846`,0.005954363`,0.004638179`,0.004606596`,0.009170096`,0.009596996`,0.008844513`,0.007894379`,0.008951579`,0.009382963`,0.007708096`,0.009596996`,0.009170096`,0.009316163`,0.009267179`,0.009440546`,0.009975263`,0.009975263`,0.009572596`,0.008415663`,0.007763063`,0.007706129`,0.007815796`,0.007369379`,0.007396946`,0.006330013`},{11/1053,0.002633692`,0.002669525`,0.002669525`,0.002644308`,0.002999742`,0.003052942`,0.002057025`,0.002935742`,0.002818975`,0.003079742`,0.002730042`,0.002449542`,0.002684175`,0.002819158`,0.002357342`,0.003826558`,0.003838492`,0.003500092`,0.003604425`,0.003323492`,0.003220975`,0.003092525`,0.003273258`,0.003631725`,0.004332675`,0.004401275`,0.004895458`,0.004225542`,0.004175192`,0.005084742`,0.004856792`,0.004494658`,0.004987525`,0.005022708`,0.002718225`,0.007283842`,0.012717692`,0.008170675`,0.012823775`,0.010011108`,0.012682958`,0.004726308`,0.009433758`,0.003248592`,0.003232558`,0.003297992`,0.003338042`,0.002524758`,0.002718225`,0.003202825`,0.002909308`,0.003117092`,0.002735208`,0.003229308`,0.003166725`,0.002951708`,0.002718225`,0.002306958`,0.002348425`,0.005886925`,0.002347358`,0.002969625`,0.004361492`,0.003492425`,0.003765608`,0.004891342`,0.003988358`,0.004823525`,0.004422558`,0.005193158`,0.005742142`,0.007287092`,0.006061358`,0.005431108`,0.006978408`,0.008463392`,0.007139942`,0.007267092`,0.008280142`,0.007226858`,0.005161642`,0.008273675`,0.006889108`,0.009174692`,0.003343042`,0.003380975`,0.003351575`,0.003351575`,0.003788558`,0.002584625`,0.002350458`,0.006683092`,0.003153675`,0.003725875`,0.006975358`,0.004731108`,0.004620725`,0.008535775`,0.008946275`,0.009620758`,0.009731742`,0.009648058`,0.009574008`,0.008910842`,0.008946275`,0.008535775`,0.009521492`,0.009421175`,0.008793775`,0.009800825`,0.009800825`,0.009126958`,0.009398875`,0.006509175`,0.006887375`,0.006512608`,0.005977342`,0.006016058`,0.005284958`},{11/1134,0.003705588`,0.003754104`,0.003754104`,0.003719271`,0.004042421`,0.003841638`,0.002445304`,0.003709021`,0.003582438`,0.003882288`,0.003639571`,0.003178321`,0.002932338`,0.002795588`,0.002374154`,0.003816704`,0.003819154`,0.003509321`,0.003682671`,0.003166071`,0.003213604`,0.002711271`,0.002957154`,0.003760388`,0.004333721`,0.005259688`,0.006029188`,0.005313171`,0.005230038`,0.005550488`,0.004870604`,0.004622304`,0.006056888`,0.006114288`,0.002518238`,0.006145854`,0.011531488`,0.006942504`,0.011638321`,0.008440521`,0.011477638`,0.003931454`,0.008578421`,0.003472721`,0.003500004`,0.003632571`,0.003625254`,0.002395921`,0.002518238`,0.002622454`,0.002215304`,0.002535238`,0.002057488`,0.002661438`,0.002503554`,0.002462104`,0.002518238`,0.001929821`,0.001983338`,0.006232788`,0.001979438`,0.002627254`,0.004129704`,0.003524121`,0.004111138`,0.005507188`,0.004410221`,0.005099071`,0.004971221`,0.004955438`,0.006602954`,0.008728988`,0.007137654`,0.006017821`,0.007795738`,0.009645221`,0.007909338`,0.008332071`,0.008280588`,0.008097354`,0.005724171`,0.009476338`,0.007681121`,0.010630771`,0.003849571`,0.003976088`,0.003881271`,0.003881271`,0.004790438`,0.003197038`,0.003342038`,0.006118521`,0.003122638`,0.004626254`,0.005547188`,0.005355788`,0.005187988`,0.008443071`,0.008978154`,0.010054288`,0.010786304`,0.010126671`,0.009791521`,0.010009054`,0.008978154`,0.008443071`,0.008987471`,0.009671821`,0.008948438`,0.008925854`,0.008925854`,0.008470804`,0.010183238`,0.006991171`,0.006682354`,0.007020521`,0.006395404`,0.006441888`,0.005407538`},{11/1215,0.005297667`,0.005350367`,0.005350367`,0.00529365`,0.00558525`,0.005612633`,0.004296867`,0.005566217`,0.004275117`,0.0056371`,0.004586433`,0.0044546`,0.0053964`,0.003589383`,0.00410315`,0.004462217`,0.004477167`,0.003752017`,0.003825667`,0.003323417`,0.0038595`,0.003125933`,0.003101167`,0.00468475`,0.0048118`,0.006473367`,0.005634333`,0.005283617`,0.005449567`,0.006410267`,0.005871767`,0.005404733`,0.007066283`,0.007023383`,0.004414367`,0.00450835`,0.010273483`,0.00496675`,0.010427233`,0.005724217`,0.010092983`,0.004011967`,0.006641133`,0.004596167`,0.004705383`,0.00470875`,0.004662517`,0.004503767`,0.004414367`,0.003105417`,0.0028772`,0.00307855`,0.002816283`,0.003110483`,0.00303665`,0.00335485`,0.004414367`,0.00394325`,0.0039176`,0.005633967`,0.003929167`,0.0038627`,0.004711967`,0.00359605`,0.00423685`,0.006239017`,0.0046646`,0.00546685`,0.005122767`,0.006031717`,0.008249817`,0.008775267`,0.008325783`,0.007089417`,0.009452033`,0.01080195`,0.009577317`,0.009531067`,0.01064975`,0.00961205`,0.0041566`,0.010536517`,0.009374767`,0.01084315`,0.0040607`,0.0041655`,0.004089283`,0.004089283`,0.004166367`,0.003585283`,0.003624617`,0.00450585`,0.00341655`,0.005907333`,0.005248533`,0.0057087`,0.005566317`,0.009052083`,0.009533433`,0.009690833`,0.009781267`,0.009773417`,0.009750667`,0.009084333`,0.009533433`,0.009052083`,0.009114483`,0.009574467`,0.009434833`,0.009779283`,0.009779283`,0.009344717`,0.009537483`,0.006062383`,0.0061934`,0.006079867`,0.00571885`,0.005801533`,0.004480067`},{11/1296,0.006197658`,0.006225125`,0.006225125`,0.006159908`,0.006461192`,0.006741708`,0.005928858`,0.006750375`,0.005039725`,0.006768408`,0.005341308`,0.005238725`,0.006448025`,0.004158892`,0.005093542`,0.005438775`,0.005465758`,0.004965325`,0.004213458`,0.004051875`,0.004307575`,0.003541625`,0.003665675`,0.006034842`,0.005289125`,0.004468225`,0.004109808`,0.004400258`,0.004566975`,0.005351942`,0.006193325`,0.006675392`,0.004004058`,0.003612342`,0.005470542`,0.006973375`,0.009337675`,0.006752225`,0.009490658`,0.007110458`,0.009567825`,0.007426292`,0.008897258`,0.005875942`,0.005855992`,0.005833175`,0.005848742`,0.005716075`,0.005470542`,0.003553042`,0.003842008`,0.003549225`,0.003248342`,0.003557242`,0.004668375`,0.004544425`,0.005470542`,0.005245592`,0.005176992`,0.005264325`,0.005188558`,0.004286592`,0.006794808`,0.005109108`,0.005993275`,0.008609908`,0.006026025`,0.007225442`,0.006673675`,0.007779692`,0.010725275`,0.011665875`,0.006602492`,0.007178942`,0.008428708`,0.009496392`,0.008546358`,0.008318558`,0.011836042`,0.008519458`,0.005022042`,0.009120725`,0.008422325`,0.009431942`,0.003766908`,0.003858808`,0.003791058`,0.003791058`,0.004015208`,0.004541192`,0.004296325`,0.006932592`,0.003525108`,0.005033692`,0.005755608`,0.005567525`,0.005447192`,0.009866242`,0.010258175`,0.009584158`,0.009455275`,0.009655775`,0.009828242`,0.008812725`,0.010258175`,0.009866242`,0.010345092`,0.009703558`,0.010055542`,0.010481025`,0.010481025`,0.010006092`,0.009352725`,0.006504908`,0.007029458`,0.006499592`,0.005942842`,0.005972608`,0.005116392`},{11/1377,0.006755917`,0.006768167`,0.006768167`,0.006685817`,0.006927733`,0.005999583`,0.0067163`,0.006143633`,0.005804917`,0.006071833`,0.005696167`,0.00570385`,0.00575135`,0.004607017`,0.005482833`,0.0051526`,0.0051041`,0.005439183`,0.004901417`,0.005255417`,0.004685167`,0.004568333`,0.0049449`,0.00432735`,0.0050277`,0.0034245`,0.004987317`,0.003909783`,0.003891483`,0.004703367`,0.004726717`,0.004663217`,0.004216783`,0.003740067`,0.005599783`,0.00889135`,0.011277183`,0.008914167`,0.011349083`,0.0092712`,0.01180495`,0.00798185`,0.010688533`,0.005705117`,0.00578695`,0.005722567`,0.005694217`,0.00560915`,0.005599783`,0.0060418`,0.0061018`,0.00599315`,0.005625633`,0.00598325`,0.0064529`,0.006011767`,0.005599783`,0.0053431`,0.005345733`,0.00684145`,0.005329317`,0.0055984`,0.005050717`,0.005706717`,0.005685567`,0.005859917`,0.0067289`,0.00450805`,0.00572365`,0.005458217`,0.008291133`,0.009517083`,0.0069408`,0.006674867`,0.00812065`,0.009372117`,0.00820475`,0.008093367`,0.011544233`,0.008206033`,0.005061133`,0.009082767`,0.008086183`,0.009619633`,0.0037613`,0.00377715`,0.0037629`,0.0037629`,0.004136533`,0.004295467`,0.003542067`,0.00613345`,0.00324575`,0.0034155`,0.004822983`,0.004154117`,0.0040425`,0.008440833`,0.008777283`,0.009400183`,0.009040567`,0.00955595`,0.009591517`,0.00869205`,0.008777283`,0.008440833`,0.0094636`,0.009451667`,0.00859255`,0.008755167`,0.008755167`,0.008270617`,0.009204633`,0.00681885`,0.007043567`,0.006834917`,0.006008617`,0.0060798`,0.0059195`},{11/1458,0.006062275`,0.006069608`,0.006069608`,0.005983425`,0.006322842`,0.005867642`,0.005767842`,0.005945308`,0.005406725`,0.005930708`,0.005456342`,0.005734375`,0.005553358`,0.005171892`,0.005141558`,0.004313058`,0.004290425`,0.004550875`,0.004343142`,0.004576992`,0.005180625`,0.004813925`,0.004679975`,0.004003492`,0.004223692`,0.004517575`,0.005587975`,0.004100425`,0.004068875`,0.007170275`,0.006971475`,0.005265058`,0.005998825`,0.005726742`,0.005064808`,0.005415725`,0.009025325`,0.005710908`,0.009108442`,0.005995992`,0.009247742`,0.005009108`,0.007482925`,0.003995992`,0.004082558`,0.004083358`,0.004055008`,0.005262742`,0.005064808`,0.004638642`,0.004403858`,0.004665458`,0.004500358`,0.004652292`,0.004367108`,0.004188775`,0.005064808`,0.004939142`,0.004893992`,0.005757525`,0.004875942`,0.004875208`,0.004125542`,0.004695975`,0.004792425`,0.006803992`,0.004975858`,0.005769092`,0.004793175`,0.007510825`,0.010268008`,0.011002758`,0.008659608`,0.008549258`,0.010604225`,0.011724108`,0.010780175`,0.010272125`,0.012991258`,0.010645458`,0.003925992`,0.011468258`,0.010506292`,0.011337075`,0.003508692`,0.003543225`,0.003514575`,0.003514575`,0.003709192`,0.002537642`,0.002350108`,0.003801708`,0.003037842`,0.004120242`,0.003383092`,0.004267075`,0.004265125`,0.005773125`,0.006323208`,0.008146825`,0.006233042`,0.008425292`,0.009262025`,0.007231775`,0.006323208`,0.005773125`,0.005840842`,0.009244558`,0.006429525`,0.005865208`,0.005865208`,0.005668708`,0.007853408`,0.005884525`,0.005874442`,0.005906125`,0.004975942`,0.005050175`,0.004878542`},{11/1539,0.004708204`,0.004742588`,0.004742588`,0.004708254`,0.004950004`,0.004799154`,0.004843571`,0.004833088`,0.004765888`,0.004854104`,0.004966004`,0.005029104`,0.004547771`,0.004874721`,0.004338504`,0.005238154`,0.005227588`,0.006375088`,0.004532438`,0.006025821`,0.004847371`,0.005413638`,0.005718038`,0.004293104`,0.004744271`,0.005184421`,0.003509004`,0.003630621`,0.003668004`,0.005517988`,0.007097238`,0.008358921`,0.003918088`,0.004078871`,0.004334471`,0.007674704`,0.008089854`,0.007402238`,0.008152271`,0.007062888`,0.008761704`,0.009272138`,0.008885604`,0.006018921`,0.005941904`,0.005890988`,0.005921404`,0.004375154`,0.004334471`,0.004284054`,0.004244604`,0.004308038`,0.004101454`,0.004271704`,0.004499604`,0.004558071`,0.004334471`,0.004210454`,0.004168888`,0.005348438`,0.004149654`,0.004106971`,0.008645554`,0.006663188`,0.007132454`,0.011537238`,0.006446038`,0.010408888`,0.008005438`,0.009814054`,0.013157254`,0.013866638`,0.005229838`,0.005910254`,0.008231771`,0.009707071`,0.008430888`,0.008068654`,0.012547021`,0.008369538`,0.003449921`,0.009381838`,0.008250638`,0.009848054`,0.003142738`,0.003141688`,0.003145304`,0.003145304`,0.003401554`,0.002400071`,0.002962971`,0.003276871`,0.002198154`,0.002260188`,0.003276204`,0.003355871`,0.003332788`,0.005759204`,0.006628171`,0.006732054`,0.005447954`,0.006154271`,0.007428654`,0.004212221`,0.006628171`,0.005759204`,0.005612271`,0.007969604`,0.007007554`,0.005302871`,0.005302871`,0.005133071`,0.005748454`,0.005857238`,0.005732288`,0.005863171`,0.004431204`,0.004597704`,0.004080588`},{11/1620,0.005386033`,0.005396333`,0.005396333`,0.0052857`,0.00623385`,0.00682645`,0.005634333`,0.006913917`,0.00516325`,0.00688775`,0.005364617`,0.00551215`,0.006278583`,0.006155583`,0.0054838`,0.004032767`,0.004003883`,0.005267083`,0.003969933`,0.005654667`,0.006011983`,0.00607715`,0.005702117`,0.003243167`,0.003873583`,0.002696067`,0.00274295`,0.002470517`,0.002553133`,0.002820767`,0.002984483`,0.003709833`,0.002444133`,0.002467317`,0.00577495`,0.0108954`,0.010771417`,0.010846233`,0.010884117`,0.010484033`,0.011265217`,0.010126183`,0.012343617`,0.007356367`,0.007453`,0.0073321`,0.00726215`,0.005920317`,0.00577495`,0.006843183`,0.007099467`,0.0068923`,0.00669225`,0.006878017`,0.00768395`,0.007593683`,0.00577495`,0.005562417`,0.005555917`,0.00799085`,0.00552085`,0.006044883`,0.006160367`,0.005934267`,0.00548925`,0.00427675`,0.007129783`,0.003576017`,0.005280333`,0.00331515`,0.005441917`,0.0070374`,0.003032567`,0.002775233`,0.003655217`,0.004143633`,0.003727383`,0.003795083`,0.004898083`,0.003772717`,0.00307145`,0.0040319`,0.003640233`,0.004126567`,0.002164717`,0.00218405`,0.002169283`,0.002169283`,0.00268415`,0.0019298`,0.0020094`,0.004290233`,0.001834433`,0.001857117`,0.003831767`,0.002905867`,0.0028593`,0.006920433`,0.007847967`,0.006800567`,0.005519017`,0.0061373`,0.007498967`,0.0038849`,0.007847967`,0.006920433`,0.006514883`,0.007940367`,0.008236817`,0.0064818`,0.0064818`,0.006430917`,0.005658817`,0.006187433`,0.007050467`,0.006174`,0.004945283`,0.005026667`,0.004468233`},{11/1701,0.005649288`,0.005673238`,0.005673238`,0.005584271`,0.005924171`,0.004750421`,0.005040221`,0.004905554`,0.004111304`,0.004805138`,0.004431121`,0.004693038`,0.003989071`,0.003578204`,0.003650671`,0.002933221`,0.002902404`,0.002837921`,0.003454421`,0.002868238`,0.003772588`,0.003413788`,0.003191654`,0.002356404`,0.002949654`,0.002175321`,0.003395504`,0.001686288`,0.001628104`,0.002471704`,0.002564921`,0.002431121`,0.002364871`,0.002173088`,0.003182621`,0.004625238`,0.010543088`,0.004821671`,0.010777838`,0.006153588`,0.011310854`,0.003573171`,0.007554188`,0.003087904`,0.003114221`,0.003104904`,0.003086771`,0.003385271`,0.003182621`,0.002949221`,0.002731838`,0.002923638`,0.002685871`,0.002948371`,0.003037638`,0.002763671`,0.003182621`,0.003070688`,0.003023971`,0.003799571`,0.003016421`,0.002970771`,0.002981771`,0.002869371`,0.002902304`,0.003137754`,0.003272071`,0.002741638`,0.002905054`,0.002870454`,0.003693238`,0.004720954`,0.003581421`,0.003185954`,0.003818221`,0.004101904`,0.003813888`,0.003886338`,0.004950971`,0.003854954`,0.003181671`,0.004024054`,0.003798521`,0.004211454`,0.002516888`,0.002528971`,0.002515454`,0.002515454`,0.003671454`,0.002383104`,0.002402654`,0.005909404`,0.002264454`,0.001799788`,0.005269421`,0.003680404`,0.003688754`,0.008788338`,0.009447238`,0.007305154`,0.005991088`,0.006772771`,0.007858521`,0.004891404`,0.009447238`,0.008788338`,0.008454471`,0.008127371`,0.009535904`,0.009365838`,0.009365838`,0.009011471`,0.006353338`,0.006824454`,0.007303621`,0.006839321`,0.005208604`,0.005299288`,0.005454954`},{1/162,0.003495992`,0.003551392`,0.003551392`,0.003576392`,0.003599525`,0.003220842`,0.003402358`,0.003244808`,0.003395042`,0.003236692`,0.003479125`,0.003616692`,0.003050508`,0.002950292`,0.003035425`,0.002406225`,0.002396242`,0.002390308`,0.003015608`,0.002372292`,0.003161375`,0.002798858`,0.002615242`,0.002041508`,0.002409275`,0.002548875`,0.003607692`,0.002108042`,0.002031558`,0.003193075`,0.003489775`,0.002816442`,0.003110758`,0.002848525`,0.002645608`,0.003470792`,0.008119975`,0.003974858`,0.008378225`,0.003955508`,0.008606792`,0.003093742`,0.005430725`,0.002678075`,0.002684125`,0.002683358`,0.002681092`,0.002769708`,0.002645608`,0.002548608`,0.002407708`,0.002548692`,0.002401675`,0.002541542`,0.002518092`,0.002408525`,0.002645608`,0.002592808`,0.002553158`,0.003018708`,0.002545925`,0.002508292`,0.002821808`,0.002434808`,0.002597325`,0.003359825`,0.002860075`,0.003328392`,0.002866075`,0.003774208`,0.004844925`,0.005981675`,0.004622275`,0.004258642`,0.005290258`,0.006757525`,0.005379058`,0.005256625`,0.008105658`,0.005363058`,0.003439375`,0.006525375`,0.005260525`,0.006841208`,0.002948208`,0.002947442`,0.002942842`,0.002942842`,0.003867175`,0.003065775`,0.003130392`,0.006022542`,0.002192708`,0.002266208`,0.006390408`,0.004535525`,0.004434942`,0.009006975`,0.009579825`,0.008270992`,0.007682842`,0.008117275`,0.008467342`,0.007268608`,0.009579825`,0.009006975`,0.008927208`,0.008395375`,0.009549725`,0.009684242`,0.009684242`,0.009111492`,0.007955275`,0.005998958`,0.006195858`,0.006029875`,0.004800942`,0.004887942`,0.005177742`},{11/1863,0.002641892`,0.002676108`,0.002676108`,0.002681825`,0.002791825`,0.002893608`,0.002755858`,0.002885342`,0.003270825`,0.002906775`,0.003219825`,0.003449658`,0.002743625`,0.002470475`,0.002725992`,0.002839825`,0.002829392`,0.002947942`,0.002716592`,0.002764792`,0.002812225`,0.002639008`,0.002745808`,0.002664892`,0.002848308`,0.003627108`,0.003948642`,0.002760092`,0.002723208`,0.004558158`,0.005451492`,0.004299792`,0.004137392`,0.004108292`,0.002402108`,0.003969458`,0.009007492`,0.004599775`,0.009287292`,0.004226558`,0.009073808`,0.004510675`,0.005334658`,0.003259808`,0.003297108`,0.003309342`,0.003298992`,0.002496908`,0.002402108`,0.002471642`,0.002505658`,0.002423342`,0.002281558`,0.002404292`,0.002848242`,0.002911075`,0.002402108`,0.002377808`,0.002342808`,0.002860892`,0.002334242`,0.002196792`,0.004109108`,0.002941808`,0.003191525`,0.006397025`,0.003488475`,0.005499408`,0.003915008`,0.006881025`,0.008813858`,0.010041442`,0.005652658`,0.005487792`,0.008098058`,0.009774125`,0.008283758`,0.007679075`,0.012396908`,0.008113992`,0.003524675`,0.009464625`,0.008056975`,0.009559075`,0.002910542`,0.002910825`,0.002907708`,0.002907708`,0.003153675`,0.003245775`,0.003098825`,0.005038692`,0.002285042`,0.002804892`,0.006694042`,0.005331942`,0.005251392`,0.008859058`,0.009378775`,0.008834708`,0.008009875`,0.008941575`,0.009045992`,0.008066025`,0.009378775`,0.008859058`,0.008921008`,0.008841108`,0.009310508`,0.009376025`,0.009376025`,0.009027542`,0.008597408`,0.006137442`,0.006494242`,0.006137058`,0.004705092`,0.004771025`,0.004310308`},{11/1944,0.002661933`,0.00269515`,0.00269515`,0.002705483`,0.0027951`,0.00282585`,0.002894233`,0.002823783`,0.00288605`,0.002830333`,0.003081067`,0.003226083`,0.002750183`,0.00268015`,0.00253405`,0.003781367`,0.003770167`,0.004122933`,0.0029107`,0.004370267`,0.003162617`,0.003751283`,0.0040242`,0.0032788`,0.0035663`,0.003662617`,0.003458083`,0.003342317`,0.00334425`,0.003984833`,0.004019533`,0.004508267`,0.003847883`,0.003865067`,0.0029793`,0.0073308`,0.0110795`,0.0072889`,0.011244383`,0.007286383`,0.011106033`,0.008001783`,0.008914333`,0.00537915`,0.005225667`,0.005148133`,0.005214417`,0.0028238`,0.0029793`,0.004166317`,0.0048537`,0.004173233`,0.00428755`,0.004111483`,0.005118667`,0.0049867`,0.0029793`,0.002815333`,0.00284125`,0.003693567`,0.002826733`,0.00307325`,0.006678833`,0.0049991`,0.00478695`,0.00756955`,0.005566417`,0.005709717`,0.005661667`,0.005312333`,0.0103166`,0.0114972`,0.00434555`,0.004381333`,0.006077167`,0.0077933`,0.00622425`,0.006186017`,0.011970567`,0.006261967`,0.004441033`,0.0074967`,0.006090717`,0.007786183`,0.002711517`,0.002758667`,0.002722683`,0.002722683`,0.002776817`,0.0030884`,0.00317065`,0.0059378`,0.002655733`,0.00328905`,0.00546515`,0.005132767`,0.004943333`,0.007917117`,0.008313833`,0.009073583`,0.007913267`,0.00927035`,0.0094037`,0.008426483`,0.008313833`,0.007917117`,0.0085248`,0.0092672`,0.008197683`,0.008561767`,0.008561767`,0.008057283`,0.008882833`,0.005417983`,0.005836467`,0.005414417`,0.004640883`,0.004635967`,0.00403925`},{11/2025,0.002785621`,0.002839354`,0.002839354`,0.002842171`,0.002849304`,0.002760171`,0.002572154`,0.002716471`,0.002884371`,0.002769171`,0.002860271`,0.002836688`,0.002731271`,0.002479738`,0.002716438`,0.003432371`,0.003434188`,0.003622654`,0.003064988`,0.003680154`,0.003157271`,0.002969988`,0.003256654`,0.003169521`,0.003456371`,0.004285254`,0.004155704`,0.003278021`,0.003256271`,0.005004354`,0.005220421`,0.004324171`,0.004164571`,0.004360388`,0.003050304`,0.005822021`,0.011698954`,0.006187354`,0.011939854`,0.007483888`,0.012275821`,0.004771288`,0.008124538`,0.004308004`,0.004298054`,0.004313171`,0.004313188`,0.002908388`,0.003050304`,0.004053388`,0.004069621`,0.004053854`,0.003903021`,0.004022221`,0.004116354`,0.003949038`,0.003050304`,0.002971038`,0.002983638`,0.004141838`,0.002956271`,0.003421454`,0.004627904`,0.004268938`,0.004400604`,0.004678871`,0.004865571`,0.004633571`,0.004526821`,0.005268538`,0.008076354`,0.008765454`,0.007027271`,0.006529838`,0.008644971`,0.010485321`,0.008882104`,0.008398738`,0.012434571`,0.008736471`,0.004176338`,0.010228871`,0.008509204`,0.010311471`,0.003373054`,0.003534554`,0.003410821`,0.003410821`,0.003949454`,0.002249838`,0.002277071`,0.003802954`,0.002502538`,0.002874704`,0.002987621`,0.004059554`,0.004049071`,0.005723971`,0.006113104`,0.007607654`,0.005242638`,0.008184704`,0.008791071`,0.006941321`,0.006113104`,0.005723971`,0.005266104`,0.008746421`,0.006092938`,0.006117188`,0.006117188`,0.005890671`,0.007405238`,0.004996821`,0.005104188`,0.005013254`,0.004767288`,0.004767971`,0.003429271`},{11/2106,0.002809217`,0.002871683`,0.002871683`,0.002888317`,0.0028529`,0.00272485`,0.00255735`,0.002687433`,0.002920433`,0.002745183`,0.002942617`,0.00278825`,0.00254245`,0.002648667`,0.002641383`,0.0046664`,0.004826683`,0.005929133`,0.00383155`,0.005012883`,0.0034643`,0.003524417`,0.004536767`,0.004012433`,0.0044008`,0.0048731`,0.003644417`,0.003807933`,0.003798517`,0.006477733`,0.00916995`,0.007071217`,0.004046167`,0.00417845`,0.002706217`,0.007511083`,0.01284845`,0.008467183`,0.01316785`,0.008955183`,0.01378795`,0.007011017`,0.008611417`,0.004943967`,0.004935917`,0.004899383`,0.004902333`,0.002664267`,0.002706217`,0.0036015`,0.004312617`,0.003636283`,0.003770883`,0.00353665`,0.004902033`,0.004582517`,0.002706217`,0.0025891`,0.0025892`,0.0034869`,0.002576467`,0.002787583`,0.006169383`,0.005325717`,0.005973133`,0.010603417`,0.004884317`,0.009325917`,0.006165433`,0.0108985`,0.012900683`,0.013649367`,0.007807583`,0.00864975`,0.010578267`,0.01170265`,0.01072915`,0.010263433`,0.014107233`,0.010635033`,0.00335365`,0.011388933`,0.010604517`,0.011149267`,0.003216583`,0.00318905`,0.003210067`,0.003210067`,0.003337367`,0.003204683`,0.003759317`,0.00274955`,0.002156833`,0.001794167`,0.0031801`,0.00291775`,0.003001333`,0.005844883`,0.00621275`,0.0069635`,0.004999317`,0.0073155`,0.0076235`,0.006453217`,0.00621275`,0.005844883`,0.0059772`,0.007401617`,0.006174083`,0.0062376`,0.0062376`,0.005906883`,0.0068395`,0.005291583`,0.005209433`,0.005279433`,0.00466715`,0.004795233`,0.003475717`},{11/2187,0.004052729`,0.004085079`,0.004085079`,0.004020179`,0.004547762`,0.004859296`,0.003578712`,0.004883279`,0.004705929`,0.004892596`,0.004615396`,0.004038762`,0.004582412`,0.004275079`,0.004092296`,0.003761196`,0.003763429`,0.004786862`,0.004255129`,0.005888396`,0.005216046`,0.004950779`,0.005386296`,0.003269746`,0.003711762`,0.002703529`,0.002321912`,0.003039579`,0.003096412`,0.003095012`,0.003671579`,0.003890429`,0.002587746`,0.002564296`,0.004771629`,0.010264496`,0.014122979`,0.011086929`,0.014264596`,0.010722879`,0.014485512`,0.010079329`,0.010931596`,0.009018946`,0.008797962`,0.008682596`,0.008773829`,0.004712696`,0.004771629`,0.007244629`,0.007388329`,0.007264779`,0.007063229`,0.007231946`,0.008632546`,0.007609479`,0.004771629`,0.004619729`,0.004629262`,0.006578229`,0.004601246`,0.005452629`,0.011075579`,0.006366829`,0.006185829`,0.012722429`,0.007836496`,0.007521446`,0.007514212`,0.006896179`,0.014806929`,0.015191129`,0.003757162`,0.003890729`,0.005324962`,0.006807012`,0.005399662`,0.005273946`,0.012826396`,0.005384262`,0.004134812`,0.006340829`,0.005334046`,0.007857062`,0.003781546`,0.003820896`,0.003784912`,0.003784912`,0.004744946`,0.002569362`,0.002624196`,0.003375462`,0.002201129`,0.004293129`,0.003441212`,0.002946896`,0.002935746`,0.005693679`,0.006018712`,0.006551279`,0.006370946`,0.006810062`,0.006716529`,0.006618412`,0.006018712`,0.005693679`,0.005013662`,0.006577862`,0.005966712`,0.006069479`,0.006069479`,0.005751596`,0.006684346`,0.004181212`,0.004432646`,0.004185062`,0.004254312`,0.004316962`,0.002810612`},{11/2268,0.003560758`,0.003610442`,0.003610442`,0.003614608`,0.003681025`,0.003601175`,0.003586558`,0.003602142`,0.003542592`,0.003643058`,0.003676492`,0.003867392`,0.003449725`,0.002981908`,0.003238942`,0.002798442`,0.002774275`,0.003083158`,0.003318258`,0.003194358`,0.003475242`,0.003147875`,0.003141975`,0.002531858`,0.002906992`,0.002549542`,0.003095125`,0.002584608`,0.002605042`,0.003408925`,0.003798742`,0.003389542`,0.002986858`,0.002740008`,0.003651642`,0.010581058`,0.013760158`,0.010791725`,0.013945758`,0.009730992`,0.014454208`,0.011716242`,0.011312575`,0.007866325`,0.007795408`,0.007604125`,0.007681008`,0.003512625`,0.003651642`,0.007169658`,0.007801758`,0.006896975`,0.006410308`,0.007056158`,0.008907375`,0.007234242`,0.003651642`,0.003531208`,0.003548325`,0.006342792`,0.003532975`,0.004464842`,0.007223425`,0.003351592`,0.003410675`,0.007181042`,0.006017575`,0.004266592`,0.004288025`,0.004541475`,0.012690742`,0.014457058`,0.005070342`,0.004693808`,0.006642442`,0.008218225`,0.006692842`,0.006626358`,0.011597042`,0.006706008`,0.006118725`,0.007856258`,0.006634475`,0.009543208`,0.004728725`,0.004767025`,0.004725342`,0.004725342`,0.007322625`,0.002847658`,0.002960158`,0.003387108`,0.004744992`,0.005681508`,0.003528042`,0.003222408`,0.003150342`,0.005650092`,0.005988058`,0.006207675`,0.006401942`,0.006493292`,0.006898242`,0.006158675`,0.005988058`,0.005650092`,0.004879625`,0.006910725`,0.005936225`,0.005859242`,0.005859242`,0.005610592`,0.006283775`,0.003098525`,0.003853142`,0.003138975`,0.003309008`,0.003374642`,0.002618025`},{11/2349,0.002390592`,0.002434158`,0.002434158`,0.002441608`,0.002546875`,0.002915075`,0.002443908`,0.002873442`,0.003210692`,0.002929492`,0.003219425`,0.003098175`,0.002941992`,0.003073692`,0.003063942`,0.002598058`,0.002578792`,0.002914058`,0.003039275`,0.003056192`,0.003148642`,0.002844208`,0.002880075`,0.002456242`,0.002781092`,0.002579192`,0.003837475`,0.003015408`,0.002992708`,0.003934292`,0.005195692`,0.003761092`,0.003177142`,0.002975875`,0.002768325`,0.009249408`,0.012793025`,0.008744925`,0.012951358`,0.011034758`,0.013671158`,0.007390958`,0.012385525`,0.004199925`,0.004053858`,0.004256875`,0.004295475`,0.002845658`,0.002768325`,0.002736242`,0.003105575`,0.002737742`,0.002663292`,0.002719008`,0.003839325`,0.003346358`,0.002768325`,0.002721525`,0.002694642`,0.003439475`,0.002683408`,0.002574242`,0.004386858`,0.003416058`,0.003580758`,0.006514592`,0.004251742`,0.004662542`,0.004321492`,0.005017192`,0.012488242`,0.013509708`,0.006600192`,0.006648092`,0.008332675`,0.011645942`,0.008467075`,0.008709425`,0.012312075`,0.008592075`,0.007727558`,0.011360908`,0.008234208`,0.013009125`,0.004920908`,0.004887742`,0.004901492`,0.004901492`,0.006167575`,0.003554875`,0.003133792`,0.002915658`,0.005707758`,0.005499975`,0.003069092`,0.003244925`,0.003115392`,0.005824275`,0.006448275`,0.006329775`,0.006184575`,0.006454275`,0.006478725`,0.006237192`,0.006448275`,0.005824275`,0.004531225`,0.006422708`,0.006602475`,0.005479392`,0.005479392`,0.005375475`,0.006377075`,0.003401642`,0.004124692`,0.003426225`,0.003751908`,0.003818092`,0.003234392`},{11/2430,0.002236912`,0.002270612`,0.002270612`,0.002270212`,0.002383179`,0.002726329`,0.002234346`,0.002674912`,0.002771096`,0.002746546`,0.002701346`,0.002511846`,0.002631879`,0.002613829`,0.002757646`,0.002845979`,0.002845112`,0.002931062`,0.002917062`,0.003071129`,0.002771146`,0.002611046`,0.002789979`,0.002623079`,0.003177562`,0.003326829`,0.005189896`,0.002862396`,0.002835696`,0.005418662`,0.005880379`,0.004264912`,0.004650646`,0.004249396`,0.002550279`,0.009874246`,0.014079862`,0.010483662`,0.014193179`,0.011378112`,0.014570029`,0.009349646`,0.012279529`,0.005630596`,0.005447729`,0.005493729`,0.005562512`,0.002534979`,0.002550279`,0.002675879`,0.004013412`,0.002669712`,0.002761196`,0.002626396`,0.004525429`,0.004554746`,0.002550279`,0.002540929`,0.002508196`,0.003275162`,0.002498346`,0.002329129`,0.007160212`,0.003296896`,0.003574162`,0.009774146`,0.005083796`,0.007376996`,0.005381946`,0.007450312`,0.013413062`,0.014056679`,0.006101862`,0.006306596`,0.007720746`,0.010898896`,0.007906262`,0.007582246`,0.013133029`,0.007845679`,0.005818462`,0.010543479`,0.007682112`,0.011936129`,0.005074729`,0.005118112`,0.005081462`,0.005081462`,0.005234429`,0.002992396`,0.003488762`,0.003495112`,0.003523462`,0.004260929`,0.003180529`,0.003251396`,0.003191379`,0.005859296`,0.006451796`,0.006682396`,0.005097546`,0.007055196`,0.007372929`,0.005836629`,0.006451796`,0.005859296`,0.004468112`,0.007044012`,0.006585879`,0.005852246`,0.005852246`,0.005739246`,0.006422912`,0.004455829`,0.005417379`,0.004436896`,0.004480412`,0.004508712`,0.003384312`},{4/27,0.002266629`,0.002311446`,0.002311446`,0.002316196`,0.002521513`,0.002761713`,0.002285213`,0.002739363`,0.003134913`,0.002793496`,0.002971696`,0.002812496`,0.002731363`,0.003371179`,0.002637496`,0.004095679`,0.004128879`,0.005070829`,0.003762479`,0.005370346`,0.003784829`,0.003974696`,0.004772913`,0.003860246`,0.004272363`,0.003808363`,0.002803429`,0.003433629`,0.003444046`,0.004704846`,0.004692829`,0.005185329`,0.003811613`,0.003787479`,0.002909063`,0.012256096`,0.014524863`,0.013046963`,0.014675129`,0.013079196`,0.015139963`,0.013024829`,0.013773496`,0.006803529`,0.006406796`,0.006453296`,0.006611563`,0.002883446`,0.002909063`,0.004776813`,0.005337196`,0.004492196`,0.004269629`,0.004661896`,0.006972729`,0.004752763`,0.002909063`,0.002733313`,0.002761013`,0.005612879`,0.002739963`,0.003406079`,0.008519463`,0.006387963`,0.006148979`,0.009070296`,0.007538229`,0.007164763`,0.007134546`,0.005633763`,0.010481729`,0.011674646`,0.003570579`,0.004050446`,0.004381646`,0.003959896`,0.004389213`,0.004248263`,0.006746479`,0.004364096`,0.002975996`,0.003891463`,0.004424029`,0.003847179`,0.004782196`,0.004790913`,0.004783963`,0.004783963`,0.004790879`,0.001583229`,0.002338246`,0.003642796`,0.002167129`,0.003129813`,0.003668896`,0.003170179`,0.003136429`,0.005935446`,0.006558079`,0.006477063`,0.005015546`,0.006239046`,0.006960113`,0.004999296`,0.006558079`,0.005935446`,0.004790413`,0.006689729`,0.006739863`,0.005961279`,0.005961279`,0.005893529`,0.005956579`,0.005994846`,0.006636863`,0.006009863`,0.005709996`,0.005733963`,0.004053346`},{2/27,0.006485029`,0.006471379`,0.006471379`,0.006211863`,0.006949746`,0.006859546`,0.004086163`,0.006958013`,0.004581663`,0.006867879`,0.004216463`,0.004487796`,0.005918646`,0.004047563`,0.004110163`,0.003708896`,0.003692696`,0.004027896`,0.004217629`,0.004393729`,0.004532246`,0.004251329`,0.004344613`,0.003382646`,0.003859196`,0.002722979`,0.002511413`,0.002533863`,0.002651513`,0.003403779`,0.003340013`,0.003723296`,0.003198813`,0.002907813`,0.005436113`,0.012368496`,0.016431729`,0.012454813`,0.016582246`,0.013997963`,0.016852379`,0.009885696`,0.014832613`,0.005918946`,0.005964763`,0.005865846`,0.005836396`,0.005531579`,0.005436113`,0.007818796`,0.006763946`,0.007411746`,0.006208946`,0.007907513`,0.007763796`,0.006017546`,0.005436113`,0.005162396`,0.005181313`,0.009852846`,0.005187846`,0.006244146`,0.004624296`,0.004423996`,0.004356863`,0.004024613`,0.005610329`,0.003883796`,0.004473896`,0.003735029`,0.004680179`,0.005549329`,0.003103113`,0.003454513`,0.003760213`,0.003509029`,0.003752646`,0.003624329`,0.004921396`,0.003730846`,0.002566513`,0.003450913`,0.003796213`,0.003324296`,0.004128713`,0.004103963`,0.004125629`,0.004125629`,0.003391246`,0.002154713`,0.002411313`,0.004762296`,0.002297813`,0.003838929`,0.004363079`,0.003659779`,0.003608729`,0.006962329`,0.007649963`,0.006666979`,0.005006279`,0.006591179`,0.006753363`,0.005403846`,0.007649963`,0.006962329`,0.005492279`,0.006518663`,0.007802046`,0.007124813`,0.007124813`,0.006941413`,0.006265013`,0.006730046`,0.007293946`,0.006724646`,0.005133163`,0.005148313`,0.004419679`},{4/81,0.005210279`,0.005244763`,0.005244763`,0.005147079`,0.005508646`,0.004516579`,0.004018413`,0.004584263`,0.004049779`,0.004585629`,0.004076763`,0.004150713`,0.004196329`,0.003849279`,0.003767529`,0.003287913`,0.003258046`,0.003748179`,0.003494379`,0.004029213`,0.003746763`,0.004026279`,0.003956913`,0.002810146`,0.003206096`,0.003170329`,0.002730113`,0.002294446`,0.002348813`,0.003654729`,0.003693313`,0.004021563`,0.003412813`,0.003391146`,0.004320146`,0.007158946`,0.014971913`,0.007011279`,0.015127196`,0.009020029`,0.014834629`,0.004505979`,0.010019696`,0.003591579`,0.003658496`,0.003662713`,0.003660463`,0.004120746`,0.004320146`,0.004438729`,0.004203363`,0.004455796`,0.004120513`,0.004482063`,0.004166613`,0.003859596`,0.004320146`,0.004094546`,0.004145246`,0.005917929`,0.004129863`,0.004697779`,0.003734296`,0.004185746`,0.004224196`,0.004422113`,0.004617129`,0.004211846`,0.004220596`,0.004275846`,0.005703479`,0.005757179`,0.003789029`,0.003754996`,0.004468329`,0.004559579`,0.004440646`,0.004292679`,0.007788813`,0.004416463`,0.003356729`,0.004351779`,0.004500013`,0.004666863`,0.004613329`,0.004607929`,0.004611679`,0.004611679`,0.003930679`,0.002920046`,0.002962596`,0.003749296`,0.002652429`,0.004040563`,0.003563096`,0.003727229`,0.003659663`,0.006715229`,0.007450979`,0.007371596`,0.005293629`,0.007425879`,0.007860479`,0.006087779`,0.007450979`,0.006715229`,0.005647379`,0.007836613`,0.007650396`,0.006533579`,0.006533579`,0.006456579`,0.006956413`,0.004595813`,0.005688879`,0.004577363`,0.003615513`,0.003639579`,0.002895979`},{1/27,0.003773396`,0.003827429`,0.003827429`,0.003832279`,0.003870546`,0.003845913`,0.003814496`,0.003770696`,0.003267563`,0.003856379`,0.003553446`,0.003688446`,0.004035863`,0.004267296`,0.003809213`,0.003758313`,0.003715213`,0.004280279`,0.003631213`,0.004438779`,0.004311663`,0.004398746`,0.004467013`,0.003130913`,0.003485296`,0.003322879`,0.002109479`,0.002569263`,0.002651729`,0.003297129`,0.003415213`,0.003663896`,0.002973329`,0.003358763`,0.004527163`,0.005369363`,0.011033196`,0.005316279`,0.011218246`,0.006244229`,0.011021579`,0.004832779`,0.007642213`,0.003860263`,0.003905696`,0.003901296`,0.003878196`,0.004318029`,0.004527163`,0.004582429`,0.004372146`,0.004649696`,0.004433196`,0.004600563`,0.004197963`,0.003961846`,0.004527163`,0.004266579`,0.004280246`,0.005386546`,0.004282029`,0.004661246`,0.004123929`,0.004325229`,0.004343529`,0.004819663`,0.004651729`,0.004049279`,0.004189213`,0.003605146`,0.006012779`,0.006502129`,0.002878479`,0.002913713`,0.003962713`,0.004127413`,0.004017646`,0.004029846`,0.006295646`,0.004047863`,0.003286929`,0.003962063`,0.003964463`,0.004303679`,0.005509196`,0.005518013`,0.005519879`,0.005519879`,0.004116079`,0.001784046`,0.001871496`,0.003341263`,0.002760396`,0.003922063`,0.003313046`,0.003409996`,0.003335279`,0.006559229`,0.007349879`,0.007806479`,0.005564146`,0.007938463`,0.008243963`,0.006686996`,0.007349879`,0.006559229`,0.005915646`,0.007881896`,0.007604563`,0.006046296`,0.006046296`,0.005993763`,0.007452529`,0.005007979`,0.006192346`,0.005027863`,0.004416979`,0.004439829`,0.003655163`},{4/135,0.003728746`,0.003772363`,0.003772363`,0.003738813`,0.003947079`,0.004115929`,0.003434179`,0.003937163`,0.003099396`,0.004093763`,0.003404913`,0.003657146`,0.004560313`,0.003827613`,0.003797796`,0.002748363`,0.002737229`,0.002866163`,0.003372663`,0.003112579`,0.003506096`,0.003551529`,0.003244546`,0.002519096`,0.002884646`,0.002798063`,0.002767296`,0.001555679`,0.001597729`,0.003238963`,0.003226546`,0.003272813`,0.003073113`,0.003080496`,0.004517296`,0.004041513`,0.008094429`,0.004458029`,0.008329029`,0.004899379`,0.009065863`,0.003543213`,0.005687979`,0.003306596`,0.003324796`,0.003329596`,0.003322146`,0.004568896`,0.004517296`,0.003731363`,0.003144729`,0.003755679`,0.003312863`,0.003810663`,0.003297913`,0.003029313`,0.004517296`,0.004327496`,0.004316246`,0.005274163`,0.004323896`,0.004535113`,0.003384513`,0.003128796`,0.003042179`,0.003506996`,0.003722979`,0.003458913`,0.003305346`,0.003443679`,0.003751279`,0.004597996`,0.003055679`,0.003172063`,0.003392029`,0.002977046`,0.003390029`,0.003310546`,0.004684296`,0.003384263`,0.003189863`,0.002895929`,0.003401363`,0.002867579`,0.006035279`,0.006050229`,0.006045679`,0.006045679`,0.005357013`,0.001860679`,0.001867529`,0.003869746`,0.003475879`,0.004266813`,0.003177496`,0.003949663`,0.003865313`,0.006269063`,0.007000513`,0.007409496`,0.005921929`,0.007482329`,0.008077779`,0.006593529`,0.007000513`,0.006269063`,0.006206629`,0.007983346`,0.007231963`,0.005811829`,0.005811829`,0.005723829`,0.007178663`,0.008025463`,0.007945296`,0.008042879`,0.005481029`,0.005519379`,0.004493513`},{2/81,0.003515504`,0.003568021`,0.003568021`,0.003562404`,0.003494096`,0.002573263`,0.002594296`,0.002579438`,0.002711829`,0.002621163`,0.002516654`,0.002487004`,0.002435846`,0.002933429`,0.002651879`,0.003075904`,0.003086996`,0.002758746`,0.003033921`,0.002743004`,0.003108471`,0.003043454`,0.002942021`,0.002903129`,0.003394771`,0.003372813`,0.003211296`,0.002304796`,0.002393679`,0.004030254`,0.004323213`,0.003787071`,0.003649221`,0.003671479`,0.002581746`,0.003900638`,0.009079588`,0.004736354`,0.009378096`,0.004795288`,0.009893204`,0.003244713`,0.004894671`,0.002857463`,0.002831413`,0.002856171`,0.002867813`,0.002523946`,0.002581746`,0.002556363`,0.002476654`,0.002569263`,0.002448513`,0.002560779`,0.002624363`,0.002484638`,0.002581746`,0.002492129`,0.002490113`,0.003111138`,0.002472263`,0.002530796`,0.003022988`,0.002642379`,0.002778454`,0.003672713`,0.002915888`,0.004013029`,0.003088604`,0.004831263`,0.004861946`,0.005668513`,0.004438179`,0.004433554`,0.006062713`,0.007466579`,0.006198179`,0.005900471`,0.008765363`,0.006144379`,0.004453821`,0.007257229`,0.006033646`,0.007668721`,0.006012346`,0.006010904`,0.006011113`,0.006011113`,0.005945696`,0.002120913`,0.002214613`,0.005153563`,0.003337754`,0.004448721`,0.003447013`,0.003705829`,0.003570513`,0.006734529`,0.007548379`,0.007800713`,0.005642071`,0.007840346`,0.008317279`,0.006477954`,0.007548379`,0.006734529`,0.006393529`,0.008161254`,0.007841921`,0.006528204`,0.006528204`,0.006473446`,0.007337246`,0.007389738`,0.007651129`,0.007388179`,0.005017613`,0.005085388`,0.005801588`},{4/189,0.002712696`,0.002775479`,0.002775479`,0.002804479`,0.002755871`,0.002691504`,0.002083371`,0.002657546`,0.003381688`,0.002732671`,0.003010713`,0.002687696`,0.002742788`,0.003293813`,0.003052204`,0.003908954`,0.003909713`,0.004315829`,0.004194546`,0.003869729`,0.003668513`,0.003597729`,0.003874154`,0.003656021`,0.004098071`,0.003777071`,0.003576388`,0.003147371`,0.003170654`,0.005000063`,0.007143063`,0.005416513`,0.004239929`,0.004232304`,0.002818404`,0.005356254`,0.011174588`,0.005241446`,0.011407296`,0.006279446`,0.011519754`,0.004269838`,0.006777629`,0.003589321`,0.003638346`,0.003622979`,0.003613838`,0.002833246`,0.002818404`,0.002974138`,0.003398971`,0.002995463`,0.002942488`,0.002954738`,0.003481146`,0.003578404`,0.002818404`,0.002646529`,0.002630421`,0.003334871`,0.002616821`,0.002667554`,0.003882496`,0.004132021`,0.004413629`,0.005635963`,0.004037696`,0.006685788`,0.004821921`,0.007942138`,0.008055088`,0.008079429`,0.006619779`,0.006381521`,0.008798904`,0.009651329`,0.008963196`,0.008526071`,0.011188621`,0.008843754`,0.004385221`,0.009394738`,0.008767096`,0.009931296`,0.005955863`,0.005964979`,0.005962829`,0.005962829`,0.004494788`,0.002285321`,0.002510996`,0.005483629`,0.003230204`,0.004519721`,0.004285163`,0.003916213`,0.003845004`,0.007824929`,0.008468904`,0.007253229`,0.005400779`,0.007184738`,0.007890679`,0.005982938`,0.008468904`,0.007824929`,0.006898446`,0.007817338`,0.008561721`,0.008256154`,0.008256154`,0.007930404`,0.006801038`,0.005675929`,0.005896788`,0.005670096`,0.004736979`,0.004811079`,0.005006729`},{1/54,0.002857621`,0.002910588`,0.002910588`,0.002927454`,0.003150271`,0.003970471`,0.003365171`,0.003924271`,0.004127771`,0.004006288`,0.003784454`,0.003582138`,0.004262771`,0.004558454`,0.004180904`,0.003134254`,0.003104921`,0.003795388`,0.003619988`,0.004437271`,0.004297188`,0.004288204`,0.004147654`,0.002754771`,0.003164021`,0.002925638`,0.003832521`,0.002420488`,0.002482354`,0.003815971`,0.004369388`,0.003909738`,0.003781638`,0.003607038`,0.004326054`,0.006657488`,0.011030038`,0.006448121`,0.011153271`,0.007209504`,0.011095821`,0.006548238`,0.008604754`,0.004966988`,0.005053271`,0.005028721`,0.004988388`,0.004505221`,0.004326054`,0.004184704`,0.004215371`,0.004236204`,0.004193238`,0.004191838`,0.004354238`,0.004646438`,0.004326054`,0.004229904`,0.004213271`,0.004708188`,0.004189654`,0.004147321`,0.006014571`,0.004770038`,0.004698671`,0.008317888`,0.005603538`,0.006083554`,0.005490054`,0.006505238`,0.010367238`,0.010320838`,0.005269421`,0.005309704`,0.008368871`,0.010581904`,0.008612354`,0.008459271`,0.011682404`,0.008616638`,0.004996388`,0.010359871`,0.008327071`,0.010580038`,0.005742471`,0.005762054`,0.005759288`,0.005759288`,0.003803938`,0.002879538`,0.002851021`,0.005080654`,0.003179954`,0.004417704`,0.003972521`,0.003692304`,0.003597221`,0.007097721`,0.007748988`,0.007045454`,0.005913788`,0.006616371`,0.007512754`,0.005581604`,0.007748988`,0.007097721`,0.006895888`,0.007519338`,0.007854104`,0.007071104`,0.007071104`,0.006758388`,0.006528371`,0.004945604`,0.005135654`,0.004957238`,0.004063438`,0.004101888`,0.003817371`},{4/243,0.003060021`,0.003103938`,0.003103938`,0.003091854`,0.003121354`,0.002801971`,0.002767354`,0.002809738`,0.001983388`,0.002844704`,0.002307638`,0.002495504`,0.002510521`,0.002425054`,0.002273504`,0.002212921`,0.002173054`,0.002537121`,0.002014704`,0.002477088`,0.002481321`,0.002146004`,0.002349354`,0.002068421`,0.002087338`,0.002363654`,0.003855138`,0.002312554`,0.002332188`,0.003090154`,0.003177954`,0.002891604`,0.003088571`,0.002809921`,0.002380554`,0.004967938`,0.008576271`,0.005040821`,0.008758854`,0.005511554`,0.009222221`,0.004389188`,0.006734038`,0.002852438`,0.002818504`,0.002858854`,0.002867271`,0.002425071`,0.002380554`,0.002268638`,0.002172371`,0.002259571`,0.002119138`,0.002266554`,0.002405654`,0.002212138`,0.002380554`,0.002264488`,0.002251454`,0.002903204`,0.002247288`,0.002249271`,0.003224088`,0.002499021`,0.002538904`,0.003532871`,0.002945288`,0.003223921`,0.002986588`,0.003530354`,0.005673871`,0.006737271`,0.004209871`,0.003975554`,0.006952104`,0.010640821`,0.007198038`,0.007236554`,0.011297888`,0.007264454`,0.005723188`,0.010299138`,0.006896621`,0.010549438`,0.005124354`,0.005182238`,0.005155938`,0.005155938`,0.003366521`,0.002690988`,0.002862188`,0.004638038`,0.002726188`,0.004179954`,0.003797921`,0.003672738`,0.003491738`,0.007287404`,0.008050888`,0.007538821`,0.006025304`,0.007266221`,0.007852338`,0.005826854`,0.008050888`,0.007287404`,0.007509488`,0.007781421`,0.008283871`,0.007569588`,0.007569588`,0.007294088`,0.006915138`,0.006050671`,0.007049238`,0.006091238`,0.005369304`,0.005188221`,0.004476738`},{2/135,0.002258633`,0.002301042`,0.002301042`,0.002299217`,0.002327392`,0.001970733`,0.001917875`,0.001992942`,0.002069917`,0.002009992`,0.002225525`,0.002042375`,0.001705575`,0.002233058`,0.001932458`,0.002016192`,0.001976483`,0.002142108`,0.002002783`,0.002105875`,0.002345692`,0.002084492`,0.002025575`,0.001664058`,0.002201175`,0.001841942`,0.003969683`,0.001674633`,0.001707125`,0.002448992`,0.002771383`,0.002180992`,0.002450975`,0.002135725`,0.001756892`,0.003094458`,0.005781525`,0.003358242`,0.005909058`,0.003608967`,0.006470075`,0.002852117`,0.005460925`,0.002314717`,0.002285942`,0.002295708`,0.002302433`,0.001726633`,0.001756892`,0.001559133`,0.001616175`,0.001563008`,0.001481633`,0.001557008`,0.0018858`,0.001816933`,0.001756892`,0.001712383`,0.00170285`,0.002205592`,0.00168485`,0.0016071`,0.002684583`,0.002031925`,0.002130683`,0.003113542`,0.002243692`,0.002777492`,0.0023698`,0.003255758`,0.00362745`,0.004508992`,0.005202`,0.004087858`,0.006809242`,0.00911715`,0.006996025`,0.007072683`,0.009653292`,0.007055617`,0.005202725`,0.008825875`,0.00671605`,0.009221817`,0.004416642`,0.004477008`,0.004438517`,0.004438517`,0.003410925`,0.001974817`,0.0020819`,0.004305517`,0.00286935`,0.004290308`,0.004354617`,0.004039033`,0.003766642`,0.005849933`,0.006351958`,0.007735983`,0.007276892`,0.007816075`,0.008389917`,0.00653315`,0.006351958`,0.005849933`,0.006888925`,0.008298833`,0.00637965`,0.006991708`,0.006991708`,0.006589583`,0.007350475`,0.005636683`,0.005549858`,0.005667133`,0.004886608`,0.00492605`,0.004638908`},{4/297,0.002742`,0.002787867`,0.002787867`,0.0027975`,0.00268485`,0.002254033`,0.002350817`,0.002267983`,0.002554583`,0.002316533`,0.00255985`,0.002448833`,0.001988467`,0.002415217`,0.002385067`,0.002264433`,0.0022192`,0.002328683`,0.002366267`,0.002324533`,0.002599483`,0.0022006`,0.002277167`,0.001773933`,0.002378183`,0.002108283`,0.003730383`,0.002347867`,0.002354567`,0.002988433`,0.003268283`,0.00222555`,0.002960883`,0.002582517`,0.002390217`,0.002315983`,0.005084933`,0.002858217`,0.005220417`,0.002661733`,0.00555905`,0.002125783`,0.00423985`,0.001966767`,0.0019678`,0.001976317`,0.00197125`,0.0022669`,0.002390217`,0.001768783`,0.001692783`,0.001783617`,0.00170445`,0.001776583`,0.00169605`,0.001668083`,0.002390217`,0.00245625`,0.0024587`,0.00243115`,0.0024425`,0.00190655`,0.002215917`,0.00214715`,0.002133717`,0.002824217`,0.00215005`,0.0026429`,0.002107617`,0.003472383`,0.00491755`,0.005491317`,0.005760217`,0.0047803`,0.008452367`,0.009902133`,0.008757067`,0.00850075`,0.011484367`,0.0087281`,0.004095317`,0.009564033`,0.00835105`,0.00938595`,0.005333683`,0.005304233`,0.0053272`,0.0053272`,0.004068867`,0.002833417`,0.0029822`,0.0036039`,0.00343885`,0.0043746`,0.003741117`,0.003763833`,0.0037828`,0.005247483`,0.005816267`,0.00784635`,0.0057783`,0.008220183`,0.0089621`,0.00708265`,0.005816267`,0.005247483`,0.005420433`,0.008981767`,0.005943483`,0.00562065`,0.00562065`,0.005461883`,0.007641817`,0.0049677`,0.004799283`,0.005008267`,0.004414033`,0.004346383`,0.0035455`},{1/81,0.003249392`,0.003307058`,0.003307058`,0.003313192`,0.003265808`,0.003008258`,0.003036325`,0.003057208`,0.002720375`,0.003066442`,0.002867308`,0.002898208`,0.002699092`,0.002867025`,0.002811525`,0.002550508`,0.002507375`,0.002510042`,0.002724675`,0.002298775`,0.003092908`,0.002960258`,0.002625758`,0.001950108`,0.002644425`,0.002713192`,0.004271875`,0.002819792`,0.002812408`,0.003733742`,0.003403992`,0.002372808`,0.003694958`,0.003523075`,0.002621575`,0.003318858`,0.004738175`,0.003704725`,0.004856175`,0.003239475`,0.005348058`,0.003580908`,0.004539042`,0.002330275`,0.002246508`,0.002268542`,0.002310925`,0.002720775`,0.002621575`,0.002310375`,0.002165592`,0.002357925`,0.002280042`,0.002316925`,0.002046108`,0.002078925`,0.002621575`,0.002582192`,0.002591758`,0.003079192`,0.002553242`,0.002430742`,0.003227625`,0.002198008`,0.002308608`,0.004555075`,0.002396008`,0.002921275`,0.002334092`,0.003757692`,0.009645992`,0.010774292`,0.004917758`,0.004516225`,0.006211825`,0.009058975`,0.006403808`,0.006583258`,0.012353225`,0.006496858`,0.005516625`,0.008684358`,0.006124025`,0.009117408`,0.004919475`,0.004930325`,0.004924375`,0.004924375`,0.004050175`,0.003090708`,0.003330858`,0.002850908`,0.003668342`,0.004387125`,0.003948608`,0.003464792`,0.003408658`,0.005509258`,0.006131742`,0.007384392`,0.005406675`,0.007571825`,0.008341442`,0.006328742`,0.006131742`,0.005509258`,0.005674625`,0.008166475`,0.006277142`,0.005556108`,0.005556108`,0.005451608`,0.006996608`,0.004350408`,0.004862675`,0.004320958`,0.003681692`,0.003714858`,0.002819375`},{4/351,0.002370188`,0.002388454`,0.002388454`,0.002366404`,0.002622888`,0.002768888`,0.002407554`,0.002782621`,0.002475554`,0.002815704`,0.002232621`,0.001968038`,0.002585804`,0.002268204`,0.002378154`,0.002971121`,0.002999754`,0.002734304`,0.003111221`,0.002524921`,0.002824604`,0.002798771`,0.002823121`,0.002916738`,0.003194421`,0.003369321`,0.003800804`,0.002797104`,0.002897854`,0.003739804`,0.002992104`,0.002682188`,0.003889821`,0.003822638`,0.002397571`,0.006338354`,0.007653938`,0.007144288`,0.007783504`,0.006610604`,0.008307488`,0.005816971`,0.006523671`,0.002810121`,0.002740788`,0.002754538`,0.002794054`,0.002417571`,0.002397571`,0.002239621`,0.002377571`,0.002291004`,0.002300854`,0.002233354`,0.002549304`,0.002551338`,0.002397571`,0.002284871`,0.002287038`,0.002995471`,0.002270954`,0.002353288`,0.004311538`,0.002539338`,0.002579354`,0.005707504`,0.002828821`,0.003437371`,0.002792204`,0.003677538`,0.007820438`,0.009732988`,0.004566104`,0.004004404`,0.005310704`,0.006869571`,0.005384938`,0.005508288`,0.008461988`,0.005456538`,0.005772488`,0.006653638`,0.005261954`,0.007912354`,0.005029704`,0.005124704`,0.005052788`,0.005052788`,0.004983588`,0.002821921`,0.003036471`,0.004459488`,0.003655171`,0.004454471`,0.004559454`,0.004768504`,0.004729904`,0.006908504`,0.007237638`,0.008018321`,0.006460604`,0.008383338`,0.008486038`,0.007537121`,0.007237638`,0.006908504`,0.006885738`,0.008209321`,0.007068621`,0.008266288`,0.008266288`,0.007916504`,0.007914071`,0.005365404`,0.006391488`,0.005383521`,0.003608771`,0.003683321`,0.002583071`},{2/189,0.002537083`,0.002563633`,0.002563633`,0.002565483`,0.002876417`,0.003134483`,0.002583567`,0.003151483`,0.003159383`,0.0031772`,0.0030268`,0.002744033`,0.003011017`,0.002390233`,0.002549667`,0.003334117`,0.003340767`,0.002956933`,0.00332755`,0.002952933`,0.003007667`,0.00279805`,0.0029245`,0.003105517`,0.003424433`,0.002772683`,0.003496083`,0.001994383`,0.00208935`,0.003593083`,0.003676567`,0.003366533`,0.002917617`,0.00279565`,0.00289305`,0.009667417`,0.0121012`,0.010204883`,0.012186583`,0.009970567`,0.012192317`,0.009687833`,0.010378317`,0.005458567`,0.005259717`,0.005197117`,0.00528255`,0.002935083`,0.00289305`,0.0030141`,0.003500583`,0.003010333`,0.003016517`,0.003025467`,0.005956783`,0.004497567`,0.00289305`,0.002712133`,0.0027174`,0.0038693`,0.002712867`,0.0030065`,0.006185367`,0.003277267`,0.003418633`,0.007469717`,0.004253117`,0.004772917`,0.004795517`,0.00482065`,0.009330667`,0.010886783`,0.0049265`,0.004319983`,0.005509983`,0.0064908`,0.005554517`,0.005423483`,0.0078191`,0.005540567`,0.004873233`,0.0062669`,0.005493567`,0.007715317`,0.00472375`,0.004710783`,0.00472005`,0.00472005`,0.004261033`,0.002895467`,0.00318445`,0.005537783`,0.003458583`,0.004153867`,0.0053933`,0.0046039`,0.004533683`,0.007990317`,0.008125983`,0.00759655`,0.006632283`,0.0077101`,0.008140517`,0.006886433`,0.008125983`,0.007990317`,0.008055033`,0.0080675`,0.007724583`,0.009714883`,0.009714883`,0.0093497`,0.007405833`,0.00620445`,0.007234567`,0.0061842`,0.005278117`,0.005250383`,0.0032237`},{4/405,0.003836896`,0.003864412`,0.003864412`,0.003833312`,0.004103329`,0.004197762`,0.003500712`,0.004049746`,0.003204612`,0.004142112`,0.003142479`,0.002994079`,0.003983479`,0.003315779`,0.003264462`,0.002105012`,0.002117162`,0.002858462`,0.002395929`,0.003344562`,0.003390062`,0.003377429`,0.003325646`,0.001259679`,0.001966429`,0.001512979`,0.003128979`,0.001116729`,0.001139962`,0.003026296`,0.003867096`,0.002706762`,0.002896496`,0.002426779`,0.003991312`,0.010388812`,0.014240812`,0.010650196`,0.014374629`,0.011143446`,0.014335362`,0.009938362`,0.011867346`,0.006185679`,0.006087062`,0.005943796`,0.005973796`,0.004036562`,0.003991312`,0.005109329`,0.005077062`,0.004884196`,0.004223946`,0.005114262`,0.007589879`,0.005897879`,0.003991312`,0.003818379`,0.003842229`,0.006949646`,0.003831662`,0.004461329`,0.005481046`,0.003586846`,0.003537246`,0.004577146`,0.004699412`,0.003872662`,0.004186796`,0.003898912`,0.005450779`,0.006333862`,0.004057746`,0.004109079`,0.004668879`,0.004885896`,0.004717712`,0.004764479`,0.005537762`,0.004757962`,0.003916662`,0.004797562`,0.004652162`,0.004937246`,0.004478312`,0.004477696`,0.004479896`,0.004479896`,0.003640929`,0.002799679`,0.002926479`,0.005630312`,0.003030812`,0.004302246`,0.004890762`,0.005410712`,0.005385096`,0.008029579`,0.008239879`,0.007397562`,0.006778896`,0.007227696`,0.007757179`,0.006017379`,0.008239879`,0.008029579`,0.008210012`,0.007767396`,0.007918829`,0.009047596`,0.009047596`,0.008707046`,0.006933029`,0.006356462`,0.006989829`,0.006372412`,0.005448862`,0.005468979`,0.003660896`},{1/108,0.00371565`,0.00375435`,0.00375435`,0.003737533`,0.003823817`,0.003536733`,0.00338155`,0.0035272`,0.003039617`,0.0035456`,0.003071533`,0.002920583`,0.00341135`,0.002946433`,0.00297115`,0.00148695`,0.0014816`,0.002150417`,0.002129233`,0.002530217`,0.002939317`,0.002766767`,0.00261475`,0.001063717`,0.001581583`,0.0016665`,0.0030465`,0.00112315`,0.0011596`,0.003076817`,0.003928133`,0.002495367`,0.002293933`,0.001978033`,0.003207117`,0.005034117`,0.009998983`,0.005240267`,0.010136483`,0.005917317`,0.0100832`,0.004274`,0.007314683`,0.00352375`,0.003531233`,0.0035182`,0.003503517`,0.003260283`,0.003207117`,0.003636`,0.003858783`,0.003592483`,0.0032771`,0.00361395`,0.004245417`,0.003610917`,0.003207117`,0.003210133`,0.003164233`,0.003920267`,0.003157417`,0.003323617`,0.003734617`,0.002634767`,0.0024908`,0.00427355`,0.003450267`,0.004109083`,0.002983717`,0.004643683`,0.005361217`,0.005711167`,0.004577433`,0.004292883`,0.00533255`,0.005918183`,0.0054096`,0.005305067`,0.006977017`,0.005394933`,0.003701017`,0.005795417`,0.00528635`,0.0059616`,0.004524483`,0.004542783`,0.00453085`,0.00453085`,0.003433417`,0.00269705`,0.002684133`,0.0039654`,0.003284767`,0.004099267`,0.003788367`,0.00355535`,0.00363105`,0.006330317`,0.00700525`,0.0078294`,0.006749367`,0.0075136`,0.008236733`,0.0063311`,0.00700525`,0.006330317`,0.006573883`,0.008188983`,0.007171783`,0.005867933`,0.005867933`,0.005690483`,0.007312333`,0.0060547`,0.0054069`,0.0060776`,0.005807017`,0.005797883`,0.003571733`},{4/459,0.002374221`,0.002384388`,0.002384388`,0.002351204`,0.002381004`,0.002738738`,0.002273838`,0.002718354`,0.002643871`,0.002758538`,0.002393754`,0.002228671`,0.002816821`,0.002630688`,0.002607321`,0.002081921`,0.002035504`,0.002761804`,0.002142621`,0.003006504`,0.002783538`,0.002874538`,0.002850054`,0.001254488`,0.001880754`,0.001179338`,0.001877138`,0.001146838`,0.001181704`,0.001496788`,0.002463921`,0.002460371`,0.001166671`,0.001095421`,0.002829254`,0.005388888`,0.011236354`,0.005525571`,0.011510521`,0.006323921`,0.011718704`,0.005684004`,0.006817704`,0.004024721`,0.003939338`,0.003868304`,0.003909538`,0.002701971`,0.002829254`,0.003229254`,0.003379638`,0.003212238`,0.003055804`,0.003229004`,0.003371904`,0.003527838`,0.002829254`,0.002708588`,0.002696554`,0.003732821`,0.002697404`,0.002900021`,0.004824621`,0.003240588`,0.003273738`,0.006311821`,0.003704488`,0.004200638`,0.003812821`,0.004375154`,0.008742554`,0.009424838`,0.002280321`,0.002349304`,0.003895954`,0.005606704`,0.004030338`,0.003934521`,0.008714971`,0.004024971`,0.002743054`,0.005345938`,0.003897138`,0.006087754`,0.004532488`,0.004557988`,0.004540954`,0.004540954`,0.003627121`,0.001916554`,0.002903688`,0.003163504`,0.002466688`,0.002858321`,0.003455038`,0.003023404`,0.003014538`,0.005464254`,0.006098838`,0.007620238`,0.006255988`,0.007211688`,0.008295871`,0.006040671`,0.006098838`,0.005464254`,0.006000904`,0.008364021`,0.006286521`,0.005028354`,0.005028354`,0.004902171`,0.007063354`,0.004880904`,0.004384138`,0.004866038`,0.004097888`,0.004209588`,0.002598054`},{2/243,0.003221083`,0.0032367`,0.0032367`,0.003170017`,0.00351915`,0.00360705`,0.002726117`,0.003640017`,0.002109617`,0.003631633`,0.002218867`,0.002280083`,0.003313067`,0.002548183`,0.002506017`,0.00179485`,0.001759267`,0.001813633`,0.0019551`,0.0020251`,0.002409583`,0.00244895`,0.0021955`,0.0011076`,0.0016851`,0.000832767`,0.001657417`,0.000827733`,0.000854567`,0.0008609`,0.00091505`,0.001228767`,0.00065245`,0.000694667`,0.00313355`,0.007558017`,0.013313917`,0.007316333`,0.013540217`,0.008720683`,0.013547033`,0.0063239`,0.01000875`,0.003353867`,0.00332935`,0.003223183`,0.00320805`,0.003137167`,0.00313355`,0.00386735`,0.004074317`,0.003799033`,0.003389267`,0.00387495`,0.004526633`,0.003766183`,0.00313355`,0.003101317`,0.00306775`,0.004784767`,0.003060533`,0.00330815`,0.002409633`,0.001985533`,0.001883517`,0.002306917`,0.002732933`,0.001212667`,0.001384433`,0.0014101`,0.0034911`,0.00456375`,0.001756667`,0.001360967`,0.002046483`,0.002335133`,0.002075383`,0.002156733`,0.003064383`,0.002112783`,0.0022312`,0.00226635`,0.002042033`,0.002392817`,0.004130317`,0.004141867`,0.004138983`,0.004138983`,0.00341555`,0.001416833`,0.001907767`,0.003294833`,0.001636583`,0.002422767`,0.004084667`,0.0026`,0.002569233`,0.00708935`,0.00784295`,0.007418317`,0.006479983`,0.007080133`,0.007903367`,0.006156017`,0.00784295`,0.00708935`,0.00733075`,0.007862267`,0.00806575`,0.007084483`,0.007084483`,0.006905`,0.00696705`,0.005747567`,0.006612933`,0.0057864`,0.00479665`,0.00487005`,0.002988433`},{4/513,0.002485808`,0.002519583`,0.002519583`,0.002504567`,0.002491817`,0.00201265`,0.001759258`,0.002039517`,0.002020075`,0.002076975`,0.001850517`,0.001641475`,0.001981317`,0.001702183`,0.001736325`,0.001435358`,0.001413517`,0.001024317`,0.001897183`,0.001324608`,0.002079017`,0.001763958`,0.0014743`,0.001026883`,0.00160545`,0.000778983`,0.001737958`,0.000672833`,0.0006939`,0.000869725`,0.001002567`,0.000991167`,0.000880967`,0.00078175`,0.001933417`,0.002598783`,0.008019592`,0.003097208`,0.008198642`,0.00357885`,0.008352642`,0.001915158`,0.00506475`,0.001479567`,0.001526567`,0.001517583`,0.001475158`,0.001898192`,0.001933417`,0.001751483`,0.001548783`,0.0016927`,0.001410067`,0.001756167`,0.002203592`,0.0015605`,0.001933417`,0.00182035`,0.0018208`,0.002260517`,0.001809108`,0.001663042`,0.001364367`,0.001528033`,0.001451067`,0.00132625`,0.001459058`,0.001215467`,0.001364642`,0.001333867`,0.001875725`,0.002534858`,0.001855758`,0.001464067`,0.002197608`,0.002721025`,0.002218033`,0.002303833`,0.003674017`,0.002259608`,0.002501992`,0.00263545`,0.002170767`,0.002907883`,0.0035664`,0.003583808`,0.003574442`,0.003574442`,0.003110592`,0.001859733`,0.002408825`,0.005571667`,0.001206117`,0.0025964`,0.006967808`,0.004363092`,0.004278417`,0.00745435`,0.00777305`,0.007341275`,0.006378017`,0.007404308`,0.0076306`,0.006293525`,0.00777305`,0.00745435`,0.007410858`,0.007219558`,0.00758165`,0.009312417`,0.009312417`,0.008934525`,0.007026658`,0.0074958`,0.008577342`,0.007527992`,0.006643467`,0.006617117`,0.004281158`},{1/135,0.001549375`,0.001556283`,0.001556283`,0.001535075`,0.001549467`,0.001704258`,0.001400917`,0.00171855`,0.00184025`,0.001771508`,0.001770125`,0.001638042`,0.001862908`,0.0016656`,0.001686825`,0.001183967`,0.00119955`,0.000913842`,0.001804717`,0.00104475`,0.001891817`,0.001402117`,0.0010391`,0.0010808`,0.001441775`,0.001362217`,0.002516583`,0.001050625`,0.001067608`,0.001800108`,0.001694492`,0.001464192`,0.001506392`,0.0015685`,0.001684708`,0.002094892`,0.005472967`,0.002994892`,0.005834442`,0.002745925`,0.00698965`,0.001658967`,0.0032868`,0.001477125`,0.001546083`,0.001568417`,0.001508608`,0.00157355`,0.001684708`,0.001381892`,0.001342017`,0.001385358`,0.001267075`,0.001379508`,0.001572342`,0.001346717`,0.001684708`,0.001588233`,0.001593275`,0.00180555`,0.001584025`,0.00133805`,0.0015237`,0.001230692`,0.001297958`,0.001654667`,0.001605067`,0.001779325`,0.001433517`,0.001962125`,0.002466692`,0.004102275`,0.002727567`,0.002250083`,0.003347558`,0.006713008`,0.003469525`,0.00374225`,0.007142458`,0.003580392`,0.003602408`,0.006452925`,0.0032688`,0.0077363`,0.003839725`,0.003847992`,0.003843167`,0.003843167`,0.003104375`,0.00400265`,0.004237767`,0.006634017`,0.001563392`,0.003765542`,0.006177358`,0.005562592`,0.00536315`,0.006614975`,0.007142183`,0.008127025`,0.006870375`,0.008185492`,0.008445742`,0.007348375`,0.007142183`,0.006614975`,0.005386908`,0.008207642`,0.0071495`,0.008011675`,0.008011675`,0.007669225`,0.007929442`,0.005756492`,0.006271825`,0.005769283`,0.004991333`,0.004974058`,0.00347335`},{4/567,0.001532162`,0.001539279`,0.001539279`,0.001510996`,0.001737262`,0.001786879`,0.001192996`,0.001867496`,0.002118162`,0.001861412`,0.002003379`,0.001799829`,0.001828179`,0.001332429`,0.001525962`,0.002464379`,0.002481079`,0.002242096`,0.002293046`,0.001871362`,0.001775412`,0.001680279`,0.001753279`,0.002604812`,0.002686012`,0.003203829`,0.003494629`,0.002297562`,0.002310046`,0.003543829`,0.003785012`,0.002950312`,0.002989679`,0.003161229`,0.001865479`,0.003418096`,0.008949579`,0.004416712`,0.009139746`,0.004798029`,0.009306479`,0.003153562`,0.004545846`,0.002032129`,0.002016962`,0.002029746`,0.002048029`,0.001647496`,0.001865479`,0.001452529`,0.001582396`,0.001447696`,0.001403212`,0.001449279`,0.001786879`,0.001804662`,0.001865479`,0.001697096`,0.001700929`,0.001869612`,0.001693229`,0.001404796`,0.002393946`,0.002016496`,0.002300046`,0.005681546`,0.002244879`,0.003392179`,0.002596146`,0.003496762`,0.008366996`,0.008697629`,0.004543229`,0.004357479`,0.007500462`,0.010356096`,0.007813912`,0.007082062`,0.011556346`,0.007604062`,0.003913696`,0.010025796`,0.007417796`,0.010191879`,0.004125912`,0.004202796`,0.004146579`,0.004146579`,0.004010046`,0.003991762`,0.004198296`,0.004981829`,0.003304779`,0.005546179`,0.003793662`,0.004870562`,0.004774446`,0.006050312`,0.006344346`,0.007809262`,0.006630562`,0.008843196`,0.009196429`,0.008045012`,0.006344346`,0.006050312`,0.006170646`,0.009188446`,0.006232296`,0.006767912`,0.006767912`,0.006513812`,0.008074629`,0.005623129`,0.005922029`,0.005622996`,0.004917462`,0.004903796`,0.003269496`},{2/297,0.003150821`,0.003168554`,0.003168554`,0.003107154`,0.003522254`,0.003490237`,0.002622737`,0.003508721`,0.003362021`,0.003530587`,0.003136287`,0.002804121`,0.003363571`,0.003408154`,0.003042637`,0.003217971`,0.003196321`,0.003647954`,0.003344937`,0.003717204`,0.003460721`,0.003626987`,0.003659704`,0.002695521`,0.002945637`,0.002875571`,0.003295321`,0.002124837`,0.002091687`,0.003406137`,0.004547121`,0.003693804`,0.002949837`,0.003017454`,0.003419104`,0.007427204`,0.011440121`,0.008476654`,0.011472804`,0.008923187`,0.011476971`,0.007649304`,0.009217054`,0.005868937`,0.005006704`,0.004691687`,0.005320004`,0.003285987`,0.003419104`,0.004483171`,0.003741221`,0.004273571`,0.003724471`,0.004446071`,0.004978987`,0.003877337`,0.003419104`,0.003356754`,0.003321954`,0.005427837`,0.003316254`,0.003516371`,0.007496521`,0.004201504`,0.004011921`,0.011061521`,0.004429587`,0.008395171`,0.005888504`,0.008271054`,0.012430154`,0.012573187`,0.004509254`,0.004711237`,0.009135271`,0.009611954`,0.009343071`,0.008442554`,0.013464821`,0.009109054`,0.003294654`,0.009241687`,0.009159554`,0.008650321`,0.004493187`,0.004396404`,0.004467471`,0.004467471`,0.004369787`,0.003628004`,0.003821521`,0.002974437`,0.002639571`,0.002909737`,0.002995754`,0.003543704`,0.003563704`,0.005012204`,0.005559204`,0.006048754`,0.005162787`,0.005903654`,0.007108537`,0.004888054`,0.005559204`,0.005012204`,0.004820854`,0.006905121`,0.005695321`,0.005161304`,0.005161304`,0.005088121`,0.005660421`,0.004395871`,0.004665454`,0.004407704`,0.004142504`,0.004093637`,0.003064337`},{4/621,0.0037079`,0.00371265`,0.00371265`,0.003636833`,0.00406975`,0.004530083`,0.003378833`,0.004271567`,0.003725733`,0.004426383`,0.003736733`,0.003725467`,0.0043484`,0.0041016`,0.004336183`,0.002746733`,0.002719133`,0.003453667`,0.003039267`,0.003927117`,0.004011`,0.004188383`,0.00391095`,0.002305767`,0.002481983`,0.001936067`,0.0021185`,0.001784217`,0.001810417`,0.002771317`,0.0028374`,0.002850767`,0.00226725`,0.002476133`,0.004812433`,0.01147095`,0.014135433`,0.011810717`,0.014242333`,0.012128817`,0.014322167`,0.012248283`,0.012704633`,0.00901115`,0.008846933`,0.008605033`,0.0087014`,0.005332383`,0.004812433`,0.0084463`,0.00741245`,0.008283817`,0.007307317`,0.008469333`,0.00906085`,0.008021833`,0.004812433`,0.004379883`,0.0044327`,0.0085591`,0.004368883`,0.006434833`,0.008575267`,0.004747383`,0.004003033`,0.008069633`,0.0063044`,0.005295083`,0.005483183`,0.004224117`,0.008919467`,0.011618783`,0.002829017`,0.002795067`,0.00356255`,0.00367455`,0.003621017`,0.003572167`,0.00543075`,0.003625167`,0.002599967`,0.003597267`,0.00355125`,0.003539767`,0.002785167`,0.0027629`,0.00278085`,0.00278085`,0.002771117`,0.00165105`,0.001692`,0.002350917`,0.001908167`,0.001777583`,0.003020517`,0.002685217`,0.00269995`,0.004878083`,0.005338183`,0.005576333`,0.004162417`,0.0050244`,0.005846617`,0.0037339`,0.005338183`,0.004878083`,0.0045507`,0.005763633`,0.0054176`,0.00500205`,0.00500205`,0.005062367`,0.004873617`,0.005014033`,0.00496525`,0.005016083`,0.004370867`,0.004421167`,0.002974`},{1/162,0.003254713`,0.003265263`,0.003265263`,0.003211996`,0.003487763`,0.003520296`,0.002715446`,0.003490396`,0.002866013`,0.003542013`,0.003112229`,0.003203413`,0.003326329`,0.002767063`,0.003022896`,0.001973563`,0.002020346`,0.002460979`,0.002302263`,0.002467113`,0.002788429`,0.002652896`,0.002400213`,0.002186579`,0.002287329`,0.001860046`,0.001418513`,0.001813729`,0.001820563`,0.002603779`,0.002530213`,0.002223946`,0.001925679`,0.002055446`,0.003536096`,0.012784296`,0.014957346`,0.012975913`,0.015110446`,0.012705246`,0.015500379`,0.011870313`,0.013124546`,0.005423246`,0.005423079`,0.005308029`,0.005284529`,0.003507463`,0.003536096`,0.007526296`,0.007205713`,0.007205829`,0.006374979`,0.007428996`,0.008305246`,0.006261246`,0.003536096`,0.003399346`,0.003426946`,0.006532563`,0.003403963`,0.004639246`,0.004585213`,0.002636713`,0.002641679`,0.004322013`,0.004517846`,0.002964813`,0.002991013`,0.002805379`,0.005085613`,0.007157329`,0.002599046`,0.002533379`,0.002975063`,0.003122263`,0.003010246`,0.002978279`,0.004687079`,0.003018513`,0.002502996`,0.003033379`,0.002970529`,0.003162079`,0.002699646`,0.002725796`,0.002713913`,0.002713913`,0.002135663`,0.001223029`,0.001183463`,0.002959546`,0.001411663`,0.001699863`,0.003238513`,0.002327129`,0.002313346`,0.005637363`,0.006282013`,0.005081163`,0.004231846`,0.004536246`,0.004663729`,0.003299696`,0.006282013`,0.005637363`,0.005119746`,0.004384313`,0.006444529`,0.005604646`,0.005604646`,0.005468596`,0.004395179`,0.005224429`,0.005557213`,0.005232829`,0.004793679`,0.004799346`,0.003391729`},{4/675,0.002755288`,0.002774004`,0.002774004`,0.002733304`,0.002873021`,0.002894354`,0.002143521`,0.002864871`,0.002614321`,0.002907238`,0.002646021`,0.002494404`,0.002974721`,0.002195054`,0.002627571`,0.001938604`,0.001980521`,0.002703471`,0.002438588`,0.002616488`,0.002697554`,0.002579121`,0.002570788`,0.002103338`,0.002256588`,0.002064838`,0.001788821`,0.001455754`,0.001457654`,0.002788204`,0.002610604`,0.002592971`,0.001941388`,0.002114188`,0.003348404`,0.013269654`,0.016063971`,0.013658354`,0.016148388`,0.014261904`,0.016315071`,0.011658738`,0.014792254`,0.006052954`,0.006024621`,0.005904354`,0.005906821`,0.003153854`,0.003348404`,0.005394438`,0.005580488`,0.005397554`,0.005026338`,0.005360204`,0.006862588`,0.005931338`,0.003348404`,0.003281388`,0.003293354`,0.005287321`,0.003284104`,0.004504854`,0.005381638`,0.002705738`,0.002811504`,0.004968138`,0.004641604`,0.003014954`,0.003325721`,0.002773071`,0.005768154`,0.007042221`,0.002687271`,0.002722238`,0.002932538`,0.002910088`,0.002952704`,0.002888454`,0.004503154`,0.002950504`,0.002309571`,0.002850438`,0.002937571`,0.002862138`,0.002444588`,0.002441704`,0.002453938`,0.002453938`,0.001554671`,0.001790604`,0.001908271`,0.004172488`,0.001009038`,0.002682388`,0.004555871`,0.003723038`,0.003716838`,0.006116888`,0.006609038`,0.005872204`,0.004735754`,0.005128621`,0.005420271`,0.003839304`,0.006609038`,0.006116888`,0.005604104`,0.005490704`,0.006636488`,0.006880771`,0.006880771`,0.006618404`,0.005116671`,0.005372704`,0.006267854`,0.005384688`,0.004830538`,0.004837971`,0.003322438`},{2/351,0.0024047`,0.00242485`,0.00242485`,0.002409333`,0.002543817`,0.0027853`,0.001938683`,0.002743317`,0.002665783`,0.002814083`,0.002667067`,0.002268133`,0.002615217`,0.002131517`,0.002256283`,0.002660017`,0.002645717`,0.003157767`,0.002688317`,0.0028668`,0.0027868`,0.0026543`,0.002712117`,0.002553717`,0.002874533`,0.002867083`,0.0022258`,0.002211367`,0.002237117`,0.002977667`,0.003036983`,0.003296667`,0.00253635`,0.002789167`,0.0028766`,0.010534967`,0.015826033`,0.011108133`,0.015923133`,0.013107167`,0.016286467`,0.010146783`,0.01382655`,0.005204867`,0.0052123`,0.00515935`,0.005148833`,0.002709617`,0.0028766`,0.0045631`,0.004708333`,0.004557933`,0.004364583`,0.004540133`,0.005237833`,0.004962867`,0.0028766`,0.002659533`,0.002695`,0.0049005`,0.00268975`,0.003488467`,0.005548033`,0.003030817`,0.003299967`,0.0060669`,0.004551167`,0.004377817`,0.004203783`,0.004127883`,0.0077765`,0.009079067`,0.003098033`,0.00311475`,0.003713183`,0.003807083`,0.003750183`,0.0035906`,0.007214067`,0.003719733`,0.002129017`,0.003645067`,0.00370765`,0.003686483`,0.00229065`,0.002301233`,0.0022965`,0.0022965`,0.001615767`,0.00186255`,0.001923817`,0.003463717`,0.002231017`,0.003036567`,0.004528917`,0.00338045`,0.003353533`,0.00682945`,0.007116567`,0.006798233`,0.00535415`,0.006300867`,0.007073817`,0.005524617`,0.007116567`,0.00682945`,0.006430767`,0.0070906`,0.00692295`,0.0079845`,0.0079845`,0.00761115`,0.006396467`,0.005477183`,0.005941033`,0.00546485`,0.0049199`,0.004933467`,0.002977317`},{4/729,0.003458396`,0.003512963`,0.003512963`,0.003503196`,0.003743179`,0.004217063`,0.002566629`,0.004103313`,0.002992546`,0.004198846`,0.002963013`,0.002525879`,0.004267596`,0.003043363`,0.003101729`,0.002651029`,0.002652279`,0.003753079`,0.003307813`,0.003995079`,0.003371213`,0.003723146`,0.003828079`,0.002705013`,0.002943379`,0.002525279`,0.002520163`,0.002325063`,0.002369963`,0.002833379`,0.003163996`,0.003298529`,0.002157096`,0.002273046`,0.003984946`,0.010619696`,0.015288896`,0.010724646`,0.015410396`,0.012990296`,0.015625496`,0.009480796`,0.013701313`,0.005552363`,0.005425946`,0.005322463`,0.005345696`,0.004140829`,0.003984946`,0.004955913`,0.004935296`,0.004934413`,0.004593463`,0.004949179`,0.005364646`,0.004907046`,0.003984946`,0.003867379`,0.003855663`,0.005666929`,0.003853229`,0.004316496`,0.005906829`,0.004477779`,0.004246929`,0.006520063`,0.004874396`,0.004682129`,0.005179946`,0.004049313`,0.008546913`,0.010630613`,0.003235913`,0.003144313`,0.003602763`,0.003312413`,0.003597763`,0.003510346`,0.006797196`,0.003582246`,0.002471463`,0.003160213`,0.003603163`,0.003627779`,0.002369063`,0.002406513`,0.002379913`,0.002379913`,0.002301663`,0.002618446`,0.002362879`,0.003824496`,0.002703646`,0.003379096`,0.004642613`,0.004105763`,0.004071479`,0.006842646`,0.007012113`,0.007678679`,0.006676163`,0.007607713`,0.008095646`,0.006805663`,0.007012113`,0.006842646`,0.007348146`,0.007786529`,0.006732179`,0.008090446`,0.008090446`,0.007689863`,0.007447979`,0.004820529`,0.004976229`,0.004823629`,0.004302346`,0.004294363`,0.003098513`},{1/189,0.003669833`,0.003703367`,0.003703367`,0.00368185`,0.003876583`,0.0038736`,0.0031866`,0.00387635`,0.003193117`,0.003888667`,0.003331083`,0.003422067`,0.003792033`,0.002835267`,0.003271583`,0.0024194`,0.0024135`,0.003291867`,0.002770517`,0.003657817`,0.003230733`,0.003245967`,0.003356117`,0.002101267`,0.002302417`,0.002311633`,0.0022582`,0.001550617`,0.001606483`,0.002808083`,0.00341515`,0.003443083`,0.0021362`,0.0021568`,0.00372575`,0.010448767`,0.015052633`,0.009974867`,0.01524685`,0.012759517`,0.015782`,0.0094374`,0.013275033`,0.005658617`,0.00552375`,0.005401233`,0.005444233`,0.00366615`,0.00372575`,0.004522933`,0.004717667`,0.004502367`,0.004289117`,0.004510933`,0.005479817`,0.005017367`,0.00372575`,0.003586767`,0.003576567`,0.004934917`,0.00357305`,0.003787283`,0.006627883`,0.00411325`,0.004062267`,0.007629167`,0.004862933`,0.004358617`,0.005007583`,0.0042334`,0.009763067`,0.011975467`,0.00316235`,0.0030362`,0.004240833`,0.006154217`,0.004405933`,0.0042445`,0.0099582`,0.00437965`,0.002771717`,0.005793`,0.00421365`,0.0064426`,0.0033805`,0.0034604`,0.003403667`,0.003403667`,0.003539283`,0.00192135`,0.001724967`,0.003161483`,0.002586683`,0.003840417`,0.0031594`,0.002722367`,0.002628383`,0.00501375`,0.005349317`,0.007049317`,0.005033733`,0.007426683`,0.008162633`,0.00625575`,0.005349317`,0.00501375`,0.005095317`,0.007943017`,0.0053133`,0.005279383`,0.005279383`,0.0051972`,0.006826883`,0.0044604`,0.004494717`,0.0044703`,0.004166667`,0.0041995`,0.00286895`},{4/783,0.003545408`,0.003565158`,0.003565158`,0.003517708`,0.003824942`,0.003727292`,0.003065258`,0.003720992`,0.003007258`,0.003744342`,0.003127875`,0.003129092`,0.003673642`,0.003155475`,0.003291725`,0.001625308`,0.001621608`,0.002338075`,0.002495992`,0.002896692`,0.002989858`,0.002955642`,0.002822792`,0.001336692`,0.001613108`,0.001292842`,0.002080342`,0.000933208`,0.000937208`,0.002075092`,0.002123842`,0.002167192`,0.001393575`,0.001391075`,0.003592325`,0.011817675`,0.016143125`,0.011729475`,0.016271392`,0.014127408`,0.016376125`,0.009666625`,0.013959142`,0.005903858`,0.005687425`,0.005665808`,0.005741325`,0.003647025`,0.003592325`,0.004917058`,0.004965408`,0.004805242`,0.004374358`,0.004934392`,0.006552992`,0.005086958`,0.003592325`,0.003515458`,0.003488092`,0.005246808`,0.003489308`,0.003878092`,0.005796275`,0.003071042`,0.002983992`,0.004908392`,0.005001125`,0.003161925`,0.003523042`,0.002982208`,0.007638958`,0.010341992`,0.002251175`,0.002204342`,0.002955242`,0.003500158`,0.003000542`,0.003001058`,0.005783142`,0.003019942`,0.002544325`,0.003377642`,0.002947942`,0.003682492`,0.003787275`,0.003834375`,0.003800875`,0.003800875`,0.003779825`,0.001785142`,0.001508342`,0.003158525`,0.002061025`,0.003967442`,0.004830258`,0.003369658`,0.003293275`,0.006488242`,0.006858242`,0.007237025`,0.005486858`,0.007253658`,0.007798775`,0.006435942`,0.006858242`,0.006488242`,0.006264008`,0.007608775`,0.006762525`,0.007726875`,0.007726875`,0.007472475`,0.006996958`,0.004101758`,0.004594542`,0.004105625`,0.003669008`,0.003711475`,0.002628642`},{2/405,0.002270829`,0.002278329`,0.002278329`,0.002240163`,0.002155979`,0.002364263`,0.002082163`,0.002332396`,0.002475029`,0.002376329`,0.002579263`,0.002589363`,0.002443196`,0.002027763`,0.002286213`,0.001594313`,0.001622846`,0.002169396`,0.002139029`,0.002309563`,0.002248196`,0.002237763`,0.002367096`,0.001542546`,0.001772213`,0.001803513`,0.002692396`,0.001176113`,0.001217279`,0.002349563`,0.002273646`,0.002453113`,0.001831179`,0.001794246`,0.002314579`,0.010056063`,0.015032813`,0.010505196`,0.015027696`,0.012293513`,0.015050479`,0.007244646`,0.012598446`,0.003164829`,0.003077046`,0.003074379`,0.003124596`,0.002351446`,0.002314579`,0.002640796`,0.002533429`,0.002645313`,0.002422529`,0.002666663`,0.003229313`,0.002742829`,0.002314579`,0.002236946`,0.002224429`,0.003295313`,0.002219929`,0.002529863`,0.003526946`,0.002429996`,0.002514413`,0.003536363`,0.003199913`,0.002745996`,0.002784813`,0.002785696`,0.005393229`,0.007637346`,0.002690596`,0.002498796`,0.002982679`,0.004294529`,0.003023113`,0.003023113`,0.005988729`,0.003040196`,0.003119679`,0.004092363`,0.002964046`,0.004861029`,0.004370346`,0.004473213`,0.004396163`,0.004396163`,0.004407296`,0.003046696`,0.002761696`,0.003871663`,0.002427729`,0.005220813`,0.004876763`,0.005095713`,0.004973746`,0.007117929`,0.007341063`,0.008639046`,0.006550163`,0.008753846`,0.008583446`,0.008579779`,0.007341063`,0.007117929`,0.007275079`,0.008454679`,0.007091046`,0.008563279`,0.008563279`,0.008093863`,0.008737213`,0.003973546`,0.004548563`,0.003978079`,0.003611646`,0.003620629`,0.002159463`},{4/837,0.002083517`,0.0020901`,0.0020901`,0.002050783`,0.002318933`,0.002669583`,0.001902883`,0.002672983`,0.002384467`,0.002692583`,0.002496133`,0.002170383`,0.002554083`,0.002349717`,0.0023701`,0.003061267`,0.003066667`,0.003052383`,0.0028137`,0.00298935`,0.002687033`,0.002724467`,0.002811333`,0.002923617`,0.003260267`,0.002664867`,0.002731`,0.001941633`,0.002028567`,0.002712267`,0.003979233`,0.003669383`,0.00217735`,0.002213933`,0.002758183`,0.011760483`,0.014528617`,0.011831767`,0.0145804`,0.0127489`,0.0146541`,0.009122267`,0.012638783`,0.003389033`,0.00334185`,0.003284917`,0.003311783`,0.002727317`,0.002758183`,0.003226117`,0.003154717`,0.003212583`,0.00304945`,0.003254917`,0.003415083`,0.003252083`,0.002758183`,0.00265475`,0.002651333`,0.004650567`,0.002644333`,0.002939583`,0.004499633`,0.00329285`,0.003463167`,0.007192217`,0.00380125`,0.004950317`,0.004003783`,0.005274983`,0.010191033`,0.011784817`,0.00410165`,0.00391695`,0.005679833`,0.006476217`,0.0057927`,0.005607867`,0.00786185`,0.0057606`,0.003660417`,0.006349267`,0.0056498`,0.006666`,0.00602985`,0.006178567`,0.006067167`,0.006067167`,0.006102333`,0.002874733`,0.0029114`,0.002459133`,0.003973167`,0.00583395`,0.004029167`,0.003661917`,0.00357775`,0.006373917`,0.006743367`,0.00846085`,0.00704235`,0.008858017`,0.008703717`,0.008448783`,0.006743367`,0.006373917`,0.00704995`,0.0088899`,0.0066514`,0.006974567`,0.006974567`,0.006600833`,0.008546383`,0.003790533`,0.0041913`,0.00380155`,0.003871917`,0.003885467`,0.002428967`}};
zxadd = {0.006357367,	0.007583117	,0.004818083,	0.007804583,	0.008165783	,0.006932633	,0.006357367,	0.005749533,	0.005546433	,0.008205883,	0.006473767,	0.005326867,	0.005326867,	0.005241833,	0.007358067	,0.004635333	,0.005005217,	0.0046315,	0.004267167,	0.004185533,	0.003379933};
 zx1981[[104]]  = Join[ zx1981[[104]], zxadd ];


SetUpRegHumid[ seas_]:={
zy1=ToExpression[ StringTake[ SCAN[[seas,1,1]],{-1}] ];
poss=If[NumberQ[zy1],If[  zy1>0,zy1,10],  -1];
zz=HumidCoeff[[poss]];
q[t_]:= f[ zz[[1]] ,2.\[Pi]/365,zz[[2]],zz[[3]],t];
qtVAR= HumidCoeff[[poss]];
}[[1]]


(* ::Subsubsection::Closed:: *)
(*settings output*)


oufc[]:={
gr0= {
{ "TOTALPOP: ",TOTALPOP},
{"NUMBERGRIDPOINTS: ",NUMBERGRIDPOINTS},
{"NUMBERPOSTSAMPLES: ",NUMBERPOSTSAMPLES},
{"MAXKERNELS: ",MAXKERNELS},
{"FOLDER: ",FOLDER},
{"RESAMPLINGQ: ",RESAMPLINGQ},
{"RESAMPCRIT: " , RESAMPCRIT},
{"RESAMPSTATE: ",RESAMPSTATE},
{"imisBB: ",imisBB},
{"imisFAC: ",imisFAC},
{"CUT: ",CUT },
{"lnaupdate: ",lnaupdate},
{"q[time] = ", q[time]}
};
Export[ StringJoin[{ FOLDER,"settings.txt"}],gr0,"Table"];
}[[1]];


(* ::Subsubsection::Closed:: *)
(*degen measure output*)


degenmeas[input_,seas_,i_]:={
tf1=input;
tf1[[All,-1]]=tf1[[All,-1]]/Total[tf1[[All,-1]]];
Neff= Total[ tf1[[All,-1]]^2]^-1;
(**)
imisvalue= N[ imischeck[  tf1, NUMBERGRIDPOINTS  ]  ];
(**)
Export[ StringJoin[{FOLDER,ToString[seas],"-",ToString[i] ,"_degenmeas.txt"}], {{"Neff :",Neff },{"IMISmeas: ",imisvalue}},"Table" ];
}[[1]]



